﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.ClientSocket
// Assembly: ConnectorLib.sd2snes, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 743ADA37-D030-4892-BC8D-59E965B0A960
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.sd2snes.dll

using ConnectorLib.sd2snes;
using ConnectorLib.usb2snes;
using log4net;
using Newtonsoft.Json;
using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Reflection;
using System.Threading;
using WebSocketSharp;
using WebSocketSharp.Server;

namespace ConnectorLib
{
  public class ClientSocket : WebSocketBehavior, IDisposable
  {
    private readonly SortedDictionary<string, Scheduler> _ports;
    private string _port_name = "";
    private static readonly ILog _log = LogManager.GetLogger(typeof (ClientSocket));

    public string Name { get; private set; }

    public event EventHandler<bool> ConnectionStateChanged;

    public bool ConnectionState { get; private set; }

    public BlockingCollection<sd2snesServer.ResponseQueueElementType> Queue { get; } = new BlockingCollection<sd2snesServer.ResponseQueueElementType>();

    public BlockingCollection<byte[]> DataQueue { get; } = new BlockingCollection<byte[]>();

    public void Dispose()
    {
      try
      {
        this.Queue?.Dispose();
      }
      catch
      {
      }
      try
      {
        this.DataQueue?.Dispose();
      }
      catch
      {
      }
    }

    public ClientSocket(SortedDictionary<string, Scheduler> ports)
    {
      this._ports = ports;
      this.Name = "Unknown";
    }

    protected override void OnOpen()
    {
      ClientSocket._log.Info((object) ("OnOpen: " + this.ID + ": " + ((object) this).GetHashCode().ToString()));
      base.OnOpen();
    }

    protected override void OnClose(CloseEventArgs e)
    {
      ClientSocket._log.Info((object) ("OnClose: " + this.ID + ": " + ((object) this).GetHashCode().ToString()));
      lock (this._ports)
      {
        if (this._ports.ContainsKey(this._port_name))
        {
          lock (this._ports[this._port_name].Clients)
            this._ports[this._port_name].Clients.Remove(((object) this).GetHashCode());
        }
      }
      base.OnClose(e);
    }

    protected override void OnError(ErrorEventArgs e)
    {
      ClientSocket._log.Info((object) ("OnError: " + this.ID + ": " + ((object) this).GetHashCode().ToString()));
      lock (this._ports)
      {
        if (this._ports.ContainsKey(this._port_name))
        {
          lock (this._ports[this._port_name].Clients)
            this._ports[this._port_name].Clients.Remove(((object) this).GetHashCode());
        }
      }
      base.OnError(e);
    }

    protected override void OnMessage(MessageEventArgs e)
    {
      if (e.Type == Opcode.Text)
      {
        string data = e.Data;
        ConnectorLib.usb2snes.RequestType requestType1 = new ConnectorLib.usb2snes.RequestType();
        ConnectorLib.usb2snes.RequestType requestType2 = JsonConvert.DeserializeObject<ConnectorLib.usb2snes.RequestType>(data);
        ClientSocket._log.Info((object) data);
        OpcodeType opcodeType = (OpcodeType) Enum.Parse(typeof (OpcodeType), requestType2.Opcode);
        switch (opcodeType)
        {
          case OpcodeType.DeviceList:
            ResponseType responseType1 = new ResponseType()
            {
              Results = new List<string>()
            };
            foreach (Core.Port device in Core.GetDeviceList(Settings.DisableComDescFilter))
              responseType1.Results.Add(device.Name);
            this.Send(JsonConvert.SerializeObject((object) responseType1));
            break;
          case OpcodeType.Attach:
            lock (this._ports)
            {
              if (this._ports.ContainsKey(this._port_name))
              {
                lock (this._ports[this._port_name].Clients)
                  this._ports[this._port_name].Clients.Remove(((object) this).GetHashCode());
              }
              using (List<Core.Port>.Enumerator enumerator = Core.GetDeviceList(Settings.DisableComDescFilter).GetEnumerator())
              {
                while (enumerator.MoveNext())
                {
                  Core.Port current = enumerator.Current;
                  if (current.Name == requestType2.Operands[0])
                  {
                    this._port_name = requestType2.Operands[0];
                    lock (this._ports)
                    {
                      if (!this._ports.ContainsKey(this._port_name))
                      {
                        try
                        {
                          GC.Collect();
                          GC.WaitForPendingFinalizers();
                          Scheduler scheduler = new Scheduler(this._port_name, this._ports);
                          scheduler.ConnectionStateChanged += (EventHandler<bool>) ((o, v) =>
                          {
                            this.ConnectionState = v;
                            EventHandler<bool> connectionStateChanged = this.ConnectionStateChanged;
                            if (connectionStateChanged == null)
                              return;
                            connectionStateChanged(o, v);
                          });
                          this._ports.Add(this._port_name, scheduler);
                        }
                        catch (Exception ex)
                        {
                          USBTools.DeviceHelper.SetDeviceEnabled(Guid.Parse("4d36e978-e325-11ce-bfc1-08002be10318"), current.PNPID, false);
                          Thread.Sleep(1500);
                          USBTools.DeviceHelper.SetDeviceEnabled(Guid.Parse("4d36e978-e325-11ce-bfc1-08002be10318"), current.PNPID, true);
                          ClientSocket._log.Error((object) ex.ToString());
                          ClientSocket._log.Error((object) ("Unable to create new port: " + requestType2.Operands[0]));
                          this.Context.WebSocket.Close();
                          break;
                        }
                      }
                      lock (this._ports[this._port_name].Clients)
                      {
                        lock (this._ports[this._port_name].Clients)
                        {
                          this._ports[this._port_name].Clients.Add(((object) this).GetHashCode(), this);
                          break;
                        }
                      }
                    }
                  }
                }
                break;
              }
            }
          case OpcodeType.AppVersion:
            ResponseType responseType2 = new ResponseType()
            {
              Results = new List<string>()
            };
            Version version = Assembly.GetExecutingAssembly().GetName().Version;
            responseType2.Results.Add(version.ToString());
            this.Send(JsonConvert.SerializeObject((object) responseType2));
            break;
          case OpcodeType.Name:
            if (requestType2.Operands.Count <= 0)
              break;
            this.Name = requestType2.Operands[0];
            break;
          default:
            lock (this._ports)
            {
              if (!this._ports.ContainsKey(this._port_name))
              {
                this.Context.WebSocket.Close();
                break;
              }
              Scheduler port = this._ports[this._port_name];
              try
              {
                port.Queue.Add(new sd2snesServer.RequestQueueElementType()
                {
                  Request = requestType2,
                  Socket = this
                });
              }
              catch
              {
              }
            }
            if (!requestType2.RequiresData())
              break;
            bool flag1 = false;
            bool flag2 = true;
            do
            {
              sd2snesServer.ResponseQueueElementType queueElementType1 = (sd2snesServer.ResponseQueueElementType) null;
              try
              {
                queueElementType1 = this.Queue.Take();
              }
              catch
              {
                flag1 = true;
              }
              if (!flag1)
              {
                sd2snesServer.ResponseQueueElementType queueElementType2 = queueElementType1;
                if (opcodeType == OpcodeType.List || opcodeType == OpcodeType.Info || opcodeType == OpcodeType.GetFile & flag2)
                {
                  this.Send(JsonConvert.SerializeObject((object) queueElementType2.Response));
                  flag2 = false;
                }
                else
                  this.Send((byte[]) queueElementType2.Data.Clone());
                flag1 = queueElementType2.Done;
              }
            }
            while (!flag1);
            break;
        }
      }
      else if (e.Type == Opcode.Binary)
      {
        this.DataQueue.Add((byte[]) e.RawData.Clone());
      }
      else
      {
        if (e.Type != Opcode.Close)
          return;
        lock (this._ports)
        {
          if (!this._ports.ContainsKey(this._port_name))
            return;
          lock (this._ports[this._port_name].Clients)
            this._ports[this._port_name].Clients.Remove(((object) this).GetHashCode());
        }
      }
    }
  }
}
