﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.Settings
// Assembly: ConnectorLib.sd2snes, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 743ADA37-D030-4892-BC8D-59E965B0A960
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.sd2snes.dll

using Microsoft.Win32;
using System.ComponentModel;

namespace ConnectorLib
{
  internal static class Settings
  {
    private static bool? _disable_com_desc_filter;

    private static string RegistryRoot => "Software\\Warp World Inc.\\CrowdControl\\";

    private static T GetRegistry<T>(string name, T defaultValue)
    {
      try
      {
        using (RegistryKey registryKey = Registry.CurrentUser?.OpenSubKey(Settings.RegistryRoot))
        {
          if (registryKey == null)
            return defaultValue;
          object text = registryKey.GetValue(name, (object) defaultValue);
          if (text != null && text.GetType().IsAssignableFrom(typeof (T)))
            return (T) text;
          T obj = (T) TypeDescriptor.GetConverter(typeof (T)).ConvertFromString((string) text);
          return (object) obj == null ? defaultValue : obj;
        }
      }
      catch
      {
        return defaultValue;
      }
    }

    private static void SetRegistry<T>(string name, T value)
    {
      try
      {
        using (RegistryKey subKey = Registry.CurrentUser?.CreateSubKey(Settings.RegistryRoot))
          subKey?.SetValue(name, (object) value);
      }
      catch
      {
      }
    }

    public static bool DisableComDescFilter
    {
      get
      {
        if (!Settings._disable_com_desc_filter.HasValue)
          Settings._disable_com_desc_filter = new bool?(Settings.GetRegistry<bool>("disableComDescFilter", false));
        return Settings._disable_com_desc_filter.Value;
      }
      set => Settings.SetRegistry<bool>("serverID", value);
    }
  }
}
