﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.sd2snes.SocketServer
// Assembly: ConnectorLib.sd2snes, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 743ADA37-D030-4892-BC8D-59E965B0A960
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.sd2snes.dll

using System;
using System.Collections.Generic;
using System.Linq;
using WebSocketSharp;
using WebSocketSharp.Server;

namespace ConnectorLib.sd2snes
{
  internal class SocketServer
  {
    private readonly SortedDictionary<string, Scheduler> _ports;
    private readonly WebSocketServer _wssv_8080;
    private readonly WebSocketServer _wssv_64213;

    public SocketServer(SortedDictionary<string, Scheduler> ports)
    {
      this._ports = ports;
      this._wssv_8080 = new WebSocketServer("ws://localhost:8080/");
      this._wssv_8080.Log.Output = (Action<LogData, string>) ((_, __) => { });
      this._wssv_8080.AddWebSocketService<ClientSocket>("/", (Func<ClientSocket>) (() =>
      {
        ClientSocket clientSocket = new ClientSocket(this._ports);
        clientSocket.ConnectionStateChanged += new EventHandler<bool>(this._socket_Onsd2snesConnected);
        return clientSocket;
      }));
      this._wssv_64213 = new WebSocketServer("ws://localhost:64213/");
      this._wssv_64213.Log.Output = (Action<LogData, string>) ((_, __) => { });
      this._wssv_64213.AddWebSocketService<ClientSocket>("/", (Func<ClientSocket>) (() =>
      {
        ClientSocket clientSocket = new ClientSocket(this._ports);
        clientSocket.ConnectionStateChanged += new EventHandler<bool>(this._socket_Onsd2snesConnected);
        return clientSocket;
      }));
    }

    public event EventHandler<bool> ConnectionStateChanged;

    public bool ConnectionState { get; private set; }

    private void _socket_Onsd2snesConnected(object sender, bool e)
    {
      this.ConnectionState = e;
      EventHandler<bool> connectionStateChanged = this.ConnectionStateChanged;
      if (connectionStateChanged == null)
        return;
      connectionStateChanged(sender, e);
    }

    public void Start()
    {
      try
      {
        this._wssv_8080.Start();
      }
      catch
      {
      }
      this._wssv_64213.Start();
    }

    public void Stop()
    {
      foreach (KeyValuePair<string, Scheduler> keyValuePair1 in this._ports.ToList<KeyValuePair<string, Scheduler>>())
      {
        foreach (KeyValuePair<int, ClientSocket> keyValuePair2 in keyValuePair1.Value.Clients.ToList<KeyValuePair<int, ClientSocket>>())
        {
          try
          {
            keyValuePair2.Value.Context.WebSocket.Close();
          }
          catch
          {
          }
        }
        keyValuePair1.Value.Stop();
      }
      try
      {
        this._wssv_8080.Stop();
      }
      catch
      {
      }
      this._wssv_64213.Stop();
    }
  }
}
