﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.USBTools
// Assembly: ConnectorLib.sd2snes, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 743ADA37-D030-4892-BC8D-59E965B0A960
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.sd2snes.dll

using Microsoft.Win32.SafeHandles;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.ConstrainedExecution;
using System.Runtime.InteropServices;
using System.Security;
using System.Text;

namespace ConnectorLib
{
  internal static class USBTools
  {
    [Flags]
    internal enum SetupDiGetClassDevsFlags
    {
      Default = 1,
      Present = 2,
      AllClasses = 4,
      Profile = 8,
      DeviceInterface = 16, // 0x00000010
    }

    internal enum DiFunction
    {
      SelectDevice = 1,
      InstallDevice = 2,
      AssignResources = 3,
      Properties = 4,
      Remove = 5,
      FirstTimeSetup = 6,
      FoundDevice = 7,
      SelectClassDrivers = 8,
      ValidateClassDrivers = 9,
      InstallClassDrivers = 10, // 0x0000000A
      CalcDiskSpace = 11, // 0x0000000B
      DestroyPrivateData = 12, // 0x0000000C
      ValidateDriver = 13, // 0x0000000D
      Detect = 15, // 0x0000000F
      InstallWizard = 16, // 0x00000010
      DestroyWizardData = 17, // 0x00000011
      PropertyChange = 18, // 0x00000012
      EnableClass = 19, // 0x00000013
      DetectVerify = 20, // 0x00000014
      InstallDeviceFiles = 21, // 0x00000015
      UnRemove = 22, // 0x00000016
      SelectBestCompatDrv = 23, // 0x00000017
      AllowInstall = 24, // 0x00000018
      RegisterDevice = 25, // 0x00000019
      NewDeviceWizardPreSelect = 26, // 0x0000001A
      NewDeviceWizardSelect = 27, // 0x0000001B
      NewDeviceWizardPreAnalyze = 28, // 0x0000001C
      NewDeviceWizardPostAnalyze = 29, // 0x0000001D
      NewDeviceWizardFinishInstall = 30, // 0x0000001E
      Unused1 = 31, // 0x0000001F
      InstallInterfaces = 32, // 0x00000020
      DetectCancel = 33, // 0x00000021
      RegisterCoInstallers = 34, // 0x00000022
      AddPropertyPageAdvanced = 35, // 0x00000023
      AddPropertyPageBasic = 36, // 0x00000024
      Reserved1 = 37, // 0x00000025
      Troubleshooter = 38, // 0x00000026
      PowerMessageWake = 39, // 0x00000027
      AddRemotePropertyPageAdvanced = 40, // 0x00000028
      UpdateDriverUI = 41, // 0x00000029
      Reserved2 = 48, // 0x00000030
    }

    internal enum StateChangeAction
    {
      Enable = 1,
      Disable = 2,
      PropChange = 3,
      Start = 4,
      Stop = 5,
    }

    [Flags]
    internal enum Scopes
    {
      Global = 1,
      ConfigSpecific = 2,
      ConfigGeneral = 4,
    }

    internal enum SetupApiError
    {
      NoAssociatedClass = -536870400, // 0xE0000200
      ClassMismatch = -536870399, // 0xE0000201
      DuplicateFound = -536870398, // 0xE0000202
      NoDriverSelected = -536870397, // 0xE0000203
      KeyDoesNotExist = -536870396, // 0xE0000204
      InvalidDevinstName = -536870395, // 0xE0000205
      InvalidClass = -536870394, // 0xE0000206
      DevinstAlreadyExists = -536870393, // 0xE0000207
      DevinfoNotRegistered = -536870392, // 0xE0000208
      InvalidRegProperty = -536870391, // 0xE0000209
      NoInf = -536870390, // 0xE000020A
      NoSuchHDevinst = -536870389, // 0xE000020B
      CantLoadClassIcon = -536870388, // 0xE000020C
      InvalidClassInstaller = -536870387, // 0xE000020D
      DiDoDefault = -536870386, // 0xE000020E
      DiNoFileCopy = -536870385, // 0xE000020F
      InvalidHwProfile = -536870384, // 0xE0000210
      NoDeviceSelected = -536870383, // 0xE0000211
      DevinfolistLocked = -536870382, // 0xE0000212
      DevinfodataLocked = -536870381, // 0xE0000213
      DiBadPath = -536870380, // 0xE0000214
      NoClassInstallParams = -536870379, // 0xE0000215
      FileQueueLocked = -536870378, // 0xE0000216
      BadServiceInstallSect = -536870377, // 0xE0000217
      NoClassDriverList = -536870376, // 0xE0000218
      NoAssociatedService = -536870375, // 0xE0000219
      NoDefaultDeviceInterface = -536870374, // 0xE000021A
      DeviceInterfaceActive = -536870373, // 0xE000021B
      DeviceInterfaceRemoved = -536870372, // 0xE000021C
      BadInterfaceInstallSect = -536870371, // 0xE000021D
      NoSuchInterfaceClass = -536870370, // 0xE000021E
      InvalidReferenceString = -536870369, // 0xE000021F
      InvalidMachineName = -536870368, // 0xE0000220
      RemoteCommFailure = -536870367, // 0xE0000221
      MachineUnavailable = -536870366, // 0xE0000222
      NoConfigMgrServices = -536870365, // 0xE0000223
      InvalidPropPageProvider = -536870364, // 0xE0000224
      NoSuchDeviceInterface = -536870363, // 0xE0000225
      DiPostProcessingRequired = -536870362, // 0xE0000226
      InvalidCOInstaller = -536870361, // 0xE0000227
      NoCompatDrivers = -536870360, // 0xE0000228
      NoDeviceIcon = -536870359, // 0xE0000229
      InvalidInfLogConfig = -536870358, // 0xE000022A
      DiDontInstall = -536870357, // 0xE000022B
      InvalidFilterDriver = -536870356, // 0xE000022C
      NonWindowsNTDriver = -536870355, // 0xE000022D
      NonWindowsDriver = -536870354, // 0xE000022E
      NoCatalogForOemInf = -536870353, // 0xE000022F
      DevInstallQueueNonNative = -536870352, // 0xE0000230
      NotDisableable = -536870351, // 0xE0000231
      CantRemoveDevinst = -536870350, // 0xE0000232
      InvalidTarget = -536870349, // 0xE0000233
      DriverNonNative = -536870348, // 0xE0000234
      InWow64 = -536870347, // 0xE0000235
      SetSystemRestorePoint = -536870346, // 0xE0000236
      IncorrectlyCopiedInf = -536870345, // 0xE0000237
      SceDisabled = -536870344, // 0xE0000238
      UnknownException = -536870343, // 0xE0000239
      PnpRegistryError = -536870342, // 0xE000023A
      RemoteRequestUnsupported = -536870341, // 0xE000023B
      NotAnInstalledOemInf = -536870340, // 0xE000023C
      InfInUseByDevices = -536870339, // 0xE000023D
      DiFunctionObsolete = -536870338, // 0xE000023E
      NoAuthenticodeCatalog = -536870337, // 0xE000023F
      AuthenticodeDisallowed = -536870336, // 0xE0000240
      AuthenticodeTrustedPublisher = -536870335, // 0xE0000241
      AuthenticodeTrustNotEstablished = -536870334, // 0xE0000242
      AuthenticodePublisherNotTrusted = -536870333, // 0xE0000243
      SignatureOSAttributeMismatch = -536870332, // 0xE0000244
      OnlyValidateViaAuthenticode = -536870331, // 0xE0000245
    }

    internal struct DeviceInfoData
    {
      public int Size;
      public Guid ClassGuid;
      public int DevInst;
      public IntPtr Reserved;
    }

    internal struct PropertyChangeParameters
    {
      public int Size;
      public USBTools.DiFunction DiFunction;
      public USBTools.StateChangeAction StateChange;
      public USBTools.Scopes Scope;
      public int HwProfile;
    }

    internal class NativeMethods
    {
      private const string SETUP_API = "setupapi.dll";

      private NativeMethods()
      {
      }

      [DllImport("setupapi.dll", SetLastError = true)]
      [return: MarshalAs(UnmanagedType.Bool)]
      public static extern bool SetupDiCallClassInstaller(
        USBTools.DiFunction installFunction,
        USBTools.SafeDeviceInfoSetHandle deviceInfoSet,
        [In] ref USBTools.DeviceInfoData deviceInfoData);

      [DllImport("setupapi.dll", SetLastError = true)]
      [return: MarshalAs(UnmanagedType.Bool)]
      public static extern bool SetupDiEnumDeviceInfo(
        USBTools.SafeDeviceInfoSetHandle deviceInfoSet,
        int memberIndex,
        ref USBTools.DeviceInfoData deviceInfoData);

      [DllImport("setupapi.dll", CharSet = CharSet.Unicode, SetLastError = true)]
      public static extern USBTools.SafeDeviceInfoSetHandle SetupDiGetClassDevs(
        [In] ref Guid classGuid,
        [MarshalAs(UnmanagedType.LPWStr)] string enumerator,
        IntPtr hwndParent,
        USBTools.SetupDiGetClassDevsFlags flags);

      [DllImport("setupapi.dll", CharSet = CharSet.Auto, SetLastError = true)]
      [return: MarshalAs(UnmanagedType.Bool)]
      public static extern bool SetupDiGetDeviceInstanceId(
        IntPtr DeviceInfoSet,
        ref USBTools.DeviceInfoData did,
        [MarshalAs(UnmanagedType.LPTStr)] StringBuilder DeviceInstanceId,
        int DeviceInstanceIdSize,
        out int RequiredSize);

      [SuppressUnmanagedCodeSecurity]
      [ReliabilityContract(Consistency.WillNotCorruptState, Cer.Success)]
      [DllImport("setupapi.dll", SetLastError = true)]
      [return: MarshalAs(UnmanagedType.Bool)]
      public static extern bool SetupDiDestroyDeviceInfoList(IntPtr deviceInfoSet);

      [DllImport("setupapi.dll", SetLastError = true)]
      [return: MarshalAs(UnmanagedType.Bool)]
      public static extern bool SetupDiSetClassInstallParams(
        USBTools.SafeDeviceInfoSetHandle deviceInfoSet,
        [In] ref USBTools.DeviceInfoData deviceInfoData,
        [In] ref USBTools.PropertyChangeParameters classInstallParams,
        int classInstallParamsSize);
    }

    internal class SafeDeviceInfoSetHandle : SafeHandleZeroOrMinusOneIsInvalid
    {
      public SafeDeviceInfoSetHandle()
        : base(true)
      {
      }

      protected override bool ReleaseHandle() => USBTools.NativeMethods.SetupDiDestroyDeviceInfoList(this.handle);
    }

    public static class DeviceHelper
    {
      public static void SetDeviceEnabled(Guid classGuid, string instanceId, bool enable)
      {
        USBTools.SafeDeviceInfoSetHandle handle = (USBTools.SafeDeviceInfoSetHandle) null;
        try
        {
          handle = USBTools.NativeMethods.SetupDiGetClassDevs(ref classGuid, (string) null, IntPtr.Zero, USBTools.SetupDiGetClassDevsFlags.Present);
          USBTools.DeviceInfoData[] deviceInfoData = USBTools.DeviceHelper.GetDeviceInfoData(handle);
          int indexOfInstance = USBTools.DeviceHelper.GetIndexOfInstance(handle, deviceInfoData, instanceId);
          USBTools.DeviceHelper.EnableDevice(handle, deviceInfoData[indexOfInstance], enable);
        }
        finally
        {
          if (handle != null)
          {
            if (!handle.IsClosed)
              handle.Close();
            handle.Dispose();
          }
        }
      }

      private static USBTools.DeviceInfoData[] GetDeviceInfoData(
        USBTools.SafeDeviceInfoSetHandle handle)
      {
        List<USBTools.DeviceInfoData> deviceInfoDataList = new List<USBTools.DeviceInfoData>();
        USBTools.DeviceInfoData deviceInfoData = new USBTools.DeviceInfoData();
        int num = Marshal.SizeOf<USBTools.DeviceInfoData>(deviceInfoData);
        deviceInfoData.Size = num;
        int memberIndex = 0;
        while (USBTools.NativeMethods.SetupDiEnumDeviceInfo(handle, memberIndex, ref deviceInfoData))
        {
          deviceInfoDataList.Add(deviceInfoData);
          ++memberIndex;
          deviceInfoData = new USBTools.DeviceInfoData();
          deviceInfoData.Size = num;
        }
        return deviceInfoDataList.ToArray();
      }

      private static int GetIndexOfInstance(
        USBTools.SafeDeviceInfoSetHandle handle,
        USBTools.DeviceInfoData[] diData,
        string instanceId)
      {
        for (int indexOfInstance = 0; indexOfInstance <= diData.Length - 1; ++indexOfInstance)
        {
          StringBuilder DeviceInstanceId = new StringBuilder(1);
          int RequiredSize = 0;
          bool deviceInstanceId = USBTools.NativeMethods.SetupDiGetDeviceInstanceId(handle.DangerousGetHandle(), ref diData[indexOfInstance], DeviceInstanceId, DeviceInstanceId.Capacity, out RequiredSize);
          if (!deviceInstanceId && Marshal.GetLastWin32Error() == 122)
          {
            DeviceInstanceId.Capacity = RequiredSize;
            deviceInstanceId = USBTools.NativeMethods.SetupDiGetDeviceInstanceId(handle.DangerousGetHandle(), ref diData[indexOfInstance], DeviceInstanceId, DeviceInstanceId.Capacity, out RequiredSize);
          }
          if (!deviceInstanceId)
            throw new Win32Exception();
          if (instanceId.Equals(DeviceInstanceId.ToString()))
            return indexOfInstance;
        }
        return -1;
      }

      private static void EnableDevice(
        USBTools.SafeDeviceInfoSetHandle handle,
        USBTools.DeviceInfoData diData,
        bool enable)
      {
        USBTools.PropertyChangeParameters classInstallParams = new USBTools.PropertyChangeParameters();
        classInstallParams.Size = 8;
        classInstallParams.DiFunction = USBTools.DiFunction.PropertyChange;
        classInstallParams.Scope = USBTools.Scopes.Global;
        classInstallParams.StateChange = !enable ? USBTools.StateChangeAction.Disable : USBTools.StateChangeAction.Enable;
        if (!USBTools.NativeMethods.SetupDiSetClassInstallParams(handle, ref diData, ref classInstallParams, Marshal.SizeOf<USBTools.PropertyChangeParameters>(classInstallParams)))
          throw new Win32Exception();
        if (USBTools.NativeMethods.SetupDiCallClassInstaller(USBTools.DiFunction.PropertyChange, handle, ref diData))
          return;
        int lastWin32Error = Marshal.GetLastWin32Error();
        if (lastWin32Error == -536870351)
          throw new ArgumentException("Device can't be disabled (programmatically or in Device Manager).");
        if (lastWin32Error >= -536870400 && lastWin32Error <= -536870331)
          throw new Win32Exception("SetupAPI error: " + ((USBTools.SetupApiError) lastWin32Error).ToString());
        throw new Win32Exception();
      }
    }
  }
}
