﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.sd2snesFeatures
// Assembly: ConnectorLib.sd2snes, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 743ADA37-D030-4892-BC8D-59E965B0A960
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.sd2snes.dll

using System;
using System.Collections.Generic;

namespace ConnectorLib
{
  [Serializable]
  public class sd2snesFeatures : IFeatureAware
  {
    public AccessLevel Access(ulong address) => AccessLevel.Read | AccessLevel.Write;

    public AccessLevel Access(ulong address, string domain)
    {
      switch (domain)
      {
        case "System Bus":
          return this.Access(address);
        default:
          return this.Access(domain);
      }
    }

    public AccessLevel Access(string domain)
    {
      switch (domain)
      {
        case "APURAM":
        case "CGRAM":
        case "OAM":
        case "VRAM":
          return AccessLevel.None;
        case "CARTRAM":
        case "CARTROM":
        case "WRAM":
          return AccessLevel.Read | AccessLevel.Write;
        case "System Bus":
          return AccessLevel.Mixed;
        default:
          throw new ArgumentOutOfRangeException(nameof (domain));
      }
    }

    public IEnumerable<string> Domains => (IEnumerable<string>) new string[7]
    {
      "WRAM",
      "CARTROM",
      "CARTRAM",
      "VRAM",
      "OAM",
      "CGRAM",
      "APURAM"
    };

    public bool CanSatisfy(Capability capability) => this.Access(capability.Address).HasFlag((Enum) capability.Access);
  }
}
