﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.AggregateCapability
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;

namespace ConnectorLib
{
  [Serializable]
  public class AggregateCapability : ICapability, ISerializable
  {
    public readonly AggregateCapability.AggregationType Type;
    public readonly IEnumerable<Capability> Capabilities;

    public AggregateCapability(
      AggregateCapability.AggregationType type,
      params Capability[] capabilities)
    {
      this.Type = type;
      this.Capabilities = (IEnumerable<Capability>) capabilities;
    }

    public AggregateCapability(SerializationInfo info, StreamingContext context)
    {
      this.Type = (AggregateCapability.AggregationType) info.GetByte("type");
      this.Capabilities = (IEnumerable<Capability>) ((Capability[]) info.GetValue("capabilities", typeof (Capability[])) ?? throw new SerializationException());
    }

    public void GetObjectData(SerializationInfo info, StreamingContext context)
    {
      info.AddValue("type", (byte) this.Type);
      info.AddValue("capabilities", (object) this.Capabilities);
    }

    public Satisfiability SatisfiableBy(IAddressableConnector connector) => this.Capabilities.Select<Capability, Satisfiability>((Func<Capability, Satisfiability>) (c => c.SatisfiableBy(connector))).Aggregate<Satisfiability>(this.Type == AggregateCapability.AggregationType.AND ? new Func<Satisfiability, Satisfiability, Satisfiability>(AggregateCapability.AND) : new Func<Satisfiability, Satisfiability, Satisfiability>(AggregateCapability.OR));

    public static Satisfiability AND(Satisfiability first, Satisfiability second)
    {
      if (first == Satisfiability.ConnectorUnable || second == Satisfiability.ConnectorUnable)
        return Satisfiability.ConnectorUnable;
      return first == Satisfiability.ConnectorRisky || second == Satisfiability.ConnectorRisky ? Satisfiability.ConnectorRisky : Satisfiability.ConnectorAble;
    }

    public static Satisfiability OR(Satisfiability first, Satisfiability second)
    {
      if (first == Satisfiability.ConnectorAble || second == Satisfiability.ConnectorAble)
        return Satisfiability.ConnectorAble;
      return first == Satisfiability.ConnectorRisky || second == Satisfiability.ConnectorRisky ? Satisfiability.ConnectorRisky : Satisfiability.ConnectorUnable;
    }

    public enum AggregationType : byte
    {
      AND,
      OR,
    }
  }
}
