﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.HIDTools.HIDStream
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using Microsoft.Win32.SafeHandles;
using System;
using System.ComponentModel;
using System.IO;

namespace ConnectorLib.HIDTools
{
  public class HIDStream : Stream
  {
    private volatile bool _closed;
    private readonly IntPtr _handle;
    private readonly FileStream _hid_stream;

    ~HIDStream() => this.Dispose(false);

    protected override void Dispose(bool disposing)
    {
      base.Dispose(disposing);
      if (disposing)
        this._hid_stream?.Close();
      ConnectorLib.HIDTools.Win32.CloseHandle(this._handle);
      this._closed = true;
    }

    public override void Flush() => this._hid_stream.Flush();

    public bool IsOpen() => !this._closed;

    public HIDStream(HIDInfo device)
    {
      this._handle = ConnectorLib.HIDTools.Win32.CreateFile(device.Path, 3221225472U, 3U, IntPtr.Zero, 3U, 1073741824U, IntPtr.Zero);
      this._hid_stream = !(this._handle == ConnectorLib.HIDTools.Win32.INVALID_HANDLE_VALUE) ? new FileStream(new SafeFileHandle(this._handle, false), FileAccess.ReadWrite, 32, true) : throw new Win32Exception("The HID handle was invalid.");
    }

    public override void Close()
    {
      this._hid_stream.Close();
      ConnectorLib.HIDTools.Win32.CloseHandle(this._handle);
      this._closed = true;
    }

    public void Write(byte[] data) => this.Write(data, 0, data.Length);

    public override void Write(byte[] data, int offset, int length)
    {
      this._hid_stream.Write(data, offset, length);
      this._hid_stream.Flush();
    }

    public override bool CanRead => this._hid_stream.CanRead;

    public override bool CanSeek => this._hid_stream.CanSeek;

    public override bool CanWrite => this._hid_stream.CanWrite;

    public override long Length => this._hid_stream.Length;

    public override long Position
    {
      get => this._hid_stream.Position;
      set => this._hid_stream.Position = value;
    }

    public override long Seek(long offset, SeekOrigin origin) => this._hid_stream.Seek(offset, origin);

    public override void SetLength(long value) => this._hid_stream.SetLength(value);

    public override int Read(byte[] data, int offset, int length) => this._hid_stream.Read(data, offset, length);

    public void ReadBlocking(byte[] data)
    {
      int offset = 0;
      int length = data.Length;
      while (offset != length)
      {
        int num = this.Read(data, offset, checked (length - offset));
        checked { offset += num; }
      }
    }
  }
}
