﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.Capability
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Runtime.Serialization;

namespace ConnectorLib
{
  [Serializable]
  public struct Capability : ICapability, ISerializable
  {
    public readonly ulong Address;
    public readonly AccessLevel Access;

    public bool Risky { get; }

    public Capability(ulong address, AccessLevel access, bool risky = false)
    {
      this.Address = address;
      this.Access = access;
      this.Risky = risky;
    }

    public Capability(SerializationInfo info, StreamingContext context)
    {
      this.Address = info.GetUInt64("address");
      this.Access = (AccessLevel) info.GetByte("access");
      this.Risky = info.GetBoolean("risky");
    }

    public void GetObjectData(SerializationInfo info, StreamingContext context)
    {
      info.AddValue("address", this.Address);
      info.AddValue("access", (byte) this.Access);
      info.AddValue("risky", this.Risky);
    }

    public Satisfiability SatisfiableBy(IAddressableConnector connector)
    {
      if (!connector.Features.CanSatisfy(this))
        return Satisfiability.ConnectorUnable;
      return !this.Risky ? Satisfiability.ConnectorAble : Satisfiability.ConnectorRisky;
    }
  }
}
