﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.ConnectorFactory
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;

namespace ConnectorLib
{
  public static class ConnectorFactory
  {
    public static readonly ConnectorFactory.ConnectorProfile[][] Available = ConnectorFactory.Build();

    private static ConnectorFactory.ConnectorProfile[][] Build()
    {
      ConnectorFactory.ConnectorProfile[][] connectorProfileArray1 = new ConnectorFactory.ConnectorProfile[Enum.GetNames(typeof (ConnectorType)).Length][];
      ConnectorFactory.ConnectorProfile connectorProfile1 = new ConnectorFactory.ConnectorProfile("Lua", typeof (LuaConnector), ConnectorFactory.Visibility.Production);
      ConnectorFactory.ConnectorProfile[] connectorProfileArray2 = new ConnectorFactory.ConnectorProfile[1]
      {
        connectorProfile1
      };
      ConnectorFactory.ConnectorProfile connectorProfile2 = new ConnectorFactory.ConnectorProfile("USBGecko", typeof (GeckoConnector<FTDIGeckoProvider>), ConnectorFactory.Visibility.Debug);
      Type type = ConnectorFactory.TryGetsd2snesConnectorType();
      if (type == (Type) null)
        connectorProfileArray1[0] = connectorProfileArray2;
      else
        connectorProfileArray1[0] = new ConnectorFactory.ConnectorProfile[2]
        {
          connectorProfile1,
          new ConnectorFactory.ConnectorProfile("SD2SNES", type, ConnectorFactory.Visibility.Production)
        };
      Type injectConnectorType = ConnectorFactory.TryGetInjectConnectorType();
      if (injectConnectorType != (Type) null)
        connectorProfileArray1[7] = new ConnectorFactory.ConnectorProfile[1]
        {
          new ConnectorFactory.ConnectorProfile("Inject", injectConnectorType, ConnectorFactory.Visibility.Production)
        };
      else
        connectorProfileArray1[7] = new ConnectorFactory.ConnectorProfile[0];
      Type clientConnectorType = ConnectorFactory.TryGetIRCClientConnectorType();
      if (clientConnectorType != (Type) null)
        connectorProfileArray1[14] = new ConnectorFactory.ConnectorProfile[1]
        {
          new ConnectorFactory.ConnectorProfile("IRC (Client)", clientConnectorType, ConnectorFactory.Visibility.Production)
        };
      else
        connectorProfileArray1[14] = new ConnectorFactory.ConnectorProfile[0];
      Type serverConnectorType = ConnectorFactory.TryGetIRCServerConnectorType();
      if (serverConnectorType != (Type) null)
        connectorProfileArray1[15] = new ConnectorFactory.ConnectorProfile[1]
        {
          new ConnectorFactory.ConnectorProfile("IRC (Server)", serverConnectorType, ConnectorFactory.Visibility.Production)
        };
      else
        connectorProfileArray1[15] = new ConnectorFactory.ConnectorProfile[0];
      connectorProfileArray1[9] = new ConnectorFactory.ConnectorProfile[1]
      {
        connectorProfile2
      };
      connectorProfileArray1[10] = new ConnectorFactory.ConnectorProfile[1]
      {
        connectorProfile2
      };
      connectorProfileArray1[11] = new ConnectorFactory.ConnectorProfile[0];
      connectorProfileArray1[1] = new ConnectorFactory.ConnectorProfile[1]
      {
        connectorProfile1
      };
      connectorProfileArray1[4] = new ConnectorFactory.ConnectorProfile[2]
      {
        connectorProfile1,
        new ConnectorFactory.ConnectorProfile("EDN8 Pro", typeof (EverDriveN8ProConnector), ConnectorFactory.Visibility.Production)
      };
      connectorProfileArray1[5] = new ConnectorFactory.ConnectorProfile[2]
      {
        connectorProfile1,
        new ConnectorFactory.ConnectorProfile("GB-Link", typeof (GBLinkConnector), ConnectorFactory.Visibility.Debug)
      };
      connectorProfileArray1[17] = connectorProfileArray2;
      connectorProfileArray1[8] = connectorProfileArray2;
      connectorProfileArray1[2] = connectorProfileArray2;
      connectorProfileArray1[3] = new ConnectorFactory.ConnectorProfile[2]
      {
        connectorProfile1,
        connectorProfile2
      };
      connectorProfileArray1[6] = new ConnectorFactory.ConnectorProfile[1]
      {
        new ConnectorFactory.ConnectorProfile("REST", typeof (RESTConnector), ConnectorFactory.Visibility.Production)
      };
      connectorProfileArray1[12] = new ConnectorFactory.ConnectorProfile[1]
      {
        new ConnectorFactory.ConnectorProfile("Null", typeof (NullConnector), ConnectorFactory.Visibility.Production)
      };
      connectorProfileArray1[13] = new ConnectorFactory.ConnectorProfile[1]
      {
        new ConnectorFactory.ConnectorProfile("NamedPipeDuplexConnector", typeof (NamedPipeDuplexConnector), ConnectorFactory.Visibility.Production)
      };
      connectorProfileArray1[16] = new ConnectorFactory.ConnectorProfile[1]
      {
        new ConnectorFactory.ConnectorProfile("SimpleTCPConnector", typeof (SimpleTCPConnector), ConnectorFactory.Visibility.Production)
      };
      return connectorProfileArray1;
    }

    private static Type TryGetsd2snesConnectorType()
    {
      try
      {
        return AppDomain.CurrentDomain.Load("ConnectorLib.sd2snes").GetType("ConnectorLib.sd2snesConnector", false);
      }
      catch
      {
        return (Type) null;
      }
    }

    private static Type TryGetInjectConnectorType()
    {
      try
      {
        return AppDomain.CurrentDomain.Load("ConnectorLib.Inject").GetType("ConnectorLib.Inject.InjectConnector", false);
      }
      catch
      {
        return (Type) null;
      }
    }

    private static Type TryGetEmulatorInjectConnectorType()
    {
      try
      {
        return AppDomain.CurrentDomain.Load("ConnectorLib.Inject").GetType("ConnectorLib.Inject.Emulator.EmulatorInjectConnector", false);
      }
      catch
      {
        return (Type) null;
      }
    }

    private static Type TryGetIRCClientConnectorType()
    {
      try
      {
        return AppDomain.CurrentDomain.Load("ConnectorLib.IRC").GetType("ConnectorLib.IRC.IRCClientConnector", false);
      }
      catch
      {
        return (Type) null;
      }
    }

    private static Type TryGetIRCServerConnectorType()
    {
      try
      {
        return AppDomain.CurrentDomain.Load("ConnectorLib.IRC").GetType("ConnectorLib.IRC.IRCServerConnector", false);
      }
      catch
      {
        return (Type) null;
      }
    }

    public class ConnectorProfile
    {
      public readonly string Name;
      public readonly Type Type;
      public readonly ConnectorFactory.Visibility Visibility;

      public ConnectorProfile(string name, Type type, ConnectorFactory.Visibility visibility)
      {
        this.Name = name;
        this.Type = type;
        this.Visibility = visibility;
      }

      public static implicit operator (string name, Type type)(
        ConnectorFactory.ConnectorProfile value)
      {
        return (value.Name, value.Type);
      }
    }

    public enum Visibility : byte
    {
      Hidden,
      Debug,
      Staging,
      Production,
    }
  }
}
