﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.EverDriveN8ProConnector
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using ConnectorLib.Patches;
using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.IO.Ports;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;

namespace ConnectorLib
{
    public class EverDriveN8ProConnector :
      ConnectorBase,
      INESProConnector,
      INESConnector,
      IGameConnector,
      IDisposable,
      IAddressableConnector,
      IROMProcessor,
      I8BitConnector
    {
        private const uint ADDR_PRG = 0;
        private const uint ADDR_CHR = 8388608;
        private const uint ADDR_SRM = 16777216;
        private const uint ADDR_CFG = 25165824;
        private const uint ADDR_SSR = 25174016;
        private const uint ADDR_FIFO = 25231360;
        private const uint ADDR_FLA_MENU = 0;
        private const uint ADDR_FLA_FPGA = 262144;
        private const uint ADDR_FLA_ICOR = 524288;
        private const uint SIZE_PRG = 8388608;
        private const uint SIZE_CHR = 8388608;
        private const uint SIZE_SRM = 262144;
        private const uint ADDR_OS_PRG = 8257536;
        private const uint ADDR_OS_CHR = 16646144;
        private const byte FAT_READ = 1;
        private const byte FAT_WRITE = 2;
        private const byte FAT_OPEN_EXISTING = 0;
        private const byte FAT_CREATE_NEW = 4;
        private const byte FAT_CREATE_ALWAYS = 8;
        private const byte FAT_OPEN_ALWAYS = 16;
        private const byte FAT_OPEN_APPEND = 48;
        private const byte CMD_STATUS = 16;
        private const byte CMD_GET_MODE = 17;
        private const byte CMD_HARD_RESET = 18;
        private const byte CMD_GET_VDC = 19;
        private const byte CMD_RTC_GET = 20;
        private const byte CMD_RTC_SET = 21;
        private const byte CMD_FLA_RD = 22;
        private const byte CMD_FLA_WR = 23;
        private const byte CMD_FLA_WR_SDC = 24;
        private const byte CMD_MEM_RD = 25;
        private const byte CMD_MEM_WR = 26;
        private const byte CMD_MEM_SET = 27;
        private const byte CMD_MEM_TST = 28;
        private const byte CMD_MEM_CRC = 29;
        private const byte CMD_FPG_USB = 30;
        private const byte CMD_FPG_SDC = 31;
        private const byte CMD_FPG_FLA = 32;
        private const byte CMD_FPG_CFG = 33;
        private const byte CMD_USB_WR = 34;
        private const byte CMD_FIFO_WR = 35;
        private const byte CMD_UART_WR = 36;
        private const byte CMD_REINIT = 37;
        private const byte CMD_SYS_INF = 38;
        private const byte CMD_GAME_CTR = 39;
        private const byte CMD_UPD_EXEC = 40;
        private const byte CMD_DISK_INIT = 192;
        private const byte CMD_DISK_RD = 193;
        private const byte CMD_DISK_WR = 194;
        private const byte CMD_F_DIR_OPN = 195;
        private const byte CMD_F_DIR_RD = 196;
        private const byte CMD_F_DIR_LD = 197;
        private const byte CMD_F_DIR_SIZE = 198;
        private const byte CMD_F_DIR_PATH = 199;
        private const byte CMD_F_DIR_GET = 200;
        private const byte CMD_F_FOPN = 201;
        private const byte CMD_F_FRD = 202;
        private const byte CMD_F_FRD_MEM = 203;
        private const byte CMD_F_FWR = 204;
        private const byte CMD_F_FWR_MEM = 205;
        private const byte CMD_F_FCLOSE = 206;
        private const byte CMD_F_FPTR = 207;
        private const byte CMD_F_FINFO = 208;
        private const byte CMD_F_FCRC = 209;
        private const byte CMD_F_DIR_MK = 210;
        private const byte CMD_F_DEL = 211;
        private const byte CMD_USB_RECOV = 240;
        private const byte CMD_RUN_APP = 241;
        private const byte PLUS = 43;
        private const byte UNPLUS = 212;
        private const byte STATUS_OK = 0;
        private int _next_id;
        private SemaphoreSlim _limiter = new SemaphoreSlim(1);
        private SerialPort _port;
        private ushort _bank_swap_func;
        private byte _control_bank;
        private ushort _control_func;
        private ushort _rom_version = ushort.MaxValue;
        private readonly ConcurrentDictionary<byte, EverDriveN8ProConnector.CommandDefinition> _read_waiters = new ConcurrentDictionary<byte, EverDriveN8ProConnector.CommandDefinition>();
        private Task _reader;
        private bool _quitting;

        private byte NextID => (byte)Interlocked.Increment(ref this._next_id);

        public void Init(ushort bankSwapFunc, byte controlBank, ushort controlFunc)
        {
            this._bank_swap_func = bankSwapFunc;
            this._control_bank = controlBank;
            this._control_func = controlFunc;
        }

        protected override void Dispose(bool disposing)
        {
            this._quitting = true;
            if (disposing)
                this._port.Dispose();
            base.Dispose(disposing);
        }

        public EverDriveN8ProConnector() => this.Connect();

        public void Connect() => this.Connect(this.FindPort());

        public void Connect(string port)
        {
            this._port = new SerialPort(port);
            this._port.Open();
            this._port.DiscardInBuffer();
            this._reader = (Task)Task.Factory.StartNew<Task>(new Func<Task>(this.ReadLoop), TaskCreationOptions.LongRunning);
            this.CheckVersion(true);
            EventHandler<(ConnectionStatus, string)> connectionStatusChanged = this.ConnectionStatusChanged;
            if (connectionStatusChanged == null)
                return;
            connectionStatusChanged((object)this, (ConnectionStatus.Open, string.Empty));
        }

        public void CheckVersion(bool force = false)
        {
            if (!(force | this._rom_version == ushort.MaxValue))
                return;
            Task.Run<bool>((Func<bool>)(() => this.Version(out ushort _)));
        }

        private async Task ReadLoop()
        {
            while (!this._quitting)
            {
                int num1 = 0;
                try
                {
                    if (this._port.ReadByte() == 32)
                    {
                        int key = this._port.ReadByte();
                        if (key >= 0)
                        {
                            EverDriveN8ProConnector.CommandDefinition commandDefinition;
                            if (this._read_waiters.TryRemove(checked((byte)key), out commandDefinition))
                            {
                                int num2 = this._port.ReadByte();
                                if (num2 >= 0)
                                {
                                    switch ((EverDriveN8ProConnector.CommandDefinition.CommandType)checked((byte)num2))
                                    {
                                        case EverDriveN8ProConnector.CommandDefinition.CommandType.Read:
                                        case EverDriveN8ProConnector.CommandDefinition.CommandType.ReadArray:
                                            int index = 0;
                                            while (index < commandDefinition.Length.Length)
                                            {
                                                ushort bytesExpected = commandDefinition.Length[index];
                                                byte[] responseBytes = new byte[(int)bytesExpected];
                                                if (this._port.ReadBlocking(responseBytes, (int)bytesExpected))
                                                {
                                                    commandDefinition.Value[index] = responseBytes;
                                                    checked { ++index; }
                                                }
                                                else
                                                    goto label_17;
                                            }
                                            break;
                                        case EverDriveN8ProConnector.CommandDefinition.CommandType.Freeze:
                                            int num3 = this._port.ReadByte();
                                            if (num3 >= 0)
                                            {
                                                commandDefinition.Value[0] = new byte[1]
                                                {
                          checked ((byte) num3)
                                                };
                                                break;
                                            }
                                            continue;
                                        case EverDriveN8ProConnector.CommandDefinition.CommandType.Version:
                                            byte[] responseBytes1 = new byte[2];
                                            if (this._port.ReadBlocking(responseBytes1, 2))
                                            {
                                                commandDefinition.Value[0] = responseBytes1;
                                                break;
                                            }
                                            continue;
                                    }
                                    commandDefinition.Waiter.Set();
                                }
                                else
                                    continue;
                            }
                            else
                                continue;
                        }
                        else
                            continue;
                    }
                    else
                        continue;
                }
                catch
                {
                    num1 = 1;
                }
            label_17:
                if (num1 == 1 && !this._quitting)
                    await Task.Delay(1000);
            }
        }

        private string FindPort() => PortFactory.GetDeviceList("EverDrive N8").FirstOrDefault<PortFactory.Port>()?.Name;

        private bool Write(byte cmdNum, params byte[] cmdData)
        {
            try
            {
                if (!this._port.IsOpen)
                    return false;
                byte[] array = ((IEnumerable<byte>)new byte[4]
                {
          (byte) 43,
          (byte) 212,
          cmdNum,
          checked ((byte) ((int) cmdNum ^ (int) byte.MaxValue))
                }).Concat<byte>((IEnumerable<byte>)cmdData).ToArray<byte>();
                this._port.Write(array, 0, array.Length);
                return true;
            }
            catch (Exception ex)
            {
                Log.Debug((object)ex);
                return false;
            }
        }

        private bool MemWrite(uint addr, byte[] data) => this.Write((byte)26, ((IEnumerable<byte>)addr.GetBytes()).Concat<byte>((IEnumerable<byte>)(checked((uint)data.Length)).GetBytes()).Append<byte>((byte)0).Concat<byte>((IEnumerable<byte>)data).ToArray<byte>());

        private bool CodeInject(byte[] asm) => this.MemWrite(25231360U, ((IEnumerable<byte>)asm).Prepend<byte>(checked((byte)asm.Length)).ToArray<byte>());

        public IBatchWriteContext OpenBatchWriteContext() => (IBatchWriteContext)new NullContext();

        public bool SendMessage(string message) => true;

        public event EventHandler<string> OnMessage;

        public bool Connected => this._port.IsOpen;

        public void KeepAlive()
        {
        }

        public event EventHandler<(ConnectionStatus, string)> ConnectionStatusChanged;

        private bool DoLimitedAction(Func<bool> action)
        {
            if (!this._limiter.Wait(TimeSpan.FromSeconds(1.0)))
                return false;
            try
            {
                return action();
            }
            finally
            {
                this._limiter.Release();
            }
        }

        private bool DoLimitedAction<T>(EverDriveN8ProConnector.OutFunc<T, bool> action, out T result)
        {
            if (!this._limiter.Wait(TimeSpan.FromSeconds(1.0)))
            {
                result = default(T);
                return false;
            }
            try
            {
                return action(out result);
            }
            finally
            {
                this._limiter.Release();
            }
        }

        public bool Version(out ushort version1) => this.DoLimitedAction<ushort>((EverDriveN8ProConnector.OutFunc<ushort, bool>)((out ushort version2) =>
        {
            byte nextId = this.NextID;
            using (EverDriveN8ProConnector.CommandDefinition commandDefinition = new EverDriveN8ProConnector.CommandDefinition(EverDriveN8ProConnector.CommandDefinition.CommandType.Version, (ushort)0, (ushort)2))
            {
                this._read_waiters[nextId] = commandDefinition;
                if (!this.CodeInject(new byte[2]
            {
          nextId,
          (byte) 254
            }.AppendChecksum()))
                {
                    version2 = (ushort)0;
                    return false;
                }
                if (!commandDefinition.Waiter.Wait(TimeSpan.FromSeconds(1.0)))
                {
                    version2 = (ushort)0;
                    return false;
                }
                this._read_waiters.TryRemove(nextId, out EverDriveN8ProConnector.CommandDefinition _);
                this._rom_version = version2 = (ushort)((uint)commandDefinition.Value[0][0] | (uint)commandDefinition.Value[0][1] << 8);
                return true;
            }
        }), out version1);

        public bool Read(ulong address, byte[] buffer) => this.DoLimitedAction((Func<bool>)(() =>
        {
            byte nextId = this.NextID;
            using (EverDriveN8ProConnector.CommandDefinition commandDefinition = new EverDriveN8ProConnector.CommandDefinition(EverDriveN8ProConnector.CommandDefinition.CommandType.Read, (ushort)address, (ushort)buffer.Length))
            {
                this._read_waiters[nextId] = commandDefinition;
                if (!this.CodeInject(new byte[5]
            {
          nextId,
          (byte) 1,
          checked ((byte) buffer.Length),
          (byte) address,
          (byte) (address >> 8)
            }.AppendChecksum()) || !commandDefinition.Waiter.Wait(TimeSpan.FromSeconds(1.0)))
                    return false;
                this._read_waiters.TryRemove(nextId, out EverDriveN8ProConnector.CommandDefinition _);
                Buffer.BlockCopy((Array)commandDefinition.Value[0], 0, (Array)buffer, 0, buffer.Length);
                return true;
            }
        }));

        public bool Write(ulong address, byte[] buffer)
        {
            return this.DoLimitedAction(delegate ()
            {
                IMemoryMapper mapper = this.Mapper;
                ValueTuple<ulong, string>? map = (mapper != null) ? new ValueTuple<ulong, string>?(mapper.Translate(address)) : null;
                EverDriveN8ProConnector.CommandDefinition.CommandType cmd;
                if (map != null)
                {
                    string text = map.Value.Item2.ToUpperInvariant();
                    EverDriveN8ProConnector.CommandDefinition.CommandType commandType;
                    if (text != null && text == "PALRAM")
                    {
                        commandType = EverDriveN8ProConnector.CommandDefinition.CommandType.WritePaletteArray;
                    }
                    else
                    {
                        commandType = EverDriveN8ProConnector.CommandDefinition.CommandType.WriteArray;
                    }
                    cmd = commandType;
                    address = map.Value.Item1;
                }

                else
                {
                    cmd = EverDriveN8ProConnector.CommandDefinition.CommandType.WriteArray;
                }
                byte i = this.NextID;
                bool result;
                using (EverDriveN8ProConnector.CommandDefinition cd = new EverDriveN8ProConnector.CommandDefinition(EverDriveN8ProConnector.CommandDefinition.CommandType.WriteArray, (ushort)address, (ushort)buffer.Length))
                {
                    this._read_waiters[i] = cd;
                    if (!this.CodeInject(new byte[]
                    {
                        i,
                        (byte)cmd,
                        checked((byte)buffer.Length),
                        (byte)address,
                        (byte)(address >> 8)
                    }.Concat(buffer).AppendChecksum().ToArray<byte>()))
                    {
                        result = false;
                    }
                    else if (!cd.Waiter.Wait(TimeSpan.FromSeconds(1.0)))
                    {
                        result = false;
                    }
                    else
                    {
                        EverDriveN8ProConnector.CommandDefinition commandDefinition;
                        this._read_waiters.TryRemove(i, out commandDefinition);
                        result = true;
                    }
                }
                return result;
            });
        }

        public bool Freeze(
              ulong address,
              ulong value,
              byte size,
              WriteType writeType,
              ulong cmpAddress,
              ulong cmpValue,
              byte cmpSize,
              CompareType cmpType)
        {
            return this.Freeze(address, value, ulong.MaxValue, size, writeType, cmpAddress, cmpValue, cmpSize, cmpType);
        }

        public bool Freeze(
          ulong address,
          ulong value,
          ulong mask,
          byte size,
          WriteType writeType,
          ulong cmpAddress,
          ulong cmpValue,
          byte cmpSize,
          CompareType cmpType)
        {
            return this.DoLimitedAction((Func<bool>)(() =>
            {
                if (size != (byte)1)
                    throw new ArgumentOutOfRangeException(nameof(size), "This connector only supports a freeze value size of 1.");
                if (cmpSize != (byte)1)
                    throw new ArgumentOutOfRangeException(nameof(cmpSize), "This connector only supports a freeze compare size of 1.");
                byte nextId = this.NextID;
                using (EverDriveN8ProConnector.CommandDefinition commandDefinition = new EverDriveN8ProConnector.CommandDefinition(EverDriveN8ProConnector.CommandDefinition.CommandType.Freeze, (ushort)address, (ushort)1))
                {
                    this._read_waiters[nextId] = commandDefinition;
                    return this.CodeInject(new byte[13]
              {
            nextId,
            (byte) 4,
            size,
            cmpSize,
            (byte) address,
            (byte) (address >> 8),
            (byte) value,
            (byte) mask,
            (byte) writeType,
            (byte) cmpAddress,
            (byte) (cmpAddress >> 8),
            (byte) cmpValue,
            (byte) cmpType
                }.AppendChecksum()) && commandDefinition.Waiter.Wait(TimeSpan.FromSeconds(1.0)) && commandDefinition.Value[0][0] > (byte)0;
                }
            }));
        }

        public bool Unfreeze(ulong address) => this.Freeze(address, 0UL, (byte)1, WriteType.None, 0UL, 0UL, (byte)1, CompareType.Never);

        public IBatchContext8 GetBatchContext8() => (IBatchContext8)null;

        public bool SetBits(ulong address, byte mask, out byte orig)
        {
            orig = (byte)0;
            return false;
        }

        public bool UnsetBits(ulong address, byte mask, out byte orig)
        {
            orig = (byte)0;
            return false;
        }

        public bool CompareSwap(ulong chkAddress, byte test, byte newVal, out byte orig)
        {
            orig = (byte)0;
            return false;
        }

        public bool FreezeU8(ulong address, byte value, byte cmpValue, CompareType cmpType) => this.Freeze(address, (ulong)value, (byte)1, WriteType.WriteValue, address, (ulong)cmpValue, (byte)1, cmpType);

        public bool FreezeU8TU8(ulong address, byte value, byte cmpValue, CompareType cmpType) => this.Freeze(address, (ulong)value, (byte)1, WriteType.WriteValue, address, (ulong)cmpValue, (byte)1, cmpType);

        public bool FreezeU8TU8(
          ulong address,
          byte value,
          ulong cmpAddress,
          byte cmpValue,
          CompareType cmpType)
        {
            throw new NotImplementedException();
        }

        public bool Read8(ulong address, out byte value1) => this.DoLimitedAction<byte>((EverDriveN8ProConnector.OutFunc<byte, bool>)((out byte value2) =>
        {
            byte nextId = this.NextID;
            using (EverDriveN8ProConnector.CommandDefinition commandDefinition = new EverDriveN8ProConnector.CommandDefinition(EverDriveN8ProConnector.CommandDefinition.CommandType.Read, (ushort)address, (ushort)1))
            {
                this._read_waiters[nextId] = commandDefinition;
                if (!this.CodeInject(new byte[5]
            {
          nextId,
          (byte) 0,
          (byte) 1,
          (byte) address,
          (byte) (address >> 8)
            }.AppendChecksum()))
                {
                    value2 = (byte)0;
                    return false;
                }
                if (!commandDefinition.Waiter.Wait(TimeSpan.FromSeconds(1.0)))
                {
                    value2 = (byte)0;
                    return false;
                }
                value2 = commandDefinition.Value[0][0];
                return true;
            }
        }), out value1);

        public bool Write8(ulong address, byte value) => this.DoLimitedAction((Func<bool>)(() =>
        {
            byte nextId = this.NextID;
            using (EverDriveN8ProConnector.CommandDefinition commandDefinition = new EverDriveN8ProConnector.CommandDefinition(EverDriveN8ProConnector.CommandDefinition.CommandType.Read, (ushort)address, (ushort)1))
            {
                this._read_waiters[nextId] = commandDefinition;
                return this.CodeInject(new byte[6]
            {
          nextId,
          (byte) 2,
          (byte) 1,
          (byte) address,
          (byte) (address >> 8),
          value
            }.AppendChecksum()) && commandDefinition.Waiter.Wait(TimeSpan.FromSeconds(1.0));
            }
        }));

        public bool Freeze8(ulong address, byte value) => this.Freeze(address, (ulong)value, (byte)1, WriteType.WriteValue, 0UL, 0UL, (byte)1, CompareType.Always);

        public IFeatureAware Features { get; } = (IFeatureAware)new AllFeatures();

        public string GetROMPath() => string.Empty;

        public bool OpenROM(string path) => false;

        public bool CloseROM() => false;

        public bool PatchROM(IROMPatch patch) => false;

        private sealed class CommandDefinition : IDisposable
        {
            public readonly EverDriveN8ProConnector.CommandDefinition.CommandType Type;
            public readonly ushort[] Address;
            public readonly ushort[] Length;
            public readonly byte[][] Value;
            public readonly ManualResetEventSlim Waiter;

            ~CommandDefinition() => this.Dispose(false);

            public void Dispose()
            {
                this.Dispose(true);
                GC.SuppressFinalize((object)this);
            }

            private void Dispose(bool disposing)
            {
                if (!disposing)
                    return;
                this.Waiter?.Dispose();
            }

            public CommandDefinition(
              EverDriveN8ProConnector.CommandDefinition.CommandType type,
              ushort address,
              ushort length)
            {
                this.Type = type;
                this.Address = new ushort[1] { address };
                this.Length = new ushort[1] { length };
                this.Value = new byte[1][];
                this.Waiter = new ManualResetEventSlim(false);
            }

            public enum CommandType : byte
            {
                Read = 0,
                ReadArray = 1,
                Write = 2,
                WriteArray = 3,
                Freeze = 4,
                ReadPaletteArray = 17, // 0x11
                WritePaletteArray = 19, // 0x13
                Version = 254, // 0xFE
                Null = 255, // 0xFF
            }
        }

        private delegate TResult OutFunc<T, out TResult>(out T result);
    }
}
