﻿// Decompiled with JetBrains decompiler
// Type: FTD2XX_NET.FTDI
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Runtime.Serialization;
using System.Text;
using System.Threading;

namespace FTD2XX_NET
{
  public class FTDI
  {
    private const uint FT_OPEN_BY_SERIAL_NUMBER = 1;
    private const uint FT_OPEN_BY_DESCRIPTION = 2;
    private const uint FT_OPEN_BY_LOCATION = 4;
    private const uint FT_DEFAULT_BAUD_RATE = 9600;
    private const uint FT_DEFAULT_DEADMAN_TIMEOUT = 5000;
    private const int FT_COM_PORT_NOT_ASSIGNED = -1;
    private const uint FT_DEFAULT_IN_TRANSFER_SIZE = 4096;
    private const uint FT_DEFAULT_OUT_TRANSFER_SIZE = 4096;
    private const byte FT_DEFAULT_LATENCY = 16;
    private const uint FT_DEFAULT_DEVICE_ID = 67330049;
    private IntPtr ftHandle = IntPtr.Zero;
    private IntPtr hFTD2XXDLL = IntPtr.Zero;
    private IntPtr pFT_CreateDeviceInfoList = IntPtr.Zero;
    private IntPtr pFT_GetDeviceInfoDetail = IntPtr.Zero;
    private IntPtr pFT_Open = IntPtr.Zero;
    private IntPtr pFT_OpenEx = IntPtr.Zero;
    private IntPtr pFT_Close = IntPtr.Zero;
    private IntPtr pFT_Read = IntPtr.Zero;
    private IntPtr pFT_Write = IntPtr.Zero;
    private IntPtr pFT_GetQueueStatus = IntPtr.Zero;
    private IntPtr pFT_GetModemStatus = IntPtr.Zero;
    private IntPtr pFT_GetStatus = IntPtr.Zero;
    private IntPtr pFT_SetBaudRate = IntPtr.Zero;
    private IntPtr pFT_SetDataCharacteristics = IntPtr.Zero;
    private IntPtr pFT_SetFlowControl = IntPtr.Zero;
    private IntPtr pFT_SetDtr = IntPtr.Zero;
    private IntPtr pFT_ClrDtr = IntPtr.Zero;
    private IntPtr pFT_SetRts = IntPtr.Zero;
    private IntPtr pFT_ClrRts = IntPtr.Zero;
    private IntPtr pFT_ResetDevice = IntPtr.Zero;
    private IntPtr pFT_ResetPort = IntPtr.Zero;
    private IntPtr pFT_CyclePort = IntPtr.Zero;
    private IntPtr pFT_Rescan = IntPtr.Zero;
    private IntPtr pFT_Reload = IntPtr.Zero;
    private IntPtr pFT_Purge = IntPtr.Zero;
    private IntPtr pFT_SetTimeouts = IntPtr.Zero;
    private IntPtr pFT_SetBreakOn = IntPtr.Zero;
    private IntPtr pFT_SetBreakOff = IntPtr.Zero;
    private IntPtr pFT_GetDeviceInfo = IntPtr.Zero;
    private IntPtr pFT_SetResetPipeRetryCount = IntPtr.Zero;
    private IntPtr pFT_StopInTask = IntPtr.Zero;
    private IntPtr pFT_RestartInTask = IntPtr.Zero;
    private IntPtr pFT_GetDriverVersion = IntPtr.Zero;
    private IntPtr pFT_GetLibraryVersion = IntPtr.Zero;
    private IntPtr pFT_SetDeadmanTimeout = IntPtr.Zero;
    private IntPtr pFT_SetChars = IntPtr.Zero;
    private IntPtr pFT_SetEventNotification = IntPtr.Zero;
    private IntPtr pFT_GetComPortNumber = IntPtr.Zero;
    private IntPtr pFT_SetLatencyTimer = IntPtr.Zero;
    private IntPtr pFT_GetLatencyTimer = IntPtr.Zero;
    private IntPtr pFT_SetBitMode = IntPtr.Zero;
    private IntPtr pFT_GetBitMode = IntPtr.Zero;
    private IntPtr pFT_SetUSBParameters = IntPtr.Zero;
    private IntPtr pFT_ReadEE = IntPtr.Zero;
    private IntPtr pFT_WriteEE = IntPtr.Zero;
    private IntPtr pFT_EraseEE = IntPtr.Zero;
    private IntPtr pFT_EE_UASize = IntPtr.Zero;
    private IntPtr pFT_EE_UARead = IntPtr.Zero;
    private IntPtr pFT_EE_UAWrite = IntPtr.Zero;
    private IntPtr pFT_EE_Read = IntPtr.Zero;
    private IntPtr pFT_EE_Program = IntPtr.Zero;
    private IntPtr pFT_EEPROM_Read = IntPtr.Zero;
    private IntPtr pFT_EEPROM_Program = IntPtr.Zero;
    private IntPtr pFT_VendorCmdGet = IntPtr.Zero;
    private IntPtr pFT_VendorCmdSet = IntPtr.Zero;

    public FTDI()
    {
      if (this.hFTD2XXDLL == IntPtr.Zero)
      {
        this.hFTD2XXDLL = FTDI.LoadLibrary("FTD2XX.DLL");
        if (this.hFTD2XXDLL == IntPtr.Zero)
        {
          Console.WriteLine("Attempting to load FTD2XX.DLL from:\n" + Path.GetDirectoryName(this.GetType().Assembly.Location));
          this.hFTD2XXDLL = FTDI.LoadLibrary(Path.GetDirectoryName(this.GetType().Assembly.Location) + "\\FTD2XX.DLL");
        }
      }
      if (this.hFTD2XXDLL != IntPtr.Zero)
        this.FindFunctionPointers();
      else
        Console.WriteLine("Failed to load FTD2XX.DLL. Are the FTDI drivers installed?");
    }

    public FTDI(string path)
    {
      if (path == "")
        return;
      if (this.hFTD2XXDLL == IntPtr.Zero)
      {
        this.hFTD2XXDLL = FTDI.LoadLibrary(path);
        if (this.hFTD2XXDLL == IntPtr.Zero)
          Console.WriteLine("Attempting to load FTD2XX.DLL from:\n" + Path.GetDirectoryName(this.GetType().Assembly.Location));
      }
      if (this.hFTD2XXDLL != IntPtr.Zero)
        this.FindFunctionPointers();
      else
        Console.WriteLine("Failed to load FTD2XX.DLL. Are the FTDI drivers installed?");
    }

    private void FindFunctionPointers()
    {
      this.pFT_CreateDeviceInfoList = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_CreateDeviceInfoList");
      this.pFT_GetDeviceInfoDetail = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_GetDeviceInfoDetail");
      this.pFT_Open = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_Open");
      this.pFT_OpenEx = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_OpenEx");
      this.pFT_Close = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_Close");
      this.pFT_Read = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_Read");
      this.pFT_Write = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_Write");
      this.pFT_GetQueueStatus = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_GetQueueStatus");
      this.pFT_GetModemStatus = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_GetModemStatus");
      this.pFT_GetStatus = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_GetStatus");
      this.pFT_SetBaudRate = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetBaudRate");
      this.pFT_SetDataCharacteristics = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetDataCharacteristics");
      this.pFT_SetFlowControl = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetFlowControl");
      this.pFT_SetDtr = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetDtr");
      this.pFT_ClrDtr = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_ClrDtr");
      this.pFT_SetRts = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetRts");
      this.pFT_ClrRts = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_ClrRts");
      this.pFT_ResetDevice = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_ResetDevice");
      this.pFT_ResetPort = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_ResetPort");
      this.pFT_CyclePort = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_CyclePort");
      this.pFT_Rescan = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_Rescan");
      this.pFT_Reload = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_Reload");
      this.pFT_Purge = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_Purge");
      this.pFT_SetTimeouts = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetTimeouts");
      this.pFT_SetBreakOn = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetBreakOn");
      this.pFT_SetBreakOff = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetBreakOff");
      this.pFT_GetDeviceInfo = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_GetDeviceInfo");
      this.pFT_SetResetPipeRetryCount = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetResetPipeRetryCount");
      this.pFT_StopInTask = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_StopInTask");
      this.pFT_RestartInTask = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_RestartInTask");
      this.pFT_GetDriverVersion = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_GetDriverVersion");
      this.pFT_GetLibraryVersion = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_GetLibraryVersion");
      this.pFT_SetDeadmanTimeout = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetDeadmanTimeout");
      this.pFT_SetChars = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetChars");
      this.pFT_SetEventNotification = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetEventNotification");
      this.pFT_GetComPortNumber = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_GetComPortNumber");
      this.pFT_SetLatencyTimer = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetLatencyTimer");
      this.pFT_GetLatencyTimer = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_GetLatencyTimer");
      this.pFT_SetBitMode = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetBitMode");
      this.pFT_GetBitMode = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_GetBitMode");
      this.pFT_SetUSBParameters = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_SetUSBParameters");
      this.pFT_ReadEE = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_ReadEE");
      this.pFT_WriteEE = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_WriteEE");
      this.pFT_EraseEE = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_EraseEE");
      this.pFT_EE_UASize = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_EE_UASize");
      this.pFT_EE_UARead = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_EE_UARead");
      this.pFT_EE_UAWrite = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_EE_UAWrite");
      this.pFT_EE_Read = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_EE_Read");
      this.pFT_EE_Program = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_EE_Program");
      this.pFT_EEPROM_Read = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_EEPROM_Read");
      this.pFT_EEPROM_Program = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_EEPROM_Program");
      this.pFT_VendorCmdGet = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_VendorCmdGet");
      this.pFT_VendorCmdSet = FTDI.GetProcAddress(this.hFTD2XXDLL, "FT_VendorCmdSet");
    }

    ~FTDI()
    {
      FTDI.FreeLibrary(this.hFTD2XXDLL);
      this.hFTD2XXDLL = IntPtr.Zero;
    }

    [DllImport("kernel32.dll")]
    private static extern IntPtr LoadLibrary(string dllToLoad);

    [DllImport("kernel32.dll")]
    private static extern IntPtr GetProcAddress(IntPtr hModule, string procedureName);

    [DllImport("kernel32.dll")]
    private static extern bool FreeLibrary(IntPtr hModule);

    public FTDI.FT_STATUS GetNumberOfDevices(ref uint devcount)
    {
      FTDI.FT_STATUS numberOfDevices = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return numberOfDevices;
      if (this.pFT_CreateDeviceInfoList != IntPtr.Zero)
        numberOfDevices = ((FTDI.tFT_CreateDeviceInfoList) Marshal.GetDelegateForFunctionPointer(this.pFT_CreateDeviceInfoList, typeof (FTDI.tFT_CreateDeviceInfoList)))(ref devcount);
      else
        Console.WriteLine("Failed to load function FT_CreateDeviceInfoList.");
      return numberOfDevices;
    }

    public FTDI.FT_STATUS GetDeviceList(FTDI.FT_DEVICE_INFO_NODE[] devicelist)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_CreateDeviceInfoList != IntPtr.Zero & this.pFT_GetDeviceInfoDetail != IntPtr.Zero)
      {
        uint numdevs = 0;
        FTDI.tFT_CreateDeviceInfoList forFunctionPointer1 = (FTDI.tFT_CreateDeviceInfoList) Marshal.GetDelegateForFunctionPointer(this.pFT_CreateDeviceInfoList, typeof (FTDI.tFT_CreateDeviceInfoList));
        FTDI.tFT_GetDeviceInfoDetail forFunctionPointer2 = (FTDI.tFT_GetDeviceInfoDetail) Marshal.GetDelegateForFunctionPointer(this.pFT_GetDeviceInfoDetail, typeof (FTDI.tFT_GetDeviceInfoDetail));
        ftStatus = forFunctionPointer1(ref numdevs);
        byte[] numArray1 = new byte[16];
        byte[] numArray2 = new byte[64];
        if (numdevs > 0U)
        {
          if ((long) devicelist.Length < (long) numdevs)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_BUFFER_SIZE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          uint index = 0;
          while (index < numdevs)
          {
            devicelist[(int) index] = new FTDI.FT_DEVICE_INFO_NODE();
            ftStatus = forFunctionPointer2(index, ref devicelist[(int) index].Flags, ref devicelist[(int) index].Type, ref devicelist[(int) index].ID, ref devicelist[(int) index].LocId, numArray1, numArray2, ref devicelist[(int) index].ftHandle);
            devicelist[(int) index].SerialNumber = Encoding.ASCII.GetString(numArray1);
            devicelist[(int) index].Description = Encoding.ASCII.GetString(numArray2);
            int length1 = devicelist[(int) index].SerialNumber.IndexOf("\0");
            if (length1 != -1)
              devicelist[(int) index].SerialNumber = devicelist[(int) index].SerialNumber.Substring(0, length1);
            int length2 = devicelist[(int) index].Description.IndexOf("\0");
            if (length2 != -1)
              devicelist[(int) index].Description = devicelist[(int) index].Description.Substring(0, length2);
            checked { ++index; }
          }
        }
      }
      else
      {
        if (this.pFT_CreateDeviceInfoList == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_CreateDeviceInfoList.");
        if (this.pFT_GetDeviceInfoDetail == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_GetDeviceInfoListDetail.");
      }
      return ftStatus;
    }

    public FTDI.FT_STATUS OpenByIndex(uint index)
    {
      FTDI.FT_STATUS ftStatus1 = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus1;
      if (this.pFT_Open != IntPtr.Zero & this.pFT_SetDataCharacteristics != IntPtr.Zero & this.pFT_SetFlowControl != IntPtr.Zero & this.pFT_SetBaudRate != IntPtr.Zero)
      {
        FTDI.tFT_Open forFunctionPointer1 = (FTDI.tFT_Open) Marshal.GetDelegateForFunctionPointer(this.pFT_Open, typeof (FTDI.tFT_Open));
        FTDI.tFT_SetDataCharacteristics forFunctionPointer2 = (FTDI.tFT_SetDataCharacteristics) Marshal.GetDelegateForFunctionPointer(this.pFT_SetDataCharacteristics, typeof (FTDI.tFT_SetDataCharacteristics));
        FTDI.tFT_SetFlowControl forFunctionPointer3 = (FTDI.tFT_SetFlowControl) Marshal.GetDelegateForFunctionPointer(this.pFT_SetFlowControl, typeof (FTDI.tFT_SetFlowControl));
        FTDI.tFT_SetBaudRate forFunctionPointer4 = (FTDI.tFT_SetBaudRate) Marshal.GetDelegateForFunctionPointer(this.pFT_SetBaudRate, typeof (FTDI.tFT_SetBaudRate));
        ftStatus1 = forFunctionPointer1(index, ref this.ftHandle);
        if (ftStatus1 != FTDI.FT_STATUS.FT_OK)
          this.ftHandle = IntPtr.Zero;
        if (this.ftHandle != IntPtr.Zero)
        {
          byte uWordLength = 8;
          byte uStopBits = 0;
          byte uParity = 0;
          FTDI.FT_STATUS ftStatus2 = forFunctionPointer2(this.ftHandle, uWordLength, uStopBits, uParity);
          ushort usFlowControl = 0;
          byte uXon = 17;
          byte uXoff = 19;
          ftStatus2 = forFunctionPointer3(this.ftHandle, usFlowControl, uXon, uXoff);
          uint dwBaudRate = 9600;
          ftStatus1 = forFunctionPointer4(this.ftHandle, dwBaudRate);
        }
      }
      else
      {
        if (this.pFT_Open == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_Open.");
        if (this.pFT_SetDataCharacteristics == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetDataCharacteristics.");
        if (this.pFT_SetFlowControl == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetFlowControl.");
        if (this.pFT_SetBaudRate == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetBaudRate.");
      }
      return ftStatus1;
    }

    public FTDI.FT_STATUS OpenBySerialNumber(string serialnumber)
    {
      FTDI.FT_STATUS ftStatus1 = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus1;
      if (this.pFT_OpenEx != IntPtr.Zero & this.pFT_SetDataCharacteristics != IntPtr.Zero & this.pFT_SetFlowControl != IntPtr.Zero & this.pFT_SetBaudRate != IntPtr.Zero)
      {
        FTDI.tFT_OpenEx forFunctionPointer1 = (FTDI.tFT_OpenEx) Marshal.GetDelegateForFunctionPointer(this.pFT_OpenEx, typeof (FTDI.tFT_OpenEx));
        FTDI.tFT_SetDataCharacteristics forFunctionPointer2 = (FTDI.tFT_SetDataCharacteristics) Marshal.GetDelegateForFunctionPointer(this.pFT_SetDataCharacteristics, typeof (FTDI.tFT_SetDataCharacteristics));
        FTDI.tFT_SetFlowControl forFunctionPointer3 = (FTDI.tFT_SetFlowControl) Marshal.GetDelegateForFunctionPointer(this.pFT_SetFlowControl, typeof (FTDI.tFT_SetFlowControl));
        FTDI.tFT_SetBaudRate forFunctionPointer4 = (FTDI.tFT_SetBaudRate) Marshal.GetDelegateForFunctionPointer(this.pFT_SetBaudRate, typeof (FTDI.tFT_SetBaudRate));
        ftStatus1 = forFunctionPointer1(serialnumber, 1U, ref this.ftHandle);
        if (ftStatus1 != FTDI.FT_STATUS.FT_OK)
          this.ftHandle = IntPtr.Zero;
        if (this.ftHandle != IntPtr.Zero)
        {
          byte uWordLength = 8;
          byte uStopBits = 0;
          byte uParity = 0;
          FTDI.FT_STATUS ftStatus2 = forFunctionPointer2(this.ftHandle, uWordLength, uStopBits, uParity);
          ushort usFlowControl = 0;
          byte uXon = 17;
          byte uXoff = 19;
          ftStatus2 = forFunctionPointer3(this.ftHandle, usFlowControl, uXon, uXoff);
          uint dwBaudRate = 9600;
          ftStatus1 = forFunctionPointer4(this.ftHandle, dwBaudRate);
        }
      }
      else
      {
        if (this.pFT_OpenEx == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_OpenEx.");
        if (this.pFT_SetDataCharacteristics == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetDataCharacteristics.");
        if (this.pFT_SetFlowControl == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetFlowControl.");
        if (this.pFT_SetBaudRate == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetBaudRate.");
      }
      return ftStatus1;
    }

    public FTDI.FT_STATUS OpenByDescription(string description)
    {
      FTDI.FT_STATUS ftStatus1 = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus1;
      if (this.pFT_OpenEx != IntPtr.Zero & this.pFT_SetDataCharacteristics != IntPtr.Zero & this.pFT_SetFlowControl != IntPtr.Zero & this.pFT_SetBaudRate != IntPtr.Zero)
      {
        FTDI.tFT_OpenEx forFunctionPointer1 = (FTDI.tFT_OpenEx) Marshal.GetDelegateForFunctionPointer(this.pFT_OpenEx, typeof (FTDI.tFT_OpenEx));
        FTDI.tFT_SetDataCharacteristics forFunctionPointer2 = (FTDI.tFT_SetDataCharacteristics) Marshal.GetDelegateForFunctionPointer(this.pFT_SetDataCharacteristics, typeof (FTDI.tFT_SetDataCharacteristics));
        FTDI.tFT_SetFlowControl forFunctionPointer3 = (FTDI.tFT_SetFlowControl) Marshal.GetDelegateForFunctionPointer(this.pFT_SetFlowControl, typeof (FTDI.tFT_SetFlowControl));
        FTDI.tFT_SetBaudRate forFunctionPointer4 = (FTDI.tFT_SetBaudRate) Marshal.GetDelegateForFunctionPointer(this.pFT_SetBaudRate, typeof (FTDI.tFT_SetBaudRate));
        ftStatus1 = forFunctionPointer1(description, 2U, ref this.ftHandle);
        if (ftStatus1 != FTDI.FT_STATUS.FT_OK)
          this.ftHandle = IntPtr.Zero;
        if (this.ftHandle != IntPtr.Zero)
        {
          byte uWordLength = 8;
          byte uStopBits = 0;
          byte uParity = 0;
          FTDI.FT_STATUS ftStatus2 = forFunctionPointer2(this.ftHandle, uWordLength, uStopBits, uParity);
          ushort usFlowControl = 0;
          byte uXon = 17;
          byte uXoff = 19;
          ftStatus2 = forFunctionPointer3(this.ftHandle, usFlowControl, uXon, uXoff);
          uint dwBaudRate = 9600;
          ftStatus1 = forFunctionPointer4(this.ftHandle, dwBaudRate);
        }
      }
      else
      {
        if (this.pFT_OpenEx == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_OpenEx.");
        if (this.pFT_SetDataCharacteristics == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetDataCharacteristics.");
        if (this.pFT_SetFlowControl == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetFlowControl.");
        if (this.pFT_SetBaudRate == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetBaudRate.");
      }
      return ftStatus1;
    }

    public FTDI.FT_STATUS OpenByLocation(uint location)
    {
      FTDI.FT_STATUS ftStatus1 = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus1;
      if (this.pFT_OpenEx != IntPtr.Zero & this.pFT_SetDataCharacteristics != IntPtr.Zero & this.pFT_SetFlowControl != IntPtr.Zero & this.pFT_SetBaudRate != IntPtr.Zero)
      {
        FTDI.tFT_OpenExLoc forFunctionPointer1 = (FTDI.tFT_OpenExLoc) Marshal.GetDelegateForFunctionPointer(this.pFT_OpenEx, typeof (FTDI.tFT_OpenExLoc));
        FTDI.tFT_SetDataCharacteristics forFunctionPointer2 = (FTDI.tFT_SetDataCharacteristics) Marshal.GetDelegateForFunctionPointer(this.pFT_SetDataCharacteristics, typeof (FTDI.tFT_SetDataCharacteristics));
        FTDI.tFT_SetFlowControl forFunctionPointer3 = (FTDI.tFT_SetFlowControl) Marshal.GetDelegateForFunctionPointer(this.pFT_SetFlowControl, typeof (FTDI.tFT_SetFlowControl));
        FTDI.tFT_SetBaudRate forFunctionPointer4 = (FTDI.tFT_SetBaudRate) Marshal.GetDelegateForFunctionPointer(this.pFT_SetBaudRate, typeof (FTDI.tFT_SetBaudRate));
        ftStatus1 = forFunctionPointer1(location, 4U, ref this.ftHandle);
        if (ftStatus1 != FTDI.FT_STATUS.FT_OK)
          this.ftHandle = IntPtr.Zero;
        if (this.ftHandle != IntPtr.Zero)
        {
          byte uWordLength = 8;
          byte uStopBits = 0;
          byte uParity = 0;
          FTDI.FT_STATUS ftStatus2 = forFunctionPointer2(this.ftHandle, uWordLength, uStopBits, uParity);
          ushort usFlowControl = 0;
          byte uXon = 17;
          byte uXoff = 19;
          ftStatus2 = forFunctionPointer3(this.ftHandle, usFlowControl, uXon, uXoff);
          uint dwBaudRate = 9600;
          ftStatus1 = forFunctionPointer4(this.ftHandle, dwBaudRate);
        }
      }
      else
      {
        if (this.pFT_OpenEx == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_OpenEx.");
        if (this.pFT_SetDataCharacteristics == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetDataCharacteristics.");
        if (this.pFT_SetFlowControl == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetFlowControl.");
        if (this.pFT_SetBaudRate == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetBaudRate.");
      }
      return ftStatus1;
    }

    public FTDI.FT_STATUS Close()
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_Close != IntPtr.Zero)
      {
        ftStatus = ((FTDI.tFT_Close) Marshal.GetDelegateForFunctionPointer(this.pFT_Close, typeof (FTDI.tFT_Close)))(this.ftHandle);
        if (ftStatus == FTDI.FT_STATUS.FT_OK)
          this.ftHandle = IntPtr.Zero;
      }
      else if (this.pFT_Close == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_Close.");
      return ftStatus;
    }

    public FTDI.FT_STATUS Read(byte[] dataBuffer, uint numBytesToRead, out uint numBytesRead)
    {
      numBytesRead = 0U;
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_Read != IntPtr.Zero)
      {
        FTDI.tFT_Read forFunctionPointer = (FTDI.tFT_Read) Marshal.GetDelegateForFunctionPointer(this.pFT_Read, typeof (FTDI.tFT_Read));
        if ((long) dataBuffer.Length < (long) numBytesToRead)
          numBytesToRead = checked ((uint) dataBuffer.Length);
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, dataBuffer, numBytesToRead, ref numBytesRead);
      }
      else if (this.pFT_Read == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_Read.");
      return ftStatus;
    }

    public FTDI.FT_STATUS Read(
      out string dataBuffer,
      uint numBytesToRead,
      out uint numBytesRead)
    {
      numBytesRead = 0U;
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      dataBuffer = string.Empty;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_Read != IntPtr.Zero)
      {
        FTDI.tFT_Read forFunctionPointer = (FTDI.tFT_Read) Marshal.GetDelegateForFunctionPointer(this.pFT_Read, typeof (FTDI.tFT_Read));
        byte[] numArray = new byte[(int) numBytesToRead];
        if (this.ftHandle != IntPtr.Zero)
        {
          ftStatus = forFunctionPointer(this.ftHandle, numArray, numBytesToRead, ref numBytesRead);
          dataBuffer = Encoding.ASCII.GetString(numArray);
          dataBuffer = dataBuffer.Substring(0, checked ((int) numBytesRead));
        }
      }
      else if (this.pFT_Read == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_Read.");
      return ftStatus;
    }

    public FTDI.FT_STATUS Write(
      byte[] dataBuffer,
      int numBytesToWrite,
      out uint numBytesWritten)
    {
      numBytesWritten = 0U;
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_Write != IntPtr.Zero)
      {
        FTDI.tFT_Write forFunctionPointer = (FTDI.tFT_Write) Marshal.GetDelegateForFunctionPointer(this.pFT_Write, typeof (FTDI.tFT_Write));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, dataBuffer, checked ((uint) numBytesToWrite), ref numBytesWritten);
      }
      else if (this.pFT_Write == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_Write.");
      return ftStatus;
    }

    public FTDI.FT_STATUS Write(
      byte[] dataBuffer,
      uint numBytesToWrite,
      out uint numBytesWritten)
    {
      numBytesWritten = 0U;
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_Write != IntPtr.Zero)
      {
        FTDI.tFT_Write forFunctionPointer = (FTDI.tFT_Write) Marshal.GetDelegateForFunctionPointer(this.pFT_Write, typeof (FTDI.tFT_Write));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, dataBuffer, numBytesToWrite, ref numBytesWritten);
      }
      else if (this.pFT_Write == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_Write.");
      return ftStatus;
    }

    public FTDI.FT_STATUS Write(
      string dataBuffer,
      int numBytesToWrite,
      out uint numBytesWritten)
    {
      numBytesWritten = 0U;
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_Write != IntPtr.Zero)
      {
        FTDI.tFT_Write forFunctionPointer = (FTDI.tFT_Write) Marshal.GetDelegateForFunctionPointer(this.pFT_Write, typeof (FTDI.tFT_Write));
        byte[] bytes = Encoding.ASCII.GetBytes(dataBuffer);
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, bytes, checked ((uint) numBytesToWrite), ref numBytesWritten);
      }
      else if (this.pFT_Write == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_Write.");
      return ftStatus;
    }

    public FTDI.FT_STATUS Write(
      string dataBuffer,
      uint numBytesToWrite,
      out uint numBytesWritten)
    {
      numBytesWritten = 0U;
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_Write != IntPtr.Zero)
      {
        FTDI.tFT_Write forFunctionPointer = (FTDI.tFT_Write) Marshal.GetDelegateForFunctionPointer(this.pFT_Write, typeof (FTDI.tFT_Write));
        byte[] bytes = Encoding.ASCII.GetBytes(dataBuffer);
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, bytes, numBytesToWrite, ref numBytesWritten);
      }
      else if (this.pFT_Write == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_Write.");
      return ftStatus;
    }

    public FTDI.FT_STATUS ResetDevice()
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_ResetDevice != IntPtr.Zero)
      {
        FTDI.tFT_ResetDevice forFunctionPointer = (FTDI.tFT_ResetDevice) Marshal.GetDelegateForFunctionPointer(this.pFT_ResetDevice, typeof (FTDI.tFT_ResetDevice));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle);
      }
      else if (this.pFT_ResetDevice == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_ResetDevice.");
      return ftStatus;
    }

    public FTDI.FT_STATUS Purge(uint purgemask)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_Purge != IntPtr.Zero)
      {
        FTDI.tFT_Purge forFunctionPointer = (FTDI.tFT_Purge) Marshal.GetDelegateForFunctionPointer(this.pFT_Purge, typeof (FTDI.tFT_Purge));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, purgemask);
      }
      else if (this.pFT_Purge == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_Purge.");
      return ftStatus;
    }

    public FTDI.FT_STATUS SetEventNotification(uint eventmask, EventWaitHandle eventhandle)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetEventNotification != IntPtr.Zero)
      {
        FTDI.tFT_SetEventNotification forFunctionPointer = (FTDI.tFT_SetEventNotification) Marshal.GetDelegateForFunctionPointer(this.pFT_SetEventNotification, typeof (FTDI.tFT_SetEventNotification));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, eventmask, (SafeHandle) eventhandle.SafeWaitHandle);
      }
      else if (this.pFT_SetEventNotification == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_SetEventNotification.");
      return ftStatus;
    }

    public FTDI.FT_STATUS StopInTask()
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_StopInTask != IntPtr.Zero)
      {
        FTDI.tFT_StopInTask forFunctionPointer = (FTDI.tFT_StopInTask) Marshal.GetDelegateForFunctionPointer(this.pFT_StopInTask, typeof (FTDI.tFT_StopInTask));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle);
      }
      else if (this.pFT_StopInTask == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_StopInTask.");
      return ftStatus;
    }

    public FTDI.FT_STATUS RestartInTask()
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_RestartInTask != IntPtr.Zero)
      {
        FTDI.tFT_RestartInTask forFunctionPointer = (FTDI.tFT_RestartInTask) Marshal.GetDelegateForFunctionPointer(this.pFT_RestartInTask, typeof (FTDI.tFT_RestartInTask));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle);
      }
      else if (this.pFT_RestartInTask == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_RestartInTask.");
      return ftStatus;
    }

    public FTDI.FT_STATUS ResetPort()
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_ResetPort != IntPtr.Zero)
      {
        FTDI.tFT_ResetPort forFunctionPointer = (FTDI.tFT_ResetPort) Marshal.GetDelegateForFunctionPointer(this.pFT_ResetPort, typeof (FTDI.tFT_ResetPort));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle);
      }
      else if (this.pFT_ResetPort == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_ResetPort.");
      return ftStatus;
    }

    public FTDI.FT_STATUS CyclePort()
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_CyclePort != IntPtr.Zero & this.pFT_Close != IntPtr.Zero)
      {
        FTDI.tFT_CyclePort forFunctionPointer1 = (FTDI.tFT_CyclePort) Marshal.GetDelegateForFunctionPointer(this.pFT_CyclePort, typeof (FTDI.tFT_CyclePort));
        FTDI.tFT_Close forFunctionPointer2 = (FTDI.tFT_Close) Marshal.GetDelegateForFunctionPointer(this.pFT_Close, typeof (FTDI.tFT_Close));
        if (this.ftHandle != IntPtr.Zero)
        {
          ftStatus = forFunctionPointer1(this.ftHandle);
          if (ftStatus == FTDI.FT_STATUS.FT_OK)
          {
            ftStatus = forFunctionPointer2(this.ftHandle);
            if (ftStatus == FTDI.FT_STATUS.FT_OK)
              this.ftHandle = IntPtr.Zero;
          }
        }
      }
      else
      {
        if (this.pFT_CyclePort == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_CyclePort.");
        if (this.pFT_Close == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_Close.");
      }
      return ftStatus;
    }

    public FTDI.FT_STATUS Rescan()
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_Rescan != IntPtr.Zero)
        ftStatus = ((FTDI.tFT_Rescan) Marshal.GetDelegateForFunctionPointer(this.pFT_Rescan, typeof (FTDI.tFT_Rescan)))();
      else if (this.pFT_Rescan == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_Rescan.");
      return ftStatus;
    }

    public FTDI.FT_STATUS Reload(ushort VendorID, ushort ProductID)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_Reload != IntPtr.Zero)
        ftStatus = ((FTDI.tFT_Reload) Marshal.GetDelegateForFunctionPointer(this.pFT_Reload, typeof (FTDI.tFT_Reload)))(VendorID, ProductID);
      else if (this.pFT_Reload == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_Reload.");
      return ftStatus;
    }

    public FTDI.FT_STATUS SetBitMode(byte Mask, byte BitMode)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetBitMode != IntPtr.Zero)
      {
        FTDI.tFT_SetBitMode forFunctionPointer = (FTDI.tFT_SetBitMode) Marshal.GetDelegateForFunctionPointer(this.pFT_SetBitMode, typeof (FTDI.tFT_SetBitMode));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          switch (DeviceType)
          {
            case FTDI.FT_DEVICE.FT_DEVICE_AM:
              FTDI.FT_ERROR ftErrorCondition1 = FTDI.FT_ERROR.FT_INVALID_BITMODE;
              this.ErrorHandler(ftStatus, ftErrorCondition1);
              break;
            case FTDI.FT_DEVICE.FT_DEVICE_100AX:
              FTDI.FT_ERROR ftErrorCondition2 = FTDI.FT_ERROR.FT_INVALID_BITMODE;
              this.ErrorHandler(ftStatus, ftErrorCondition2);
              break;
            default:
              if (DeviceType == FTDI.FT_DEVICE.FT_DEVICE_BM && BitMode != (byte) 0)
              {
                if (((int) BitMode & 1) == 0)
                {
                  FTDI.FT_ERROR ftErrorCondition3 = FTDI.FT_ERROR.FT_INVALID_BITMODE;
                  this.ErrorHandler(ftStatus, ftErrorCondition3);
                  break;
                }
                break;
              }
              if (DeviceType == FTDI.FT_DEVICE.FT_DEVICE_2232 && BitMode != (byte) 0)
              {
                if (((int) BitMode & 31) == 0)
                {
                  FTDI.FT_ERROR ftErrorCondition4 = FTDI.FT_ERROR.FT_INVALID_BITMODE;
                  this.ErrorHandler(ftStatus, ftErrorCondition4);
                }
                if (BitMode == (byte) 2 & this.InterfaceIdentifier != "A")
                {
                  FTDI.FT_ERROR ftErrorCondition5 = FTDI.FT_ERROR.FT_INVALID_BITMODE;
                  this.ErrorHandler(ftStatus, ftErrorCondition5);
                  break;
                }
                break;
              }
              if (DeviceType == FTDI.FT_DEVICE.FT_DEVICE_232R && BitMode != (byte) 0)
              {
                if (((int) BitMode & 37) == 0)
                {
                  FTDI.FT_ERROR ftErrorCondition6 = FTDI.FT_ERROR.FT_INVALID_BITMODE;
                  this.ErrorHandler(ftStatus, ftErrorCondition6);
                  break;
                }
                break;
              }
              if (DeviceType == FTDI.FT_DEVICE.FT_DEVICE_2232H && BitMode != (byte) 0)
              {
                if (((int) BitMode & 95) == 0)
                {
                  FTDI.FT_ERROR ftErrorCondition7 = FTDI.FT_ERROR.FT_INVALID_BITMODE;
                  this.ErrorHandler(ftStatus, ftErrorCondition7);
                }
                if ((BitMode == (byte) 8 | BitMode == (byte) 64) & this.InterfaceIdentifier != "A")
                {
                  FTDI.FT_ERROR ftErrorCondition8 = FTDI.FT_ERROR.FT_INVALID_BITMODE;
                  this.ErrorHandler(ftStatus, ftErrorCondition8);
                  break;
                }
                break;
              }
              if (DeviceType == FTDI.FT_DEVICE.FT_DEVICE_4232H && BitMode != (byte) 0)
              {
                if (((int) BitMode & 7) == 0)
                {
                  FTDI.FT_ERROR ftErrorCondition9 = FTDI.FT_ERROR.FT_INVALID_BITMODE;
                  this.ErrorHandler(ftStatus, ftErrorCondition9);
                }
                if (BitMode == (byte) 2 & this.InterfaceIdentifier != "A" & this.InterfaceIdentifier != "B")
                {
                  FTDI.FT_ERROR ftErrorCondition10 = FTDI.FT_ERROR.FT_INVALID_BITMODE;
                  this.ErrorHandler(ftStatus, ftErrorCondition10);
                  break;
                }
                break;
              }
              if (DeviceType == FTDI.FT_DEVICE.FT_DEVICE_232H && BitMode != (byte) 0 && BitMode > (byte) 64)
              {
                FTDI.FT_ERROR ftErrorCondition11 = FTDI.FT_ERROR.FT_INVALID_BITMODE;
                this.ErrorHandler(ftStatus, ftErrorCondition11);
                break;
              }
              break;
          }
          ftStatus = forFunctionPointer(this.ftHandle, Mask, BitMode);
        }
      }
      else if (this.pFT_SetBitMode == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_SetBitMode.");
      return ftStatus;
    }

    public FTDI.FT_STATUS GetPinStates(ref byte BitMode)
    {
      FTDI.FT_STATUS pinStates = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return pinStates;
      if (this.pFT_GetBitMode != IntPtr.Zero)
      {
        FTDI.tFT_GetBitMode forFunctionPointer = (FTDI.tFT_GetBitMode) Marshal.GetDelegateForFunctionPointer(this.pFT_GetBitMode, typeof (FTDI.tFT_GetBitMode));
        if (this.ftHandle != IntPtr.Zero)
          pinStates = forFunctionPointer(this.ftHandle, ref BitMode);
      }
      else if (this.pFT_GetBitMode == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetBitMode.");
      return pinStates;
    }

    public FTDI.FT_STATUS ReadEEPROMLocation(uint Address, ref ushort EEValue)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_ReadEE != IntPtr.Zero)
      {
        FTDI.tFT_ReadEE forFunctionPointer = (FTDI.tFT_ReadEE) Marshal.GetDelegateForFunctionPointer(this.pFT_ReadEE, typeof (FTDI.tFT_ReadEE));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, Address, ref EEValue);
      }
      else if (this.pFT_ReadEE == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_ReadEE.");
      return ftStatus;
    }

    public FTDI.FT_STATUS WriteEEPROMLocation(uint Address, ushort EEValue)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_WriteEE != IntPtr.Zero)
      {
        FTDI.tFT_WriteEE forFunctionPointer = (FTDI.tFT_WriteEE) Marshal.GetDelegateForFunctionPointer(this.pFT_WriteEE, typeof (FTDI.tFT_WriteEE));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, Address, EEValue);
      }
      else if (this.pFT_WriteEE == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_WriteEE.");
      return ftStatus;
    }

    public FTDI.FT_STATUS EraseEEPROM()
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EraseEE != IntPtr.Zero)
      {
        FTDI.tFT_EraseEE forFunctionPointer = (FTDI.tFT_EraseEE) Marshal.GetDelegateForFunctionPointer(this.pFT_EraseEE, typeof (FTDI.tFT_EraseEE));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType == FTDI.FT_DEVICE.FT_DEVICE_232R)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          ftStatus = forFunctionPointer(this.ftHandle);
        }
      }
      else if (this.pFT_EraseEE == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EraseEE.");
      return ftStatus;
    }

    public FTDI.FT_STATUS ReadFT232BEEPROM(FTDI.FT232B_EEPROM_STRUCTURE ee232b)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Read != IntPtr.Zero)
      {
        FTDI.tFT_EE_Read forFunctionPointer = (FTDI.tFT_EE_Read) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Read, typeof (FTDI.tFT_EE_Read));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_BM)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 2U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          ee232b.Manufacturer = Marshal.PtrToStringAnsi(pData.Manufacturer);
          ee232b.ManufacturerID = Marshal.PtrToStringAnsi(pData.ManufacturerID);
          ee232b.Description = Marshal.PtrToStringAnsi(pData.Description);
          ee232b.SerialNumber = Marshal.PtrToStringAnsi(pData.SerialNumber);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
          ee232b.VendorID = pData.VendorID;
          ee232b.ProductID = pData.ProductID;
          ee232b.MaxPower = pData.MaxPower;
          ee232b.SelfPowered = Convert.ToBoolean(pData.SelfPowered);
          ee232b.RemoteWakeup = Convert.ToBoolean(pData.RemoteWakeup);
          ee232b.PullDownEnable = Convert.ToBoolean(pData.PullDownEnable);
          ee232b.SerNumEnable = Convert.ToBoolean(pData.SerNumEnable);
          ee232b.USBVersionEnable = Convert.ToBoolean(pData.USBVersionEnable);
          ee232b.USBVersion = pData.USBVersion;
        }
      }
      else if (this.pFT_EE_Read == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Read.");
      return ftStatus;
    }

    public FTDI.FT_STATUS ReadFT2232EEPROM(FTDI.FT2232_EEPROM_STRUCTURE ee2232)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Read != IntPtr.Zero)
      {
        FTDI.tFT_EE_Read forFunctionPointer = (FTDI.tFT_EE_Read) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Read, typeof (FTDI.tFT_EE_Read));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_2232)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 2U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          ee2232.Manufacturer = Marshal.PtrToStringAnsi(pData.Manufacturer);
          ee2232.ManufacturerID = Marshal.PtrToStringAnsi(pData.ManufacturerID);
          ee2232.Description = Marshal.PtrToStringAnsi(pData.Description);
          ee2232.SerialNumber = Marshal.PtrToStringAnsi(pData.SerialNumber);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
          ee2232.VendorID = pData.VendorID;
          ee2232.ProductID = pData.ProductID;
          ee2232.MaxPower = pData.MaxPower;
          ee2232.SelfPowered = Convert.ToBoolean(pData.SelfPowered);
          ee2232.RemoteWakeup = Convert.ToBoolean(pData.RemoteWakeup);
          ee2232.PullDownEnable = Convert.ToBoolean(pData.PullDownEnable5);
          ee2232.SerNumEnable = Convert.ToBoolean(pData.SerNumEnable5);
          ee2232.USBVersionEnable = Convert.ToBoolean(pData.USBVersionEnable5);
          ee2232.USBVersion = pData.USBVersion5;
          ee2232.AIsHighCurrent = Convert.ToBoolean(pData.AIsHighCurrent);
          ee2232.BIsHighCurrent = Convert.ToBoolean(pData.BIsHighCurrent);
          ee2232.IFAIsFifo = Convert.ToBoolean(pData.IFAIsFifo);
          ee2232.IFAIsFifoTar = Convert.ToBoolean(pData.IFAIsFifoTar);
          ee2232.IFAIsFastSer = Convert.ToBoolean(pData.IFAIsFastSer);
          ee2232.AIsVCP = Convert.ToBoolean(pData.AIsVCP);
          ee2232.IFBIsFifo = Convert.ToBoolean(pData.IFBIsFifo);
          ee2232.IFBIsFifoTar = Convert.ToBoolean(pData.IFBIsFifoTar);
          ee2232.IFBIsFastSer = Convert.ToBoolean(pData.IFBIsFastSer);
          ee2232.BIsVCP = Convert.ToBoolean(pData.BIsVCP);
        }
      }
      else if (this.pFT_EE_Read == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Read.");
      return ftStatus;
    }

    public FTDI.FT_STATUS ReadFT232REEPROM(FTDI.FT232R_EEPROM_STRUCTURE ee232r)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Read != IntPtr.Zero)
      {
        FTDI.tFT_EE_Read forFunctionPointer = (FTDI.tFT_EE_Read) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Read, typeof (FTDI.tFT_EE_Read));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_232R)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 2U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          ee232r.Manufacturer = Marshal.PtrToStringAnsi(pData.Manufacturer);
          ee232r.ManufacturerID = Marshal.PtrToStringAnsi(pData.ManufacturerID);
          ee232r.Description = Marshal.PtrToStringAnsi(pData.Description);
          ee232r.SerialNumber = Marshal.PtrToStringAnsi(pData.SerialNumber);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
          ee232r.VendorID = pData.VendorID;
          ee232r.ProductID = pData.ProductID;
          ee232r.MaxPower = pData.MaxPower;
          ee232r.SelfPowered = Convert.ToBoolean(pData.SelfPowered);
          ee232r.RemoteWakeup = Convert.ToBoolean(pData.RemoteWakeup);
          ee232r.UseExtOsc = Convert.ToBoolean(pData.UseExtOsc);
          ee232r.HighDriveIOs = Convert.ToBoolean(pData.HighDriveIOs);
          ee232r.EndpointSize = pData.EndpointSize;
          ee232r.PullDownEnable = Convert.ToBoolean(pData.PullDownEnableR);
          ee232r.SerNumEnable = Convert.ToBoolean(pData.SerNumEnableR);
          ee232r.InvertTXD = Convert.ToBoolean(pData.InvertTXD);
          ee232r.InvertRXD = Convert.ToBoolean(pData.InvertRXD);
          ee232r.InvertRTS = Convert.ToBoolean(pData.InvertRTS);
          ee232r.InvertCTS = Convert.ToBoolean(pData.InvertCTS);
          ee232r.InvertDTR = Convert.ToBoolean(pData.InvertDTR);
          ee232r.InvertDSR = Convert.ToBoolean(pData.InvertDSR);
          ee232r.InvertDCD = Convert.ToBoolean(pData.InvertDCD);
          ee232r.InvertRI = Convert.ToBoolean(pData.InvertRI);
          ee232r.Cbus0 = pData.Cbus0;
          ee232r.Cbus1 = pData.Cbus1;
          ee232r.Cbus2 = pData.Cbus2;
          ee232r.Cbus3 = pData.Cbus3;
          ee232r.Cbus4 = pData.Cbus4;
          ee232r.RIsD2XX = Convert.ToBoolean(pData.RIsD2XX);
        }
      }
      else if (this.pFT_EE_Read == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Read.");
      return ftStatus;
    }

    public FTDI.FT_STATUS ReadFT2232HEEPROM(FTDI.FT2232H_EEPROM_STRUCTURE ee2232h)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Read != IntPtr.Zero)
      {
        FTDI.tFT_EE_Read forFunctionPointer = (FTDI.tFT_EE_Read) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Read, typeof (FTDI.tFT_EE_Read));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_2232H)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 3U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          ee2232h.Manufacturer = Marshal.PtrToStringAnsi(pData.Manufacturer);
          ee2232h.ManufacturerID = Marshal.PtrToStringAnsi(pData.ManufacturerID);
          ee2232h.Description = Marshal.PtrToStringAnsi(pData.Description);
          ee2232h.SerialNumber = Marshal.PtrToStringAnsi(pData.SerialNumber);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
          ee2232h.VendorID = pData.VendorID;
          ee2232h.ProductID = pData.ProductID;
          ee2232h.MaxPower = pData.MaxPower;
          ee2232h.SelfPowered = Convert.ToBoolean(pData.SelfPowered);
          ee2232h.RemoteWakeup = Convert.ToBoolean(pData.RemoteWakeup);
          ee2232h.PullDownEnable = Convert.ToBoolean(pData.PullDownEnable7);
          ee2232h.SerNumEnable = Convert.ToBoolean(pData.SerNumEnable7);
          ee2232h.ALSlowSlew = Convert.ToBoolean(pData.ALSlowSlew);
          ee2232h.ALSchmittInput = Convert.ToBoolean(pData.ALSchmittInput);
          ee2232h.ALDriveCurrent = pData.ALDriveCurrent;
          ee2232h.AHSlowSlew = Convert.ToBoolean(pData.AHSlowSlew);
          ee2232h.AHSchmittInput = Convert.ToBoolean(pData.AHSchmittInput);
          ee2232h.AHDriveCurrent = pData.AHDriveCurrent;
          ee2232h.BLSlowSlew = Convert.ToBoolean(pData.BLSlowSlew);
          ee2232h.BLSchmittInput = Convert.ToBoolean(pData.BLSchmittInput);
          ee2232h.BLDriveCurrent = pData.BLDriveCurrent;
          ee2232h.BHSlowSlew = Convert.ToBoolean(pData.BHSlowSlew);
          ee2232h.BHSchmittInput = Convert.ToBoolean(pData.BHSchmittInput);
          ee2232h.BHDriveCurrent = pData.BHDriveCurrent;
          ee2232h.IFAIsFifo = Convert.ToBoolean(pData.IFAIsFifo7);
          ee2232h.IFAIsFifoTar = Convert.ToBoolean(pData.IFAIsFifoTar7);
          ee2232h.IFAIsFastSer = Convert.ToBoolean(pData.IFAIsFastSer7);
          ee2232h.AIsVCP = Convert.ToBoolean(pData.AIsVCP7);
          ee2232h.IFBIsFifo = Convert.ToBoolean(pData.IFBIsFifo7);
          ee2232h.IFBIsFifoTar = Convert.ToBoolean(pData.IFBIsFifoTar7);
          ee2232h.IFBIsFastSer = Convert.ToBoolean(pData.IFBIsFastSer7);
          ee2232h.BIsVCP = Convert.ToBoolean(pData.BIsVCP7);
          ee2232h.PowerSaveEnable = Convert.ToBoolean(pData.PowerSaveEnable);
        }
      }
      else if (this.pFT_EE_Read == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Read.");
      return ftStatus;
    }

    public FTDI.FT_STATUS ReadFT4232HEEPROM(FTDI.FT4232H_EEPROM_STRUCTURE ee4232h)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Read != IntPtr.Zero)
      {
        FTDI.tFT_EE_Read forFunctionPointer = (FTDI.tFT_EE_Read) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Read, typeof (FTDI.tFT_EE_Read));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_4232H)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 4U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          ee4232h.Manufacturer = Marshal.PtrToStringAnsi(pData.Manufacturer);
          ee4232h.ManufacturerID = Marshal.PtrToStringAnsi(pData.ManufacturerID);
          ee4232h.Description = Marshal.PtrToStringAnsi(pData.Description);
          ee4232h.SerialNumber = Marshal.PtrToStringAnsi(pData.SerialNumber);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
          ee4232h.VendorID = pData.VendorID;
          ee4232h.ProductID = pData.ProductID;
          ee4232h.MaxPower = pData.MaxPower;
          ee4232h.SelfPowered = Convert.ToBoolean(pData.SelfPowered);
          ee4232h.RemoteWakeup = Convert.ToBoolean(pData.RemoteWakeup);
          ee4232h.PullDownEnable = Convert.ToBoolean(pData.PullDownEnable8);
          ee4232h.SerNumEnable = Convert.ToBoolean(pData.SerNumEnable8);
          ee4232h.ASlowSlew = Convert.ToBoolean(pData.ASlowSlew);
          ee4232h.ASchmittInput = Convert.ToBoolean(pData.ASchmittInput);
          ee4232h.ADriveCurrent = pData.ADriveCurrent;
          ee4232h.BSlowSlew = Convert.ToBoolean(pData.BSlowSlew);
          ee4232h.BSchmittInput = Convert.ToBoolean(pData.BSchmittInput);
          ee4232h.BDriveCurrent = pData.BDriveCurrent;
          ee4232h.CSlowSlew = Convert.ToBoolean(pData.CSlowSlew);
          ee4232h.CSchmittInput = Convert.ToBoolean(pData.CSchmittInput);
          ee4232h.CDriveCurrent = pData.CDriveCurrent;
          ee4232h.DSlowSlew = Convert.ToBoolean(pData.DSlowSlew);
          ee4232h.DSchmittInput = Convert.ToBoolean(pData.DSchmittInput);
          ee4232h.DDriveCurrent = pData.DDriveCurrent;
          ee4232h.ARIIsTXDEN = Convert.ToBoolean(pData.ARIIsTXDEN);
          ee4232h.BRIIsTXDEN = Convert.ToBoolean(pData.BRIIsTXDEN);
          ee4232h.CRIIsTXDEN = Convert.ToBoolean(pData.CRIIsTXDEN);
          ee4232h.DRIIsTXDEN = Convert.ToBoolean(pData.DRIIsTXDEN);
          ee4232h.AIsVCP = Convert.ToBoolean(pData.AIsVCP8);
          ee4232h.BIsVCP = Convert.ToBoolean(pData.BIsVCP8);
          ee4232h.CIsVCP = Convert.ToBoolean(pData.CIsVCP8);
          ee4232h.DIsVCP = Convert.ToBoolean(pData.DIsVCP8);
        }
      }
      else if (this.pFT_EE_Read == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Read.");
      return ftStatus;
    }

    public FTDI.FT_STATUS ReadFT232HEEPROM(FTDI.FT232H_EEPROM_STRUCTURE ee232h)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Read != IntPtr.Zero)
      {
        FTDI.tFT_EE_Read forFunctionPointer = (FTDI.tFT_EE_Read) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Read, typeof (FTDI.tFT_EE_Read));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_232H)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 5U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          ee232h.Manufacturer = Marshal.PtrToStringAnsi(pData.Manufacturer);
          ee232h.ManufacturerID = Marshal.PtrToStringAnsi(pData.ManufacturerID);
          ee232h.Description = Marshal.PtrToStringAnsi(pData.Description);
          ee232h.SerialNumber = Marshal.PtrToStringAnsi(pData.SerialNumber);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
          ee232h.VendorID = pData.VendorID;
          ee232h.ProductID = pData.ProductID;
          ee232h.MaxPower = pData.MaxPower;
          ee232h.SelfPowered = Convert.ToBoolean(pData.SelfPowered);
          ee232h.RemoteWakeup = Convert.ToBoolean(pData.RemoteWakeup);
          ee232h.PullDownEnable = Convert.ToBoolean(pData.PullDownEnableH);
          ee232h.SerNumEnable = Convert.ToBoolean(pData.SerNumEnableH);
          ee232h.ACSlowSlew = Convert.ToBoolean(pData.ACSlowSlewH);
          ee232h.ACSchmittInput = Convert.ToBoolean(pData.ACSchmittInputH);
          ee232h.ACDriveCurrent = pData.ACDriveCurrentH;
          ee232h.ADSlowSlew = Convert.ToBoolean(pData.ADSlowSlewH);
          ee232h.ADSchmittInput = Convert.ToBoolean(pData.ADSchmittInputH);
          ee232h.ADDriveCurrent = pData.ADDriveCurrentH;
          ee232h.Cbus0 = pData.Cbus0H;
          ee232h.Cbus1 = pData.Cbus1H;
          ee232h.Cbus2 = pData.Cbus2H;
          ee232h.Cbus3 = pData.Cbus3H;
          ee232h.Cbus4 = pData.Cbus4H;
          ee232h.Cbus5 = pData.Cbus5H;
          ee232h.Cbus6 = pData.Cbus6H;
          ee232h.Cbus7 = pData.Cbus7H;
          ee232h.Cbus8 = pData.Cbus8H;
          ee232h.Cbus9 = pData.Cbus9H;
          ee232h.IsFifo = Convert.ToBoolean(pData.IsFifoH);
          ee232h.IsFifoTar = Convert.ToBoolean(pData.IsFifoTarH);
          ee232h.IsFastSer = Convert.ToBoolean(pData.IsFastSerH);
          ee232h.IsFT1248 = Convert.ToBoolean(pData.IsFT1248H);
          ee232h.FT1248Cpol = Convert.ToBoolean(pData.FT1248CpolH);
          ee232h.FT1248Lsb = Convert.ToBoolean(pData.FT1248LsbH);
          ee232h.FT1248FlowControl = Convert.ToBoolean(pData.FT1248FlowControlH);
          ee232h.IsVCP = Convert.ToBoolean(pData.IsVCPH);
          ee232h.PowerSaveEnable = Convert.ToBoolean(pData.PowerSaveEnableH);
        }
      }
      else if (this.pFT_EE_Read == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Read.");
      return ftStatus;
    }

    public FTDI.FT_STATUS ReadXSeriesEEPROM(FTDI.FT_XSERIES_EEPROM_STRUCTURE eeX)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EEPROM_Read != IntPtr.Zero)
      {
        FTDI.tFT_EEPROM_Read forFunctionPointer = (FTDI.tFT_EEPROM_Read) Marshal.GetDelegateForFunctionPointer(this.pFT_EEPROM_Read, typeof (FTDI.tFT_EEPROM_Read));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_X_SERIES)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          FTDI.FT_XSERIES_DATA structure1 = new FTDI.FT_XSERIES_DATA();
          FTDI.FT_EEPROM_HEADER ftEepromHeader = new FTDI.FT_EEPROM_HEADER();
          byte[] numArray1 = new byte[32];
          byte[] numArray2 = new byte[16];
          byte[] numArray3 = new byte[64];
          byte[] numArray4 = new byte[16];
          ftEepromHeader.deviceType = 9U;
          structure1.common = ftEepromHeader;
          int num1 = Marshal.SizeOf<FTDI.FT_XSERIES_DATA>(structure1);
          IntPtr num2 = Marshal.AllocHGlobal(num1);
          Marshal.StructureToPtr<FTDI.FT_XSERIES_DATA>(structure1, num2, false);
          ftStatus = forFunctionPointer(this.ftHandle, num2, checked ((uint) num1), numArray1, numArray2, numArray3, numArray4);
          if (ftStatus == FTDI.FT_STATUS.FT_OK)
          {
            FTDI.FT_XSERIES_DATA structure2 = (FTDI.FT_XSERIES_DATA) Marshal.PtrToStructure(num2, typeof (FTDI.FT_XSERIES_DATA));
            UTF8Encoding utF8Encoding = new UTF8Encoding();
            eeX.Manufacturer = utF8Encoding.GetString(numArray1);
            eeX.ManufacturerID = utF8Encoding.GetString(numArray2);
            eeX.Description = utF8Encoding.GetString(numArray3);
            eeX.SerialNumber = utF8Encoding.GetString(numArray4);
            eeX.VendorID = structure2.common.VendorId;
            eeX.ProductID = structure2.common.ProductId;
            eeX.MaxPower = structure2.common.MaxPower;
            eeX.SelfPowered = Convert.ToBoolean(structure2.common.SelfPowered);
            eeX.RemoteWakeup = Convert.ToBoolean(structure2.common.RemoteWakeup);
            eeX.SerNumEnable = Convert.ToBoolean(structure2.common.SerNumEnable);
            eeX.PullDownEnable = Convert.ToBoolean(structure2.common.PullDownEnable);
            eeX.Cbus0 = structure2.Cbus0;
            eeX.Cbus1 = structure2.Cbus1;
            eeX.Cbus2 = structure2.Cbus2;
            eeX.Cbus3 = structure2.Cbus3;
            eeX.Cbus4 = structure2.Cbus4;
            eeX.Cbus5 = structure2.Cbus5;
            eeX.Cbus6 = structure2.Cbus6;
            eeX.ACDriveCurrent = structure2.ACDriveCurrent;
            eeX.ACSchmittInput = structure2.ACSchmittInput;
            eeX.ACSlowSlew = structure2.ACSlowSlew;
            eeX.ADDriveCurrent = structure2.ADDriveCurrent;
            eeX.ADSchmittInput = structure2.ADSchmittInput;
            eeX.ADSlowSlew = structure2.ADSlowSlew;
            eeX.BCDDisableSleep = structure2.BCDDisableSleep;
            eeX.BCDEnable = structure2.BCDEnable;
            eeX.BCDForceCbusPWREN = structure2.BCDForceCbusPWREN;
            eeX.FT1248Cpol = structure2.FT1248Cpol;
            eeX.FT1248FlowControl = structure2.FT1248FlowControl;
            eeX.FT1248Lsb = structure2.FT1248Lsb;
            eeX.I2CDeviceId = structure2.I2CDeviceId;
            eeX.I2CDisableSchmitt = structure2.I2CDisableSchmitt;
            eeX.I2CSlaveAddress = structure2.I2CSlaveAddress;
            eeX.InvertCTS = structure2.InvertCTS;
            eeX.InvertDCD = structure2.InvertDCD;
            eeX.InvertDSR = structure2.InvertDSR;
            eeX.InvertDTR = structure2.InvertDTR;
            eeX.InvertRI = structure2.InvertRI;
            eeX.InvertRTS = structure2.InvertRTS;
            eeX.InvertRXD = structure2.InvertRXD;
            eeX.InvertTXD = structure2.InvertTXD;
            eeX.PowerSaveEnable = structure2.PowerSaveEnable;
            eeX.RS485EchoSuppress = structure2.RS485EchoSuppress;
            eeX.IsVCP = structure2.DriverType;
          }
        }
      }
      else if (this.pFT_EE_Read == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Read.");
      return ftStatus;
    }

    public FTDI.FT_STATUS WriteFT232BEEPROM(FTDI.FT232B_EEPROM_STRUCTURE ee232b)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Program != IntPtr.Zero)
      {
        FTDI.tFT_EE_Program forFunctionPointer = (FTDI.tFT_EE_Program) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Program, typeof (FTDI.tFT_EE_Program));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_BM)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          if (ee232b.VendorID == (ushort) 0 | ee232b.ProductID == (ushort) 0)
            return FTDI.FT_STATUS.FT_INVALID_PARAMETER;
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 2U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          if (ee232b.Manufacturer.Length > 32)
            ee232b.Manufacturer = ee232b.Manufacturer.Substring(0, 32);
          if (ee232b.ManufacturerID.Length > 16)
            ee232b.ManufacturerID = ee232b.ManufacturerID.Substring(0, 16);
          if (ee232b.Description.Length > 64)
            ee232b.Description = ee232b.Description.Substring(0, 64);
          if (ee232b.SerialNumber.Length > 16)
            ee232b.SerialNumber = ee232b.SerialNumber.Substring(0, 16);
          pData.Manufacturer = Marshal.StringToHGlobalAnsi(ee232b.Manufacturer);
          pData.ManufacturerID = Marshal.StringToHGlobalAnsi(ee232b.ManufacturerID);
          pData.Description = Marshal.StringToHGlobalAnsi(ee232b.Description);
          pData.SerialNumber = Marshal.StringToHGlobalAnsi(ee232b.SerialNumber);
          pData.VendorID = ee232b.VendorID;
          pData.ProductID = ee232b.ProductID;
          pData.MaxPower = ee232b.MaxPower;
          pData.SelfPowered = Convert.ToUInt16(ee232b.SelfPowered);
          pData.RemoteWakeup = Convert.ToUInt16(ee232b.RemoteWakeup);
          pData.Rev4 = Convert.ToByte(true);
          pData.PullDownEnable = Convert.ToByte(ee232b.PullDownEnable);
          pData.SerNumEnable = Convert.ToByte(ee232b.SerNumEnable);
          pData.USBVersionEnable = Convert.ToByte(ee232b.USBVersionEnable);
          pData.USBVersion = ee232b.USBVersion;
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
        }
      }
      else if (this.pFT_EE_Program == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Program.");
      return ftStatus;
    }

    public FTDI.FT_STATUS WriteFT2232EEPROM(FTDI.FT2232_EEPROM_STRUCTURE ee2232)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Program != IntPtr.Zero)
      {
        FTDI.tFT_EE_Program forFunctionPointer = (FTDI.tFT_EE_Program) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Program, typeof (FTDI.tFT_EE_Program));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_2232)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          if (ee2232.VendorID == (ushort) 0 | ee2232.ProductID == (ushort) 0)
            return FTDI.FT_STATUS.FT_INVALID_PARAMETER;
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 2U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          if (ee2232.Manufacturer.Length > 32)
            ee2232.Manufacturer = ee2232.Manufacturer.Substring(0, 32);
          if (ee2232.ManufacturerID.Length > 16)
            ee2232.ManufacturerID = ee2232.ManufacturerID.Substring(0, 16);
          if (ee2232.Description.Length > 64)
            ee2232.Description = ee2232.Description.Substring(0, 64);
          if (ee2232.SerialNumber.Length > 16)
            ee2232.SerialNumber = ee2232.SerialNumber.Substring(0, 16);
          pData.Manufacturer = Marshal.StringToHGlobalAnsi(ee2232.Manufacturer);
          pData.ManufacturerID = Marshal.StringToHGlobalAnsi(ee2232.ManufacturerID);
          pData.Description = Marshal.StringToHGlobalAnsi(ee2232.Description);
          pData.SerialNumber = Marshal.StringToHGlobalAnsi(ee2232.SerialNumber);
          pData.VendorID = ee2232.VendorID;
          pData.ProductID = ee2232.ProductID;
          pData.MaxPower = ee2232.MaxPower;
          pData.SelfPowered = Convert.ToUInt16(ee2232.SelfPowered);
          pData.RemoteWakeup = Convert.ToUInt16(ee2232.RemoteWakeup);
          pData.Rev5 = Convert.ToByte(true);
          pData.PullDownEnable5 = Convert.ToByte(ee2232.PullDownEnable);
          pData.SerNumEnable5 = Convert.ToByte(ee2232.SerNumEnable);
          pData.USBVersionEnable5 = Convert.ToByte(ee2232.USBVersionEnable);
          pData.USBVersion5 = ee2232.USBVersion;
          pData.AIsHighCurrent = Convert.ToByte(ee2232.AIsHighCurrent);
          pData.BIsHighCurrent = Convert.ToByte(ee2232.BIsHighCurrent);
          pData.IFAIsFifo = Convert.ToByte(ee2232.IFAIsFifo);
          pData.IFAIsFifoTar = Convert.ToByte(ee2232.IFAIsFifoTar);
          pData.IFAIsFastSer = Convert.ToByte(ee2232.IFAIsFastSer);
          pData.AIsVCP = Convert.ToByte(ee2232.AIsVCP);
          pData.IFBIsFifo = Convert.ToByte(ee2232.IFBIsFifo);
          pData.IFBIsFifoTar = Convert.ToByte(ee2232.IFBIsFifoTar);
          pData.IFBIsFastSer = Convert.ToByte(ee2232.IFBIsFastSer);
          pData.BIsVCP = Convert.ToByte(ee2232.BIsVCP);
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
        }
      }
      else if (this.pFT_EE_Program == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Program.");
      return ftStatus;
    }

    public FTDI.FT_STATUS WriteFT232REEPROM(FTDI.FT232R_EEPROM_STRUCTURE ee232r)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Program != IntPtr.Zero)
      {
        FTDI.tFT_EE_Program forFunctionPointer = (FTDI.tFT_EE_Program) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Program, typeof (FTDI.tFT_EE_Program));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_232R)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          if (ee232r.VendorID == (ushort) 0 | ee232r.ProductID == (ushort) 0)
            return FTDI.FT_STATUS.FT_INVALID_PARAMETER;
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 2U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          if (ee232r.Manufacturer.Length > 32)
            ee232r.Manufacturer = ee232r.Manufacturer.Substring(0, 32);
          if (ee232r.ManufacturerID.Length > 16)
            ee232r.ManufacturerID = ee232r.ManufacturerID.Substring(0, 16);
          if (ee232r.Description.Length > 64)
            ee232r.Description = ee232r.Description.Substring(0, 64);
          if (ee232r.SerialNumber.Length > 16)
            ee232r.SerialNumber = ee232r.SerialNumber.Substring(0, 16);
          pData.Manufacturer = Marshal.StringToHGlobalAnsi(ee232r.Manufacturer);
          pData.ManufacturerID = Marshal.StringToHGlobalAnsi(ee232r.ManufacturerID);
          pData.Description = Marshal.StringToHGlobalAnsi(ee232r.Description);
          pData.SerialNumber = Marshal.StringToHGlobalAnsi(ee232r.SerialNumber);
          pData.VendorID = ee232r.VendorID;
          pData.ProductID = ee232r.ProductID;
          pData.MaxPower = ee232r.MaxPower;
          pData.SelfPowered = Convert.ToUInt16(ee232r.SelfPowered);
          pData.RemoteWakeup = Convert.ToUInt16(ee232r.RemoteWakeup);
          pData.PullDownEnableR = Convert.ToByte(ee232r.PullDownEnable);
          pData.SerNumEnableR = Convert.ToByte(ee232r.SerNumEnable);
          pData.UseExtOsc = Convert.ToByte(ee232r.UseExtOsc);
          pData.HighDriveIOs = Convert.ToByte(ee232r.HighDriveIOs);
          pData.EndpointSize = (byte) 64;
          pData.PullDownEnableR = Convert.ToByte(ee232r.PullDownEnable);
          pData.SerNumEnableR = Convert.ToByte(ee232r.SerNumEnable);
          pData.InvertTXD = Convert.ToByte(ee232r.InvertTXD);
          pData.InvertRXD = Convert.ToByte(ee232r.InvertRXD);
          pData.InvertRTS = Convert.ToByte(ee232r.InvertRTS);
          pData.InvertCTS = Convert.ToByte(ee232r.InvertCTS);
          pData.InvertDTR = Convert.ToByte(ee232r.InvertDTR);
          pData.InvertDSR = Convert.ToByte(ee232r.InvertDSR);
          pData.InvertDCD = Convert.ToByte(ee232r.InvertDCD);
          pData.InvertRI = Convert.ToByte(ee232r.InvertRI);
          pData.Cbus0 = ee232r.Cbus0;
          pData.Cbus1 = ee232r.Cbus1;
          pData.Cbus2 = ee232r.Cbus2;
          pData.Cbus3 = ee232r.Cbus3;
          pData.Cbus4 = ee232r.Cbus4;
          pData.RIsD2XX = Convert.ToByte(ee232r.RIsD2XX);
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
        }
      }
      else if (this.pFT_EE_Program == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Program.");
      return ftStatus;
    }

    public FTDI.FT_STATUS WriteFT2232HEEPROM(FTDI.FT2232H_EEPROM_STRUCTURE ee2232h)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Program != IntPtr.Zero)
      {
        FTDI.tFT_EE_Program forFunctionPointer = (FTDI.tFT_EE_Program) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Program, typeof (FTDI.tFT_EE_Program));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_2232H)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          if (ee2232h.VendorID == (ushort) 0 | ee2232h.ProductID == (ushort) 0)
            return FTDI.FT_STATUS.FT_INVALID_PARAMETER;
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 3U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          if (ee2232h.Manufacturer.Length > 32)
            ee2232h.Manufacturer = ee2232h.Manufacturer.Substring(0, 32);
          if (ee2232h.ManufacturerID.Length > 16)
            ee2232h.ManufacturerID = ee2232h.ManufacturerID.Substring(0, 16);
          if (ee2232h.Description.Length > 64)
            ee2232h.Description = ee2232h.Description.Substring(0, 64);
          if (ee2232h.SerialNumber.Length > 16)
            ee2232h.SerialNumber = ee2232h.SerialNumber.Substring(0, 16);
          pData.Manufacturer = Marshal.StringToHGlobalAnsi(ee2232h.Manufacturer);
          pData.ManufacturerID = Marshal.StringToHGlobalAnsi(ee2232h.ManufacturerID);
          pData.Description = Marshal.StringToHGlobalAnsi(ee2232h.Description);
          pData.SerialNumber = Marshal.StringToHGlobalAnsi(ee2232h.SerialNumber);
          pData.VendorID = ee2232h.VendorID;
          pData.ProductID = ee2232h.ProductID;
          pData.MaxPower = ee2232h.MaxPower;
          pData.SelfPowered = Convert.ToUInt16(ee2232h.SelfPowered);
          pData.RemoteWakeup = Convert.ToUInt16(ee2232h.RemoteWakeup);
          pData.PullDownEnable7 = Convert.ToByte(ee2232h.PullDownEnable);
          pData.SerNumEnable7 = Convert.ToByte(ee2232h.SerNumEnable);
          pData.ALSlowSlew = Convert.ToByte(ee2232h.ALSlowSlew);
          pData.ALSchmittInput = Convert.ToByte(ee2232h.ALSchmittInput);
          pData.ALDriveCurrent = ee2232h.ALDriveCurrent;
          pData.AHSlowSlew = Convert.ToByte(ee2232h.AHSlowSlew);
          pData.AHSchmittInput = Convert.ToByte(ee2232h.AHSchmittInput);
          pData.AHDriveCurrent = ee2232h.AHDriveCurrent;
          pData.BLSlowSlew = Convert.ToByte(ee2232h.BLSlowSlew);
          pData.BLSchmittInput = Convert.ToByte(ee2232h.BLSchmittInput);
          pData.BLDriveCurrent = ee2232h.BLDriveCurrent;
          pData.BHSlowSlew = Convert.ToByte(ee2232h.BHSlowSlew);
          pData.BHSchmittInput = Convert.ToByte(ee2232h.BHSchmittInput);
          pData.BHDriveCurrent = ee2232h.BHDriveCurrent;
          pData.IFAIsFifo7 = Convert.ToByte(ee2232h.IFAIsFifo);
          pData.IFAIsFifoTar7 = Convert.ToByte(ee2232h.IFAIsFifoTar);
          pData.IFAIsFastSer7 = Convert.ToByte(ee2232h.IFAIsFastSer);
          pData.AIsVCP7 = Convert.ToByte(ee2232h.AIsVCP);
          pData.IFBIsFifo7 = Convert.ToByte(ee2232h.IFBIsFifo);
          pData.IFBIsFifoTar7 = Convert.ToByte(ee2232h.IFBIsFifoTar);
          pData.IFBIsFastSer7 = Convert.ToByte(ee2232h.IFBIsFastSer);
          pData.BIsVCP7 = Convert.ToByte(ee2232h.BIsVCP);
          pData.PowerSaveEnable = Convert.ToByte(ee2232h.PowerSaveEnable);
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
        }
      }
      else if (this.pFT_EE_Program == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Program.");
      return ftStatus;
    }

    public FTDI.FT_STATUS WriteFT4232HEEPROM(FTDI.FT4232H_EEPROM_STRUCTURE ee4232h)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Program != IntPtr.Zero)
      {
        FTDI.tFT_EE_Program forFunctionPointer = (FTDI.tFT_EE_Program) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Program, typeof (FTDI.tFT_EE_Program));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_4232H)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          if (ee4232h.VendorID == (ushort) 0 | ee4232h.ProductID == (ushort) 0)
            return FTDI.FT_STATUS.FT_INVALID_PARAMETER;
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 4U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          if (ee4232h.Manufacturer.Length > 32)
            ee4232h.Manufacturer = ee4232h.Manufacturer.Substring(0, 32);
          if (ee4232h.ManufacturerID.Length > 16)
            ee4232h.ManufacturerID = ee4232h.ManufacturerID.Substring(0, 16);
          if (ee4232h.Description.Length > 64)
            ee4232h.Description = ee4232h.Description.Substring(0, 64);
          if (ee4232h.SerialNumber.Length > 16)
            ee4232h.SerialNumber = ee4232h.SerialNumber.Substring(0, 16);
          pData.Manufacturer = Marshal.StringToHGlobalAnsi(ee4232h.Manufacturer);
          pData.ManufacturerID = Marshal.StringToHGlobalAnsi(ee4232h.ManufacturerID);
          pData.Description = Marshal.StringToHGlobalAnsi(ee4232h.Description);
          pData.SerialNumber = Marshal.StringToHGlobalAnsi(ee4232h.SerialNumber);
          pData.VendorID = ee4232h.VendorID;
          pData.ProductID = ee4232h.ProductID;
          pData.MaxPower = ee4232h.MaxPower;
          pData.SelfPowered = Convert.ToUInt16(ee4232h.SelfPowered);
          pData.RemoteWakeup = Convert.ToUInt16(ee4232h.RemoteWakeup);
          pData.PullDownEnable8 = Convert.ToByte(ee4232h.PullDownEnable);
          pData.SerNumEnable8 = Convert.ToByte(ee4232h.SerNumEnable);
          pData.ASlowSlew = Convert.ToByte(ee4232h.ASlowSlew);
          pData.ASchmittInput = Convert.ToByte(ee4232h.ASchmittInput);
          pData.ADriveCurrent = ee4232h.ADriveCurrent;
          pData.BSlowSlew = Convert.ToByte(ee4232h.BSlowSlew);
          pData.BSchmittInput = Convert.ToByte(ee4232h.BSchmittInput);
          pData.BDriveCurrent = ee4232h.BDriveCurrent;
          pData.CSlowSlew = Convert.ToByte(ee4232h.CSlowSlew);
          pData.CSchmittInput = Convert.ToByte(ee4232h.CSchmittInput);
          pData.CDriveCurrent = ee4232h.CDriveCurrent;
          pData.DSlowSlew = Convert.ToByte(ee4232h.DSlowSlew);
          pData.DSchmittInput = Convert.ToByte(ee4232h.DSchmittInput);
          pData.DDriveCurrent = ee4232h.DDriveCurrent;
          pData.ARIIsTXDEN = Convert.ToByte(ee4232h.ARIIsTXDEN);
          pData.BRIIsTXDEN = Convert.ToByte(ee4232h.BRIIsTXDEN);
          pData.CRIIsTXDEN = Convert.ToByte(ee4232h.CRIIsTXDEN);
          pData.DRIIsTXDEN = Convert.ToByte(ee4232h.DRIIsTXDEN);
          pData.AIsVCP8 = Convert.ToByte(ee4232h.AIsVCP);
          pData.BIsVCP8 = Convert.ToByte(ee4232h.BIsVCP);
          pData.CIsVCP8 = Convert.ToByte(ee4232h.CIsVCP);
          pData.DIsVCP8 = Convert.ToByte(ee4232h.DIsVCP);
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
        }
      }
      else if (this.pFT_EE_Program == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Program.");
      return ftStatus;
    }

    public FTDI.FT_STATUS WriteFT232HEEPROM(FTDI.FT232H_EEPROM_STRUCTURE ee232h)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_Program != IntPtr.Zero)
      {
        FTDI.tFT_EE_Program forFunctionPointer = (FTDI.tFT_EE_Program) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_Program, typeof (FTDI.tFT_EE_Program));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_232H)
          {
            FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
            this.ErrorHandler(ftStatus, ftErrorCondition);
          }
          if (ee232h.VendorID == (ushort) 0 | ee232h.ProductID == (ushort) 0)
            return FTDI.FT_STATUS.FT_INVALID_PARAMETER;
          FTDI.FT_PROGRAM_DATA pData = new FTDI.FT_PROGRAM_DATA();
          pData.Signature1 = 0U;
          pData.Signature2 = uint.MaxValue;
          pData.Version = 5U;
          pData.Manufacturer = Marshal.AllocHGlobal(32);
          pData.ManufacturerID = Marshal.AllocHGlobal(16);
          pData.Description = Marshal.AllocHGlobal(64);
          pData.SerialNumber = Marshal.AllocHGlobal(16);
          if (ee232h.Manufacturer.Length > 32)
            ee232h.Manufacturer = ee232h.Manufacturer.Substring(0, 32);
          if (ee232h.ManufacturerID.Length > 16)
            ee232h.ManufacturerID = ee232h.ManufacturerID.Substring(0, 16);
          if (ee232h.Description.Length > 64)
            ee232h.Description = ee232h.Description.Substring(0, 64);
          if (ee232h.SerialNumber.Length > 16)
            ee232h.SerialNumber = ee232h.SerialNumber.Substring(0, 16);
          pData.Manufacturer = Marshal.StringToHGlobalAnsi(ee232h.Manufacturer);
          pData.ManufacturerID = Marshal.StringToHGlobalAnsi(ee232h.ManufacturerID);
          pData.Description = Marshal.StringToHGlobalAnsi(ee232h.Description);
          pData.SerialNumber = Marshal.StringToHGlobalAnsi(ee232h.SerialNumber);
          pData.VendorID = ee232h.VendorID;
          pData.ProductID = ee232h.ProductID;
          pData.MaxPower = ee232h.MaxPower;
          pData.SelfPowered = Convert.ToUInt16(ee232h.SelfPowered);
          pData.RemoteWakeup = Convert.ToUInt16(ee232h.RemoteWakeup);
          pData.PullDownEnableH = Convert.ToByte(ee232h.PullDownEnable);
          pData.SerNumEnableH = Convert.ToByte(ee232h.SerNumEnable);
          pData.ACSlowSlewH = Convert.ToByte(ee232h.ACSlowSlew);
          pData.ACSchmittInputH = Convert.ToByte(ee232h.ACSchmittInput);
          pData.ACDriveCurrentH = Convert.ToByte(ee232h.ACDriveCurrent);
          pData.ADSlowSlewH = Convert.ToByte(ee232h.ADSlowSlew);
          pData.ADSchmittInputH = Convert.ToByte(ee232h.ADSchmittInput);
          pData.ADDriveCurrentH = Convert.ToByte(ee232h.ADDriveCurrent);
          pData.Cbus0H = Convert.ToByte(ee232h.Cbus0);
          pData.Cbus1H = Convert.ToByte(ee232h.Cbus1);
          pData.Cbus2H = Convert.ToByte(ee232h.Cbus2);
          pData.Cbus3H = Convert.ToByte(ee232h.Cbus3);
          pData.Cbus4H = Convert.ToByte(ee232h.Cbus4);
          pData.Cbus5H = Convert.ToByte(ee232h.Cbus5);
          pData.Cbus6H = Convert.ToByte(ee232h.Cbus6);
          pData.Cbus7H = Convert.ToByte(ee232h.Cbus7);
          pData.Cbus8H = Convert.ToByte(ee232h.Cbus8);
          pData.Cbus9H = Convert.ToByte(ee232h.Cbus9);
          pData.IsFifoH = Convert.ToByte(ee232h.IsFifo);
          pData.IsFifoTarH = Convert.ToByte(ee232h.IsFifoTar);
          pData.IsFastSerH = Convert.ToByte(ee232h.IsFastSer);
          pData.IsFT1248H = Convert.ToByte(ee232h.IsFT1248);
          pData.FT1248CpolH = Convert.ToByte(ee232h.FT1248Cpol);
          pData.FT1248LsbH = Convert.ToByte(ee232h.FT1248Lsb);
          pData.FT1248FlowControlH = Convert.ToByte(ee232h.FT1248FlowControl);
          pData.IsVCPH = Convert.ToByte(ee232h.IsVCP);
          pData.PowerSaveEnableH = Convert.ToByte(ee232h.PowerSaveEnable);
          ftStatus = forFunctionPointer(this.ftHandle, pData);
          Marshal.FreeHGlobal(pData.Manufacturer);
          Marshal.FreeHGlobal(pData.ManufacturerID);
          Marshal.FreeHGlobal(pData.Description);
          Marshal.FreeHGlobal(pData.SerialNumber);
        }
      }
      else if (this.pFT_EE_Program == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_Program.");
      return ftStatus;
    }

    public FTDI.FT_STATUS WriteXSeriesEEPROM(FTDI.FT_XSERIES_EEPROM_STRUCTURE eeX)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero || !(this.pFT_EEPROM_Program != IntPtr.Zero))
        return ftStatus;
      FTDI.tFT_EEPROM_Program forFunctionPointer = (FTDI.tFT_EEPROM_Program) Marshal.GetDelegateForFunctionPointer(this.pFT_EEPROM_Program, typeof (FTDI.tFT_EEPROM_Program));
      if (this.ftHandle != IntPtr.Zero)
      {
        FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
        int deviceType = (int) this.GetDeviceType(ref DeviceType);
        if (DeviceType != FTDI.FT_DEVICE.FT_DEVICE_X_SERIES)
        {
          FTDI.FT_ERROR ftErrorCondition = FTDI.FT_ERROR.FT_INCORRECT_DEVICE;
          this.ErrorHandler(ftStatus, ftErrorCondition);
        }
        if (eeX.VendorID == (ushort) 0 | eeX.ProductID == (ushort) 0)
          return FTDI.FT_STATUS.FT_INVALID_PARAMETER;
        FTDI.FT_XSERIES_DATA structure = new FTDI.FT_XSERIES_DATA();
        byte[] numArray1 = new byte[32];
        byte[] numArray2 = new byte[16];
        byte[] numArray3 = new byte[64];
        byte[] numArray4 = new byte[16];
        if (eeX.Manufacturer.Length > 32)
          eeX.Manufacturer = eeX.Manufacturer.Substring(0, 32);
        if (eeX.ManufacturerID.Length > 16)
          eeX.ManufacturerID = eeX.ManufacturerID.Substring(0, 16);
        if (eeX.Description.Length > 64)
          eeX.Description = eeX.Description.Substring(0, 64);
        if (eeX.SerialNumber.Length > 16)
          eeX.SerialNumber = eeX.SerialNumber.Substring(0, 16);
        UTF8Encoding utF8Encoding = new UTF8Encoding();
        byte[] bytes1 = utF8Encoding.GetBytes(eeX.Manufacturer);
        byte[] bytes2 = utF8Encoding.GetBytes(eeX.ManufacturerID);
        byte[] bytes3 = utF8Encoding.GetBytes(eeX.Description);
        byte[] bytes4 = utF8Encoding.GetBytes(eeX.SerialNumber);
        structure.common.deviceType = 9U;
        structure.common.VendorId = eeX.VendorID;
        structure.common.ProductId = eeX.ProductID;
        structure.common.MaxPower = eeX.MaxPower;
        structure.common.SelfPowered = Convert.ToByte(eeX.SelfPowered);
        structure.common.RemoteWakeup = Convert.ToByte(eeX.RemoteWakeup);
        structure.common.SerNumEnable = Convert.ToByte(eeX.SerNumEnable);
        structure.common.PullDownEnable = Convert.ToByte(eeX.PullDownEnable);
        structure.Cbus0 = eeX.Cbus0;
        structure.Cbus1 = eeX.Cbus1;
        structure.Cbus2 = eeX.Cbus2;
        structure.Cbus3 = eeX.Cbus3;
        structure.Cbus4 = eeX.Cbus4;
        structure.Cbus5 = eeX.Cbus5;
        structure.Cbus6 = eeX.Cbus6;
        structure.ACDriveCurrent = eeX.ACDriveCurrent;
        structure.ACSchmittInput = eeX.ACSchmittInput;
        structure.ACSlowSlew = eeX.ACSlowSlew;
        structure.ADDriveCurrent = eeX.ADDriveCurrent;
        structure.ADSchmittInput = eeX.ADSchmittInput;
        structure.ADSlowSlew = eeX.ADSlowSlew;
        structure.BCDDisableSleep = eeX.BCDDisableSleep;
        structure.BCDEnable = eeX.BCDEnable;
        structure.BCDForceCbusPWREN = eeX.BCDForceCbusPWREN;
        structure.FT1248Cpol = eeX.FT1248Cpol;
        structure.FT1248FlowControl = eeX.FT1248FlowControl;
        structure.FT1248Lsb = eeX.FT1248Lsb;
        structure.I2CDeviceId = eeX.I2CDeviceId;
        structure.I2CDisableSchmitt = eeX.I2CDisableSchmitt;
        structure.I2CSlaveAddress = eeX.I2CSlaveAddress;
        structure.InvertCTS = eeX.InvertCTS;
        structure.InvertDCD = eeX.InvertDCD;
        structure.InvertDSR = eeX.InvertDSR;
        structure.InvertDTR = eeX.InvertDTR;
        structure.InvertRI = eeX.InvertRI;
        structure.InvertRTS = eeX.InvertRTS;
        structure.InvertRXD = eeX.InvertRXD;
        structure.InvertTXD = eeX.InvertTXD;
        structure.PowerSaveEnable = eeX.PowerSaveEnable;
        structure.RS485EchoSuppress = eeX.RS485EchoSuppress;
        structure.DriverType = eeX.IsVCP;
        int num1 = Marshal.SizeOf<FTDI.FT_XSERIES_DATA>(structure);
        IntPtr num2 = Marshal.AllocHGlobal(num1);
        Marshal.StructureToPtr<FTDI.FT_XSERIES_DATA>(structure, num2, false);
        ftStatus = forFunctionPointer(this.ftHandle, num2, checked ((uint) num1), bytes1, bytes2, bytes3, bytes4);
      }
      return ftStatus;
    }

    public FTDI.FT_STATUS EEReadUserArea(byte[] UserAreaDataBuffer, out uint numBytesRead)
    {
      numBytesRead = 0U;
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_UASize != IntPtr.Zero & this.pFT_EE_UARead != IntPtr.Zero)
      {
        FTDI.tFT_EE_UASize forFunctionPointer1 = (FTDI.tFT_EE_UASize) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_UASize, typeof (FTDI.tFT_EE_UASize));
        FTDI.tFT_EE_UARead forFunctionPointer2 = (FTDI.tFT_EE_UARead) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_UARead, typeof (FTDI.tFT_EE_UARead));
        if (this.ftHandle != IntPtr.Zero)
        {
          uint dwSize = 0;
          ftStatus = forFunctionPointer1(this.ftHandle, ref dwSize);
          if ((long) UserAreaDataBuffer.Length >= (long) dwSize)
            ftStatus = forFunctionPointer2(this.ftHandle, UserAreaDataBuffer, UserAreaDataBuffer.Length, ref numBytesRead);
        }
      }
      else
      {
        if (this.pFT_EE_UASize == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_EE_UASize.");
        if (this.pFT_EE_UARead == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_EE_UARead.");
      }
      return ftStatus;
    }

    public FTDI.FT_STATUS EEWriteUserArea(byte[] UserAreaDataBuffer)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_UASize != IntPtr.Zero & this.pFT_EE_UAWrite != IntPtr.Zero)
      {
        FTDI.tFT_EE_UASize forFunctionPointer1 = (FTDI.tFT_EE_UASize) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_UASize, typeof (FTDI.tFT_EE_UASize));
        FTDI.tFT_EE_UAWrite forFunctionPointer2 = (FTDI.tFT_EE_UAWrite) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_UAWrite, typeof (FTDI.tFT_EE_UAWrite));
        if (this.ftHandle != IntPtr.Zero)
        {
          uint dwSize = 0;
          ftStatus = forFunctionPointer1(this.ftHandle, ref dwSize);
          if ((long) UserAreaDataBuffer.Length <= (long) dwSize)
            ftStatus = forFunctionPointer2(this.ftHandle, UserAreaDataBuffer, UserAreaDataBuffer.Length);
        }
      }
      else
      {
        if (this.pFT_EE_UASize == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_EE_UASize.");
        if (this.pFT_EE_UAWrite == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_EE_UAWrite.");
      }
      return ftStatus;
    }

    public FTDI.FT_STATUS GetDeviceType(ref FTDI.FT_DEVICE DeviceType)
    {
      FTDI.FT_STATUS deviceType = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return deviceType;
      if (this.pFT_GetDeviceInfo != IntPtr.Zero)
      {
        FTDI.tFT_GetDeviceInfo forFunctionPointer = (FTDI.tFT_GetDeviceInfo) Marshal.GetDelegateForFunctionPointer(this.pFT_GetDeviceInfo, typeof (FTDI.tFT_GetDeviceInfo));
        uint lpdwID = 0;
        byte[] pcSerialNumber = new byte[16];
        byte[] pcDescription = new byte[64];
        DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
        if (this.ftHandle != IntPtr.Zero)
          deviceType = forFunctionPointer(this.ftHandle, ref DeviceType, ref lpdwID, pcSerialNumber, pcDescription, IntPtr.Zero);
      }
      else if (this.pFT_GetDeviceInfo == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetDeviceInfo.");
      return deviceType;
    }

    public FTDI.FT_STATUS GetDeviceID(ref uint DeviceID)
    {
      FTDI.FT_STATUS deviceId = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return deviceId;
      if (this.pFT_GetDeviceInfo != IntPtr.Zero)
      {
        FTDI.tFT_GetDeviceInfo forFunctionPointer = (FTDI.tFT_GetDeviceInfo) Marshal.GetDelegateForFunctionPointer(this.pFT_GetDeviceInfo, typeof (FTDI.tFT_GetDeviceInfo));
        FTDI.FT_DEVICE pftType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
        byte[] pcSerialNumber = new byte[16];
        byte[] pcDescription = new byte[64];
        if (this.ftHandle != IntPtr.Zero)
          deviceId = forFunctionPointer(this.ftHandle, ref pftType, ref DeviceID, pcSerialNumber, pcDescription, IntPtr.Zero);
      }
      else if (this.pFT_GetDeviceInfo == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetDeviceInfo.");
      return deviceId;
    }

    public FTDI.FT_STATUS GetDescription(out string Description)
    {
      FTDI.FT_STATUS description = FTDI.FT_STATUS.FT_OTHER_ERROR;
      Description = string.Empty;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return description;
      if (this.pFT_GetDeviceInfo != IntPtr.Zero)
      {
        FTDI.tFT_GetDeviceInfo forFunctionPointer = (FTDI.tFT_GetDeviceInfo) Marshal.GetDelegateForFunctionPointer(this.pFT_GetDeviceInfo, typeof (FTDI.tFT_GetDeviceInfo));
        uint lpdwID = 0;
        FTDI.FT_DEVICE pftType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
        byte[] pcSerialNumber = new byte[16];
        byte[] numArray = new byte[64];
        if (this.ftHandle != IntPtr.Zero)
        {
          description = forFunctionPointer(this.ftHandle, ref pftType, ref lpdwID, pcSerialNumber, numArray, IntPtr.Zero);
          Description = Encoding.ASCII.GetString(numArray);
          Description = Description.Substring(0, Description.IndexOf("\0"));
        }
      }
      else if (this.pFT_GetDeviceInfo == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetDeviceInfo.");
      return description;
    }

    public FTDI.FT_STATUS GetSerialNumber(out string SerialNumber)
    {
      FTDI.FT_STATUS serialNumber = FTDI.FT_STATUS.FT_OTHER_ERROR;
      SerialNumber = string.Empty;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return serialNumber;
      if (this.pFT_GetDeviceInfo != IntPtr.Zero)
      {
        FTDI.tFT_GetDeviceInfo forFunctionPointer = (FTDI.tFT_GetDeviceInfo) Marshal.GetDelegateForFunctionPointer(this.pFT_GetDeviceInfo, typeof (FTDI.tFT_GetDeviceInfo));
        uint lpdwID = 0;
        FTDI.FT_DEVICE pftType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
        byte[] numArray = new byte[16];
        byte[] pcDescription = new byte[64];
        if (this.ftHandle != IntPtr.Zero)
        {
          serialNumber = forFunctionPointer(this.ftHandle, ref pftType, ref lpdwID, numArray, pcDescription, IntPtr.Zero);
          SerialNumber = Encoding.ASCII.GetString(numArray);
          SerialNumber = SerialNumber.Substring(0, SerialNumber.IndexOf("\0"));
        }
      }
      else if (this.pFT_GetDeviceInfo == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetDeviceInfo.");
      return serialNumber;
    }

    public FTDI.FT_STATUS GetRxBytesAvailable(ref uint RxQueue)
    {
      FTDI.FT_STATUS rxBytesAvailable = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return rxBytesAvailable;
      if (this.pFT_GetQueueStatus != IntPtr.Zero)
      {
        FTDI.tFT_GetQueueStatus forFunctionPointer = (FTDI.tFT_GetQueueStatus) Marshal.GetDelegateForFunctionPointer(this.pFT_GetQueueStatus, typeof (FTDI.tFT_GetQueueStatus));
        if (this.ftHandle != IntPtr.Zero)
          rxBytesAvailable = forFunctionPointer(this.ftHandle, ref RxQueue);
      }
      else if (this.pFT_GetQueueStatus == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetQueueStatus.");
      return rxBytesAvailable;
    }

    public FTDI.FT_STATUS GetTxBytesWaiting(ref uint TxQueue)
    {
      FTDI.FT_STATUS txBytesWaiting = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return txBytesWaiting;
      if (this.pFT_GetStatus != IntPtr.Zero)
      {
        FTDI.tFT_GetStatus forFunctionPointer = (FTDI.tFT_GetStatus) Marshal.GetDelegateForFunctionPointer(this.pFT_GetStatus, typeof (FTDI.tFT_GetStatus));
        uint lpdwAmountInRxQueue = 0;
        uint lpdwEventStatus = 0;
        if (this.ftHandle != IntPtr.Zero)
          txBytesWaiting = forFunctionPointer(this.ftHandle, ref lpdwAmountInRxQueue, ref TxQueue, ref lpdwEventStatus);
      }
      else if (this.pFT_GetStatus == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetStatus.");
      return txBytesWaiting;
    }

    public FTDI.FT_STATUS GetEventType(ref uint EventType)
    {
      FTDI.FT_STATUS eventType = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return eventType;
      if (this.pFT_GetStatus != IntPtr.Zero)
      {
        FTDI.tFT_GetStatus forFunctionPointer = (FTDI.tFT_GetStatus) Marshal.GetDelegateForFunctionPointer(this.pFT_GetStatus, typeof (FTDI.tFT_GetStatus));
        uint lpdwAmountInRxQueue = 0;
        uint lpdwAmountInTxQueue = 0;
        if (this.ftHandle != IntPtr.Zero)
          eventType = forFunctionPointer(this.ftHandle, ref lpdwAmountInRxQueue, ref lpdwAmountInTxQueue, ref EventType);
      }
      else if (this.pFT_GetStatus == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetStatus.");
      return eventType;
    }

    public FTDI.FT_STATUS GetModemStatus(ref byte ModemStatus)
    {
      FTDI.FT_STATUS modemStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return modemStatus;
      if (this.pFT_GetModemStatus != IntPtr.Zero)
      {
        FTDI.tFT_GetModemStatus forFunctionPointer = (FTDI.tFT_GetModemStatus) Marshal.GetDelegateForFunctionPointer(this.pFT_GetModemStatus, typeof (FTDI.tFT_GetModemStatus));
        uint lpdwModemStatus = 0;
        if (this.ftHandle != IntPtr.Zero)
          modemStatus = forFunctionPointer(this.ftHandle, ref lpdwModemStatus);
        ModemStatus = Convert.ToByte(lpdwModemStatus & (uint) byte.MaxValue);
      }
      else if (this.pFT_GetModemStatus == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetModemStatus.");
      return modemStatus;
    }

    public FTDI.FT_STATUS GetLineStatus(ref byte LineStatus)
    {
      FTDI.FT_STATUS lineStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return lineStatus;
      if (this.pFT_GetModemStatus != IntPtr.Zero)
      {
        FTDI.tFT_GetModemStatus forFunctionPointer = (FTDI.tFT_GetModemStatus) Marshal.GetDelegateForFunctionPointer(this.pFT_GetModemStatus, typeof (FTDI.tFT_GetModemStatus));
        uint lpdwModemStatus = 0;
        if (this.ftHandle != IntPtr.Zero)
          lineStatus = forFunctionPointer(this.ftHandle, ref lpdwModemStatus);
        LineStatus = Convert.ToByte(lpdwModemStatus >> 8 & (uint) byte.MaxValue);
      }
      else if (this.pFT_GetModemStatus == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetModemStatus.");
      return lineStatus;
    }

    public FTDI.FT_STATUS SetBaudRate(uint BaudRate)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetBaudRate != IntPtr.Zero)
      {
        FTDI.tFT_SetBaudRate forFunctionPointer = (FTDI.tFT_SetBaudRate) Marshal.GetDelegateForFunctionPointer(this.pFT_SetBaudRate, typeof (FTDI.tFT_SetBaudRate));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, BaudRate);
      }
      else if (this.pFT_SetBaudRate == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_SetBaudRate.");
      return ftStatus;
    }

    public FTDI.FT_STATUS SetDataCharacteristics(byte DataBits, byte StopBits, byte Parity)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetDataCharacteristics != IntPtr.Zero)
      {
        FTDI.tFT_SetDataCharacteristics forFunctionPointer = (FTDI.tFT_SetDataCharacteristics) Marshal.GetDelegateForFunctionPointer(this.pFT_SetDataCharacteristics, typeof (FTDI.tFT_SetDataCharacteristics));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, DataBits, StopBits, Parity);
      }
      else if (this.pFT_SetDataCharacteristics == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_SetDataCharacteristics.");
      return ftStatus;
    }

    public FTDI.FT_STATUS SetFlowControl(ushort FlowControl, byte Xon, byte Xoff)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetFlowControl != IntPtr.Zero)
      {
        FTDI.tFT_SetFlowControl forFunctionPointer = (FTDI.tFT_SetFlowControl) Marshal.GetDelegateForFunctionPointer(this.pFT_SetFlowControl, typeof (FTDI.tFT_SetFlowControl));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, FlowControl, Xon, Xoff);
      }
      else if (this.pFT_SetFlowControl == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_SetFlowControl.");
      return ftStatus;
    }

    public FTDI.FT_STATUS SetRTS(bool Enable)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetRts != IntPtr.Zero & this.pFT_ClrRts != IntPtr.Zero)
      {
        FTDI.tFT_SetRts forFunctionPointer1 = (FTDI.tFT_SetRts) Marshal.GetDelegateForFunctionPointer(this.pFT_SetRts, typeof (FTDI.tFT_SetRts));
        FTDI.tFT_ClrRts forFunctionPointer2 = (FTDI.tFT_ClrRts) Marshal.GetDelegateForFunctionPointer(this.pFT_ClrRts, typeof (FTDI.tFT_ClrRts));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = !Enable ? forFunctionPointer2(this.ftHandle) : forFunctionPointer1(this.ftHandle);
      }
      else
      {
        if (this.pFT_SetRts == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetRts.");
        if (this.pFT_ClrRts == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_ClrRts.");
      }
      return ftStatus;
    }

    public FTDI.FT_STATUS SetDTR(bool Enable)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetDtr != IntPtr.Zero & this.pFT_ClrDtr != IntPtr.Zero)
      {
        FTDI.tFT_SetDtr forFunctionPointer1 = (FTDI.tFT_SetDtr) Marshal.GetDelegateForFunctionPointer(this.pFT_SetDtr, typeof (FTDI.tFT_SetDtr));
        FTDI.tFT_ClrDtr forFunctionPointer2 = (FTDI.tFT_ClrDtr) Marshal.GetDelegateForFunctionPointer(this.pFT_ClrDtr, typeof (FTDI.tFT_ClrDtr));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = !Enable ? forFunctionPointer2(this.ftHandle) : forFunctionPointer1(this.ftHandle);
      }
      else
      {
        if (this.pFT_SetDtr == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetDtr.");
        if (this.pFT_ClrDtr == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_ClrDtr.");
      }
      return ftStatus;
    }

    public FTDI.FT_STATUS SetTimeouts(uint ReadTimeout, uint WriteTimeout)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetTimeouts != IntPtr.Zero)
      {
        FTDI.tFT_SetTimeouts forFunctionPointer = (FTDI.tFT_SetTimeouts) Marshal.GetDelegateForFunctionPointer(this.pFT_SetTimeouts, typeof (FTDI.tFT_SetTimeouts));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, ReadTimeout, WriteTimeout);
      }
      else if (this.pFT_SetTimeouts == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_SetTimeouts.");
      return ftStatus;
    }

    public FTDI.FT_STATUS SetBreak(bool Enable)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetBreakOn != IntPtr.Zero & this.pFT_SetBreakOff != IntPtr.Zero)
      {
        FTDI.tFT_SetBreakOn forFunctionPointer1 = (FTDI.tFT_SetBreakOn) Marshal.GetDelegateForFunctionPointer(this.pFT_SetBreakOn, typeof (FTDI.tFT_SetBreakOn));
        FTDI.tFT_SetBreakOff forFunctionPointer2 = (FTDI.tFT_SetBreakOff) Marshal.GetDelegateForFunctionPointer(this.pFT_SetBreakOff, typeof (FTDI.tFT_SetBreakOff));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = !Enable ? forFunctionPointer2(this.ftHandle) : forFunctionPointer1(this.ftHandle);
      }
      else
      {
        if (this.pFT_SetBreakOn == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetBreakOn.");
        if (this.pFT_SetBreakOff == IntPtr.Zero)
          Console.WriteLine("Failed to load function FT_SetBreakOff.");
      }
      return ftStatus;
    }

    public FTDI.FT_STATUS SetResetPipeRetryCount(uint ResetPipeRetryCount)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetResetPipeRetryCount != IntPtr.Zero)
      {
        FTDI.tFT_SetResetPipeRetryCount forFunctionPointer = (FTDI.tFT_SetResetPipeRetryCount) Marshal.GetDelegateForFunctionPointer(this.pFT_SetResetPipeRetryCount, typeof (FTDI.tFT_SetResetPipeRetryCount));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, ResetPipeRetryCount);
      }
      else if (this.pFT_SetResetPipeRetryCount == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_SetResetPipeRetryCount.");
      return ftStatus;
    }

    public FTDI.FT_STATUS GetDriverVersion(ref uint DriverVersion)
    {
      FTDI.FT_STATUS driverVersion = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return driverVersion;
      if (this.pFT_GetDriverVersion != IntPtr.Zero)
      {
        FTDI.tFT_GetDriverVersion forFunctionPointer = (FTDI.tFT_GetDriverVersion) Marshal.GetDelegateForFunctionPointer(this.pFT_GetDriverVersion, typeof (FTDI.tFT_GetDriverVersion));
        if (this.ftHandle != IntPtr.Zero)
          driverVersion = forFunctionPointer(this.ftHandle, ref DriverVersion);
      }
      else if (this.pFT_GetDriverVersion == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetDriverVersion.");
      return driverVersion;
    }

    public FTDI.FT_STATUS GetLibraryVersion(ref uint LibraryVersion)
    {
      FTDI.FT_STATUS libraryVersion = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return libraryVersion;
      if (this.pFT_GetLibraryVersion != IntPtr.Zero)
        libraryVersion = ((FTDI.tFT_GetLibraryVersion) Marshal.GetDelegateForFunctionPointer(this.pFT_GetLibraryVersion, typeof (FTDI.tFT_GetLibraryVersion)))(ref LibraryVersion);
      else if (this.pFT_GetLibraryVersion == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetLibraryVersion.");
      return libraryVersion;
    }

    public FTDI.FT_STATUS SetDeadmanTimeout(uint DeadmanTimeout)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetDeadmanTimeout != IntPtr.Zero)
      {
        FTDI.tFT_SetDeadmanTimeout forFunctionPointer = (FTDI.tFT_SetDeadmanTimeout) Marshal.GetDelegateForFunctionPointer(this.pFT_SetDeadmanTimeout, typeof (FTDI.tFT_SetDeadmanTimeout));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, DeadmanTimeout);
      }
      else if (this.pFT_SetDeadmanTimeout == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_SetDeadmanTimeout.");
      return ftStatus;
    }

    public FTDI.FT_STATUS SetLatency(byte Latency)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetLatencyTimer != IntPtr.Zero)
      {
        FTDI.tFT_SetLatencyTimer forFunctionPointer = (FTDI.tFT_SetLatencyTimer) Marshal.GetDelegateForFunctionPointer(this.pFT_SetLatencyTimer, typeof (FTDI.tFT_SetLatencyTimer));
        if (this.ftHandle != IntPtr.Zero)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_UNKNOWN;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if ((DeviceType == FTDI.FT_DEVICE.FT_DEVICE_BM || DeviceType == FTDI.FT_DEVICE.FT_DEVICE_2232) && Latency < (byte) 2)
            Latency = (byte) 2;
          ftStatus = forFunctionPointer(this.ftHandle, Latency);
        }
      }
      else if (this.pFT_SetLatencyTimer == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_SetLatencyTimer.");
      return ftStatus;
    }

    public FTDI.FT_STATUS GetLatency(ref byte Latency)
    {
      FTDI.FT_STATUS latency = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return latency;
      if (this.pFT_GetLatencyTimer != IntPtr.Zero)
      {
        FTDI.tFT_GetLatencyTimer forFunctionPointer = (FTDI.tFT_GetLatencyTimer) Marshal.GetDelegateForFunctionPointer(this.pFT_GetLatencyTimer, typeof (FTDI.tFT_GetLatencyTimer));
        if (this.ftHandle != IntPtr.Zero)
          latency = forFunctionPointer(this.ftHandle, ref Latency);
      }
      else if (this.pFT_GetLatencyTimer == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetLatencyTimer.");
      return latency;
    }

    public FTDI.FT_STATUS InTransferSize(uint InTransferSize)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetUSBParameters != IntPtr.Zero)
      {
        FTDI.tFT_SetUSBParameters forFunctionPointer = (FTDI.tFT_SetUSBParameters) Marshal.GetDelegateForFunctionPointer(this.pFT_SetUSBParameters, typeof (FTDI.tFT_SetUSBParameters));
        uint dwOutTransferSize = InTransferSize;
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, InTransferSize, dwOutTransferSize);
      }
      else if (this.pFT_SetUSBParameters == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_SetUSBParameters.");
      return ftStatus;
    }

    public FTDI.FT_STATUS SetCharacters(
      byte EventChar,
      bool EventCharEnable,
      byte ErrorChar,
      bool ErrorCharEnable)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_SetChars != IntPtr.Zero)
      {
        FTDI.tFT_SetChars forFunctionPointer = (FTDI.tFT_SetChars) Marshal.GetDelegateForFunctionPointer(this.pFT_SetChars, typeof (FTDI.tFT_SetChars));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, EventChar, Convert.ToByte(EventCharEnable), ErrorChar, Convert.ToByte(ErrorCharEnable));
      }
      else if (this.pFT_SetChars == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_SetChars.");
      return ftStatus;
    }

    public FTDI.FT_STATUS EEUserAreaSize(ref uint UASize)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_EE_UASize != IntPtr.Zero)
      {
        FTDI.tFT_EE_UASize forFunctionPointer = (FTDI.tFT_EE_UASize) Marshal.GetDelegateForFunctionPointer(this.pFT_EE_UASize, typeof (FTDI.tFT_EE_UASize));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, ref UASize);
      }
      else if (this.pFT_EE_UASize == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_EE_UASize.");
      return ftStatus;
    }

    public FTDI.FT_STATUS GetCOMPort(out string ComPortName)
    {
      FTDI.FT_STATUS comPort = FTDI.FT_STATUS.FT_OTHER_ERROR;
      ComPortName = string.Empty;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return comPort;
      if (this.pFT_GetComPortNumber != IntPtr.Zero)
      {
        FTDI.tFT_GetComPortNumber forFunctionPointer = (FTDI.tFT_GetComPortNumber) Marshal.GetDelegateForFunctionPointer(this.pFT_GetComPortNumber, typeof (FTDI.tFT_GetComPortNumber));
        int dwComPortNumber = -1;
        if (this.ftHandle != IntPtr.Zero)
          comPort = forFunctionPointer(this.ftHandle, ref dwComPortNumber);
        ComPortName = dwComPortNumber != -1 ? "COM" + dwComPortNumber.ToString() : string.Empty;
      }
      else if (this.pFT_GetComPortNumber == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_GetComPortNumber.");
      return comPort;
    }

    public FTDI.FT_STATUS VendorCmdGet(ushort request, byte[] buf, ushort len)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_VendorCmdGet != IntPtr.Zero)
      {
        FTDI.tFT_VendorCmdGet forFunctionPointer = (FTDI.tFT_VendorCmdGet) Marshal.GetDelegateForFunctionPointer(this.pFT_VendorCmdGet, typeof (FTDI.tFT_VendorCmdGet));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, request, buf, len);
      }
      else if (this.pFT_VendorCmdGet == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_VendorCmdGet.");
      return ftStatus;
    }

    public FTDI.FT_STATUS VendorCmdSet(ushort request, byte[] buf, ushort len)
    {
      FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OTHER_ERROR;
      if (this.hFTD2XXDLL == IntPtr.Zero)
        return ftStatus;
      if (this.pFT_VendorCmdSet != IntPtr.Zero)
      {
        FTDI.tFT_VendorCmdSet forFunctionPointer = (FTDI.tFT_VendorCmdSet) Marshal.GetDelegateForFunctionPointer(this.pFT_VendorCmdSet, typeof (FTDI.tFT_VendorCmdSet));
        if (this.ftHandle != IntPtr.Zero)
          ftStatus = forFunctionPointer(this.ftHandle, request, buf, len);
      }
      else if (this.pFT_VendorCmdSet == IntPtr.Zero)
        Console.WriteLine("Failed to load function FT_VendorCmdSet.");
      return ftStatus;
    }

    public bool IsOpen => !(this.ftHandle == IntPtr.Zero);

    private string InterfaceIdentifier
    {
      get
      {
        string empty = string.Empty;
        if (this.IsOpen)
        {
          FTDI.FT_DEVICE DeviceType = FTDI.FT_DEVICE.FT_DEVICE_BM;
          int deviceType = (int) this.GetDeviceType(ref DeviceType);
          if (DeviceType == FTDI.FT_DEVICE.FT_DEVICE_2232 | DeviceType == FTDI.FT_DEVICE.FT_DEVICE_2232H | DeviceType == FTDI.FT_DEVICE.FT_DEVICE_4232H)
          {
            string Description;
            int description = (int) this.GetDescription(out Description);
            return Description.Substring(checked (Description.Length - 1));
          }
        }
        return empty;
      }
    }

    private void ErrorHandler(FTDI.FT_STATUS ftStatus, FTDI.FT_ERROR ftErrorCondition)
    {
      switch (ftStatus)
      {
        case FTDI.FT_STATUS.FT_INVALID_HANDLE:
          throw new FTDI.FT_EXCEPTION("Invalid handle for FTDI device.");
        case FTDI.FT_STATUS.FT_DEVICE_NOT_FOUND:
          throw new FTDI.FT_EXCEPTION("FTDI device not found.");
        case FTDI.FT_STATUS.FT_DEVICE_NOT_OPENED:
          throw new FTDI.FT_EXCEPTION("FTDI device not opened.");
        case FTDI.FT_STATUS.FT_IO_ERROR:
          throw new FTDI.FT_EXCEPTION("FTDI device IO error.");
        case FTDI.FT_STATUS.FT_INSUFFICIENT_RESOURCES:
          throw new FTDI.FT_EXCEPTION("Insufficient resources.");
        case FTDI.FT_STATUS.FT_INVALID_PARAMETER:
          throw new FTDI.FT_EXCEPTION("Invalid parameter for FTD2XX function call.");
        case FTDI.FT_STATUS.FT_INVALID_BAUD_RATE:
          throw new FTDI.FT_EXCEPTION("Invalid Baud rate for FTDI device.");
        case FTDI.FT_STATUS.FT_DEVICE_NOT_OPENED_FOR_ERASE:
          throw new FTDI.FT_EXCEPTION("FTDI device not opened for erase.");
        case FTDI.FT_STATUS.FT_DEVICE_NOT_OPENED_FOR_WRITE:
          throw new FTDI.FT_EXCEPTION("FTDI device not opened for write.");
        case FTDI.FT_STATUS.FT_FAILED_TO_WRITE_DEVICE:
          throw new FTDI.FT_EXCEPTION("Failed to write to FTDI device.");
        case FTDI.FT_STATUS.FT_EEPROM_READ_FAILED:
          throw new FTDI.FT_EXCEPTION("Failed to read FTDI device EEPROM.");
        case FTDI.FT_STATUS.FT_EEPROM_WRITE_FAILED:
          throw new FTDI.FT_EXCEPTION("Failed to write FTDI device EEPROM.");
        case FTDI.FT_STATUS.FT_EEPROM_ERASE_FAILED:
          throw new FTDI.FT_EXCEPTION("Failed to erase FTDI device EEPROM.");
        case FTDI.FT_STATUS.FT_EEPROM_NOT_PRESENT:
          throw new FTDI.FT_EXCEPTION("No EEPROM fitted to FTDI device.");
        case FTDI.FT_STATUS.FT_EEPROM_NOT_PROGRAMMED:
          throw new FTDI.FT_EXCEPTION("FTDI device EEPROM not programmed.");
        case FTDI.FT_STATUS.FT_INVALID_ARGS:
          throw new FTDI.FT_EXCEPTION("Invalid arguments for FTD2XX function call.");
        case FTDI.FT_STATUS.FT_OTHER_ERROR:
          throw new FTDI.FT_EXCEPTION("An unexpected error has occurred when trying to communicate with the FTDI device.");
        default:
          switch (ftErrorCondition)
          {
            case FTDI.FT_ERROR.FT_NO_ERROR:
              return;
            case FTDI.FT_ERROR.FT_INCORRECT_DEVICE:
              throw new FTDI.FT_EXCEPTION("The current device type does not match the EEPROM structure.");
            case FTDI.FT_ERROR.FT_INVALID_BITMODE:
              throw new FTDI.FT_EXCEPTION("The requested bit mode is not valid for the current device.");
            case FTDI.FT_ERROR.FT_BUFFER_SIZE:
              throw new FTDI.FT_EXCEPTION("The supplied buffer is not big enough.");
            default:
              return;
          }
      }
    }

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_CreateDeviceInfoList(ref uint numdevs);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_GetDeviceInfoDetail(
      uint index,
      ref uint flags,
      ref FTDI.FT_DEVICE chiptype,
      ref uint id,
      ref uint locid,
      byte[] serialnumber,
      byte[] description,
      ref IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_Open(uint index, ref IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_OpenEx(
      string devstring,
      uint dwFlags,
      ref IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_OpenExLoc(
      uint devloc,
      uint dwFlags,
      ref IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_Close(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_Read(
      IntPtr ftHandle,
      byte[] lpBuffer,
      uint dwBytesToRead,
      ref uint lpdwBytesReturned);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_Write(
      IntPtr ftHandle,
      byte[] lpBuffer,
      uint dwBytesToWrite,
      ref uint lpdwBytesWritten);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_GetQueueStatus(
      IntPtr ftHandle,
      ref uint lpdwAmountInRxQueue);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_GetModemStatus(
      IntPtr ftHandle,
      ref uint lpdwModemStatus);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_GetStatus(
      IntPtr ftHandle,
      ref uint lpdwAmountInRxQueue,
      ref uint lpdwAmountInTxQueue,
      ref uint lpdwEventStatus);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetBaudRate(IntPtr ftHandle, uint dwBaudRate);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetDataCharacteristics(
      IntPtr ftHandle,
      byte uWordLength,
      byte uStopBits,
      byte uParity);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetFlowControl(
      IntPtr ftHandle,
      ushort usFlowControl,
      byte uXon,
      byte uXoff);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetDtr(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_ClrDtr(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetRts(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_ClrRts(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_ResetDevice(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_ResetPort(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_CyclePort(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_Rescan();

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_Reload(ushort wVID, ushort wPID);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_Purge(IntPtr ftHandle, uint dwMask);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetTimeouts(
      IntPtr ftHandle,
      uint dwReadTimeout,
      uint dwWriteTimeout);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetBreakOn(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetBreakOff(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_GetDeviceInfo(
      IntPtr ftHandle,
      ref FTDI.FT_DEVICE pftType,
      ref uint lpdwID,
      byte[] pcSerialNumber,
      byte[] pcDescription,
      IntPtr pvDummy);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetResetPipeRetryCount(IntPtr ftHandle, uint dwCount);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_StopInTask(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_RestartInTask(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_GetDriverVersion(
      IntPtr ftHandle,
      ref uint lpdwDriverVersion);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_GetLibraryVersion(ref uint lpdwLibraryVersion);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetDeadmanTimeout(
      IntPtr ftHandle,
      uint dwDeadmanTimeout);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetChars(
      IntPtr ftHandle,
      byte uEventCh,
      byte uEventChEn,
      byte uErrorCh,
      byte uErrorChEn);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetEventNotification(
      IntPtr ftHandle,
      uint dwEventMask,
      SafeHandle hEvent);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_GetComPortNumber(
      IntPtr ftHandle,
      ref int dwComPortNumber);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetLatencyTimer(IntPtr ftHandle, byte ucLatency);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_GetLatencyTimer(IntPtr ftHandle, ref byte ucLatency);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetBitMode(IntPtr ftHandle, byte ucMask, byte ucMode);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_GetBitMode(IntPtr ftHandle, ref byte ucMode);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_SetUSBParameters(
      IntPtr ftHandle,
      uint dwInTransferSize,
      uint dwOutTransferSize);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_ReadEE(
      IntPtr ftHandle,
      uint dwWordOffset,
      ref ushort lpwValue);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_WriteEE(
      IntPtr ftHandle,
      uint dwWordOffset,
      ushort wValue);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_EraseEE(IntPtr ftHandle);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_EE_UASize(IntPtr ftHandle, ref uint dwSize);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_EE_UARead(
      IntPtr ftHandle,
      byte[] pucData,
      int dwDataLen,
      ref uint lpdwDataRead);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_EE_UAWrite(
      IntPtr ftHandle,
      byte[] pucData,
      int dwDataLen);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_EE_Read(IntPtr ftHandle, FTDI.FT_PROGRAM_DATA pData);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_EE_Program(IntPtr ftHandle, FTDI.FT_PROGRAM_DATA pData);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_EEPROM_Read(
      IntPtr ftHandle,
      IntPtr eepromData,
      uint eepromDataSize,
      byte[] manufacturer,
      byte[] manufacturerID,
      byte[] description,
      byte[] serialnumber);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_EEPROM_Program(
      IntPtr ftHandle,
      IntPtr eepromData,
      uint eepromDataSize,
      byte[] manufacturer,
      byte[] manufacturerID,
      byte[] description,
      byte[] serialnumber);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_VendorCmdGet(
      IntPtr ftHandle,
      ushort request,
      byte[] buf,
      ushort len);

    [UnmanagedFunctionPointer(CallingConvention.StdCall)]
    private delegate FTDI.FT_STATUS tFT_VendorCmdSet(
      IntPtr ftHandle,
      ushort request,
      byte[] buf,
      ushort len);

    public enum FT_STATUS
    {
      FT_OK,
      FT_INVALID_HANDLE,
      FT_DEVICE_NOT_FOUND,
      FT_DEVICE_NOT_OPENED,
      FT_IO_ERROR,
      FT_INSUFFICIENT_RESOURCES,
      FT_INVALID_PARAMETER,
      FT_INVALID_BAUD_RATE,
      FT_DEVICE_NOT_OPENED_FOR_ERASE,
      FT_DEVICE_NOT_OPENED_FOR_WRITE,
      FT_FAILED_TO_WRITE_DEVICE,
      FT_EEPROM_READ_FAILED,
      FT_EEPROM_WRITE_FAILED,
      FT_EEPROM_ERASE_FAILED,
      FT_EEPROM_NOT_PRESENT,
      FT_EEPROM_NOT_PROGRAMMED,
      FT_INVALID_ARGS,
      FT_OTHER_ERROR,
    }

    private enum FT_ERROR
    {
      FT_NO_ERROR,
      FT_INCORRECT_DEVICE,
      FT_INVALID_BITMODE,
      FT_BUFFER_SIZE,
    }

    public class FT_DATA_BITS
    {
      public const byte FT_BITS_8 = 8;
      public const byte FT_BITS_7 = 7;
    }

    public class FT_STOP_BITS
    {
      public const byte FT_STOP_BITS_1 = 0;
      public const byte FT_STOP_BITS_2 = 2;
    }

    public class FT_PARITY
    {
      public const byte FT_PARITY_NONE = 0;
      public const byte FT_PARITY_ODD = 1;
      public const byte FT_PARITY_EVEN = 2;
      public const byte FT_PARITY_MARK = 3;
      public const byte FT_PARITY_SPACE = 4;
    }

    public class FT_FLOW_CONTROL
    {
      public const ushort FT_FLOW_NONE = 0;
      public const ushort FT_FLOW_RTS_CTS = 256;
      public const ushort FT_FLOW_DTR_DSR = 512;
      public const ushort FT_FLOW_XON_XOFF = 1024;
    }

    public class FT_PURGE
    {
      public const byte FT_PURGE_RX = 1;
      public const byte FT_PURGE_TX = 2;
    }

    public class FT_MODEM_STATUS
    {
      public const byte FT_CTS = 16;
      public const byte FT_DSR = 32;
      public const byte FT_RI = 64;
      public const byte FT_DCD = 128;
    }

    public class FT_LINE_STATUS
    {
      public const byte FT_OE = 2;
      public const byte FT_PE = 4;
      public const byte FT_FE = 8;
      public const byte FT_BI = 16;
    }

    public class FT_EVENTS
    {
      public const uint FT_EVENT_RXCHAR = 1;
      public const uint FT_EVENT_MODEM_STATUS = 2;
      public const uint FT_EVENT_LINE_STATUS = 4;
    }

    public class FT_BIT_MODES
    {
      public const byte FT_BIT_MODE_RESET = 0;
      public const byte FT_BIT_MODE_ASYNC_BITBANG = 1;
      public const byte FT_BIT_MODE_MPSSE = 2;
      public const byte FT_BIT_MODE_SYNC_BITBANG = 4;
      public const byte FT_BIT_MODE_MCU_HOST = 8;
      public const byte FT_BIT_MODE_FAST_SERIAL = 16;
      public const byte FT_BIT_MODE_CBUS_BITBANG = 32;
      public const byte FT_BIT_MODE_SYNC_FIFO = 64;
    }

    public class FT_CBUS_OPTIONS
    {
      public const byte FT_CBUS_TXDEN = 0;
      public const byte FT_CBUS_PWRON = 1;
      public const byte FT_CBUS_RXLED = 2;
      public const byte FT_CBUS_TXLED = 3;
      public const byte FT_CBUS_TXRXLED = 4;
      public const byte FT_CBUS_SLEEP = 5;
      public const byte FT_CBUS_CLK48 = 6;
      public const byte FT_CBUS_CLK24 = 7;
      public const byte FT_CBUS_CLK12 = 8;
      public const byte FT_CBUS_CLK6 = 9;
      public const byte FT_CBUS_IOMODE = 10;
      public const byte FT_CBUS_BITBANG_WR = 11;
      public const byte FT_CBUS_BITBANG_RD = 12;
    }

    public class FT_232H_CBUS_OPTIONS
    {
      public const byte FT_CBUS_TRISTATE = 0;
      public const byte FT_CBUS_RXLED = 1;
      public const byte FT_CBUS_TXLED = 2;
      public const byte FT_CBUS_TXRXLED = 3;
      public const byte FT_CBUS_PWREN = 4;
      public const byte FT_CBUS_SLEEP = 5;
      public const byte FT_CBUS_DRIVE_0 = 6;
      public const byte FT_CBUS_DRIVE_1 = 7;
      public const byte FT_CBUS_IOMODE = 8;
      public const byte FT_CBUS_TXDEN = 9;
      public const byte FT_CBUS_CLK30 = 10;
      public const byte FT_CBUS_CLK15 = 11;
      public const byte FT_CBUS_CLK7_5 = 12;
    }

    public class FT_XSERIES_CBUS_OPTIONS
    {
      public const byte FT_CBUS_TRISTATE = 0;
      public const byte FT_CBUS_RXLED = 1;
      public const byte FT_CBUS_TXLED = 2;
      public const byte FT_CBUS_TXRXLED = 3;
      public const byte FT_CBUS_PWREN = 4;
      public const byte FT_CBUS_SLEEP = 5;
      public const byte FT_CBUS_Drive_0 = 6;
      public const byte FT_CBUS_Drive_1 = 7;
      public const byte FT_CBUS_GPIO = 8;
      public const byte FT_CBUS_TXDEN = 9;
      public const byte FT_CBUS_CLK24MHz = 10;
      public const byte FT_CBUS_CLK12MHz = 11;
      public const byte FT_CBUS_CLK6MHz = 12;
      public const byte FT_CBUS_BCD_Charger = 13;
      public const byte FT_CBUS_BCD_Charger_N = 14;
      public const byte FT_CBUS_I2C_TXE = 15;
      public const byte FT_CBUS_I2C_RXF = 16;
      public const byte FT_CBUS_VBUS_Sense = 17;
      public const byte FT_CBUS_BitBang_WR = 18;
      public const byte FT_CBUS_BitBang_RD = 19;
      public const byte FT_CBUS_Time_Stamp = 20;
      public const byte FT_CBUS_Keep_Awake = 21;
    }

    public class FT_FLAGS
    {
      public const uint FT_FLAGS_OPENED = 1;
      public const uint FT_FLAGS_HISPEED = 2;
    }

    public class FT_DRIVE_CURRENT
    {
      public const byte FT_DRIVE_CURRENT_4MA = 4;
      public const byte FT_DRIVE_CURRENT_8MA = 8;
      public const byte FT_DRIVE_CURRENT_12MA = 12;
      public const byte FT_DRIVE_CURRENT_16MA = 16;
    }

    public enum FT_DEVICE
    {
      FT_DEVICE_BM,
      FT_DEVICE_AM,
      FT_DEVICE_100AX,
      FT_DEVICE_UNKNOWN,
      FT_DEVICE_2232,
      FT_DEVICE_232R,
      FT_DEVICE_2232H,
      FT_DEVICE_4232H,
      FT_DEVICE_232H,
      FT_DEVICE_X_SERIES,
      FT_DEVICE_4222H_0,
      FT_DEVICE_4222H_1_2,
      FT_DEVICE_4222H_3,
      FT_DEVICE_4222_PROG,
    }

    public class FT_DEVICE_INFO_NODE
    {
      public uint Flags;
      public FTDI.FT_DEVICE Type;
      public uint ID;
      public uint LocId;
      public string SerialNumber;
      public string Description;
      public IntPtr ftHandle;
    }

    [StructLayout(LayoutKind.Sequential, Pack = 4)]
    private class FT_PROGRAM_DATA
    {
      public uint Signature1;
      public uint Signature2;
      public uint Version;
      public ushort VendorID;
      public ushort ProductID;
      public IntPtr Manufacturer;
      public IntPtr ManufacturerID;
      public IntPtr Description;
      public IntPtr SerialNumber;
      public ushort MaxPower;
      public ushort PnP;
      public ushort SelfPowered;
      public ushort RemoteWakeup;
      public byte Rev4;
      public byte IsoIn;
      public byte IsoOut;
      public byte PullDownEnable;
      public byte SerNumEnable;
      public byte USBVersionEnable;
      public ushort USBVersion;
      public byte Rev5;
      public byte IsoInA;
      public byte IsoInB;
      public byte IsoOutA;
      public byte IsoOutB;
      public byte PullDownEnable5;
      public byte SerNumEnable5;
      public byte USBVersionEnable5;
      public ushort USBVersion5;
      public byte AIsHighCurrent;
      public byte BIsHighCurrent;
      public byte IFAIsFifo;
      public byte IFAIsFifoTar;
      public byte IFAIsFastSer;
      public byte AIsVCP;
      public byte IFBIsFifo;
      public byte IFBIsFifoTar;
      public byte IFBIsFastSer;
      public byte BIsVCP;
      public byte UseExtOsc;
      public byte HighDriveIOs;
      public byte EndpointSize;
      public byte PullDownEnableR;
      public byte SerNumEnableR;
      public byte InvertTXD;
      public byte InvertRXD;
      public byte InvertRTS;
      public byte InvertCTS;
      public byte InvertDTR;
      public byte InvertDSR;
      public byte InvertDCD;
      public byte InvertRI;
      public byte Cbus0;
      public byte Cbus1;
      public byte Cbus2;
      public byte Cbus3;
      public byte Cbus4;
      public byte RIsD2XX;
      public byte PullDownEnable7;
      public byte SerNumEnable7;
      public byte ALSlowSlew;
      public byte ALSchmittInput;
      public byte ALDriveCurrent;
      public byte AHSlowSlew;
      public byte AHSchmittInput;
      public byte AHDriveCurrent;
      public byte BLSlowSlew;
      public byte BLSchmittInput;
      public byte BLDriveCurrent;
      public byte BHSlowSlew;
      public byte BHSchmittInput;
      public byte BHDriveCurrent;
      public byte IFAIsFifo7;
      public byte IFAIsFifoTar7;
      public byte IFAIsFastSer7;
      public byte AIsVCP7;
      public byte IFBIsFifo7;
      public byte IFBIsFifoTar7;
      public byte IFBIsFastSer7;
      public byte BIsVCP7;
      public byte PowerSaveEnable;
      public byte PullDownEnable8;
      public byte SerNumEnable8;
      public byte ASlowSlew;
      public byte ASchmittInput;
      public byte ADriveCurrent;
      public byte BSlowSlew;
      public byte BSchmittInput;
      public byte BDriveCurrent;
      public byte CSlowSlew;
      public byte CSchmittInput;
      public byte CDriveCurrent;
      public byte DSlowSlew;
      public byte DSchmittInput;
      public byte DDriveCurrent;
      public byte ARIIsTXDEN;
      public byte BRIIsTXDEN;
      public byte CRIIsTXDEN;
      public byte DRIIsTXDEN;
      public byte AIsVCP8;
      public byte BIsVCP8;
      public byte CIsVCP8;
      public byte DIsVCP8;
      public byte PullDownEnableH;
      public byte SerNumEnableH;
      public byte ACSlowSlewH;
      public byte ACSchmittInputH;
      public byte ACDriveCurrentH;
      public byte ADSlowSlewH;
      public byte ADSchmittInputH;
      public byte ADDriveCurrentH;
      public byte Cbus0H;
      public byte Cbus1H;
      public byte Cbus2H;
      public byte Cbus3H;
      public byte Cbus4H;
      public byte Cbus5H;
      public byte Cbus6H;
      public byte Cbus7H;
      public byte Cbus8H;
      public byte Cbus9H;
      public byte IsFifoH;
      public byte IsFifoTarH;
      public byte IsFastSerH;
      public byte IsFT1248H;
      public byte FT1248CpolH;
      public byte FT1248LsbH;
      public byte FT1248FlowControlH;
      public byte IsVCPH;
      public byte PowerSaveEnableH;
    }

    [StructLayout(LayoutKind.Sequential, Pack = 4)]
    private struct FT_EEPROM_HEADER
    {
      public uint deviceType;
      public ushort VendorId;
      public ushort ProductId;
      public byte SerNumEnable;
      public ushort MaxPower;
      public byte SelfPowered;
      public byte RemoteWakeup;
      public byte PullDownEnable;
    }

    [StructLayout(LayoutKind.Sequential, Pack = 4)]
    private struct FT_XSERIES_DATA
    {
      public FTDI.FT_EEPROM_HEADER common;
      public byte ACSlowSlew;
      public byte ACSchmittInput;
      public byte ACDriveCurrent;
      public byte ADSlowSlew;
      public byte ADSchmittInput;
      public byte ADDriveCurrent;
      public byte Cbus0;
      public byte Cbus1;
      public byte Cbus2;
      public byte Cbus3;
      public byte Cbus4;
      public byte Cbus5;
      public byte Cbus6;
      public byte InvertTXD;
      public byte InvertRXD;
      public byte InvertRTS;
      public byte InvertCTS;
      public byte InvertDTR;
      public byte InvertDSR;
      public byte InvertDCD;
      public byte InvertRI;
      public byte BCDEnable;
      public byte BCDForceCbusPWREN;
      public byte BCDDisableSleep;
      public ushort I2CSlaveAddress;
      public uint I2CDeviceId;
      public byte I2CDisableSchmitt;
      public byte FT1248Cpol;
      public byte FT1248Lsb;
      public byte FT1248FlowControl;
      public byte RS485EchoSuppress;
      public byte PowerSaveEnable;
      public byte DriverType;
    }

    public class FT_EEPROM_DATA
    {
      public ushort VendorID = 1027;
      public ushort ProductID = 24577;
      public string Manufacturer = nameof (FTDI);
      public string ManufacturerID = "FT";
      public string Description = "USB-Serial Converter";
      public string SerialNumber = "";
      public ushort MaxPower = 144;
      public bool SelfPowered;
      public bool RemoteWakeup;
    }

    public class FT232B_EEPROM_STRUCTURE : FTDI.FT_EEPROM_DATA
    {
      public bool PullDownEnable;
      public bool SerNumEnable = true;
      public bool USBVersionEnable = true;
      public ushort USBVersion = 512;
    }

    public class FT2232_EEPROM_STRUCTURE : FTDI.FT_EEPROM_DATA
    {
      public bool PullDownEnable;
      public bool SerNumEnable = true;
      public bool USBVersionEnable = true;
      public ushort USBVersion = 512;
      public bool AIsHighCurrent;
      public bool BIsHighCurrent;
      public bool IFAIsFifo;
      public bool IFAIsFifoTar;
      public bool IFAIsFastSer;
      public bool AIsVCP = true;
      public bool IFBIsFifo;
      public bool IFBIsFifoTar;
      public bool IFBIsFastSer;
      public bool BIsVCP = true;
    }

    public class FT232R_EEPROM_STRUCTURE : FTDI.FT_EEPROM_DATA
    {
      public bool UseExtOsc;
      public bool HighDriveIOs;
      public byte EndpointSize = 64;
      public bool PullDownEnable;
      public bool SerNumEnable = true;
      public bool InvertTXD;
      public bool InvertRXD;
      public bool InvertRTS;
      public bool InvertCTS;
      public bool InvertDTR;
      public bool InvertDSR;
      public bool InvertDCD;
      public bool InvertRI;
      public byte Cbus0 = 5;
      public byte Cbus1 = 5;
      public byte Cbus2 = 5;
      public byte Cbus3 = 5;
      public byte Cbus4 = 5;
      public bool RIsD2XX;
    }

    public class FT2232H_EEPROM_STRUCTURE : FTDI.FT_EEPROM_DATA
    {
      public bool PullDownEnable;
      public bool SerNumEnable = true;
      public bool ALSlowSlew;
      public bool ALSchmittInput;
      public byte ALDriveCurrent = 4;
      public bool AHSlowSlew;
      public bool AHSchmittInput;
      public byte AHDriveCurrent = 4;
      public bool BLSlowSlew;
      public bool BLSchmittInput;
      public byte BLDriveCurrent = 4;
      public bool BHSlowSlew;
      public bool BHSchmittInput;
      public byte BHDriveCurrent = 4;
      public bool IFAIsFifo;
      public bool IFAIsFifoTar;
      public bool IFAIsFastSer;
      public bool AIsVCP = true;
      public bool IFBIsFifo;
      public bool IFBIsFifoTar;
      public bool IFBIsFastSer;
      public bool BIsVCP = true;
      public bool PowerSaveEnable;
    }

    public class FT4232H_EEPROM_STRUCTURE : FTDI.FT_EEPROM_DATA
    {
      public bool PullDownEnable;
      public bool SerNumEnable = true;
      public bool ASlowSlew;
      public bool ASchmittInput;
      public byte ADriveCurrent = 4;
      public bool BSlowSlew;
      public bool BSchmittInput;
      public byte BDriveCurrent = 4;
      public bool CSlowSlew;
      public bool CSchmittInput;
      public byte CDriveCurrent = 4;
      public bool DSlowSlew;
      public bool DSchmittInput;
      public byte DDriveCurrent = 4;
      public bool ARIIsTXDEN;
      public bool BRIIsTXDEN;
      public bool CRIIsTXDEN;
      public bool DRIIsTXDEN;
      public bool AIsVCP = true;
      public bool BIsVCP = true;
      public bool CIsVCP = true;
      public bool DIsVCP = true;
    }

    public class FT232H_EEPROM_STRUCTURE : FTDI.FT_EEPROM_DATA
    {
      public bool PullDownEnable;
      public bool SerNumEnable = true;
      public bool ACSlowSlew;
      public bool ACSchmittInput;
      public byte ACDriveCurrent = 4;
      public bool ADSlowSlew;
      public bool ADSchmittInput;
      public byte ADDriveCurrent = 4;
      public byte Cbus0;
      public byte Cbus1;
      public byte Cbus2;
      public byte Cbus3;
      public byte Cbus4;
      public byte Cbus5;
      public byte Cbus6;
      public byte Cbus7;
      public byte Cbus8;
      public byte Cbus9;
      public bool IsFifo;
      public bool IsFifoTar;
      public bool IsFastSer;
      public bool IsFT1248;
      public bool FT1248Cpol;
      public bool FT1248Lsb;
      public bool FT1248FlowControl;
      public bool IsVCP = true;
      public bool PowerSaveEnable;
    }

    public class FT_XSERIES_EEPROM_STRUCTURE : FTDI.FT_EEPROM_DATA
    {
      public bool PullDownEnable;
      public bool SerNumEnable = true;
      public bool USBVersionEnable = true;
      public ushort USBVersion = 512;
      public byte ACSlowSlew;
      public byte ACSchmittInput;
      public byte ACDriveCurrent;
      public byte ADSlowSlew;
      public byte ADSchmittInput;
      public byte ADDriveCurrent;
      public byte Cbus0;
      public byte Cbus1;
      public byte Cbus2;
      public byte Cbus3;
      public byte Cbus4;
      public byte Cbus5;
      public byte Cbus6;
      public byte InvertTXD;
      public byte InvertRXD;
      public byte InvertRTS;
      public byte InvertCTS;
      public byte InvertDTR;
      public byte InvertDSR;
      public byte InvertDCD;
      public byte InvertRI;
      public byte BCDEnable;
      public byte BCDForceCbusPWREN;
      public byte BCDDisableSleep;
      public ushort I2CSlaveAddress;
      public uint I2CDeviceId;
      public byte I2CDisableSchmitt;
      public byte FT1248Cpol;
      public byte FT1248Lsb;
      public byte FT1248FlowControl;
      public byte RS485EchoSuppress;
      public byte PowerSaveEnable;
      public byte IsVCP;
    }

    [Serializable]
    public class FT_EXCEPTION : Exception
    {
      public FT_EXCEPTION()
      {
      }

      public FT_EXCEPTION(string message)
        : base(message)
      {
      }

      public FT_EXCEPTION(string message, Exception inner)
        : base(message, inner)
      {
      }

      protected FT_EXCEPTION(SerializationInfo info, StreamingContext context)
        : base(info, context)
      {
      }
    }
  }
}
