﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.Features.BizhawkBSNESFeatures
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Collections.Generic;

namespace ConnectorLib.Features
{
  [Serializable]
  public class BizhawkBSNESFeatures : IFeatureAware
  {
    public AccessLevel Access(ulong address)
    {
      ulong num1 = address;
      if (num1 >= 7340032UL && num1 <= 8257535UL)
        return AccessLevel.Read | AccessLevel.Write | AccessLevel.Freeze;
      ulong num2 = address;
      if (num2 >= 8257536UL && num2 <= 8388607UL)
        return AccessLevel.Read | AccessLevel.Write | AccessLevel.Freeze;
      if (address <= 16777215UL)
        return AccessLevel.Read;
      throw new ArgumentOutOfRangeException(nameof (address));
    }

    public AccessLevel Access(ulong address, string domain)
    {
      AccessLevel accessLevel;
      switch (domain)
      {
        case "System Bus":
          accessLevel = this.Access(address);
          break;
        default:
          accessLevel = this.Access(domain);
          break;
      }
      return accessLevel;
    }

    public AccessLevel Access(string domain)
    {
      switch (domain)
      {
        case "System Bus":
          return AccessLevel.Mixed;
        case "WRAM":
          return AccessLevel.Read | AccessLevel.Write | AccessLevel.Freeze;
        case "CARTRAM":
          return AccessLevel.Read | AccessLevel.Write | AccessLevel.Freeze;
        case "CARTROM":
          return AccessLevel.Read;
        default:
          throw new ArgumentOutOfRangeException(nameof (domain));
      }
    }

    public IEnumerable<string> Domains => (IEnumerable<string>) new string[7]
    {
      "WRAM",
      "CARTROM",
      "CARTRAM",
      "VRAM",
      "OAM",
      "CGRAM",
      "APURAM"
    };

    public bool CanSatisfy(Capability capability) => this.Access(capability.Address).HasFlag((Enum) capability.Access);
  }
}
