﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.Features.BizhawkMupen64PlusFeatures
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Collections.Generic;

namespace ConnectorLib.Features
{
  [Serializable]
  public class BizhawkMupen64PlusFeatures : IFeatureAware
  {
    public AccessLevel Access(ulong address)
    {
      ulong num1 = address;
      if (num1 >= 2147483648UL && num1 <= 2684354559UL)
        return AccessLevel.Read | AccessLevel.Write | AccessLevel.Freeze;
      ulong num2 = address;
      if (num2 >= 2684354560UL && num2 <= 3221225471UL)
        return AccessLevel.Read | AccessLevel.Write | AccessLevel.Freeze;
      throw new ArgumentOutOfRangeException(nameof (address));
    }

    public AccessLevel Access(ulong address, string domain)
    {
      switch (domain)
      {
        case "System Bus":
          return this.Access(address);
        default:
          return this.Access(domain);
      }
    }

    public AccessLevel Access(string domain)
    {
      switch (domain)
      {
        case "System Bus":
          return AccessLevel.Mixed;
        case "RDRAM":
        case "EEPROM":
          return AccessLevel.Read | AccessLevel.Write | AccessLevel.Freeze;
        case "ROM":
          return AccessLevel.Read;
        default:
          throw new ArgumentOutOfRangeException(nameof (domain));
      }
    }

    public IEnumerable<string> Domains => (IEnumerable<string>) new string[8]
    {
      "RDRAM",
      "ROM",
      "PI Register",
      "SI Register",
      "VI Register",
      "RI Register",
      "AI Register",
      "EEPROM"
    };

    public bool CanSatisfy(Capability capability) => this.Access(capability.Address).HasFlag((Enum) capability.Access);
  }
}
