﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.TeensyGBLink
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using ConnectorLib.HIDTools;
using System;
using System.Collections.Generic;
using System.Linq;

namespace ConnectorLib
{
  public class TeensyGBLink : IPipelineProvider
  {
    private readonly HIDStream _stream;

    public static IEnumerable<HIDInfo> GetDevices() => HIDBrowse.Browse().Where<HIDInfo>((Func<HIDInfo, bool>) (next => string.Equals(next.Product, "Teensyduino RawHID", StringComparison.InvariantCultureIgnoreCase)));

    public TeensyGBLink() => this._stream = new HIDStream(TeensyGBLink.GetDevices().FirstOrDefault<HIDInfo>() ?? throw new Exception("The Teensy GB Link Device was not found."));

    public bool Connected => this._stream.IsOpen();

    bool IPipelineProvider.Send(byte[] data) => this.Send((IEnumerable<byte>) data);

    public bool Send(IEnumerable<byte> data) => data.All<byte>((Func<byte, bool>) (b => this.TryExchangeByte(b, out byte _)));

    public bool TryExchangeByte(byte data, out byte exchange)
    {
      try
      {
        int num = this._stream.ReadByte();
        if (num < 0)
        {
          exchange = byte.MaxValue;
          return false;
        }
        exchange = checked ((byte) num);
        if (exchange != (byte) 0)
          return false;
        this._stream.WriteByte(data);
        return true;
      }
      catch (Exception ex)
      {
        Log.Debug((object) ex);
        exchange = byte.MaxValue;
        return false;
      }
    }
  }
}
