﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.GeckoConnector`1
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using ConnectorLib.Patches;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using WebSocketSharp;

namespace ConnectorLib
{
  public class GeckoConnector<T> : 
    ConnectorBase,
    IVirtualConnector,
    IN64Connector,
    IGameConnector,
    IDisposable,
    IAddressableConnector,
    IROMProcessor,
    I64BitConnector,
    I32BitConnector,
    I16BitConnector,
    I8BitConnector,
    IGCNConnector,
    IWiiConnector,
    IWiiUConnector
    where T : IGeckoProvider, new()
  {
    public readonly IGeckoProvider Provider;
    private const uint RX_SIZE = 1024;
    private const uint TX_SIZE = 1024;
    private const byte BLK_ZERO = 176;
    private const byte BLK_NONZERO = 189;
    private volatile bool _canceling;

    public GeckoConnector() => this.Provider = (IGeckoProvider) new T();

    public IBatchWriteContext OpenBatchWriteContext() => (IBatchWriteContext) new NullContext();

    public bool SendMessage(string message)
    {
      EventHandler<string> onMessage = this.OnMessage;
      if (onMessage != null)
        onMessage((object) this, message);
      return true;
    }

    public event EventHandler<string> OnMessage;

    public bool Connected => this.Provider.Connected;

    public void KeepAlive()
    {
    }

    public event EventHandler<(ConnectionStatus, string)> ConnectionStatusChanged
    {
      add => this.Provider.ConnectionStatusChanged += value;
      remove => this.Provider.ConnectionStatusChanged -= value;
    }

    public long AddressShift { get; set; }

    public byte[] TranslateAddress(ulong address) => ((uint) ((ulong) (uint) address + (ulong) this.AddressShift)).ToByteArray<uint>(ByteOrder.Big);

    public byte[] TranslateValue(ulong value) => ((uint) value).ToByteArray<uint>(ByteOrder.Big);

    public bool Read(ulong address, byte[] buffer)
    {
      uint start = checked ((uint) (unchecked ((long) address) & 4294967292L));
      int srcOffset = checked ((int) (ulong) (unchecked ((long) address) & 3L));
      byte[] numArray = new byte[checked (buffer.Length + srcOffset)];
      bool flag = this.BlockRead(start, numArray);
      Buffer.BlockCopy((Array) numArray, srcOffset, (Array) buffer, 0, buffer.Length);
      return flag;
    }

    public bool Write(ulong address, byte[] buffer) => false;

    public bool Read8(ulong address, out byte value)
    {
      uint num;
      bool flag = this.Read32(address, out num);
      value = flag ? (byte) (num >> 24) : (byte) 0;
      return flag;
    }

    public bool Write8(ulong address, byte value) => this.Provider.TryWrite(((IEnumerable<byte>) new byte[1]
    {
      (byte) 1
    }).Concat<byte>((IEnumerable<byte>) this.TranslateAddress(address)).Concat<byte>((IEnumerable<byte>) this.TranslateValue((ulong) value)).ToArray<byte>(), out uint _);

    public bool Freeze8(ulong address, byte value) => false;

    public bool Unfreeze(ulong address) => false;

    public bool Freeze(
      ulong address,
      ulong value,
      byte size,
      WriteType writeType,
      ulong cmpAddress,
      ulong cmpValue,
      byte cmpSize,
      CompareType cmpType)
    {
      return false;
    }

    public bool Freeze(
      ulong address,
      ulong value,
      ulong mask,
      byte size,
      WriteType writeType,
      ulong cmpAddress,
      ulong cmpValue,
      byte cmpSize,
      CompareType cmpType)
    {
      return false;
    }

    public IBatchContext8 GetBatchContext8() => (IBatchContext8) null;

    public bool SetBits(ulong address, byte mask, out byte orig) => this.Read8(address, out orig) && this.Write8(address, checked ((byte) ((int) orig | (int) mask)));

    public bool UnsetBits(ulong address, byte mask, out byte orig) => this.Read8(address, out orig) && this.Write8(address, checked ((byte) ((int) orig & (int) ~mask)));

    public bool CompareSwap(ulong chkAddress, byte test, byte newVal, out byte orig)
    {
      if (!this.Read8(chkAddress, out orig))
        return false;
      return (int) orig != (int) test || this.Write8(chkAddress, newVal);
    }

    public bool FreezeU8(ulong address, byte value, byte cmpValue, CompareType cmpType) => false;

    public bool FreezeU8TU8(ulong address, byte value, byte cmpValue, CompareType cmpType) => false;

    public bool FreezeU8TU8(
      ulong address,
      byte value,
      ulong cmpAddress,
      byte cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public IFeatureAware Features { get; } = (IFeatureAware) new GeckoConnector<T>.GeckoFeatures();

    public string GetROMPath() => string.Empty;

    public bool OpenROM(string path) => false;

    public bool CloseROM() => false;

    public bool PatchROM(IROMPatch patch) => false;

    public bool Read16(ulong address, out ushort value)
    {
      uint num;
      bool flag = this.Read32(address, out num);
      value = flag ? (ushort) (num >> 16) : (ushort) 0;
      return flag;
    }

    public bool Write16(ulong address, ushort value) => this.Provider.TryWrite(((IEnumerable<byte>) new byte[1]
    {
      (byte) 2
    }).Concat<byte>((IEnumerable<byte>) this.TranslateAddress(address)).Concat<byte>((IEnumerable<byte>) this.TranslateValue((ulong) value)).ToArray<byte>(), out uint _);

    public bool Freeze16(ulong address, ushort value) => false;

    public Endianness Endianness => Endianness.BigEndian;

    public IBatchContext16 GetBatchContext16() => (IBatchContext16) null;

    public bool FreezeU16(ulong address, ushort value, ushort cmpValue, CompareType cmpType) => false;

    public bool FreezeU8TU16(ulong address, byte value, ushort cmpValue, CompareType cmpType) => false;

    public bool FreezeU16TU8(ulong address, ushort value, byte cmpValue, CompareType cmpType) => false;

    public bool FreezeU16TU16(ulong address, ushort value, ushort cmpValue, CompareType cmpType) => false;

    public bool FreezeU8TU16(
      ulong address,
      byte value,
      ulong cmpAddress,
      ushort cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU16TU8(
      ulong address,
      ushort value,
      ulong cmpAddress,
      byte cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU16TU16(
      ulong address,
      ushort value,
      ulong cmpAddress,
      ushort cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool Read32(ulong address, out uint value)
    {
      uint start = checked ((uint) (unchecked ((long) address) & 4294967292L));
      int index = checked ((int) (ulong) (unchecked ((long) address) & 3L));
      byte[] bytes = new byte[index == 0 ? 4 : 8];
      bool flag = this.BlockRead(start, bytes);
      value = flag ? (uint) ((int) bytes[index] << 24 | (int) bytes[index + 1] << 16 | (int) bytes[index + 2] << 8) | (uint) bytes[index + 3] : 0U;
      return flag;
    }

    public bool Write32(ulong address, uint value) => this.Provider.TryWrite(((IEnumerable<byte>) new byte[1]
    {
      (byte) 3
    }).Concat<byte>((IEnumerable<byte>) this.TranslateAddress(address)).Concat<byte>((IEnumerable<byte>) this.TranslateValue((ulong) value)).ToArray<byte>(), out uint _);

    public bool Freeze32(ulong address, uint value) => false;

    public IBatchContext32 GetBatchContext32() => (IBatchContext32) null;

    public bool FreezeU32(ulong address, uint value, uint cmpValue, CompareType cmpType) => false;

    public bool FreezeU8TU32(ulong address, byte value, uint cmpValue, CompareType cmpType) => false;

    public bool FreezeU16TU32(ulong address, ushort value, uint cmpValue, CompareType cmpType) => false;

    public bool FreezeU32TU8(ulong address, uint value, byte cmpValue, CompareType cmpType) => false;

    public bool FreezeU32TU16(ulong address, uint value, ushort cmpValue, CompareType cmpType) => false;

    public bool FreezeU32TU32(ulong address, uint value, uint cmpValue, CompareType cmpType) => false;

    public bool FreezeU8TU32(
      ulong address,
      byte value,
      ulong cmpAddress,
      uint cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU16TU32(
      ulong address,
      ushort value,
      ulong cmpAddress,
      uint cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU32TU8(
      ulong address,
      uint value,
      ulong cmpAddress,
      byte cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU32TU16(
      ulong address,
      uint value,
      ulong cmpAddress,
      ushort cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU32TU32(
      ulong address,
      uint value,
      ulong cmpAddress,
      uint cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool Read64(ulong address, out ulong value)
    {
      uint start = checked ((uint) (unchecked ((long) address) & 4294967292L));
      int index = checked ((int) (ulong) (unchecked ((long) address) & 3L));
      byte[] bytes = new byte[index == 0 ? 8 : 12];
      bool flag = this.BlockRead(start, bytes);
      value = flag ? (ulong) ((long) bytes[index] << 56 | (long) bytes[index + 1] << 48 | (long) bytes[index + 2] << 40 | (long) bytes[index + 3] << 32 | (long) bytes[index + 4] << 24 | (long) bytes[index + 5] << 16 | (long) bytes[index + 6] << 8) | (ulong) bytes[index + 7] : 0UL;
      return flag;
    }

    public bool Write64(ulong address, ulong value) => this.Write32(address, (uint) (value >> 32)) && this.Write32(checked (address + 4UL), (uint) value);

    public bool Freeze64(ulong address, ulong value) => false;

    public IBatchContext64 GetBatchContext64() => (IBatchContext64) null;

    public bool FreezeU64(ulong address, ulong value, ulong cmpValue, CompareType cmpType) => false;

    public bool FreezeU8TU64(ulong address, byte value, ulong cmpValue, CompareType cmpType) => false;

    public bool FreezeU16TU64(ulong address, ushort value, ulong cmpValue, CompareType cmpType) => false;

    public bool FreezeU32TU64(ulong address, uint value, ulong cmpValue, CompareType cmpType) => false;

    public bool FreezeU64TU8(ulong address, ulong value, byte cmpValue, CompareType cmpType) => false;

    public bool FreezeU64TU16(ulong address, ulong value, ushort cmpValue, CompareType cmpType) => false;

    public bool FreezeU64TU32(ulong address, ulong value, uint cmpValue, CompareType cmpType) => false;

    public bool FreezeU64TU64(ulong address, ulong value, ulong cmpValue, CompareType cmpType) => false;

    public bool FreezeU8TU64(
      ulong address,
      byte value,
      ulong cmpAddress,
      ulong cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU16TU64(
      ulong address,
      ushort value,
      ulong cmpAddress,
      ulong cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU32TU64(
      ulong address,
      uint value,
      ulong cmpAddress,
      ulong cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU64TU8(
      ulong address,
      ulong value,
      ulong cmpAddress,
      byte cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU64TU16(
      ulong address,
      ulong value,
      ulong cmpAddress,
      ushort cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU64TU32(
      ulong address,
      ulong value,
      ulong cmpAddress,
      uint cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    public bool FreezeU64TU64(
      ulong address,
      ulong value,
      ulong cmpAddress,
      ulong cmpValue,
      CompareType cmpType)
    {
      return false;
    }

    private bool BlockRead(uint start, byte[] bytes)
    {
      try
      {
        using (MemoryStream memoryStream = new MemoryStream())
        {
          this.Provider.GeckoInit();
          uint length = checked ((uint) bytes.Length);
          uint address = checked (start + length - 1U);
          uint num1 = length / 63488U;
          uint count = length % 63488U;
          Log.Message((object) string.Format("GeckoConnector is attempting to read {0:X8}-{1:X8} ({2} full chunks{3}", (object) start, (object) address, (object) num1, count > 0U ? (object) string.Format(" / 1 partial chunk). Final chunk is {0} bytes.", (object) count) : (object) ")."));
          if (!this.Provider.TryWrite(new byte[1]
          {
            (byte) 4
          }, out uint _))
            return false;
          Log.Message((object) "GeckoConnector sent a read command.");
          byte[] data = new byte[1];
          int num2 = 0;
          while (!this.Provider.TryRead(data, false) || data[0] != (byte) 170)
          {
            if (num2 > 9)
            {
              Log.Message((object) "GeckoConnector failed to get a valid command response.");
              return false;
            }
            checked { ++num2; }
          }
          Log.Message((object) "GeckoConnector sent a read command range.");
          if (!this.Provider.TryWrite(((IEnumerable<byte>) this.TranslateAddress((ulong) address)).Concat<byte>((IEnumerable<byte>) this.TranslateAddress((ulong) start)).ToArray<byte>()))
          {
            Log.Message((object) "GeckoConnector failed to get a valid command response.");
            return false;
          }
          this._canceling = false;
          byte[] numArray1 = new byte[63488];
          uint num3 = 0;
          while (num3 < num1 && !this._canceling)
          {
            Log.Message((object) string.Format("GeckoConnector is reading chunk {0}.", (object) num3));
            if (!this.Provider.TryRead(numArray1, false) || numArray1[0] != (byte) 170)
            {
              Log.Message((object) "GeckoConnector failed to read a chunk.");
              this.Provider.TryWrite(new byte[1]
              {
                (byte) 204
              });
              return false;
            }
            memoryStream.Write(numArray1, 0, 63488);
            this.Provider.TryWrite(new byte[1]{ (byte) 170 });
            checked { ++num3; }
          }
          if (count > 0U)
          {
            Log.Message((object) string.Format("GeckoConnector is reading a partial chunk ({0} bytes).", (object) count));
            byte[] numArray2 = new byte[(int) count];
            if (!this.Provider.TryRead(numArray2, false) || numArray2[0] != (byte) 170)
            {
              Log.Message((object) "GeckoConnector failed to read a chunk.");
              this.Provider.TryWrite(new byte[1]
              {
                (byte) 204
              });
              return false;
            }
            memoryStream.Write(numArray2, 0, checked ((int) count));
            this.Provider.TryWrite(new byte[1]{ (byte) 170 });
          }
          Buffer.BlockCopy((Array) memoryStream.ToArray(), 0, (Array) bytes, 0, Math.Min(checked ((int) memoryStream.Length), bytes.Length));
          Log.Message((object) ("GeckoConnector read some bytes: " + bytes.ToHexString()));
          return true;
        }
      }
      catch (Exception ex)
      {
        Log.Error((object) ex);
        return false;
      }
      finally
      {
        this.Provider.TryWrite(new byte[1]{ (byte) 7 });
      }
    }

    private enum GeckoStatus
    {
      BPHit = 17, // 0x00000011
      Ack = 170, // 0x000000AA
      Retry = 187, // 0x000000BB
      Fail = 204, // 0x000000CC
      Done = 255, // 0x000000FF
    }

    private enum GeckoCommands : byte
    {
      Write8 = 1,
      Write16 = 2,
      Write32 = 3,
      Read = 4,
      Pause = 6,
      Resume = 7,
    }

    private enum GeckoPlatform : byte
    {
      Wii = 128, // 0x80
      GameCube = 129, // 0x81
      WiiU = 130, // 0x82
    }

    public class GeckoFeatures : IFeatureAware
    {
      public AccessLevel Access(ulong address)
      {
        ulong num1 = address;
        if (num1 >= 2147483648UL && num1 <= 2172649472UL)
          return AccessLevel.Read | AccessLevel.Write;
        ulong num2 = address;
        if (num2 >= 2415919104UL && num2 <= 2470445056UL)
          return AccessLevel.Read | AccessLevel.Write;
        ulong num3 = address;
        if (num3 >= 3221225472UL && num3 <= 3246391296UL)
          return AccessLevel.Read | AccessLevel.Write;
        ulong num4 = address;
        if (num4 >= 3489660928UL && num4 <= 3544186880UL)
          return AccessLevel.Read | AccessLevel.Write;
        ulong num5 = address;
        if (num5 >= 3355443200UL && num5 <= 3422552064UL)
          return AccessLevel.Read | AccessLevel.Write;
        ulong num6 = address;
        if (num6 >= 3422552064UL && num6 <= 3422584832UL)
          return AccessLevel.Read | AccessLevel.Write;
        ulong num7 = address;
        if (num7 >= 3439329280UL && num7 <= 3439362048UL)
          return AccessLevel.Read | AccessLevel.Write;
        throw new ArgumentOutOfRangeException(nameof (address));
      }

      public AccessLevel Access(ulong address, string domain)
      {
        AccessLevel accessLevel;
        switch (domain)
        {
          case "System Bus":
            accessLevel = this.Access(address);
            break;
          default:
            accessLevel = this.Access(domain);
            break;
        }
        return accessLevel;
      }

      public AccessLevel Access(string domain)
      {
        switch (domain)
        {
          case "System Bus":
            return AccessLevel.Mixed;
          default:
            throw new ArgumentOutOfRangeException(nameof (domain));
        }
      }

      public IEnumerable<string> Domains { get; } = (IEnumerable<string>) new string[1]
      {
        "System Bus"
      };

      public bool CanSatisfy(Capability capability) => this.Access(capability.Address).HasFlag((Enum) capability.Access);
    }
  }
}
