﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.HIDTools.HIDBrowse
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Text;

namespace ConnectorLib.HIDTools
{
  public class HIDBrowse
  {
    public static List<HIDInfo> Browse()
    {
      List<HIDInfo> hidInfoList = new List<HIDInfo>();
      Guid gHid;
      Win32.HidD_GetHidGuid(out gHid);
      IntPtr classDevs = Win32.SetupDiGetClassDevs(ref gHid, (string) null, IntPtr.Zero, 18U);
      Win32.DeviceInterfaceData structure = new Win32.DeviceInterfaceData();
      structure.Size = Marshal.SizeOf<Win32.DeviceInterfaceData>(structure);
      uint nIndex = 0;
      while (Win32.SetupDiEnumDeviceInterfaces(classDevs, 0U, ref gHid, nIndex, ref structure))
      {
        string path = HIDBrowse.GetPath(classDevs, ref structure);
        IntPtr handle = HIDBrowse.Open(path);
        if (handle != Win32.INVALID_HANDLE_VALUE)
        {
          string manufacturer = HIDBrowse.GetManufacturer(handle);
          string product = HIDBrowse.GetProduct(handle);
          string serialNumber = HIDBrowse.GetSerialNumber(handle);
          short vid;
          short pid;
          HIDBrowse.GetVidPid(handle, out vid, out pid);
          HIDInfo hidInfo = new HIDInfo(product, serialNumber, manufacturer, path, vid, pid);
          hidInfoList.Add(hidInfo);
          HIDBrowse.Close(handle);
        }
        checked { ++nIndex; }
      }
      if (!Win32.SetupDiDestroyDeviceInfoList(classDevs))
        throw new Win32Exception();
      return hidInfoList;
    }

    private static IntPtr Open(string path) => Win32.CreateFile(path, 3221225472U, 3U, IntPtr.Zero, 3U, 1073741824U, IntPtr.Zero);

    private static void Close(IntPtr handle, bool throwOnFail = true)
    {
      if (!Win32.CloseHandle(handle) & throwOnFail)
        throw new Win32Exception();
    }

    private static string GetPath(IntPtr hInfoSet, ref Win32.DeviceInterfaceData iface)
    {
      Win32.DeviceInterfaceDetailData oDetailData = new Win32.DeviceInterfaceDetailData();
      uint nRequiredSize = checked ((uint) Marshal.SizeOf<Win32.DeviceInterfaceDetailData>(oDetailData));
      oDetailData.Size = Marshal.SizeOf(typeof (IntPtr)) == 8 ? 8 : 5;
      if (!Win32.SetupDiGetDeviceInterfaceDetail(hInfoSet, ref iface, ref oDetailData, nRequiredSize, ref nRequiredSize, IntPtr.Zero))
        throw new Win32Exception();
      return oDetailData.DevicePath;
    }

    private static string GetManufacturer(IntPtr handle) => HIDBrowse.GetField(handle, new Func<IntPtr, StringBuilder, int, bool>(Win32.HidD_GetManufacturerString));

    private static string GetProduct(IntPtr handle) => HIDBrowse.GetField(handle, new Func<IntPtr, StringBuilder, int, bool>(Win32.HidD_GetProductString));

    private static string GetSerialNumber(IntPtr handle) => HIDBrowse.GetField(handle, new Func<IntPtr, StringBuilder, int, bool>(Win32.HidD_GetSerialNumberString));

    private static string GetField(IntPtr handle, Func<IntPtr, StringBuilder, int, bool> fieldFunc)
    {
      StringBuilder stringBuilder = new StringBuilder(256);
      string empty = string.Empty;
      if (fieldFunc(handle, stringBuilder, stringBuilder.Capacity))
        empty = stringBuilder.ToString();
      return empty;
    }

    private static void GetVidPid(IntPtr handle, out short vid, out short pid)
    {
      Win32.HIDAttributes attributes = new Win32.HIDAttributes();
      attributes.Size = Marshal.SizeOf<Win32.HIDAttributes>(attributes);
      vid = Win32.HidD_GetAttributes(handle, ref attributes) ? attributes.VendorID : throw new Win32Exception();
      pid = attributes.ProductID;
    }
  }
}
