﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.Log
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.IO;

namespace ConnectorLib
{
  public static class Log
  {
    public static void Debug(object message) => Log.Write(Console.Out, message);

    public static void Message(object message) => Log.Write(Console.Out, message);

    public static void Error(object message) => Log.Write(Console.Error, message);

    public static void Error(Exception ex, string message) => Log.Write(Console.Error, (object) (message + Environment.NewLine + ex?.ToString()));

    public static void DebugFormat(string message, params object[] args) => Log.WriteFormat(Console.Out, message, args);

    public static void MessageFormat(string message, params object[] args) => Log.WriteFormat(Console.Out, message, args);

    public static void ErrorFormat(string message, params object[] args) => Log.WriteFormat(Console.Error, message, args);

    private static void WriteFormat(TextWriter writer, string format, object[] args) => Log.Write(writer, (object) string.Format(format, args));

    private static void Write(TextWriter writer, object message)
    {
      string str = string.Format("[{0}] ", (object) DateTimeOffset.UtcNow) + (message?.ToString() ?? "(null)");
      writer.Write("> ");
      writer.WriteLine(str);
      Action<string> onMessage = Log.OnMessage;
      if (onMessage == null)
        return;
      onMessage(str);
    }

    public static void InvokeOnMessage(object message, bool omitTimestamp = false)
    {
      Action<string> onMessage = Log.OnMessage;
      if (onMessage == null)
        return;
      onMessage((omitTimestamp ? string.Empty : string.Format("[{0}] ", (object) DateTimeOffset.UtcNow)) + (message?.ToString() ?? "(null)"));
    }

    public static event Action<string> OnMessage;
  }
}
