﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.Memory.PointerAddressChain
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Collections.Generic;
using System.Linq;

namespace ConnectorLib.Memory
{
  public class PointerAddressChain : AddressChain
  {
    public byte Size { get; }

    public Endianness Endianness { get; }

    public PointerType Type { get; }

    public PointerAddressChain(
      AddressChain parent,
      byte size,
      Endianness endianness,
      PointerType type)
      : base(parent)
    {
      this.Size = size;
      this.Endianness = endianness;
      this.Type = type;
    }

    private long ReadRelativePointer()
    {
      byte[] buffer = new byte[(int) this.Size];
      if (!this._connector.Read(this._parent.Address, buffer))
        throw new InvalidOperationException("Could not read from the connector.");
      byte size = this.Size;
      if (this.Size == (byte) 1)
        return (long) (sbyte) buffer[0];
      if (this.Size == (byte) 2)
        return (long) (short) ((int) buffer[1] << 8 | (int) buffer[0]);
      if (this.Size == (byte) 4)
        return (long) ((uint) ((int) buffer[3] << 24 | (int) buffer[2] << 16 | (int) buffer[1] << 8) | (uint) buffer[0]);
      throw new InvalidOperationException("Relative pointers must be 1, 2 or 4 bytes.");
    }

    private ulong ReadAbsolutePointer()
    {
      byte[] numArray = new byte[(int) this.Size];
      ulong address = this._parent.Address;
      if (address == 0UL)
        throw new NullReferenceException("Cannot follow a null pointer.");
      if (!this._connector.Read(address, numArray))
        throw new InvalidOperationException("Could not read from the connector.");
      if (this.Endianness == Endianness.BigEndian)
        numArray = ((IEnumerable<byte>) numArray).Reverse<byte>().ToArray<byte>();
      byte size = this.Size;
      ulong num;
      if (this.Size == (byte) 1)
        num = (ulong) numArray[0];
      else if (this.Size == (byte) 2)
        num = checked ((ulong) ((int) numArray[1] << 8 | (int) numArray[0]));
      else if (this.Size == (byte) 3)
      {
        num = checked ((ulong) ((int) numArray[2] << 16 | (int) numArray[1] << 8 | (int) numArray[0]));
      }
      else
      {
        if (this.Size != (byte) 4)
          throw new InvalidOperationException("Relative pointers must be 1 - 4 bytes.");
        num = (ulong) ((uint) ((int) numArray[3] << 24 | (int) numArray[2] << 16 | (int) numArray[1] << 8) | (uint) numArray[0]);
      }
      if (num == 0UL)
        throw new NullReferenceException("The decoded address was zero.");
      return num != 3735928559UL ? num : throw new NullReferenceException("The decoded address was not a valid pointer.");
    }

    public override ulong Address => this.Type != PointerType.Absolute ? this._parent.Address + (ulong) this.ReadRelativePointer() : this.ReadAbsolutePointer();
  }
}
