﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.N64Mapper
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Collections.Generic;

namespace ConnectorLib
{
  [Serializable]
  public class N64Mapper : IMemoryMapper
  {
    public (ulong address, string domain) Translate(ulong address)
    {
      ulong num1 = address;
      if (num1 >= 2147483648UL && num1 < 2684354559UL)
        return (address & 536870911UL, "RDRAM");
      ulong num2 = address;
      if (num2 >= 2684354560UL && num2 < 3221225471UL)
        return (address & 536870911UL, "RDRAM");
      throw new ArgumentOutOfRangeException(nameof (address));
    }

    public ulong Translate(ulong address, string domain)
    {
      switch (domain)
      {
        case "System Bus":
          return address;
        case "RDRAM":
          return address | 2147483648UL;
        default:
          throw new ArgumentOutOfRangeException(nameof (domain));
      }
    }

    public IEnumerable<string> Domains => (IEnumerable<string>) new string[8]
    {
      "RDRAM",
      "ROM",
      "PI Register",
      "SI Register",
      "VI Register",
      "RI Register",
      "AI Register",
      "EEPROM"
    };
  }
}
