﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.NativeMethods
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Runtime.InteropServices;

namespace ConnectorLib
{
  public static class NativeMethods
  {
    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern IntPtr GetCurrentProcess();

    [DllImport("advapi32.dll", SetLastError = true)]
    [return: MarshalAs(UnmanagedType.Bool)]
    public static extern bool OpenProcessToken(
      IntPtr processHandle,
      uint desiredAccess,
      out IntPtr tokenHandle);

    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern IntPtr OpenProcess(
      NativeMethods.ProcessAccessFlagsEnum dwDesiredAccess,
      bool bInheritHandle,
      int dwProcessId);

    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern bool CloseHandle(IntPtr hProcess);

    [DllImport("advapi32.dll", SetLastError = true)]
    public static extern bool LookupPrivilegeValue(
      string lpSystemName,
      string lpName,
      ref NativeMethods.LUID lpLuid);

    [DllImport("advapi32.dll", SetLastError = true)]
    [return: MarshalAs(UnmanagedType.Bool)]
    public static extern bool AdjustTokenPrivileges(
      IntPtr hToken,
      [MarshalAs(UnmanagedType.Bool)] bool disableAllPrivileges,
      ref NativeMethods.TOKEN_PRIVILEGES newState,
      uint zero,
      IntPtr null1,
      IntPtr null2);

    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern bool ReadProcessMemory(
      IntPtr hProcess,
      long lpBaseAddress,
      byte[] lpBuffer,
      int dwSize,
      ref int lpNumberOfBytesRead);

    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern bool WriteProcessMemory(
      IntPtr hProcess,
      long lpBaseAddress,
      byte[] lpBuffer,
      int dwSize,
      ref int lpNumberOfBytesWritten);

    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern void GetSystemInfo(out NativeMethods.SYSTEM_INFO info);

    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern int VirtualQueryEx(
      IntPtr hProcess,
      IntPtr lpAddress,
      out NativeMethods.MEMORY_BASIC_INFORMATION lpBuffer,
      uint dwLength);

    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern IntPtr VirtualAllocEx(
      IntPtr hProcess,
      IntPtr lpAddress,
      uint dwSize,
      NativeMethods.AllocationTypeEnum flAllocationType,
      NativeMethods.MemoryProtectionEnum flProtect);

    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern bool VirtualFreeEx(
      IntPtr hProcess,
      IntPtr lpAddress,
      int dwSize,
      NativeMethods.AllocationTypeEnum dwFreeType);

    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern bool FlushInstructionCache(
      IntPtr hProcess,
      IntPtr lpBaseAddress,
      uint dwSize);

    public enum ErrorCode
    {
      ERROR_ACCESS_DENIED = 5,
      ERROR_INVALID_PARAMETER = 87, // 0x00000057
    }

    public enum ProcessAccessFlagsEnum : uint
    {
      PROCESS_VM_OPERATION = 8,
      PROCESS_VM_READ = 16, // 0x00000010
      PROCESS_VM_WRITE = 32, // 0x00000020
      PROCESS_ALL_ACCESS = 2035711, // 0x001F0FFF
    }

    public struct LUID
    {
      public uint LowPart;
      public int HighPart;
    }

    public struct TOKEN_PRIVILEGES
    {
      public int PrivilegeCount;
      [MarshalAs(UnmanagedType.ByValArray, SizeConst = 1)]
      public NativeMethods.LUID_AND_ATTRIBUTES[] Privileges;
    }

    [StructLayout(LayoutKind.Sequential, Pack = 4)]
    public struct LUID_AND_ATTRIBUTES
    {
      public NativeMethods.LUID Luid;
      public NativeMethods.TokenPrivilegeAttributeEnum Attributes;
    }

    public enum TokenPrivilegeAttributeEnum : uint
    {
      SE_PRIVILEGE_ENABLED_BY_DEFAULT = 1,
      SE_PRIVILEGE_ENABLED = 2,
      SE_PRIVILEGE_REMOVED = 4,
      SE_PRIVILEGE_USED_FOR_ACCESS = 2147483648, // 0x80000000
    }

    public struct SYSTEM_INFO
    {
      public NativeMethods.ProcessorArchitectureEnum ProcessorArchitecture;
      public uint PageSize;
      public IntPtr MinimumApplicationAddress;
      public IntPtr MaximumApplicationAddress;
      public IntPtr ActiveProcessorMask;
      public uint NumberOfProcessors;
      public uint ProcessorType;
      public uint AllocationGranularity;
      public ushort ProcessorLevel;
      public ushort ProcessorRevision;
    }

    public enum ProcessorArchitectureEnum
    {
      Arm = -1, // 0xFFFFFFFF
      x86 = 0,
      Itanium = 6,
      x64 = 9,
      Unknown = 4095, // 0x00000FFF
    }

    public struct MEMORY_BASIC_INFORMATION
    {
      public IntPtr BaseAddress;
      public IntPtr AllocationBase;
      public NativeMethods.AllocationProtectEnum AllocationProtect;
      public IntPtr RegionSize;
      public NativeMethods.StateEnum State;
      public NativeMethods.AllocationProtectEnum Protect;
      public NativeMethods.TypeEnum Type;
    }

    public enum AllocationProtectEnum : uint
    {
      PAGE_NOACCESS = 1,
      PAGE_READONLY = 2,
      PAGE_READWRITE = 4,
      PAGE_WRITECOPY = 8,
      PAGE_EXECUTE = 16, // 0x00000010
      PAGE_EXECUTE_READ = 32, // 0x00000020
      PAGE_EXECUTE_READWRITE = 64, // 0x00000040
      PAGE_EXECUTE_WRITECOPY = 128, // 0x00000080
      PAGE_GUARD = 256, // 0x00000100
      PAGE_NOCACHE = 512, // 0x00000200
      PAGE_WRITECOMBINE = 1024, // 0x00000400
    }

    public enum StateEnum : uint
    {
      MEM_COMMIT = 4096, // 0x00001000
      MEM_RESERVE = 8192, // 0x00002000
      MEM_FREE = 65536, // 0x00010000
    }

    public enum TypeEnum : uint
    {
      MEM_PRIVATE = 131072, // 0x00020000
      MEM_MAPPED = 262144, // 0x00040000
      MEM_IMAGE = 16777216, // 0x01000000
    }

    [Flags]
    public enum AllocationTypeEnum
    {
      Commit = 4096, // 0x00001000
      Reserve = 8192, // 0x00002000
      Decommit = 16384, // 0x00004000
      Release = 32768, // 0x00008000
      Reset = 524288, // 0x00080000
      Physical = 4194304, // 0x00400000
      TopDown = 1048576, // 0x00100000
      WriteWatch = 2097152, // 0x00200000
      LargePages = 536870912, // 0x20000000
    }

    [Flags]
    public enum MemoryProtectionEnum
    {
      Execute = 16, // 0x00000010
      ExecuteRead = 32, // 0x00000020
      ExecuteReadWrite = 64, // 0x00000040
      ExecuteWriteCopy = 128, // 0x00000080
      NoAccess = 1,
      ReadOnly = 2,
      ReadWrite = 4,
      WriteCopy = 8,
      GuardModifierFlag = 256, // 0x00000100
      NoCacheModifierFlag = 512, // 0x00000200
      WriteCombineModifierFlag = 1024, // 0x00000400
    }
  }
}
