﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.Patches.CRC32
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System.Collections.Generic;
using System.IO;

namespace ConnectorLib.Patches
{
  internal class CRC32
  {
    private static readonly uint[] _table;
    private uint _checksum = uint.MaxValue;

    public uint Checksum => ~this._checksum;

    public void Append(byte[] bytes)
    {
      foreach (int num in bytes)
      {
        byte index = checked ((byte) (unchecked ((int) this._checksum) & (int) byte.MaxValue ^ num));
        this._checksum = this._checksum >> 8 ^ CRC32._table[(int) index];
      }
    }

    public void Append(byte r)
    {
      byte index = checked ((byte) (unchecked ((int) this._checksum) & (int) byte.MaxValue ^ (int) r));
      this._checksum = this._checksum >> 8 ^ CRC32._table[(int) index];
    }

    public static uint Calculate(Stream bytes)
    {
      bytes.Position = 0L;
      byte[] buffer = new byte[bytes.Length];
      bytes.Read(buffer, 0, buffer.Length);
      return CRC32.Calculate((IEnumerable<byte>) buffer);
    }

    public static uint Calculate(IEnumerable<byte> bytes)
    {
      uint num1 = uint.MaxValue;
      foreach (byte num2 in bytes)
      {
        byte index = checked ((byte) (unchecked ((int) num1) & (int) byte.MaxValue ^ (int) num2));
        num1 = num1 >> 8 ^ CRC32._table[(int) index];
      }
      return ~num1;
    }

    static CRC32()
    {
      uint num1 = 3988292384;
      CRC32._table = new uint[256];
      uint index = 0;
      while ((long) index < (long) CRC32._table.Length)
      {
        uint num2 = index;
        int num3 = 8;
        while (num3 > 0)
        {
          if (((int) num2 & 1) == 1)
            num2 = num2 >> 1 ^ num1;
          else
            num2 >>= 1;
          checked { --num3; }
        }
        CRC32._table[(int) index] = num2;
        checked { ++index; }
      }
    }
  }
}
