﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.Patches.IPS
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace ConnectorLib.Patches
{
  [Serializable]
  public class IPS : IROMPatch
  {
    public readonly List<IPS.Patch> Items = new List<IPS.Patch>();

    IReadOnlyList<IPatch> IROMPatch.Items => (IReadOnlyList<IPatch>) this.Items;

    public byte[] Data { get; private set; }

    public IPS()
    {
    }

    public IPS(string fileName) => this.Parse(fileName);

    public IPS(byte[] data) => this.Parse(data);

    public void Parse(string fileName) => this.Parse(File.ReadAllBytes(fileName));

    public void Parse(byte[] data)
    {
      this.Data = (byte[]) data.Clone();
      int num1 = 0;
      ASCIIEncoding asciiEncoding = new ASCIIEncoding();
      int index1 = 0;
      while (index1 < 5)
      {
        if ((int) data[index1] != (int) asciiEncoding.GetBytes("PATCH")[index1])
          throw new Exception("IPS: error parsing PATCH");
        checked { ++index1; }
      }
      int offset = checked (num1 + 5);
      bool flag = false;
      while (!flag)
      {
        if (offset == checked (data.Length - 3) || offset == checked (data.Length - 6))
        {
          flag = true;
          int index2 = 0;
          while (index2 < 3)
          {
            if ((int) data[checked (offset + index2)] != (int) asciiEncoding.GetBytes("EOF")[index2])
            {
              flag = false;
              break;
            }
            checked { ++index2; }
          }
        }
        if (!flag)
        {
          IPS.Patch patch1 = new IPS.Patch();
          this.Items.Add(patch1);
          if (checked (offset + 3) >= data.Length)
            throw new Exception("IPS: error parsing address");
          patch1.Address = (int) data[offset];
          patch1.Address <<= 8;
          patch1.Address |= (int) data[checked (offset + 1)];
          patch1.Address <<= 8;
          patch1.Address |= (int) data[checked (offset + 2)];
          IPS.Patch patch2 = patch1;
          patch2.Address = patch2.Address;
          int index3 = checked (offset + 3);
          if (checked (index3 + 2) >= data.Length)
            throw new Exception("IPS: error parsing length");
          int count1 = (int) data[index3] << 8 | (int) data[checked (index3 + 1)];
          offset = checked (index3 + 2);
          if (count1 == 0)
          {
            if (checked (offset + 3) >= data.Length)
              throw new Exception("IPS: error parsing RLE count/byte");
            int count2 = (int) data[offset] << 8 | (int) data[checked (offset + 1)];
            byte element = data[checked (offset + 2)];
            checked { offset += 3; }
            patch1.Data.AddRange(Enumerable.Repeat<byte>(element, count2));
          }
          else
          {
            int num2 = 0;
            while (num2 < count1)
            {
              if (checked (offset + count1) >= data.Length)
                throw new Exception("IPS: error parsing data");
              patch1.Data.AddRange((IEnumerable<byte>) new ArraySegment<byte>(data, offset, count1).ToArray<byte>());
              checked { num2 += count1; }
              checked { offset += count1; }
            }
          }
        }
      }
      if (offset != data.Length && offset != checked (data.Length - 3))
        throw new Exception("IPS: unexpected end of file");
    }

    [Serializable]
    public class Patch : IPatch
    {
      public List<byte> Data { get; }

      byte[] IPatch.Data => this.Data.ToArray();

      public int Address { get; set; }

      public Patch() => this.Data = new List<byte>();
    }
  }
}
