﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.PipelineConnector`1
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Collections.Generic;

namespace ConnectorLib
{
  public class PipelineConnector<T> : ConnectorBase, IGameConnector, IDisposable, IPipelineProvider
    where T : IPipelineProvider, new()
  {
    private T _pipeline = new T();

    public PipelineConnector()
    {
      EventHandler<(ConnectionStatus, string)> connectionStatusChanged = this.ConnectionStatusChanged;
      if (connectionStatusChanged == null)
        return;
      connectionStatusChanged((object) this, (ConnectionStatus.Open, string.Empty));
    }

    public IBatchWriteContext OpenBatchWriteContext() => (IBatchWriteContext) new NullContext();

    public bool SendMessage(string message)
    {
      EventHandler<string> onMessage = this.OnMessage;
      if (onMessage != null)
        onMessage((object) this, message);
      return true;
    }

    public event EventHandler<string> OnMessage;

    public bool Send(byte[] data) => this._pipeline.Send(data);

    public bool Send(IEnumerable<byte> data) => this._pipeline.Send(data);

    public bool Connected => this._pipeline.Connected;

    public void KeepAlive()
    {
    }

    public event EventHandler<(ConnectionStatus, string)> ConnectionStatusChanged;
  }
}
