﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.PortFactory
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Collections.Generic;

namespace ConnectorLib
{
  internal static class PortFactory
  {
    public static List<PortFactory.Port> GetDeviceList(string filter = null)
    {
      List<PortFactory.Port> deviceList = new List<PortFactory.Port>();
      foreach (Win32DeviceMgmt.DeviceInfo allComPort in Win32DeviceMgmt.GetAllCOMPorts())
      {
        if (filter != null)
        {
          string busDescription = allComPort.bus_description;
          if ((busDescription != null ? (busDescription.Contains(filter) ? 1 : 0) : 0) == 0)
            continue;
        }
        deviceList.Add(new PortFactory.Port(allComPort.name?.Trim() ?? string.Empty, allComPort.name?.Trim() ?? string.Empty + " | " + allComPort.description?.Trim(), allComPort.instance_path?.Trim() ?? string.Empty));
      }
      deviceList.Sort();
      return deviceList;
    }

    public class Port : IComparable<PortFactory.Port>
    {
      public string Name { get; }

      public string Desc { get; }

      public string PNPID { get; }

      public Port(string name, string desc, string pnpID)
      {
        this.Name = name;
        this.Desc = desc;
        this.PNPID = pnpID;
      }

      public override string ToString() => this.Desc;

      public int CompareTo(PortFactory.Port p) => p != null ? string.Compare(this.Name, p.Name, StringComparison.InvariantCultureIgnoreCase) : 1;
    }
  }
}
