﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.WebsocketBlock`1
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Runtime.Serialization;

namespace ConnectorLib
{
  [Serializable]
  public class WebsocketBlock<T> : ISerializable
  {
    public uint ID { get; }

    public DateTimeOffset Stamp { get; }

    public CommandType Type { get; }

    public string Message { get; set; } = "";

    public string Field { get; set; }

    public T Value { get; set; }

    public WebsocketBlock(uint id, CommandType type)
    {
      this.ID = id;
      this.Type = type;
      this.Stamp = DateTimeOffset.UtcNow;
    }

    public WebsocketBlock(SerializationInfo info, StreamingContext context)
    {
      this.ID = info.GetUInt32("id");
      this.Stamp = DateTimeOffset.FromUnixTimeSeconds(info.GetInt64("stamp"));
      this.Type = (CommandType) info.GetByte("type");
      this.Message = info.GetString("message") ?? string.Empty;
      this.Field = info.GetString("field") ?? string.Empty;
      try
      {
        this.Value = (T) info.GetValue("value", typeof (T));
      }
      catch
      {
        this.Value = default (T);
      }
    }

    public void GetObjectData(SerializationInfo info, StreamingContext context)
    {
      info.AddValue("id", this.ID);
      info.AddValue("stamp", this.Stamp.ToUnixTimeSeconds());
      info.AddValue("type", (byte) this.Type);
      info.AddValue("message", (object) this.Message);
      info.AddValue("field", (object) this.Field);
      info.AddValue("value", (object) this.Value);
    }
  }
}
