﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.WebsocketConnector
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Threading;
using WebSocketSharp;

namespace ConnectorLib
{
  public class WebsocketConnector : ConnectorBase, IKeyedConnector, IGameConnector, IDisposable
  {
    private static uint _next_id;
    private readonly WebSocket _socket;
    private readonly Dictionary<uint, ManualResetEvent> _response_events = new Dictionary<uint, ManualResetEvent>();
    private readonly Dictionary<uint, object> _response_values = new Dictionary<uint, object>();

    private static uint NextID => WebsocketConnector._next_id++;

    public bool Connected => this._socket.IsAlive;

    public WebsocketConnector(string url) => this._socket = new WebSocket(url, Array.Empty<string>());

    public IBatchWriteContext OpenBatchWriteContext() => throw new NotSupportedException();

    public bool SendMessage(string message)
    {
      EventHandler<string> onMessage = this.OnMessage;
      if (onMessage != null)
        onMessage((object) this, message);
      return this.WriteBlock<string>(new WebsocketBlock<string>(0U, CommandType.SendMessage)
      {
        Message = message
      });
    }

    public event EventHandler<string> OnMessage;

    private static CommandType GetCommandType(object value, bool write = false)
    {
      if (value is bool || typeof (bool).Equals(value))
        return !write ? CommandType.ReadBoolean : CommandType.WriteBoolean;
      if (value is byte || typeof (byte).Equals(value))
        return !write ? CommandType.ReadU8 : CommandType.WriteU8;
      if (value is sbyte || typeof (sbyte).Equals(value))
        return !write ? CommandType.ReadS8 : CommandType.WriteS8;
      if (value is ushort || typeof (ushort).Equals(value))
        return !write ? CommandType.ReadU16 : CommandType.WriteU16;
      if (value is short || typeof (short).Equals(value))
        return !write ? CommandType.ReadS16 : CommandType.WriteS16;
      if (value is uint || typeof (uint).Equals(value))
        return !write ? CommandType.ReadU32 : CommandType.WriteU32;
      if (value is int || typeof (int).Equals(value))
        return !write ? CommandType.ReadS32 : CommandType.WriteS32;
      if (value is ulong || typeof (ulong).Equals(value))
        return !write ? CommandType.ReadU64 : CommandType.WriteU64;
      if (value is long || typeof (long).Equals(value))
        return !write ? CommandType.ReadS64 : CommandType.WriteS64;
      if (!(value is string) && !typeof (string).Equals(value))
        throw new ArgumentException("The value was null or not an allowed type. ", nameof (value));
      return !write ? CommandType.ReadString : CommandType.WriteString;
    }

    public bool WriteValue<T>(string field, T value) => this.WriteBlock<T>(new WebsocketBlock<T>(WebsocketConnector.NextID, WebsocketConnector.GetCommandType((object) value))
    {
      Field = field,
      Value = value
    });

    public T ReadValue<T>(string field)
    {
      uint nextId = WebsocketConnector.NextID;
      CommandType commandType = WebsocketConnector.GetCommandType((object) typeof (T));
      if (!this.WriteBlock<T>(new WebsocketBlock<T>(nextId, commandType)
      {
        Field = field
      }))
        return default (T);
      this._response_events.Put<uint, ManualResetEvent>(nextId, new ManualResetEvent(false));
      this._response_events[nextId].WaitOne();
      try
      {
        return (T) this._response_values[nextId];
      }
      catch
      {
        return default (T);
      }
    }

    private bool WriteBlock<T>(WebsocketBlock<T> block)
    {
      if (!this.Connected)
        return false;
      string str = JsonConvert.SerializeObject((object) block);
      if (str == null)
        return false;
      try
      {
        lock (this._socket)
          this._socket.Send(str + "\0");
      }
      catch
      {
        return false;
      }
      return true;
    }

    [DebuggerStepThrough]
    public void KeepAlive() => throw new NotImplementedException();

    public event EventHandler<(ConnectionStatus, string)> ConnectionStatusChanged;
  }
}
