﻿// Decompiled with JetBrains decompiler
// Type: ConnectorLib.Win32DeviceMgmt
// Assembly: ConnectorLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: CC4FDCDA-98EE-4CD3-AF60-DEE32CDD48A0
// Assembly location: C:\Program Files (x86)\EmoTracker\ConnectorLib.dll

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Text;

namespace ConnectorLib
{
  internal static class Win32DeviceMgmt
  {
    private const uint DICS_FLAG_GLOBAL = 1;
    private const uint DIREG_DEV = 1;
    private const uint KEY_QUERY_VALUE = 1;
    private const int BUFFER_SIZE = 1024;
    private const int utf16terminatorSize_bytes = 2;
    private static Win32DeviceMgmt.DEVPROPKEY DEVPKEY_Device_BusReportedDeviceDesc = new Win32DeviceMgmt.DEVPROPKEY()
    {
      fmtid = new Guid(1410045054U, (ushort) 35648, (ushort) 17852, (byte) 168, (byte) 162, (byte) 106, (byte) 11, (byte) 137, (byte) 76, (byte) 189, (byte) 162),
      pid = 4
    };
    private static Win32DeviceMgmt.DEVPROPKEY DEVPKEY_Device_InstancePath = new Win32DeviceMgmt.DEVPROPKEY()
    {
      fmtid = new Guid(2026065864, (short) 4170, (short) 19146, (byte) 158, (byte) 164, (byte) 82, (byte) 77, (byte) 82, (byte) 153, (byte) 110, (byte) 87),
      pid = 256
    };

    [DllImport("setupapi.dll")]
    private static extern int SetupDiDestroyDeviceInfoList(IntPtr DeviceInfoSet);

    [DllImport("setupapi.dll", SetLastError = true)]
    private static extern bool SetupDiEnumDeviceInfo(
      IntPtr DeviceInfoSet,
      uint MemberIndex,
      ref Win32DeviceMgmt.SP_DEVINFO_DATA DeviceInterfaceData);

    [DllImport("setupapi.dll", SetLastError = true)]
    private static extern IntPtr SetupDiGetClassDevs(
      ref Guid gClass,
      uint iEnumerator,
      uint hParent,
      Win32DeviceMgmt.DiGetClassFlags nFlags);

    [DllImport("Setupapi", CharSet = CharSet.Auto, SetLastError = true)]
    private static extern IntPtr SetupDiOpenDevRegKey(
      IntPtr hDeviceInfoSet,
      ref Win32DeviceMgmt.SP_DEVINFO_DATA deviceInfoData,
      uint scope,
      uint hwProfile,
      uint parameterRegistryValueKind,
      uint samDesired);

    [DllImport("advapi32.dll", EntryPoint = "RegQueryValueExW", CharSet = CharSet.Unicode, SetLastError = true)]
    private static extern int RegQueryValueEx(
      IntPtr hKey,
      string lpValueName,
      int lpReserved,
      out uint lpType,
      byte[] lpData,
      ref uint lpcbData);

    [DllImport("advapi32.dll", CharSet = CharSet.Ansi, SetLastError = true)]
    private static extern int RegCloseKey(IntPtr hKey);

    [DllImport("kernel32.dll")]
    private static extern int GetLastError();

    [DllImport("setupapi.dll", SetLastError = true)]
    private static extern bool SetupDiClassGuidsFromName(
      string ClassName,
      ref Guid ClassGuidArray1stItem,
      uint ClassGuidArraySize,
      out uint RequiredSize);

    [DllImport("setupapi.dll")]
    private static extern int SetupDiClassNameFromGuid(
      ref Guid ClassGuid,
      StringBuilder className,
      int ClassNameSize,
      ref int RequiredSize);

    [DllImport("setupapi.dll", CharSet = CharSet.Auto, SetLastError = true)]
    private static extern bool SetupDiGetDeviceRegistryProperty(
      IntPtr DeviceInfoSet,
      ref Win32DeviceMgmt.SP_DEVINFO_DATA DeviceInfoData,
      Win32DeviceMgmt.SPDRP Property,
      out uint PropertyRegDataType,
      byte[] PropertyBuffer,
      uint PropertyBufferSize,
      out uint RequiredSize);

    [DllImport("setupapi.dll", SetLastError = true)]
    private static extern bool SetupDiGetDevicePropertyW(
      IntPtr deviceInfoSet,
      [In] ref Win32DeviceMgmt.SP_DEVINFO_DATA DeviceInfoData,
      [In] ref Win32DeviceMgmt.DEVPROPKEY propertyKey,
      out uint propertyType,
      byte[] propertyBuffer,
      uint propertyBufferSize,
      out uint requiredSize,
      uint flags);

    public static List<Win32DeviceMgmt.DeviceInfo> GetAllCOMPorts()
    {
      Guid[] classGuiDs = Win32DeviceMgmt.GetClassGUIDs("Ports");
      List<Win32DeviceMgmt.DeviceInfo> allComPorts = new List<Win32DeviceMgmt.DeviceInfo>();
      int index = 0;
      while (index < classGuiDs.Length)
      {
        IntPtr classDevs = Win32DeviceMgmt.SetupDiGetClassDevs(ref classGuiDs[index], 0U, 0U, Win32DeviceMgmt.DiGetClassFlags.DIGCF_PRESENT);
        if (classDevs == IntPtr.Zero)
          throw new Exception("Failed to get device information set for the COM ports");
        try
        {
          uint MemberIndex = 0;
          while (true)
          {
            Win32DeviceMgmt.SP_DEVINFO_DATA DeviceInterfaceData = new Win32DeviceMgmt.SP_DEVINFO_DATA();
            DeviceInterfaceData.cbSize = checked ((uint) Marshal.SizeOf(typeof (Win32DeviceMgmt.SP_DEVINFO_DATA)));
            if (Win32DeviceMgmt.SetupDiEnumDeviceInfo(classDevs, MemberIndex, ref DeviceInterfaceData))
            {
              Win32DeviceMgmt.DeviceInfo deviceInfo = new Win32DeviceMgmt.DeviceInfo()
              {
                name = Win32DeviceMgmt.GetDeviceName(classDevs, DeviceInterfaceData) ?? string.Empty,
                description = Win32DeviceMgmt.GetDeviceDescription(classDevs, DeviceInterfaceData) ?? string.Empty,
                instance_path = Win32DeviceMgmt.GetDeviceInstancePath(classDevs, DeviceInterfaceData) ?? string.Empty
              };
              try
              {
                deviceInfo.bus_description = Win32DeviceMgmt.GetDeviceBusDescription(classDevs, DeviceInterfaceData);
                allComPorts.Add(deviceInfo);
              }
              catch
              {
              }
              checked { ++MemberIndex; }
            }
            else
              break;
          }
        }
        finally
        {
          Win32DeviceMgmt.SetupDiDestroyDeviceInfoList(classDevs);
        }
        checked { ++index; }
      }
      return allComPorts;
    }

    private static string GetDeviceName(
      IntPtr pDevInfoSet,
      Win32DeviceMgmt.SP_DEVINFO_DATA deviceInfoData)
    {
      IntPtr hKey = Win32DeviceMgmt.SetupDiOpenDevRegKey(pDevInfoSet, ref deviceInfoData, 1U, 0U, 1U, 1U);
      if (hKey == IntPtr.Zero)
        throw new Exception("Failed to open a registry key for device-specific configuration information");
      byte[] numArray = new byte[1024];
      uint length = checked ((uint) numArray.Length);
      try
      {
        if (Win32DeviceMgmt.RegQueryValueEx(hKey, "PortName", 0, out uint _, numArray, ref length) != 0)
          throw new Exception("Can not read registry value PortName for device " + deviceInfoData.ClassGuid.ToString());
      }
      finally
      {
        Win32DeviceMgmt.RegCloseKey(hKey);
      }
      return Encoding.Unicode.GetString(numArray, 0, checked ((int) length - 2));
    }

    private static string GetDeviceDescription(
      IntPtr hDeviceInfoSet,
      Win32DeviceMgmt.SP_DEVINFO_DATA deviceInfoData)
    {
      byte[] numArray = new byte[1024];
      uint RequiredSize;
      if (!Win32DeviceMgmt.SetupDiGetDeviceRegistryProperty(hDeviceInfoSet, ref deviceInfoData, Win32DeviceMgmt.SPDRP.SPDRP_DEVICEDESC, out uint _, numArray, 1024U, out RequiredSize))
        throw new Exception("Can not read registry value PortName for device " + deviceInfoData.ClassGuid.ToString());
      return Encoding.Unicode.GetString(numArray, 0, checked ((int) RequiredSize - 2));
    }

    private static string GetDeviceBusDescription(
      IntPtr hDeviceInfoSet,
      Win32DeviceMgmt.SP_DEVINFO_DATA deviceInfoData)
    {
      return Win32DeviceMgmt.GetInfo_SetupDiGetDevicePropertyW(hDeviceInfoSet, deviceInfoData, ref Win32DeviceMgmt.DEVPKEY_Device_BusReportedDeviceDesc, "Can not read Bus provided device description device ");
    }

    private static string GetDeviceInstancePath(
      IntPtr hDeviceInfoSet,
      Win32DeviceMgmt.SP_DEVINFO_DATA deviceInfoData)
    {
      return Win32DeviceMgmt.GetInfo_SetupDiGetDevicePropertyW(hDeviceInfoSet, deviceInfoData, ref Win32DeviceMgmt.DEVPKEY_Device_InstancePath, "Can not read device instance path ");
    }

    private static string GetInfo_SetupDiGetDevicePropertyW(
      IntPtr hDeviceInfoSet,
      Win32DeviceMgmt.SP_DEVINFO_DATA deviceInfoData,
      ref Win32DeviceMgmt.DEVPROPKEY key,
      string errorText)
    {
      byte[] numArray = new byte[1024];
      uint requiredSize;
      if (!Win32DeviceMgmt.SetupDiGetDevicePropertyW(hDeviceInfoSet, ref deviceInfoData, ref key, out uint _, numArray, 1024U, out requiredSize, 0U))
        throw new Win32DeviceMgmt.USBCoreException(errorText + deviceInfoData.ClassGuid.ToString());
      return Encoding.Unicode.GetString(numArray, 0, checked ((int) requiredSize - 2));
    }

    private static Guid[] GetClassGUIDs(string className)
    {
      uint RequiredSize = 0;
      Guid[] classGuiDs = new Guid[1];
      if (!Win32DeviceMgmt.SetupDiClassGuidsFromName(className, ref classGuiDs[0], 1U, out RequiredSize))
        throw new Win32Exception();
      if (1U < RequiredSize)
      {
        classGuiDs = new Guid[(int) RequiredSize];
        Win32DeviceMgmt.SetupDiClassGuidsFromName(className, ref classGuiDs[0], RequiredSize, out RequiredSize);
      }
      return classGuiDs;
    }

    [Flags]
    public enum DiGetClassFlags : uint
    {
      DIGCF_DEFAULT = 1,
      DIGCF_PRESENT = 2,
      DIGCF_ALLCLASSES = 4,
      DIGCF_PROFILE = 8,
      DIGCF_DEVICEINTERFACE = 16, // 0x00000010
    }

    public enum SPDRP : uint
    {
      SPDRP_DEVICEDESC,
      SPDRP_HARDWAREID,
      SPDRP_COMPATIBLEIDS,
      SPDRP_UNUSED0,
      SPDRP_SERVICE,
      SPDRP_UNUSED1,
      SPDRP_UNUSED2,
      SPDRP_CLASS,
      SPDRP_CLASSGUID,
      SPDRP_DRIVER,
      SPDRP_CONFIGFLAGS,
      SPDRP_MFG,
      SPDRP_FRIENDLYNAME,
      SPDRP_LOCATION_INFORMATION,
      SPDRP_PHYSICAL_DEVICE_OBJECT_NAME,
      SPDRP_CAPABILITIES,
      SPDRP_UI_NUMBER,
      SPDRP_UPPERFILTERS,
      SPDRP_LOWERFILTERS,
      SPDRP_BUSTYPEGUID,
      SPDRP_LEGACYBUSTYPE,
      SPDRP_BUSNUMBER,
      SPDRP_ENUMERATOR_NAME,
      SPDRP_SECURITY,
      SPDRP_SECURITY_SDS,
      SPDRP_DEVTYPE,
      SPDRP_EXCLUSIVE,
      SPDRP_CHARACTERISTICS,
      SPDRP_ADDRESS,
      SPDRP_UI_NUMBER_DESC_FORMAT,
      SPDRP_DEVICE_POWER_DATA,
      SPDRP_REMOVAL_POLICY,
      SPDRP_REMOVAL_POLICY_HW_DEFAULT,
      SPDRP_REMOVAL_POLICY_OVERRIDE,
      SPDRP_INSTALL_STATE,
      SPDRP_LOCATION_PATHS,
    }

    private struct SP_DEVINFO_DATA
    {
      public uint cbSize;
      public Guid ClassGuid;
      public uint DevInst;
      public UIntPtr Reserved;
    }

    private struct DEVPROPKEY
    {
      public Guid fmtid;
      public uint pid;
    }

    public struct DeviceInfo
    {
      public string name;
      public string description;
      public string bus_description;
      public string instance_path;
    }

    public class USBCoreException : Exception
    {
      public USBCoreException(string message)
        : base(message)
      {
      }
    }
  }
}
