﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Cloud.Authentication.AuthenticationFlow
// Assembly: EmoTracker.Cloud, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 1992ADA3-34F0-4E7D-A3D6-4A70C3AA8B78
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Cloud.dll

using Amazon.CognitoIdentityProvider;
using Amazon.Extensions.CognitoAuthentication;
using Amazon.Runtime;
using EmoTracker.Core;
using System.Threading.Tasks;

namespace EmoTracker.Cloud.Authentication
{
  public class AuthenticationFlow : ObservableObject
  {
    private string mUsername;
    private string mPassword;

    [DependentProperty("Submittable")]
    public string Username
    {
      get => this.mUsername;
      set => this.SetProperty<string>(ref this.mUsername, value, nameof (Username));
    }

    [DependentProperty("Submittable")]
    public string Password
    {
      get => this.mPassword;
      set => this.SetProperty<string>(ref this.mPassword, value, nameof (Password));
    }

    public bool Submittable => !string.IsNullOrWhiteSpace(this.Username) && !string.IsNullOrWhiteSpace(this.Password);

    public async Task<bool> Login()
    {
      CognitoUser user = CognitoAuthEnvironment.CreateUnauthenticatedUserObject(this.Username);
      try
      {
        AuthFlowResponse authFlowResponse = await user.StartWithSrpAuthAsync(new InitiateSrpAuthRequest()
        {
          Password = this.Password
        });
        if (authFlowResponse != null)
        {
          if ((ConstantClass) authFlowResponse.ChallengeName == (ConstantClass) ChallengeNameType.NEW_PASSWORD_REQUIRED)
          {
            AuthFlowResponse passwordRequiredAsync = await user.RespondToNewPasswordRequiredAsync(new RespondToNewPasswordRequiredRequest()
            {
              NewPassword = this.Password,
              SessionID = authFlowResponse.SessionID
            });
          }
          return true;
        }
      }
      catch
      {
      }
      return false;
    }
  }
}
