﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Cloud.Authentication.RegistrationFlow
// Assembly: EmoTracker.Cloud, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 1992ADA3-34F0-4E7D-A3D6-4A70C3AA8B78
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Cloud.dll

using Amazon.CognitoIdentityProvider.Model;
using EmoTracker.Core;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace EmoTracker.Cloud.Authentication
{
  public class RegistrationFlow : ObservableObject
  {
    private string mUsername;
    private string mEmail;
    private string mPassword;

    [DependentProperty("Submittable")]
    public string Username
    {
      get => this.mUsername;
      set => this.SetProperty<string>(ref this.mUsername, value, nameof (Username));
    }

    [DependentProperty("Submittable")]
    public string Email
    {
      get => this.mEmail;
      set => this.SetProperty<string>(ref this.mEmail, value, nameof (Email));
    }

    [DependentProperty("Submittable")]
    public string Password
    {
      get => this.mPassword;
      set => this.SetProperty<string>(ref this.mPassword, value, nameof (Password));
    }

    public bool Submittable => !string.IsNullOrWhiteSpace(this.Username) && !string.IsNullOrWhiteSpace(this.Email) && !string.IsNullOrWhiteSpace(this.Password);

    public async Task<bool> Register()
    {
      Dictionary<string, string> userAttributes = new Dictionary<string, string>();
      Dictionary<string, string> validationData = new Dictionary<string, string>();
      userAttributes["email"] = this.Email;
      try
      {
        await CognitoAuthEnvironment.UserPool.SignUpAsync(this.Username, this.Password, (IDictionary<string, string>) userAttributes, (IDictionary<string, string>) validationData);
      }
      catch (UsernameExistsException ex)
      {
      }
      catch (InvalidPasswordException ex)
      {
      }
      catch
      {
      }
      return false;
    }
  }
}
