﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Core.BufferedObservableCollectionSynchronizerMT`2
// Assembly: EmoTracker.Core, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 4F6DD65D-7348-46EE-83CB-CEA4A6F85CDC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Core.dll

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;

namespace EmoTracker.Core
{
  public class BufferedObservableCollectionSynchronizerMT<SrcType, DstType> : 
    ObservableCollectionSynchronizer<SrcType, DstType>
    where DstType : class
  {
    private bool mbEnableThreadSafety = true;
    private int mBufferSize = 100;
    private List<KeyValuePair<object, NotifyCollectionChangedEventArgs>> mBuffer;

    public BufferedObservableCollectionSynchronizerMT(
      IReadOnlyCollection<SrcType> source,
      ObservableCollection<DstType> dest,
      Func<SrcType, DstType> itemConverter,
      Action<DstType> itemDisposer = null)
      : base(source, dest, itemConverter, itemDisposer)
    {
    }

    public bool EnableThreadSafety
    {
      get => this.mbEnableThreadSafety;
      set
      {
        if (value == this.mbEnableThreadSafety)
          return;
        this.mbEnableThreadSafety = value;
        if (this.mbEnableThreadSafety)
          return;
        this.Flush();
      }
    }

    public int BufferLength
    {
      get => this.mBufferSize;
      set => this.mBufferSize = value;
    }

    public void Flush()
    {
      if (this.mBuffer == null)
        return;
      List<KeyValuePair<object, NotifyCollectionChangedEventArgs>> mBuffer = this.mBuffer;
      this.mBuffer = (List<KeyValuePair<object, NotifyCollectionChangedEventArgs>>) null;
      foreach (KeyValuePair<object, NotifyCollectionChangedEventArgs> keyValuePair in mBuffer)
        base.SourceCollectionChanged(keyValuePair.Key, keyValuePair.Value);
    }

    protected override void SourceCollectionChanged(
      object sender,
      NotifyCollectionChangedEventArgs e)
    {
      if (this.EnableThreadSafety)
      {
        if (this.mBuffer == null)
          this.mBuffer = new List<KeyValuePair<object, NotifyCollectionChangedEventArgs>>();
        this.mBuffer.Add(new KeyValuePair<object, NotifyCollectionChangedEventArgs>(sender, e));
        if (this.mBuffer.Count < this.BufferLength)
          return;
        this.Flush();
      }
      else
        base.SourceCollectionChanged(sender, e);
    }
  }
}
