﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Core.JsonTypeTagsAttribute
// Assembly: EmoTracker.Core, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 4F6DD65D-7348-46EE-83CB-CEA4A6F85CDC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Core.dll

using System;
using System.Collections.Generic;
using System.Linq;

namespace EmoTracker.Core
{
  [AttributeUsage(AttributeTargets.Class, AllowMultiple = false, Inherited = false)]
  public class JsonTypeTagsAttribute : Attribute
  {
    private string[] mTags;

    public JsonTypeTagsAttribute(params string[] tags) => this.mTags = ((IEnumerable<string>) tags).ToArray<string>();

    public IEnumerable<string> TypeTags => (IEnumerable<string>) this.mTags;

    public static T CreateIntanceForTypeTag<T>(string type) where T : class
    {
      if (string.IsNullOrWhiteSpace(type))
        return default (T);
      type = type.Trim();
      foreach (Type type1 in TypeRegistry<T>.SupportRegistry)
      {
        object[] customAttributes = type1.GetCustomAttributes(typeof (DisallowCreationFromTagAttribute), false);
        if (customAttributes == null || customAttributes.Length == 0)
        {
          foreach (JsonTypeTagsAttribute customAttribute in type1.GetCustomAttributes(typeof (JsonTypeTagsAttribute), false))
          {
            foreach (string typeTag in customAttribute.TypeTags)
            {
              if (string.Equals(typeTag, type, StringComparison.OrdinalIgnoreCase))
                return Activator.CreateInstance(type1) as T;
            }
          }
        }
      }
      return default (T);
    }

    public static string GetDefaultTagForType(Type type)
    {
      if (type == (Type) null)
        return (string) null;
      object[] customAttributes = type.GetCustomAttributes(typeof (JsonTypeTagsAttribute), false);
      int index = 0;
      return index < customAttributes.Length ? ((JsonTypeTagsAttribute) customAttributes[index]).TypeTags.FirstOrDefault<string>() : (string) null;
    }

    public static bool GetTypeSupportsTag(Type type, string tag)
    {
      if (type == (Type) null || string.IsNullOrWhiteSpace(tag))
        return false;
      foreach (JsonTypeTagsAttribute customAttribute in type.GetCustomAttributes(typeof (JsonTypeTagsAttribute), false))
      {
        foreach (string typeTag in customAttribute.TypeTags)
        {
          if (string.Equals(typeTag, tag, StringComparison.OrdinalIgnoreCase))
            return true;
        }
      }
      return false;
    }
  }
}
