﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Core.MultiSelectionSet`1
// Assembly: EmoTracker.Core, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 4F6DD65D-7348-46EE-83CB-CEA4A6F85CDC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Core.dll

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Linq;

namespace EmoTracker.Core
{
  public class MultiSelectionSet<T> : ObservableObject where T : class
  {
    private IReadOnlyCollection<T> mSource;
    private ObservableCollection<T> mSelected = new ObservableCollection<T>();
    private ObservableCollection<T> mNotSelected = new ObservableCollection<T>();
    private ObservableCollectionSynchronizer<T, MultiSelectionSet<T>.Entry> mEntrySynchronizer;
    private ObservableCollection<MultiSelectionSet<T>.Entry> mEntries = new ObservableCollection<MultiSelectionSet<T>.Entry>();
    private string mAllEntriesCheckedText;
    private object mAllEntriesCheckedValue;

    public event MultiSelectionSet<T>.SelectionSetModifiedEvent SelectionSetModified;

    internal void NotifySelectionSetModified()
    {
      this.mAllEntriesCheckedValue = !this.AreAllSelected ? (!this.AreAnySelected ? (object) false : (object) null) : (object) true;
      this.NotifyPropertyChanged("AllEntriesCheckedValue");
      this.NotifyPropertyChanged("DisplayText");
      this.NotifyPropertyChanged("AreAnySelected");
      this.NotifyPropertyChanged("AreAllSelected");
      if (this.SelectionSetModified == null)
        return;
      this.SelectionSetModified(this, EventArgs.Empty);
    }

    public IReadOnlyCollection<T> Source
    {
      get => this.mSource;
      set
      {
        if (!this.SetProperty<IReadOnlyCollection<T>>(ref this.mSource, value, nameof (Source)))
          return;
        this.DisposeObjectAndDefault<ObservableCollectionSynchronizer<T, MultiSelectionSet<T>.Entry>>(ref this.mEntrySynchronizer);
        this.DisposeCollection<MultiSelectionSet<T>.Entry>((IEnumerable<MultiSelectionSet<T>.Entry>) this.mEntries);
        this.mEntries.Clear();
        this.mEntrySynchronizer = new ObservableCollectionSynchronizer<T, MultiSelectionSet<T>.Entry>(this.mSource, this.mEntries, new Func<T, MultiSelectionSet<T>.Entry>(this.EntryConverterFunc));
        this.NotifyPropertyChanged("DisplayText");
        this.NotifySelectionSetModified();
      }
    }

    public ObservableCollection<T> Selected
    {
      get => this.mSelected;
      protected set => this.SetProperty<ObservableCollection<T>>(ref this.mSelected, value, nameof (Selected));
    }

    public ObservableCollection<T> NotSelected
    {
      get => this.mNotSelected;
      protected set => this.SetProperty<ObservableCollection<T>>(ref this.mNotSelected, value, nameof (NotSelected));
    }

    private MultiSelectionSet<T>.Entry EntryConverterFunc(T arg) => new MultiSelectionSet<T>.Entry(this, arg);

    public ObservableCollection<MultiSelectionSet<T>.Entry> Entries
    {
      get => this.mEntries;
      protected set => this.SetProperty<ObservableCollection<MultiSelectionSet<T>.Entry>>(ref this.mEntries, value, nameof (Entries));
    }

    public string DisplayText
    {
      get
      {
        string displayText = (string) null;
        bool flag = true;
        foreach (MultiSelectionSet<T>.Entry entry in (Collection<MultiSelectionSet<T>.Entry>) this.Entries)
        {
          if (entry.Selected)
          {
            displayText = !flag ? string.Format("{0}, {1}", (object) displayText, (object) entry.DisplayText) : entry.DisplayText;
            flag = false;
          }
        }
        return displayText;
      }
    }

    public bool IsSelected(T value)
    {
      foreach (MultiSelectionSet<T>.Entry entry in (Collection<MultiSelectionSet<T>.Entry>) this.Entries)
      {
        if (object.Equals((object) entry.Value, (object) value))
          return entry.Selected;
      }
      return false;
    }

    public void Select(T value)
    {
      foreach (MultiSelectionSet<T>.Entry entry in (Collection<MultiSelectionSet<T>.Entry>) this.Entries)
      {
        if (object.Equals((object) entry.Value, (object) value))
        {
          entry.Selected = true;
          break;
        }
      }
    }

    public void SelectAs(string value)
    {
      foreach (MultiSelectionSet<T>.Entry entry in (Collection<MultiSelectionSet<T>.Entry>) this.Entries)
      {
        if (string.Equals(entry.Value.ToString(), value))
        {
          entry.Selected = true;
          break;
        }
      }
    }

    public void Deselect(T value)
    {
      foreach (MultiSelectionSet<T>.Entry entry in (Collection<MultiSelectionSet<T>.Entry>) this.Entries)
      {
        if (object.Equals((object) entry.Value, (object) value))
        {
          entry.Selected = false;
          break;
        }
      }
    }

    public void ClearSelection()
    {
      foreach (MultiSelectionSet<T>.Entry entry in (Collection<MultiSelectionSet<T>.Entry>) this.Entries)
        entry.Selected = false;
    }

    public void SelectAll()
    {
      foreach (MultiSelectionSet<T>.Entry entry in (Collection<MultiSelectionSet<T>.Entry>) this.Entries)
        entry.Selected = true;
    }

    public bool AreAnySelected
    {
      get
      {
        foreach (MultiSelectionSet<T>.Entry entry in (Collection<MultiSelectionSet<T>.Entry>) this.Entries)
        {
          if (entry.Selected)
            return true;
        }
        return false;
      }
    }

    public bool AreAllSelected
    {
      get
      {
        foreach (MultiSelectionSet<T>.Entry entry in (Collection<MultiSelectionSet<T>.Entry>) this.Entries)
        {
          if (!entry.Selected)
            return false;
        }
        return true;
      }
    }

    public string AllEntriesCheckedText
    {
      get => this.mAllEntriesCheckedText;
      set => this.SetProperty<string>(ref this.mAllEntriesCheckedText, value, nameof (AllEntriesCheckedText));
    }

    public object AllEntriesCheckedValue
    {
      get => this.mAllEntriesCheckedValue;
      set
      {
        if (this.SetProperty<object>(ref this.mAllEntriesCheckedValue, value, nameof (AllEntriesCheckedValue)))
        {
          if (this.mAllEntriesCheckedValue == null)
            return;
          if ((bool) this.mAllEntriesCheckedValue)
            this.SelectAll();
          else
            this.ClearSelection();
        }
        else
          this.AllEntriesCheckedValue = (object) false;
      }
    }

    public MultiSelectionSet(IReadOnlyCollection<T> source = null)
    {
      this.Source = source;
      this.mEntries.CollectionChanged += new NotifyCollectionChangedEventHandler(this.mEntries_CollectionChanged);
    }

    public override void Dispose()
    {
      this.DisposeObjectAndDefault<ObservableCollectionSynchronizer<T, MultiSelectionSet<T>.Entry>>(ref this.mEntrySynchronizer);
      this.mEntries.CollectionChanged -= new NotifyCollectionChangedEventHandler(this.mEntries_CollectionChanged);
      this.DisposeCollection<MultiSelectionSet<T>.Entry>((IEnumerable<MultiSelectionSet<T>.Entry>) this.mEntries);
      this.mEntries.Clear();
      base.Dispose();
    }

    private void mEntries_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
    {
      foreach (T obj in this.Selected.ToArray<T>())
      {
        T selectedEntry = obj;
        if (!this.Entries.Any<MultiSelectionSet<T>.Entry>((Func<MultiSelectionSet<T>.Entry, bool>) (entry => (object) entry.Value == (object) selectedEntry)))
          this.Selected.Remove(selectedEntry);
      }
      foreach (T obj in this.NotSelected.ToArray<T>())
      {
        T notSelectedEntry = obj;
        if (!this.Entries.Any<MultiSelectionSet<T>.Entry>((Func<MultiSelectionSet<T>.Entry, bool>) (entry => (object) entry.Value == (object) notSelectedEntry)))
          this.NotSelected.Remove(notSelectedEntry);
      }
      this.Selected.Sort<T, int>(new Func<T, int>(this.OrderToMatchSource));
      this.NotSelected.Sort<T, int>(new Func<T, int>(this.OrderToMatchSource));
      this.NotifySelectionSetModified();
    }

    private int OrderToMatchSource(T arg)
    {
      int count = this.Entries.Count;
      for (int index = 0; index < count; ++index)
      {
        if ((object) this.Entries[index].Value == (object) arg)
          return index;
      }
      return count;
    }

    public delegate void SelectionSetModifiedEvent(MultiSelectionSet<T> sender, EventArgs e);

    public class Entry : ObservableObject
    {
      private MultiSelectionSet<T> mOwner;
      private T mValue;
      private bool mSelected;

      public T Value
      {
        get => this.mValue;
        private set
        {
          if ((object) this.mValue != null && this.mValue is INotifyPropertyChanged mValue1)
            mValue1.PropertyChanged -= new PropertyChangedEventHandler(this.npc_PropertyChanged);
          this.SetProperty<T>(ref this.mValue, value, nameof (Value));
          this.mOwner.NotifyPropertyChanged("DisplayText");
          if ((object) this.mValue == null || !(this.mValue is INotifyPropertyChanged mValue2))
            return;
          mValue2.PropertyChanged += new PropertyChangedEventHandler(this.npc_PropertyChanged);
        }
      }

      public override void Dispose()
      {
        if (this.mValue is INotifyPropertyChanged mValue)
          mValue.PropertyChanged -= new PropertyChangedEventHandler(this.npc_PropertyChanged);
        base.Dispose();
      }

      private void npc_PropertyChanged(object sender, PropertyChangedEventArgs e)
      {
        this.NotifyPropertyChanged("DisplayText");
        this.mOwner.NotifyPropertyChanged("DisplayText");
      }

      public bool Selected
      {
        get => this.mSelected;
        set
        {
          if (!this.SetProperty<bool>(ref this.mSelected, value, nameof (Selected)))
            return;
          if (this.mSelected)
          {
            this.mOwner.NotSelected.Remove(this.Value);
            this.mOwner.Selected.Add(this.Value);
          }
          else
          {
            this.mOwner.NotSelected.Add(this.Value);
            this.mOwner.Selected.Remove(this.Value);
          }
          this.mOwner.NotifyPropertyChanged("DisplayText");
          this.mOwner.NotifySelectionSetModified();
        }
      }

      public string DisplayText => this.Value.ToString();

      public Entry(MultiSelectionSet<T> owner, T value)
      {
        this.mOwner = owner;
        this.Value = value;
      }
    }
  }
}
