﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Core.ObservableCollectionUniqueSetAggregrator`2
// Assembly: EmoTracker.Core, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 4F6DD65D-7348-46EE-83CB-CEA4A6F85CDC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Core.dll

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;

namespace EmoTracker.Core
{
  public class ObservableCollectionUniqueSetAggregrator<SrcType, DstType> : ObservableObject
  {
    protected ObservableCollection<DstType> mNonUniqueAggregate = new ObservableCollection<DstType>();
    protected ObservableCollection<DstType> mUniqueSet;
    protected ObservableCollectionAggregatorSynchronizer<SrcType, DstType> mSynchronizer;
    private bool mEnableDispose;

    public bool EnableDispose
    {
      get => this.mEnableDispose;
      set
      {
        if (!this.SetProperty<bool>(ref this.mEnableDispose, value, nameof (EnableDispose)) || this.mSynchronizer == null)
          return;
        this.mSynchronizer.EnableDispose = this.mEnableDispose;
      }
    }

    public ObservableCollectionUniqueSetAggregrator(
      ObservableCollection<DstType> dest,
      Func<SrcType, DstType> itemConverter,
      params ObservableCollection<SrcType>[] sources)
    {
      this.mUniqueSet = dest;
      this.mSynchronizer = new ObservableCollectionAggregatorSynchronizer<SrcType, DstType>(this.mNonUniqueAggregate, itemConverter, (IReadOnlyCollection<SrcType>[]) sources)
      {
        EnableDispose = this.EnableDispose
      };
      this.mNonUniqueAggregate.CollectionChanged += new NotifyCollectionChangedEventHandler(this.mNonUniqueAggregate_CollectionChanged);
      this.UpdateUniqueSet();
    }

    private void mNonUniqueAggregate_CollectionChanged(
      object sender,
      NotifyCollectionChangedEventArgs e)
    {
      this.UpdateUniqueSet();
    }

    public void AddSource(IReadOnlyCollection<SrcType> source) => this.mSynchronizer.AddSource(source);

    public void RemoveSource(IReadOnlyCollection<SrcType> source) => this.mSynchronizer.RemoveSource(source);

    protected void UpdateUniqueSet()
    {
      foreach (DstType dstType in (Collection<DstType>) this.mNonUniqueAggregate)
      {
        if (!this.mUniqueSet.Contains(dstType))
          this.mUniqueSet.Add(dstType);
      }
      List<DstType> dstTypeList = new List<DstType>();
      foreach (DstType mUnique in (Collection<DstType>) this.mUniqueSet)
      {
        if (!this.mNonUniqueAggregate.Contains(mUnique))
          dstTypeList.Add(mUnique);
      }
      foreach (DstType dstType in dstTypeList)
        this.mUniqueSet.Remove(dstType);
    }

    public override void Dispose()
    {
      this.DisposeObjectAndDefault<ObservableCollectionAggregatorSynchronizer<SrcType, DstType>>(ref this.mSynchronizer);
      this.DisposeCollection<DstType>((IEnumerable<DstType>) this.mNonUniqueAggregate);
      this.DisposeCollection<DstType>((IEnumerable<DstType>) this.mUniqueSet);
      base.Dispose();
    }
  }
}
