﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Core.ObservableDictionary`2
// Assembly: EmoTracker.Core, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 4F6DD65D-7348-46EE-83CB-CEA4A6F85CDC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Core.dll

using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Linq;

namespace EmoTracker.Core
{
  public class ObservableDictionary<TKey, TValue> : 
    IDictionary<TKey, TValue>,
    ICollection<KeyValuePair<TKey, TValue>>,
    IEnumerable<KeyValuePair<TKey, TValue>>,
    IEnumerable,
    INotifyCollectionChanged,
    INotifyPropertyChanged
  {
    private const string CountString = "Count";
    private const string IndexerName = "Item[]";
    private IDictionary<TKey, TValue> _Dictionary;

    protected IDictionary<TKey, TValue> Dictionary => this._Dictionary;

    public ObservableDictionary() => this._Dictionary = (IDictionary<TKey, TValue>) new System.Collections.Generic.Dictionary<TKey, TValue>();

    public ObservableDictionary(IDictionary<TKey, TValue> dictionary) => this._Dictionary = (IDictionary<TKey, TValue>) new System.Collections.Generic.Dictionary<TKey, TValue>(dictionary);

    public ObservableDictionary(IEqualityComparer<TKey> comparer) => this._Dictionary = (IDictionary<TKey, TValue>) new System.Collections.Generic.Dictionary<TKey, TValue>(comparer);

    public ObservableDictionary(int capacity) => this._Dictionary = (IDictionary<TKey, TValue>) new System.Collections.Generic.Dictionary<TKey, TValue>(capacity);

    public ObservableDictionary(
      IDictionary<TKey, TValue> dictionary,
      IEqualityComparer<TKey> comparer)
    {
      this._Dictionary = (IDictionary<TKey, TValue>) new System.Collections.Generic.Dictionary<TKey, TValue>(dictionary, comparer);
    }

    public ObservableDictionary(int capacity, IEqualityComparer<TKey> comparer) => this._Dictionary = (IDictionary<TKey, TValue>) new System.Collections.Generic.Dictionary<TKey, TValue>(capacity, comparer);

    public void Add(TKey key, TValue value) => this.Insert(key, value, true);

    public bool ContainsKey(TKey key) => this.Dictionary.ContainsKey(key);

    public ICollection<TKey> Keys => this.Dictionary.Keys;

    public bool Remove(TKey key)
    {
      if ((object) key == null)
        throw new ArgumentNullException(nameof (key));
      int num = this.Dictionary.Remove(key) ? 1 : 0;
      if (num == 0)
        return num != 0;
      this.OnCollectionChanged();
      return num != 0;
    }

    public bool TryGetValue(TKey key, out TValue value) => this.Dictionary.TryGetValue(key, out value);

    public ICollection<TValue> Values => this.Dictionary.Values;

    public TValue this[TKey key]
    {
      get => this.Dictionary[key];
      set => this.Insert(key, value, false);
    }

    public void Add(KeyValuePair<TKey, TValue> item) => this.Insert(item.Key, item.Value, true);

    public void Clear()
    {
      if (this.Dictionary.Count <= 0)
        return;
      this.Dictionary.Clear();
      this.OnCollectionChanged();
    }

    public bool Contains(KeyValuePair<TKey, TValue> item) => this.Dictionary.Contains(item);

    public void CopyTo(KeyValuePair<TKey, TValue>[] array, int arrayIndex) => this.Dictionary.CopyTo(array, arrayIndex);

    public int Count => this.Dictionary.Count;

    public bool IsReadOnly => this.Dictionary.IsReadOnly;

    public bool Remove(KeyValuePair<TKey, TValue> item) => this.Remove(item.Key);

    public IEnumerator<KeyValuePair<TKey, TValue>> GetEnumerator() => this.Dictionary.GetEnumerator();

    IEnumerator IEnumerable.GetEnumerator() => this.Dictionary.GetEnumerator();

    public event NotifyCollectionChangedEventHandler CollectionChanged;

    public event PropertyChangedEventHandler PropertyChanged;

    public void AddRange(IDictionary<TKey, TValue> items)
    {
      if (items == null)
        throw new ArgumentNullException(nameof (items));
      if (items.Count <= 0)
        return;
      if (this.Dictionary.Count > 0)
      {
        if (items.Keys.Any<TKey>((Func<TKey, bool>) (k => this.Dictionary.ContainsKey(k))))
          throw new ArgumentException("An item with the same key has already been added.");
        foreach (KeyValuePair<TKey, TValue> keyValuePair in (IEnumerable<KeyValuePair<TKey, TValue>>) items)
          this.Dictionary.Add(keyValuePair);
      }
      else
        this._Dictionary = (IDictionary<TKey, TValue>) new System.Collections.Generic.Dictionary<TKey, TValue>(items);
      this.OnCollectionChanged(NotifyCollectionChangedAction.Add, (IList) items.ToArray<KeyValuePair<TKey, TValue>>());
    }

    private void Insert(TKey key, TValue value, bool add)
    {
      if ((object) key == null)
        throw new ArgumentNullException(nameof (key));
      TValue objA;
      if (this.Dictionary.TryGetValue(key, out objA))
      {
        if (add)
          throw new ArgumentException("An item with the same key has already been added.");
        if (object.Equals((object) objA, (object) value))
          return;
        this.Dictionary[key] = value;
        this.OnCollectionChanged(NotifyCollectionChangedAction.Replace, new KeyValuePair<TKey, TValue>(key, value), new KeyValuePair<TKey, TValue>(key, objA));
      }
      else
      {
        this.Dictionary[key] = value;
        this.OnCollectionChanged(NotifyCollectionChangedAction.Add, new KeyValuePair<TKey, TValue>(key, value));
      }
    }

    private void OnPropertyChanged()
    {
      this.OnPropertyChanged("Count");
      this.OnPropertyChanged("Item[]");
    }

    protected virtual void OnPropertyChanged(string propertyName)
    {
      if (this.PropertyChanged == null)
        return;
      this.PropertyChanged((object) this, new PropertyChangedEventArgs(propertyName));
    }

    private void OnCollectionChanged()
    {
      this.OnPropertyChanged();
      if (this.CollectionChanged == null)
        return;
      this.CollectionChanged((object) this, new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset));
    }

    private void OnCollectionChanged(
      NotifyCollectionChangedAction action,
      KeyValuePair<TKey, TValue> changedItem)
    {
      this.OnPropertyChanged();
      if (this.CollectionChanged == null)
        return;
      this.CollectionChanged((object) this, new NotifyCollectionChangedEventArgs(action, (object) changedItem));
    }

    private void OnCollectionChanged(
      NotifyCollectionChangedAction action,
      KeyValuePair<TKey, TValue> newItem,
      KeyValuePair<TKey, TValue> oldItem)
    {
      this.OnPropertyChanged();
      if (this.CollectionChanged == null)
        return;
      this.CollectionChanged((object) this, new NotifyCollectionChangedEventArgs(action, (object) newItem, (object) oldItem));
    }

    private void OnCollectionChanged(NotifyCollectionChangedAction action, IList newItems)
    {
      this.OnPropertyChanged();
      if (this.CollectionChanged == null)
        return;
      this.CollectionChanged((object) this, new NotifyCollectionChangedEventArgs(action, newItems));
    }
  }
}
