﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Core.TypedObjectRegistry`1
// Assembly: EmoTracker.Core, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: 4F6DD65D-7348-46EE-83CB-CEA4A6F85CDC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Core.dll

using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;

namespace EmoTracker.Core
{
  public class TypedObjectRegistry<T> where T : class
  {
    private static string sRegistryLock = "Registry";
    private static List<T> sSupportRegistry;

    public static IEnumerable<T> SupportRegistry
    {
      get
      {
        lock (TypedObjectRegistry<T>.sRegistryLock)
        {
          if (TypedObjectRegistry<T>.sSupportRegistry == null)
            TypedObjectRegistry<T>.BuildRegistry();
          return (IEnumerable<T>) TypedObjectRegistry<T>.sSupportRegistry;
        }
      }
    }

    private static void BuildRegistry()
    {
      TypedObjectRegistry<T>.sSupportRegistry = new List<T>();
      List<Type> typeList = new List<Type>();
      foreach (Assembly assembly in AppDomain.CurrentDomain.GetAssemblies())
      {
        try
        {
          foreach (Type type in assembly.GetTypes())
          {
            if ((typeof (T).IsInterface ? (((IEnumerable<Type>) type.GetInterfaces()).Contains<Type>(typeof (T)) ? 1 : 0) : (type.IsSubclassOf(typeof (T)) ? 1 : 0)) != 0)
              typeList.Add(type);
          }
        }
        catch (ReflectionTypeLoadException ex)
        {
          foreach (Exception loaderException in ex.LoaderExceptions)
            ;
        }
        catch (Exception ex)
        {
        }
      }
      foreach (Type type in typeList)
      {
        if (!type.IsAbstract && !type.IsInterface && !type.ContainsGenericParameters && Activator.CreateInstance(type) is T instance)
          TypedObjectRegistry<T>.sSupportRegistry.Add(instance);
      }
    }

    public static T GetObjectOfConcreteType<V>()
    {
      foreach (T objectOfConcreteType in TypedObjectRegistry<T>.SupportRegistry)
      {
        if (objectOfConcreteType.GetType().IsSubclassOf(typeof (V)))
          return objectOfConcreteType;
      }
      return default (T);
    }
  }
}
