﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.ApplicationSettings
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.IO;
using System.Linq;

namespace EmoTracker.Data
{
  public class ApplicationSettings : ObservableSingleton<ApplicationSettings>
  {
    private double mInitialWidth = -1.0;
    private double mInitialHeight = -1.0;
    private double mNDIFrameRate = 30.0;
    private int mNDIOutputScale = 1;
    private bool mbAlwaysOnTop;
    private bool mbEnableDiscordRichPresence;
    private bool mbEnableVoice = true;
    private bool mbEnableBontaMultiWorld;
    private bool mbIgnoreBontaMultiWorldRomCheck;
    private bool mbPromptOnRefreshClose;
    private bool mbDisplayAllLocations;
    private bool mbIgnoreAllLogic;
    private bool mbAutoUnpinLocationsOnClear = true;
    private bool mbAlwaysAllowClearing;
    private bool mbPinLocationsOnItemCapture = true;
    private bool mbFastTooltips;
    private string mTwitchChannelName;
    private string mLastActivePackage;
    private string mLastActivePackageVariant;
    private string mCommandLinePackage;
    private string mCommandLinePackageVariant;
    private ObservableCollection<string> mPackageRepositories = new ObservableCollection<string>();
    private MultiworldNotificationLevel mMultiworldNotificationLevel = MultiworldNotificationLevel.Normal;

    public bool IgnoreAllLogic
    {
      get => this.mbIgnoreAllLogic;
      set
      {
        if (!this.SetProperty<bool>(ref this.mbIgnoreAllLogic, value, nameof (IgnoreAllLogic)))
          return;
        ObservableSingleton<LocationDatabase>.Instance.RefeshAccessibility();
      }
    }

    public bool AutoUnpinLocationsOnClear
    {
      get => this.mbAutoUnpinLocationsOnClear;
      set => this.SetProperty<bool>(ref this.mbAutoUnpinLocationsOnClear, value, nameof (AutoUnpinLocationsOnClear));
    }

    public bool AlwaysAllowClearing
    {
      get => this.mbAlwaysAllowClearing;
      set => this.SetProperty<bool>(ref this.mbAlwaysAllowClearing, value, nameof (AlwaysAllowClearing));
    }

    public bool PinLocationsOnItemCapture
    {
      get => this.mbPinLocationsOnItemCapture;
      set => this.SetProperty<bool>(ref this.mbPinLocationsOnItemCapture, value, nameof (PinLocationsOnItemCapture));
    }

    public bool DisplayAllLocations
    {
      get => this.mbDisplayAllLocations;
      set => this.SetProperty<bool>(ref this.mbDisplayAllLocations, value, nameof (DisplayAllLocations));
    }

    public bool FastToolTips
    {
      get => this.mbFastTooltips;
      set => this.SetProperty<bool>(ref this.mbFastTooltips, value, nameof (FastToolTips));
    }

    public MultiworldNotificationLevel MultiworldNotificationLevel
    {
      get => this.mMultiworldNotificationLevel;
      set => this.SetProperty<MultiworldNotificationLevel>(ref this.mMultiworldNotificationLevel, value, nameof (MultiworldNotificationLevel));
    }

    public double InitialWidth
    {
      get => this.mInitialWidth;
      set => this.SetProperty<double>(ref this.mInitialWidth, value, nameof (InitialWidth));
    }

    public double InitialHeight
    {
      get => this.mInitialHeight;
      set => this.SetProperty<double>(ref this.mInitialHeight, value, nameof (InitialHeight));
    }

    public bool AlwaysOnTop
    {
      get => this.mbAlwaysOnTop;
      set => this.SetProperty<bool>(ref this.mbAlwaysOnTop, value, nameof (AlwaysOnTop));
    }

    public bool EnableVoiceControl
    {
      get => this.mbEnableVoice;
      set => this.SetProperty<bool>(ref this.mbEnableVoice, value, nameof (EnableVoiceControl));
    }

    public bool EnableBontaMultiWorld
    {
      get => this.mbEnableBontaMultiWorld;
      set => this.SetProperty<bool>(ref this.mbEnableBontaMultiWorld, value, nameof (EnableBontaMultiWorld));
    }

    public bool IgnoreBontaMultiWorldRomCheck
    {
      get => this.mbIgnoreBontaMultiWorldRomCheck;
      set => this.SetProperty<bool>(ref this.mbIgnoreBontaMultiWorldRomCheck, value, nameof (IgnoreBontaMultiWorldRomCheck));
    }

    public bool PromptOnRefreshClose
    {
      get => this.mbPromptOnRefreshClose;
      set => this.SetProperty<bool>(ref this.mbPromptOnRefreshClose, value, nameof (PromptOnRefreshClose));
    }

    public bool EnableDiscordRichPresence
    {
      get => this.mbEnableDiscordRichPresence;
      set => this.SetProperty<bool>(ref this.mbEnableDiscordRichPresence, value, nameof (EnableDiscordRichPresence));
    }

    public string LastActivePackage
    {
      get => this.mLastActivePackage;
      set => this.SetProperty<string>(ref this.mLastActivePackage, value, nameof (LastActivePackage));
    }

    public string LastActivePackageVariant
    {
      get => this.mLastActivePackageVariant;
      set => this.SetProperty<string>(ref this.mLastActivePackageVariant, value, nameof (LastActivePackageVariant));
    }

    public string CommandLinePackage
    {
      get => this.mCommandLinePackage;
      set => this.SetProperty<string>(ref this.mCommandLinePackage, value, nameof (CommandLinePackage));
    }

    public string CommandLinePackageVariant
    {
      get => this.mCommandLinePackageVariant;
      set => this.SetProperty<string>(ref this.mCommandLinePackageVariant, value, nameof (CommandLinePackageVariant));
    }

    public string TwitchChannelName
    {
      get => this.mTwitchChannelName;
      set => this.SetProperty<string>(ref this.mTwitchChannelName, value, nameof (TwitchChannelName));
    }

    public double NdiFrameRate
    {
      get => this.mNDIFrameRate;
      set => this.SetProperty<double>(ref this.mNDIFrameRate, Math.Max(value, 1.0), nameof (NdiFrameRate));
    }

    public int NdiOutputScale
    {
      get => this.mNDIOutputScale;
      set => this.SetProperty<int>(ref this.mNDIOutputScale, Math.Max(value, 1), nameof (NdiOutputScale));
    }

    public IEnumerable<string> AdditionalRepositories => (IEnumerable<string>) this.mPackageRepositories;

    public ApplicationSettings()
    {
      this.LoadSettings();
      this.PropertyChanged += new PropertyChangedEventHandler(this.LocalPropertyChanged);
      this.mPackageRepositories.CollectionChanged += new NotifyCollectionChangedEventHandler(this.RepositoriesModified);
    }

    private void RepositoriesModified(object sender, NotifyCollectionChangedEventArgs e)
    {
    }

    private void LocalPropertyChanged(object sender, PropertyChangedEventArgs e) => this.WriteSettings();

    private void LoadSettings()
    {
      try
      {
        if (File.Exists(Path.Combine(UserDirectory.Path, "application_settings.json")))
        {
          using (StreamReader reader = new StreamReader((Stream) File.OpenRead(Path.Combine(UserDirectory.Path, "application_settings.json"))))
          {
            JObject token = (JObject) JToken.ReadFrom((JsonReader) new JsonTextReader((TextReader) reader));
            this.InitialWidth = token.GetValue<double>("initial_width", -1.0);
            this.InitialHeight = token.GetValue<double>("initial_height", -1.0);
            this.NdiFrameRate = token.GetValue<double>("ndi_frame_rate", 30.0);
            this.NdiOutputScale = token.GetValue<int>("ndi_output_scale", 1);
            this.AlwaysOnTop = token.GetValue<bool>("always_on_top");
            this.EnableDiscordRichPresence = token.GetValue<bool>("discord_rich_presence");
            this.EnableVoiceControl = token.GetValue<bool>("enable_voice_control", true);
            this.EnableBontaMultiWorld = token.GetValue<bool>("enable_bonta_alttpr_multiworld");
            this.IgnoreBontaMultiWorldRomCheck = token.GetValue<bool>("ignore_bonta_alttpr_multiworld_rom_check");
            this.MultiworldNotificationLevel = token.GetEnumValue<MultiworldNotificationLevel>("multiworld_notification_level", MultiworldNotificationLevel.Normal);
            this.PromptOnRefreshClose = token.GetValue<bool>("prompt_on_refresh_close");
            this.LastActivePackage = token.GetValue<string>("last_active_package", (string) null);
            this.LastActivePackageVariant = token.GetValue<string>("last_active_package_variant", (string) null);
            this.TwitchChannelName = token.GetValue<string>("twitch_channel", (string) null);
            this.IgnoreAllLogic = token.GetValue<bool>("tracking_ignore_all_logic");
            this.AlwaysAllowClearing = token.GetValue<bool>("tracking_always_allow_clearing_locations");
            this.DisplayAllLocations = token.GetValue<bool>("tracking_display_all_locations");
            this.AutoUnpinLocationsOnClear = token.GetValue<bool>("tracking_auto_unpin_locations_on_clear", true);
            this.PinLocationsOnItemCapture = token.GetValue<bool>("tracking_pin_locations_on_item_capture", true);
            this.FastToolTips = token.GetValue<bool>("assistance_fast_tool_tips");
            JArray jarray = token.GetValue<JArray>("package_repositories");
            if (jarray != null)
            {
              foreach (JToken jtoken in jarray)
              {
                string str = (string) jtoken;
                if (!string.IsNullOrWhiteSpace(str) && !this.mPackageRepositories.Contains<string>(str, (IEqualityComparer<string>) StringComparer.OrdinalIgnoreCase))
                  this.mPackageRepositories.Add(str);
              }
            }
          }
        }
        string[] commandLineArgs = Environment.GetCommandLineArgs();
        for (int index = 0; index < commandLineArgs.Length; ++index)
        {
          if (string.Equals(commandLineArgs[index], "--pack"))
          {
            ++index;
            if (index > commandLineArgs.Length - 1)
              break;
            this.CommandLinePackage = commandLineArgs[index];
          }
          if (string.Equals(commandLineArgs[index], "--variant"))
          {
            ++index;
            if (index > commandLineArgs.Length - 1)
              break;
            this.CommandLinePackageVariant = commandLineArgs[index];
          }
        }
      }
      catch
      {
      }
    }

    private void WriteSettings()
    {
      try
      {
        using (StreamWriter streamWriter = new StreamWriter((Stream) File.Open(Path.Combine(UserDirectory.Path, "application_settings.json"), FileMode.Create)))
        {
          using (JsonTextWriter jsonTextWriter = new JsonTextWriter((TextWriter) streamWriter))
          {
            jsonTextWriter.AutoCompleteOnClose = true;
            jsonTextWriter.Formatting = Formatting.Indented;
            JObject jobject = new JObject();
            if (this.InitialWidth >= 0.0)
              jobject.Add("initial_width", JToken.FromObject((object) this.InitialWidth));
            if (this.InitialHeight >= 0.0)
              jobject.Add("initial_height", JToken.FromObject((object) this.InitialHeight));
            if (this.NdiFrameRate > 1.0)
              jobject.Add("ndi_frame_rate", JToken.FromObject((object) this.NdiFrameRate));
            if (this.NdiOutputScale > 1)
              jobject.Add("ndi_output_scale", JToken.FromObject((object) this.NdiOutputScale));
            jobject.Add("always_on_top", JToken.FromObject((object) this.AlwaysOnTop));
            jobject.Add("discord_rich_presence", JToken.FromObject((object) this.EnableDiscordRichPresence));
            jobject.Add("enable_voice_control", JToken.FromObject((object) this.EnableVoiceControl));
            jobject.Add("prompt_on_refresh_close", JToken.FromObject((object) this.PromptOnRefreshClose));
            jobject.Add("ignore_bonta_alttpr_multiworld_rom_check", JToken.FromObject((object) this.IgnoreBontaMultiWorldRomCheck));
            jobject.Add("multiworld_notification_level", JToken.FromObject((object) this.MultiworldNotificationLevel));
            if (!string.IsNullOrWhiteSpace(this.LastActivePackage))
              jobject.Add("last_active_package", JToken.FromObject((object) this.LastActivePackage));
            if (!string.IsNullOrWhiteSpace(this.LastActivePackageVariant))
              jobject.Add("last_active_package_variant", JToken.FromObject((object) this.LastActivePackageVariant));
            if (!string.IsNullOrWhiteSpace(this.TwitchChannelName))
              jobject.Add("twitch_channel", JToken.FromObject((object) this.TwitchChannelName));
            jobject.Add("tracking_ignore_all_logic", JToken.FromObject((object) this.IgnoreAllLogic));
            jobject.Add("tracking_always_allow_clearing_locations", JToken.FromObject((object) this.AlwaysAllowClearing));
            jobject.Add("tracking_display_all_locations", JToken.FromObject((object) this.DisplayAllLocations));
            jobject.Add("tracking_auto_unpin_locations_on_clear", JToken.FromObject((object) this.AutoUnpinLocationsOnClear));
            jobject.Add("tracking_pin_locations_on_item_capture", JToken.FromObject((object) this.PinLocationsOnItemCapture));
            jobject.Add("assistance_fast_tool_tips", JToken.FromObject((object) this.FastToolTips));
            JArray jarray = JArray.FromObject((object) this.AdditionalRepositories);
            if (jarray != null)
              jobject.Add("package_repositories", (JToken) jarray);
            jsonTextWriter.WriteToken(jobject.CreateReader());
          }
        }
      }
      catch
      {
      }
    }
  }
}
