﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Items.CompositeToggleItem
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using EmoTracker.Data.Media;
using Newtonsoft.Json.Linq;
using System.Collections.Generic;
using System.ComponentModel;

namespace EmoTracker.Data.Items
{
  [JsonTypeTags(new string[] {"composite_toggle"})]
  public class CompositeToggleItem : ItemBase
  {
    private ToggleItem mItemA;
    private ToggleItem mItemB;
    private CodeProvider mProvidedCodes = new CodeProvider();
    private Dictionary<KeyValuePair<bool, bool>, ImageReference> mIcons = new Dictionary<KeyValuePair<bool, bool>, ImageReference>();

    public override bool CanProvideCode(string code) => this.mProvidedCodes.ProvidesCode(code);

    public override uint ProvidesCode(string code) => this.mProvidedCodes.ProvidesCode(code) ? 1U : 0U;

    public override void AdvanceToCode(string code = null)
    {
    }

    public override void OnLeftClick()
    {
      if (this.mItemA == null)
        return;
      this.mItemA.Active = !this.mItemA.Active;
    }

    public override void OnRightClick()
    {
      if (this.mItemB == null)
        return;
      this.mItemB.Active = !this.mItemB.Active;
    }

    protected void UpdateImage()
    {
      bool key = this.mItemA != null && this.mItemA.Active;
      bool flag = this.mItemB != null && this.mItemB.Active;
      ImageReference imageReference = (ImageReference) null;
      if (!this.mIcons.TryGetValue(new KeyValuePair<bool, bool>(key, flag), out imageReference))
        return;
      this.Icon = imageReference;
    }

    protected override void ParseDataInternal(JObject data, IGamePackage package)
    {
      this.Capturable = false;
      this.mProvidedCodes.AddCodes(data.GetValue<string>("codes", (string) null));
      this.mItemA = Singleton<ItemDatabase>.Instance.FindProvidingItemForCode(data.GetValue<string>("item_left", (string) null)) as ToggleItem;
      this.mItemB = Singleton<ItemDatabase>.Instance.FindProvidingItemForCode(data.GetValue<string>("item_right", (string) null)) as ToggleItem;
      if (this.mItemA != null)
        this.mItemA.PropertyChanged += new PropertyChangedEventHandler(this.MonitoredItem_PropertyChanged);
      if (this.mItemB != null)
        this.mItemB.PropertyChanged += new PropertyChangedEventHandler(this.MonitoredItem_PropertyChanged);
      foreach (JObject token in (JArray) data.GetValue("images"))
      {
        string path = token.GetValue<string>("img", (string) null);
        ImageReference imageReference = ImageReference.FromPackRelativePath(package, path, token.GetValue<string>("img_mods", (string) null));
        if (imageReference != null)
          this.mIcons[new KeyValuePair<bool, bool>(token.GetValue<bool>("left"), token.GetValue<bool>("right"))] = imageReference;
      }
      this.UpdateImage();
    }

    private void MonitoredItem_PropertyChanged(object sender, PropertyChangedEventArgs e) => this.UpdateImage();

    public class Stage : CodeProvider
    {
      public ImageReference Icon { get; set; }
    }
  }
}
