﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Items.ItemBase
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.Core.Transactions;
using EmoTracker.Data.JSON;
using EmoTracker.Data.Media;
using Newtonsoft.Json.Linq;
using System;
using System.ComponentModel;

namespace EmoTracker.Data.Items
{
  public abstract class ItemBase : 
    TransactableObject,
    ITrackableItem,
    INotifyPropertyChanged,
    IDisposable
  {
    private ImageReference mCurrentIcon;
    private ImageReference mPotentialIcon;
    private string mName;
    private string mDisabledImageFilterSpec;
    private string mBadgeText;
    private string mBadgeTextColor = "WhiteSmoke";
    private bool mbCapturable = true;
    private bool mbMaskInput;
    private bool mbIgnoreUserInput;

    public string Name
    {
      get => this.mName;
      set => this.SetProperty<string>(ref this.mName, value, nameof (Name));
    }

    public string BadgeText
    {
      get => this.mBadgeText;
      set => this.SetProperty<string>(ref this.mBadgeText, value, nameof (BadgeText));
    }

    public string BadgeTextColor
    {
      get => this.mBadgeTextColor;
      set => this.SetProperty<string>(ref this.mBadgeTextColor, value, nameof (BadgeTextColor));
    }

    public string DisabledImageFilterSpec
    {
      get => this.mDisabledImageFilterSpec != null ? this.mDisabledImageFilterSpec : ObservableSingleton<Tracker>.Instance.DisabledImageFilterSpec;
      set => this.SetProperty<string>(ref this.mDisabledImageFilterSpec, value, nameof (DisabledImageFilterSpec));
    }

    public bool Capturable
    {
      get => this.mbCapturable;
      set => this.SetProperty<bool>(ref this.mbCapturable, value, nameof (Capturable));
    }

    public bool MaskInput
    {
      get => this.mbMaskInput;
      set => this.SetProperty<bool>(ref this.mbMaskInput, value, nameof (MaskInput));
    }

    public bool IgnoreUserInput
    {
      get => this.mbIgnoreUserInput;
      set => this.SetProperty<bool>(ref this.mbIgnoreUserInput, value, nameof (IgnoreUserInput));
    }

    [DependentProperty("PotentialIcon")]
    public ImageReference Icon
    {
      get => this.mCurrentIcon;
      set
      {
        if (!this.SetProperty<ImageReference>(ref this.mCurrentIcon, value, nameof (Icon)))
          return;
        ObservableSingleton<LocationDatabase>.Instance.RefeshAccessibility();
      }
    }

    public ImageReference PotentialIcon
    {
      get => this.mPotentialIcon != null ? this.mPotentialIcon : this.mCurrentIcon;
      set
      {
        this.mPotentialIcon = value;
        this.NotifyPropertyChanged(nameof (PotentialIcon));
      }
    }

    public void InvalidateAccessibility() => ObservableSingleton<LocationDatabase>.Instance.RefeshAccessibility();

    public abstract void OnLeftClick();

    public abstract void OnRightClick();

    public abstract uint ProvidesCode(string code);

    public abstract bool CanProvideCode(string code);

    public abstract void AdvanceToCode(string code = null);

    public static ITrackableItem CreateItem(JObject data, IGamePackage package)
    {
      ItemBase intanceForTypeTag = JsonTypeTagsAttribute.CreateIntanceForTypeTag<ItemBase>(data.GetValue<string>("type", (string) null));
      if (intanceForTypeTag != null)
      {
        intanceForTypeTag.Name = data.GetValue<string>("name", (string) null);
        intanceForTypeTag.Capturable = data.GetValue<bool>("capturable", true);
        intanceForTypeTag.MaskInput = data.GetValue<bool>("mask_input");
        intanceForTypeTag.IgnoreUserInput = data.GetValue<bool>("ignore_user_input");
        intanceForTypeTag.DisabledImageFilterSpec = data.GetValue<string>("disabled_image_filter", (string) null);
        intanceForTypeTag.ParseDataInternal(data, package);
      }
      return (ITrackableItem) intanceForTypeTag;
    }

    protected abstract void ParseDataInternal(JObject data, IGamePackage package);

    protected virtual bool Save(JObject data) => false;

    protected virtual bool Load(JObject data) => true;

    bool ITrackableItem.Save(JObject data) => this.Save(data);

    bool ITrackableItem.Load(JObject data) => this.Load(data);
  }
}
