﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Items.ItemGrid
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using Newtonsoft.Json.Linq;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace EmoTracker.Data.Items
{
  public class ItemGrid : ObservableObject
  {
    private ObservableCollection<ItemList> mRows = new ObservableCollection<ItemList>();
    private string mLegacyMargin;
    private double mItemWidth = 32.0;
    private double mItemHeight = 32.0;
    private string mItemMargin;
    private double mBadgeFontSize = 12.0;

    public IEnumerable<ItemList> Rows => (IEnumerable<ItemList>) this.mRows;

    public string LegacyMargin
    {
      get => this.mLegacyMargin;
      set => this.SetProperty<string>(ref this.mLegacyMargin, value, nameof (LegacyMargin));
    }

    public double ItemWidth
    {
      get => this.mItemWidth;
      set => this.SetProperty<double>(ref this.mItemWidth, value, nameof (ItemWidth));
    }

    public double ItemHeight
    {
      get => this.mItemHeight;
      set => this.SetProperty<double>(ref this.mItemHeight, value, nameof (ItemHeight));
    }

    public string ItemMargin
    {
      get => this.mItemMargin;
      set => this.SetProperty<string>(ref this.mItemMargin, value, nameof (ItemMargin));
    }

    public double BadgeFontSize
    {
      get => this.mBadgeFontSize;
      set => this.SetProperty<double>(ref this.mBadgeFontSize, value, nameof (BadgeFontSize));
    }

    public void AddRow(ItemList row) => this.mRows.Add(row);

    public void Clear() => this.mRows.Clear();

    public void Load(JObject data)
    {
      this.ItemMargin = data.GetValue<string>("item_margin", "5");
      this.ItemWidth = this.mItemHeight = data.GetValue<double>("item_size", 32.0);
      this.ItemWidth = data.GetValue<double>("item_width", this.ItemWidth);
      this.ItemHeight = data.GetValue<double>("item_height", this.ItemHeight);
      this.BadgeFontSize = data.GetValue<double>("badge_font_size", 12.0);
      this.LoadRows(data.GetValue<JArray>("rows"));
    }

    private void LoadRows(JArray data)
    {
      foreach (JArray jarray in data)
      {
        ItemList row = new ItemList();
        foreach (JToken jtoken in jarray)
        {
          string code = (string) jtoken;
          row.Add(Singleton<ItemDatabase>.Instance.FindProvidingItemForCode(code));
        }
        this.AddRow(row);
      }
    }
  }
}
