﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Items.SectionChestsProxyItem
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using EmoTracker.Data.Locations;
using Newtonsoft.Json.Linq;
using System.ComponentModel;

namespace EmoTracker.Data.Items
{
  [JsonTypeTags(new string[] {"sectionchests"})]
  public class SectionChestsProxyItem : ItemBase
  {
    private CodeProvider mCodeProvider = new CodeProvider();
    private Section mSection;

    public Section Section
    {
      get => this.mSection;
      protected set
      {
        Section mSection = this.mSection;
        if (!this.SetProperty<Section>(ref this.mSection, value, nameof (Section)))
          return;
        if (mSection != null)
          mSection.PropertyChanged -= new PropertyChangedEventHandler(this.Section_PropertyChanged);
        if (this.mSection != null)
          this.mSection.PropertyChanged += new PropertyChangedEventHandler(this.Section_PropertyChanged);
        this.RefreshState();
      }
    }

    public SectionChestsProxyItem() => ObservableSingleton<Tracker>.Instance.PropertyChanged += new PropertyChangedEventHandler(this.Tracker_PropertyChanged);

    private void Tracker_PropertyChanged(object sender, PropertyChangedEventArgs e)
    {
      if (!(e.PropertyName == "AlwaysAllowClearing"))
        return;
      this.RefreshState();
    }

    private void Section_PropertyChanged(object sender, PropertyChangedEventArgs e) => this.RefreshState();

    public uint Count => this.Section != null ? this.Section.AvailableChestCount : 0U;

    private bool AllowManipulation => this.Section != null && this.Section.Visible && (ObservableSingleton<ApplicationSettings>.Instance.AlwaysAllowClearing || this.Section.AccessibilityLevel != AccessibilityLevel.None);

    public override void AdvanceToCode(string code = null)
    {
    }

    public override bool CanProvideCode(string code) => this.mCodeProvider.ProvidesCode(code);

    public override void OnLeftClick()
    {
      if (!this.AllowManipulation || this.Section.AvailableChestCount <= 0U)
        return;
      --this.Section.AvailableChestCount;
    }

    public override void OnRightClick()
    {
      if (!this.AllowManipulation || this.Section.AvailableChestCount >= this.Section.ChestCount)
        return;
      ++this.Section.AvailableChestCount;
    }

    public override uint ProvidesCode(string code) => this.CanProvideCode(code) ? this.Count : 0U;

    private void RefreshState()
    {
      if (this.Section == null)
        return;
      this.BadgeText = this.Count.ToString();
      if (this.Count >= this.Section.ChestCount)
        this.BadgeTextColor = "#00ff00";
      else
        this.BadgeTextColor = "WhiteSmoke";
      if (this.Count == 0U)
        this.Icon = this.AllowManipulation ? this.Section.OpenChestImage : this.Section.UnavailableOpenChestImage;
      else
        this.Icon = this.AllowManipulation ? this.Section.ClosedChestImage : this.Section.UnavailableClosedChestImage;
    }

    protected override void ParseDataInternal(JObject data, IGamePackage package)
    {
      this.mCodeProvider.AddCodes(data.GetValue<string>("codes", (string) null));
      this.Section = ObservableSingleton<Tracker>.Instance.FindObjectForCode(data.GetValue<string>("section", (string) null)) as Section;
    }
  }
}
