﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Items.ToggleBadgedItem
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using EmoTracker.Data.Media;
using Newtonsoft.Json.Linq;
using System;
using System.ComponentModel;

namespace EmoTracker.Data.Items
{
  [JsonTypeTags(new string[] {"toggle_badged"})]
  public class ToggleBadgedItem : ItemBase
  {
    private ImageReference mInactiveIcon;
    private ImageReference mActiveIcon;
    private CodeProvider mCodeProvider = new CodeProvider();
    private ITrackableItem mBaseItem;

    public ITrackableItem BaseItem
    {
      get => this.mBaseItem;
      set
      {
        if (!this.SetProperty<ITrackableItem>(ref this.mBaseItem, value, nameof (BaseItem)))
          return;
        this.UpdateDisplayIcon();
      }
    }

    public ImageReference ActiveIcon
    {
      get => this.mActiveIcon;
      set
      {
        this.mActiveIcon = value;
        this.UpdateDisplayIcon();
      }
    }

    public bool Active
    {
      get => this.GetTransactableProperty<bool>(nameof (Active));
      set => this.SetTransactableProperty<bool>(value, (Action<bool>) (processedValue => this.UpdateDisplayIcon()), nameof (Active));
    }

    private void UpdateDisplayIcon()
    {
      if (this.BaseItem != null)
      {
        this.PotentialIcon = ImageReference.FromLayeredImageReferences(this.BaseItem.PotentialIcon, this.mActiveIcon);
        this.Icon = ImageReference.FromLayeredImageReferences(this.BaseItem.Icon, this.Active ? this.mActiveIcon : this.mInactiveIcon);
      }
      else
      {
        this.PotentialIcon = this.mActiveIcon;
        this.Icon = this.Active ? this.mActiveIcon : this.mInactiveIcon;
      }
    }

    public override void OnLeftClick()
    {
      if (this.BaseItem == null)
        return;
      this.BaseItem.OnLeftClick();
    }

    public override void OnRightClick() => this.Active = !this.Active;

    public override uint ProvidesCode(string code) => this.Active && this.CanProvideCode(code) ? 1U : 0U;

    public override bool CanProvideCode(string code) => this.mCodeProvider.ProvidesCode(code);

    public override void AdvanceToCode(string code = null) => this.Active = true;

    public void AddProvidedCodes(string spec) => this.mCodeProvider.AddCodes(spec);

    protected override void ParseDataInternal(JObject data, IGamePackage package)
    {
      this.BaseItem = Singleton<ItemDatabase>.Instance.FindProvidingItemForCode(data.GetValue<string>("base_item", (string) null));
      if (this.BaseItem != null)
        this.BaseItem.PropertyChanged += new PropertyChangedEventHandler(this.BaseItem_PropertyChanged);
      string defaultValue = data.GetValue<string>("disabled_img_spec", (string) null);
      string str = data.GetValue<string>("disabled_img_mods", defaultValue);
      this.mInactiveIcon = ImageReference.FromPackRelativePath(package, data.GetValue<string>("disabled_img", (string) null), str ?? this.DisabledImageFilterSpec);
      this.ActiveIcon = ImageReference.FromPackRelativePath(package, data.GetValue<string>("img", (string) null), data.GetValue<string>("img_mods", (string) null));
      this.Active = data.GetValue<bool>("initial_active_state", this.Active);
      this.AddProvidedCodes(data.GetValue<string>("codes", (string) null));
    }

    protected override bool Save(JObject data)
    {
      data["active"] = (JToken) this.Active;
      return true;
    }

    protected override bool Load(JObject data)
    {
      this.Active = data.GetValue<bool>("active", this.Active);
      return true;
    }

    private void BaseItem_PropertyChanged(object sender, PropertyChangedEventArgs e) => this.UpdateDisplayIcon();
  }
}
