﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Items.ToggleItem
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using EmoTracker.Data.Media;
using Newtonsoft.Json.Linq;
using System;

namespace EmoTracker.Data.Items
{
  [JsonTypeTags(new string[] {"toggle"})]
  public class ToggleItem : ItemBase, IConsumingItem
  {
    private ImageReference mInactiveIcon;
    private ImageReference mActiveIcon;
    private bool mbLoop;
    private string mConsumedCode;
    private CodeProvider mCodeProvider = new CodeProvider();

    public bool Loop
    {
      get => this.mbLoop;
      set => this.SetProperty<bool>(ref this.mbLoop, value, nameof (Loop));
    }

    public string ConsumedCode => this.mConsumedCode;

    public ImageReference ActiveIcon
    {
      get => this.mActiveIcon;
      set
      {
        this.mActiveIcon = value;
        this.UpdateBaseIcon();
      }
    }

    public bool Active
    {
      get => this.GetTransactableProperty<bool>(nameof (Active));
      set
      {
        bool flag = value;
        if (!string.IsNullOrWhiteSpace(this.mConsumedCode) && Singleton<ItemDatabase>.Instance.FindProvidingItemForCode(this.mConsumedCode) is ConsumableItem providingItemForCode)
        {
          if (!this.Active & value)
          {
            if (!providingItemForCode.Consume())
              flag = false;
          }
          else if (this.Active && !value && !providingItemForCode.Release())
            flag = true;
        }
        this.SetTransactableProperty<bool>(flag, (Action<bool>) (processedValue => this.UpdateBaseIcon()), nameof (Active));
      }
    }

    private void UpdateBaseIcon()
    {
      this.PotentialIcon = this.mActiveIcon;
      if (this.Active)
        this.Icon = this.mActiveIcon;
      else
        this.Icon = this.mInactiveIcon;
    }

    public override void OnLeftClick()
    {
      if (this.Loop)
        this.Active = !this.Active;
      else
        this.Active = true;
    }

    public override void OnRightClick()
    {
      if (this.Loop)
        this.Active = !this.Active;
      else
        this.Active = false;
    }

    public override uint ProvidesCode(string code) => this.Active && this.CanProvideCode(code) ? 1U : 0U;

    public override bool CanProvideCode(string code) => this.mCodeProvider.ProvidesCode(code);

    public override void AdvanceToCode(string code = null) => this.Active = true;

    public void AddProvidedCodes(string spec) => this.mCodeProvider.AddCodes(spec);

    protected override void ParseDataInternal(JObject data, IGamePackage package)
    {
      string path = data.GetValue<string>("img", (string) null);
      this.ActiveIcon = ImageReference.FromPackRelativePath(package, path, data.GetValue<string>("img_mods", (string) null));
      string defaultValue = data.GetValue<string>("disabled_img_spec", this.DisabledImageFilterSpec);
      string filter = data.GetValue<string>("disabled_img_mods", defaultValue);
      this.mInactiveIcon = ImageReference.FromPackRelativePath(package, data.GetValue<string>("disabled_img", (string) null), filter);
      if (this.mActiveIcon != null && this.mInactiveIcon == null)
        this.mInactiveIcon = ImageReference.FromImageReference(this.mActiveIcon, filter);
      this.Active = data.GetValue<bool>("initial_active_state", this.Active);
      this.UpdateBaseIcon();
      this.AddProvidedCodes(data.GetValue<string>("codes", (string) null));
      this.mConsumedCode = data.GetValue<string>("consume", (string) null);
      this.Loop = data.GetValue<bool>("loop");
    }

    protected override bool Save(JObject data)
    {
      data["active"] = (JToken) this.Active;
      return true;
    }

    protected override bool Load(JObject data)
    {
      this.Active = data.GetValue<bool>("active", this.Active);
      return true;
    }

    public bool GetPotentialConsumedItem(out string code, out uint count)
    {
      if (!this.Active && !string.IsNullOrWhiteSpace(this.ConsumedCode))
      {
        code = this.ConsumedCode;
        count = 1U;
        return true;
      }
      code = (string) null;
      count = 0U;
      return false;
    }
  }
}
