﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Layout.ArrayPanel
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace EmoTracker.Data.Layout
{
  [JsonTypeTags(new string[] {"array"})]
  public class ArrayPanel : LayoutItem
  {
    private ObservableCollection<LayoutItem> mChildren = new ObservableCollection<LayoutItem>();
    private Orientation mOrientation;
    private PanelStyle mStyle;

    public IEnumerable<LayoutItem> Children => (IEnumerable<LayoutItem>) this.mChildren;

    public override void Dispose()
    {
      this.DisposeCollection<LayoutItem>((IEnumerable<LayoutItem>) this.mChildren);
      this.mChildren.Clear();
      base.Dispose();
    }

    public Orientation Orientation
    {
      get => this.mOrientation;
      set => this.SetProperty<Orientation>(ref this.mOrientation, value, nameof (Orientation));
    }

    public PanelStyle Style
    {
      get => this.mStyle;
      set => this.SetProperty<PanelStyle>(ref this.mStyle, value, nameof (Style));
    }

    protected bool TryParsePanelConfiguration(JObject data, IGamePackage package)
    {
      string a1 = data.GetValue<string>("orientation", (string) null);
      this.Orientation = string.IsNullOrEmpty(a1) || !string.Equals(a1, "horizontal", StringComparison.OrdinalIgnoreCase) ? Orientation.Vertical : Orientation.Horizontal;
      string a2 = data.GetValue<string>("style", (string) null);
      this.Style = string.IsNullOrEmpty(a2) || !string.Equals(a2, "wrap", StringComparison.OrdinalIgnoreCase) ? PanelStyle.Stack : PanelStyle.Wrap;
      return true;
    }

    protected override bool TryParseInternal(JObject data, IGamePackage package)
    {
      this.TryParsePanelConfiguration(data, package);
      this.mChildren.Clear();
      this.ParseLayoutItemList(data.GetValue<JArray>("content"), (ICollection<LayoutItem>) this.mChildren, package);
      return true;
    }
  }
}
