﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Layout.LayoutItem
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;

namespace EmoTracker.Data.Layout
{
  public abstract class LayoutItem : ObservableObject
  {
    private string mBackground;
    private string mForeground;
    private string mMargin;
    private HorizontalAlignment mHorizontalAlignment = HorizontalAlignment.Stretch;
    private VerticalAlignment mVerticalAlignment = VerticalAlignment.Stretch;
    private double mScale = -1.0;
    private double mWidth = -1.0;
    private double mHeight = -1.0;
    private double mMinWidth = -1.0;
    private double mMinHeight = -1.0;
    private double mMaxWidth = -1.0;
    private double mMaxHeight = -1.0;
    private double mCanvasX = -1.0;
    private double mCanvasY = -1.0;
    private double mCanvasDepth = -1.0;
    private string mUniqueID;
    private string mDockLocation;
    private bool mbEnableDropShadow;
    private bool mbEnableBroadcastDropShadow;
    private bool mbHitTestVisible = true;

    public string UniqueID => this.mUniqueID;

    public bool DropShadow
    {
      get => this.mbEnableDropShadow;
      set => this.SetProperty<bool>(ref this.mbEnableDropShadow, value, nameof (DropShadow));
    }

    public bool BroadcastShadow
    {
      get => this.mbEnableBroadcastDropShadow;
      set => this.SetProperty<bool>(ref this.mbEnableBroadcastDropShadow, value, nameof (BroadcastShadow));
    }

    public bool HitTestVisible
    {
      get => this.mbHitTestVisible;
      set => this.SetProperty<bool>(ref this.mbHitTestVisible, value, nameof (HitTestVisible));
    }

    public bool OverrideBackground => !string.IsNullOrEmpty(this.mBackground);

    public bool OverrideForeground => !string.IsNullOrEmpty(this.mForeground);

    public bool OverrideDockLocation => !string.IsNullOrEmpty(this.mDockLocation);

    public bool OverrideWidth => this.mWidth >= 0.0;

    public bool OverrideHeight => this.mHeight >= 0.0;

    public bool OverrideMinWidth => this.mMinWidth >= 0.0;

    public bool OverrideMinHeight => this.mMinHeight >= 0.0;

    public bool OverrideMaxWidth => this.mMaxWidth >= 0.0;

    public bool OverrideMaxHeight => this.mMaxHeight >= 0.0;

    public bool OverrideScale => this.mScale > 0.0;

    public bool OverrideCanvasX => this.mCanvasX > 0.0;

    public bool OverrideCanvasY => this.mCanvasY > 0.0;

    public bool OverrideCanvasDepth => this.mCanvasDepth > 0.0;

    public string Background
    {
      get => this.mBackground;
      set => this.SetProperty<string>(ref this.mBackground, value, nameof (Background));
    }

    public string Foreground
    {
      get => this.mForeground;
      set => this.SetProperty<string>(ref this.mForeground, value, nameof (Foreground));
    }

    public string DockLocation
    {
      get => this.mDockLocation;
      set => this.SetProperty<string>(ref this.mDockLocation, value, nameof (DockLocation));
    }

    public double Scale
    {
      get => this.mScale;
      protected set
      {
        this.SetProperty<double>(ref this.mScale, value, nameof (Scale));
        this.NotifyPropertyChanged("OverrideScale");
      }
    }

    public double Width
    {
      get => this.mWidth;
      protected set
      {
        this.SetProperty<double>(ref this.mWidth, value, nameof (Width));
        this.NotifyPropertyChanged("OverrideWidth");
      }
    }

    public double Height
    {
      get => this.mHeight;
      protected set
      {
        this.SetProperty<double>(ref this.mHeight, value, nameof (Height));
        this.NotifyPropertyChanged("OverrideHeight");
      }
    }

    public double MinWidth
    {
      get => this.mMinWidth;
      protected set
      {
        this.SetProperty<double>(ref this.mMinWidth, value, nameof (MinWidth));
        this.NotifyPropertyChanged("OverrideMinWidth");
      }
    }

    public double MinHeight
    {
      get => this.mMinHeight;
      protected set
      {
        this.SetProperty<double>(ref this.mMinHeight, value, nameof (MinHeight));
        this.NotifyPropertyChanged("OverrideMinHeight");
      }
    }

    public double MaxWidth
    {
      get => this.mMaxWidth;
      protected set
      {
        this.SetProperty<double>(ref this.mMaxWidth, value, nameof (MaxWidth));
        this.NotifyPropertyChanged("OverrideMaxWidth");
      }
    }

    public double MaxHeight
    {
      get => this.mMaxHeight;
      protected set
      {
        this.SetProperty<double>(ref this.mMaxHeight, value, nameof (MaxHeight));
        this.NotifyPropertyChanged("OverrideMaxHeight");
      }
    }

    public double CanvasX
    {
      get => this.mCanvasX;
      protected set
      {
        this.SetProperty<double>(ref this.mCanvasX, value, nameof (CanvasX));
        this.NotifyPropertyChanged("OverrideCanvasX");
      }
    }

    public double CanvasY
    {
      get => this.mCanvasY;
      protected set
      {
        this.SetProperty<double>(ref this.mCanvasY, value, nameof (CanvasY));
        this.NotifyPropertyChanged("OverrideCanvasY");
      }
    }

    public double CanvasDepth
    {
      get => this.mCanvasDepth;
      protected set
      {
        this.SetProperty<double>(ref this.mCanvasDepth, value, nameof (CanvasDepth));
        this.NotifyPropertyChanged("OverrideCanvasDepth");
      }
    }

    public string Margin
    {
      get => this.mMargin;
      set => this.SetProperty<string>(ref this.mMargin, value, nameof (Margin));
    }

    public HorizontalAlignment HorizontalAlignment
    {
      get => this.mHorizontalAlignment;
      set => this.SetProperty<HorizontalAlignment>(ref this.mHorizontalAlignment, value, nameof (HorizontalAlignment));
    }

    public VerticalAlignment VerticalAlignment
    {
      get => this.mVerticalAlignment;
      set => this.SetProperty<VerticalAlignment>(ref this.mVerticalAlignment, value, nameof (VerticalAlignment));
    }

    protected bool TryParse(JObject data, IGamePackage package)
    {
      if (data == null)
        return false;
      this.mUniqueID = data.GetValue<string>("uid", (string) null);
      if (!string.IsNullOrWhiteSpace(this.mUniqueID))
        ObservableSingleton<LayoutManager>.Instance.RegisterLayoutItemForUID(this.mUniqueID, this);
      this.Background = data.GetValue<string>("background", (string) null);
      this.Foreground = data.GetValue<string>("foreground", (string) null);
      this.DockLocation = data.GetValue<string>("dock", (string) null);
      this.Margin = data.GetValue<string>("margin", "0");
      if (ObservableSingleton<Tracker>.Instance.SwapLeftRight)
      {
        bool flag = false;
        if (string.Equals(this.DockLocation, "left", StringComparison.OrdinalIgnoreCase))
        {
          this.DockLocation = "right";
          flag = true;
        }
        else if (string.Equals(this.DockLocation, "right", StringComparison.OrdinalIgnoreCase))
        {
          this.DockLocation = "left";
          flag = true;
        }
        if (flag && !string.IsNullOrWhiteSpace(this.Margin))
        {
          string[] strArray = this.Margin.Split(',');
          if (strArray.Length == 4)
            this.Margin = string.Format("{0},{1},{2},{3}", (object) strArray[2], (object) strArray[1], (object) strArray[0], (object) strArray[3]);
        }
      }
      this.HorizontalAlignment = data.GetEnumValue<HorizontalAlignment>("h_alignment", HorizontalAlignment.Stretch);
      this.VerticalAlignment = data.GetEnumValue<VerticalAlignment>("v_alignment", VerticalAlignment.Stretch);
      this.Scale = data.GetValue<double>("scale", -1.0);
      this.Width = data.GetValue<double>("width", -1.0);
      this.Height = data.GetValue<double>("height", -1.0);
      this.MinWidth = data.GetValue<double>("min_width", -1.0);
      this.MinHeight = data.GetValue<double>("min_height", -1.0);
      this.MaxWidth = data.GetValue<double>("max_width", -1.0);
      this.MaxHeight = data.GetValue<double>("max_height", -1.0);
      this.CanvasX = data.GetValue<double>("canvas_left", -1.0);
      this.CanvasY = data.GetValue<double>("canvas_top", -1.0);
      this.CanvasDepth = data.GetValue<double>("canvas_depth", -1.0);
      this.DropShadow = data.GetValue<bool>("dropshadow");
      this.BroadcastShadow = data.GetValue<bool>("broadcast_shadow");
      this.HitTestVisible = data.GetValue<bool>("hit_test_visible", true);
      return this.TryParseInternal(data, package);
    }

    protected void ParseLayoutItemList(
      JArray list,
      ICollection<LayoutItem> destination,
      IGamePackage package)
    {
      if (list == null)
        return;
      foreach (JObject data in list)
      {
        LayoutItem layoutItem = LayoutItem.CreateLayoutItem(data, package);
        if (layoutItem != null)
          destination.Add(layoutItem);
      }
    }

    protected abstract bool TryParseInternal(JObject data, IGamePackage package);

    public static LayoutItem CreateLayoutItem(JObject data, IGamePackage package)
    {
      if (data != null)
      {
        LayoutItem intanceForTypeTag = JsonTypeTagsAttribute.CreateIntanceForTypeTag<LayoutItem>(data.GetValue<string>("type", (string) null));
        if (intanceForTypeTag != null && intanceForTypeTag.TryParse(data, package))
          return intanceForTypeTag;
      }
      return (LayoutItem) null;
    }
  }
}
