﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Layout.LayoutManager
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.IO;

namespace EmoTracker.Data.Layout
{
  public class LayoutManager : ObservableSingleton<LayoutManager>
  {
    private Dictionary<string, LayoutItem> mUidToLayoutItem = new Dictionary<string, LayoutItem>();
    private Dictionary<string, EmoTracker.Data.Layout.Layout> mKeyToLayout = new Dictionary<string, EmoTracker.Data.Layout.Layout>();

    public EmoTracker.Data.Layout.Layout FindLayout(string key)
    {
      EmoTracker.Data.Layout.Layout layout = (EmoTracker.Data.Layout.Layout) null;
      return this.mKeyToLayout.TryGetValue(key, out layout) ? layout : (EmoTracker.Data.Layout.Layout) null;
    }

    public LayoutItem FindElement(string uid)
    {
      LayoutItem layoutItem = (LayoutItem) null;
      return this.mUidToLayoutItem.TryGetValue(uid, out layoutItem) ? layoutItem : (LayoutItem) null;
    }

    public void Clear()
    {
      this.mUidToLayoutItem.Clear();
      foreach (ObservableObject observableObject in this.mKeyToLayout.Values)
        observableObject.Dispose();
      this.mKeyToLayout.Clear();
    }

    public bool IncrementalLoad(string path, IGamePackage package)
    {
      ObservableSingleton<ScriptManager>.Instance.Output("Loading Layouts: {0}", (object) path);
      using (new LoggingBlock())
      {
        try
        {
          using (StreamReader reader = new StreamReader(package.Open(path)))
          {
            JObject token = (JObject) JToken.ReadFrom((JsonReader) new JsonTextReader((TextReader) reader));
            if (token != null)
            {
              foreach (JProperty property in token.Properties())
              {
                string name = property.Name;
                if (!this.mKeyToLayout.ContainsKey(name))
                {
                  JObject root = token.GetValue<JObject>(name);
                  if (root != null)
                  {
                    EmoTracker.Data.Layout.Layout layout = new EmoTracker.Data.Layout.Layout();
                    layout.Load(root, package);
                    if (layout.Root != null)
                      this.mKeyToLayout[name] = layout;
                  }
                }
              }
            }
          }
          return true;
        }
        catch (Exception ex)
        {
          ObservableSingleton<ScriptManager>.Instance.OutputException(ex);
          return false;
        }
      }
    }

    public bool LegacyLoad(IGamePackage package)
    {
      if (package == null)
        return false;
      ObservableSingleton<ScriptManager>.Instance.OutputWarning("Loading legacy layout data");
      using (new LoggingBlock())
      {
        try
        {
          using (StreamReader reader = new StreamReader(package.Open("tracker_layout.json")))
          {
            JObject token = ((JObject) JToken.ReadFrom((JsonReader) new JsonTextReader((TextReader) reader))).GetValue<JObject>("layouts");
            if (token != null)
            {
              foreach (JProperty property in token.Properties())
              {
                string name = property.Name;
                if (!this.mKeyToLayout.ContainsKey(name))
                {
                  JObject root = token.GetValue<JObject>(name);
                  if (root != null)
                  {
                    EmoTracker.Data.Layout.Layout layout = new EmoTracker.Data.Layout.Layout();
                    layout.Load(root, package);
                    if (layout.Root != null)
                      this.mKeyToLayout[name] = layout;
                  }
                }
              }
            }
          }
          return true;
        }
        catch (Exception ex)
        {
          ObservableSingleton<ScriptManager>.Instance.OutputException(ex);
          return false;
        }
      }
    }

    internal void RegisterLayoutItemForUID(string uid, LayoutItem layoutItem)
    {
      if (string.IsNullOrWhiteSpace(uid) || layoutItem == null)
        return;
      this.mUidToLayoutItem[uid] = layoutItem;
    }
  }
}
