﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Layout.MapPanel
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using EmoTracker.Data.Locations;
using Newtonsoft.Json.Linq;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace EmoTracker.Data.Layout
{
  [JsonTypeTags(new string[] {"map"})]
  public class MapPanel : LayoutItem
  {
    private MapPanel.MapOrientation mOrientation;
    private ObservableCollection<Map> mMaps;

    public MapPanel.MapOrientation Orientation
    {
      get => this.mOrientation;
      set => this.SetProperty<MapPanel.MapOrientation>(ref this.mOrientation, value, nameof (Orientation));
    }

    public IEnumerable<Map> Maps => this.mMaps != null ? (IEnumerable<Map>) this.mMaps : ObservableSingleton<MapDatabase>.Instance.Maps;

    protected override bool TryParseInternal(JObject data, IGamePackage package)
    {
      if (!ObservableSingleton<Tracker>.Instance.MapEnabled)
        return false;
      this.Orientation = data.GetEnumValue<MapPanel.MapOrientation>("orientation");
      JArray jarray = data.GetValue<JArray>("maps");
      if (jarray != null)
      {
        foreach (JToken name in jarray)
        {
          Map map = ObservableSingleton<MapDatabase>.Instance.FindMap((string) name);
          if (map != null)
          {
            if (this.mMaps == null)
              this.mMaps = new ObservableCollection<Map>();
            this.mMaps.Add(map);
          }
        }
      }
      return true;
    }

    public enum MapOrientation
    {
      Auto,
      Horizontal,
      Vertical,
    }
  }
}
