﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Layout.RecentPinnedLocations
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using EmoTracker.Data.Locations;
using Newtonsoft.Json.Linq;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;

namespace EmoTracker.Data.Layout
{
  [JsonTypeTags(new string[] {"recentpins", "recent_pins"})]
  public class RecentPinnedLocations : ArrayPanel
  {
    private ObservableCollection<Location> mDisplayLocations = new ObservableCollection<Location>();
    private int mNumItems;
    private bool mbDisplayCompact = true;

    public RecentPinnedLocations()
    {
      if (!(ObservableSingleton<LocationDatabase>.Instance.PinnedLocations is INotifyCollectionChanged pinnedLocations))
        return;
      pinnedLocations.CollectionChanged += new NotifyCollectionChangedEventHandler(this.Ncc_CollectionChanged);
    }

    public override void Dispose()
    {
      if (ObservableSingleton<LocationDatabase>.Instance.PinnedLocations is INotifyCollectionChanged pinnedLocations)
        pinnedLocations.CollectionChanged -= new NotifyCollectionChangedEventHandler(this.Ncc_CollectionChanged);
      base.Dispose();
    }

    private void Ncc_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e) => this.RefreshDisplayItems();

    public IEnumerable<Location> Locations => (IEnumerable<Location>) this.mDisplayLocations;

    public int NumItems
    {
      get => this.mNumItems;
      set
      {
        this.SetProperty<int>(ref this.mNumItems, value, nameof (NumItems));
        this.RefreshDisplayItems();
      }
    }

    public bool CompactDisplay
    {
      get => this.mbDisplayCompact;
      set => this.SetProperty<bool>(ref this.mbDisplayCompact, value, nameof (CompactDisplay));
    }

    private void RefreshDisplayItems()
    {
      this.mDisplayLocations.Clear();
      int num = 0;
      foreach (Location pinnedLocation in ObservableSingleton<LocationDatabase>.Instance.PinnedLocations)
      {
        this.mDisplayLocations.Add(pinnedLocation);
        if (++num >= this.NumItems && this.NumItems > 0)
          break;
      }
    }

    protected override bool TryParseInternal(JObject data, IGamePackage package)
    {
      this.TryParsePanelConfiguration(data, package);
      this.CompactDisplay = data.GetValue<bool>("compact", true);
      this.NumItems = data.GetValue<int>("num_items");
      return true;
    }
  }
}
