﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Layout.TabPanel
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using EmoTracker.Data.Media;
using Newtonsoft.Json.Linq;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;

namespace EmoTracker.Data.Layout
{
  [JsonTypeTags(new string[] {"tabbed"})]
  public class TabPanel : LayoutItem
  {
    private ObservableCollection<TabPanel.Tab> mTabs = new ObservableCollection<TabPanel.Tab>();
    private TabPanel.Tab mCurrentTab;

    public override void Dispose()
    {
      this.DisposeCollection<TabPanel.Tab>((IEnumerable<TabPanel.Tab>) this.mTabs);
      this.mTabs.Clear();
      base.Dispose();
    }

    public IEnumerable<TabPanel.Tab> Tabs => (IEnumerable<TabPanel.Tab>) this.mTabs;

    public TabPanel.Tab CurrentTab
    {
      get => this.mCurrentTab;
      set => this.SetProperty<TabPanel.Tab>(ref this.mCurrentTab, value, nameof (CurrentTab));
    }

    protected override bool TryParseInternal(JObject data, IGamePackage package)
    {
      this.mTabs.Clear();
      JArray jarray = data.GetValue<JArray>("tabs");
      if (jarray != null)
      {
        foreach (JObject token in jarray)
        {
          LayoutItem layoutItem = LayoutItem.CreateLayoutItem(token.GetValue<JObject>("content"), package);
          if (layoutItem != null)
            this.mTabs.Add(new TabPanel.Tab()
            {
              Content = layoutItem,
              Title = token.GetValue<string>("title", (string) null),
              Icon = ImageReference.FromPackRelativePath(package, token.GetValue<string>("icon", (string) null), token.GetValue<string>("icon_image_spec", (string) null))
            });
        }
        this.CurrentTab = this.mTabs.FirstOrDefault<TabPanel.Tab>();
      }
      return true;
    }

    public class Tab : ObservableObject
    {
      private LayoutItem mContent;
      private string mTitle;
      private ImageReference mIcon;

      public LayoutItem Content
      {
        get => this.mContent;
        set => this.SetProperty<LayoutItem>(ref this.mContent, value, nameof (Content));
      }

      public string Title
      {
        get => this.mTitle;
        set => this.SetProperty<string>(ref this.mTitle, value, nameof (Title));
      }

      public ImageReference Icon
      {
        get => this.mIcon;
        set => this.SetProperty<ImageReference>(ref this.mIcon, value, nameof (Icon));
      }

      public override void Dispose()
      {
        this.DisposeObjectAndDefault<LayoutItem>(ref this.mContent);
        this.DisposeObjectAndDefault<ImageReference>(ref this.mIcon);
        base.Dispose();
      }
    }
  }
}
