﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Locations.AccessibilityRule
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using System;
using System.Collections.Generic;

namespace EmoTracker.Data.Locations
{
  public class AccessibilityRule
  {
    private static bool sbEnableCache = true;
    private static Dictionary<string, AccessibilityRule.AccessibilityResult> mAccessiblityCache = new Dictionary<string, AccessibilityRule.AccessibilityResult>();
    private HashSet<AccessibilityRule.CodeRule> mCodes = new HashSet<AccessibilityRule.CodeRule>();
    private bool mbIsInspectable;

    public static bool EnableCache
    {
      get => AccessibilityRule.sbEnableCache;
      set
      {
        AccessibilityRule.sbEnableCache = value;
        AccessibilityRule.ClearCaches();
      }
    }

    public static void ClearCaches() => AccessibilityRule.mAccessiblityCache.Clear();

    private static uint GetProviderCountForCode(
      string code,
      out AccessibilityLevel maxAccessibility)
    {
      AccessibilityRule.AccessibilityResult accessibilityResult;
      if (AccessibilityRule.sbEnableCache && AccessibilityRule.mAccessiblityCache.TryGetValue(code, out accessibilityResult))
      {
        maxAccessibility = accessibilityResult.Level;
        return accessibilityResult.ProvidedCount;
      }
      AccessibilityLevel maxAccessibility1;
      uint providerCountForCode = ObservableSingleton<Tracker>.Instance.ProviderCountForCode(code, out maxAccessibility1);
      if (AccessibilityRule.sbEnableCache)
        AccessibilityRule.mAccessiblityCache[code] = new AccessibilityRule.AccessibilityResult()
        {
          Level = maxAccessibility1,
          ProvidedCount = providerCountForCode
        };
      maxAccessibility = maxAccessibility1;
      return providerCountForCode;
    }

    private static AccessibilityLevel Min(
      AccessibilityLevel a,
      AccessibilityLevel b)
    {
      return a >= b ? b : a;
    }

    private static AccessibilityLevel Max(
      AccessibilityLevel a,
      AccessibilityLevel b)
    {
      return a <= b ? b : a;
    }

    public IEnumerable<AccessibilityRule.CodeRule> Codes => (IEnumerable<AccessibilityRule.CodeRule>) this.mCodes;

    public AccessibilityRule(string rule)
    {
      if (string.IsNullOrWhiteSpace(rule))
        return;
      if (rule.StartsWith("{") && rule.EndsWith("}"))
      {
        this.mbIsInspectable = true;
        rule = rule.Substring(1, rule.Length - 2);
      }
      string str1 = rule;
      char[] separator = new char[1]{ ',' };
      foreach (string str2 in str1.Split(separator, StringSplitOptions.RemoveEmptyEntries))
      {
        AccessibilityRule.CodeRule codeRule = new AccessibilityRule.CodeRule();
        char[] chArray = new char[3]{ ' ', '\t', '\n' };
        string str3 = str2.Trim(chArray);
        if (str3.StartsWith("[") && str3.EndsWith("]"))
        {
          codeRule.mbIsSequenceBreakable = true;
          str3 = str3.Substring(1, str3.Length - 2);
          if (str3.StartsWith("[") && str3.EndsWith("]"))
          {
            codeRule.mbIsGlitch = true;
            str3 = str3.Substring(1, str3.Length - 2);
          }
        }
        string[] strArray = str3.Split(':');
        codeRule.mCode = strArray[0].Trim();
        if (strArray.Length > 1)
        {
          uint result = 1;
          if (uint.TryParse(strArray[1], out result))
            codeRule.mRequiredCount = result;
        }
        this.mCodes.Add(codeRule);
      }
    }

    public AccessibilityLevel AccessibilityLevel
    {
      get
      {
        AccessibilityLevel b = AccessibilityLevel.Normal;
        foreach (AccessibilityRule.CodeRule mCode in this.mCodes)
        {
          AccessibilityLevel maxAccessibility;
          uint providerCountForCode = AccessibilityRule.GetProviderCountForCode(mCode.mCode, out maxAccessibility);
          if (!mCode.mbIsSequenceBreakable && providerCountForCode < mCode.mRequiredCount)
          {
            b = AccessibilityLevel.None;
            break;
          }
          b = !mCode.mbIsSequenceBreakable || providerCountForCode >= mCode.mRequiredCount ? AccessibilityRule.Min(maxAccessibility, b) : AccessibilityLevel.SequenceBreak;
        }
        if (this.mbIsInspectable && b >= AccessibilityLevel.Glitch)
          b = AccessibilityLevel.Inspect;
        return b;
      }
    }

    private struct AccessibilityResult
    {
      public AccessibilityLevel Level;
      public uint ProvidedCount;
    }

    public class CodeRule
    {
      public string mCode;
      public bool mbIsSequenceBreakable;
      public bool mbIsGlitch;
      public uint mRequiredCount = 1;
    }
  }
}
