﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Locations.AccessibilityRuleSet
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using System.Collections.Generic;

namespace EmoTracker.Data.Locations
{
  public class AccessibilityRuleSet
  {
    private List<AccessibilityRule> mRules = new List<AccessibilityRule>();

    public bool Empty => this.mRules.Count == 0;

    public IEnumerable<AccessibilityRule> Rules => (IEnumerable<AccessibilityRule>) this.mRules;

    public void AddRule(string spec) => this.mRules.Add(new AccessibilityRule(spec));

    public AccessibilityLevel Accessibility
    {
      get
      {
        if (ObservableSingleton<ApplicationSettings>.Instance.IgnoreAllLogic || this.mRules.Count == 0)
          return AccessibilityLevel.Normal;
        AccessibilityLevel accessibility = AccessibilityLevel.None;
        foreach (AccessibilityRule mRule in this.mRules)
        {
          if (mRule.AccessibilityLevel > accessibility)
            accessibility = mRule.AccessibilityLevel;
        }
        return accessibility;
      }
    }

    public AccessibilityLevel AccessibilityWithoutModifiers
    {
      get
      {
        if (ObservableSingleton<ApplicationSettings>.Instance.IgnoreAllLogic || this.mRules.Count == 0)
          return AccessibilityLevel.Normal;
        AccessibilityLevel withoutModifiers = AccessibilityLevel.None;
        foreach (AccessibilityRule mRule in this.mRules)
        {
          AccessibilityLevel accessibilityLevel = mRule.AccessibilityLevel;
          if (accessibilityLevel != AccessibilityLevel.Inspect && accessibilityLevel > withoutModifiers)
            withoutModifiers = accessibilityLevel;
        }
        return withoutModifiers;
      }
    }

    public AccessibilityLevel AccessibilityForVisibility
    {
      get
      {
        if (this.mRules.Count == 0)
          return AccessibilityLevel.Normal;
        AccessibilityLevel accessibilityForVisibility = AccessibilityLevel.None;
        foreach (AccessibilityRule mRule in this.mRules)
        {
          AccessibilityLevel accessibilityLevel = mRule.AccessibilityLevel;
          if (accessibilityLevel != AccessibilityLevel.Inspect && accessibilityLevel > accessibilityForVisibility)
            accessibilityForVisibility = accessibilityLevel;
        }
        return accessibilityForVisibility;
      }
    }
  }
}
