﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Locations.LocationVisualProperties
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.Core.Transactions;
using EmoTracker.Data.Media;

namespace EmoTracker.Data.Locations
{
  public class LocationVisualProperties : TransactableObject
  {
    private LocationVisualProperties mVisualParent;
    private ImageReference mOpenChestImage;
    private ImageReference mClosedChestImage;
    private ImageReference mUnavailableOpenChestImage;
    private ImageReference mUnavailableClosedChestImage;
    private bool mbAlwaysAllowChestManipulation;
    private bool mbOverrideAlwaysAllowChestManipulation;
    private bool mbOverrideAutoUnpinOnClear;
    private bool mbAutoUnpinOnClear;

    public LocationVisualProperties VisualParent
    {
      get => this.mVisualParent;
      protected set => this.SetProperty<LocationVisualProperties>(ref this.mVisualParent, value, nameof (VisualParent));
    }

    public bool AlwaysAllowChestManipulation
    {
      get
      {
        if (this.mbOverrideAlwaysAllowChestManipulation)
          return this.mbAlwaysAllowChestManipulation;
        return this.mVisualParent != null && this.mVisualParent.AlwaysAllowChestManipulation;
      }
      set
      {
        this.mbOverrideAlwaysAllowChestManipulation = true;
        this.SetProperty<bool>(ref this.mbAlwaysAllowChestManipulation, value, nameof (AlwaysAllowChestManipulation));
      }
    }

    public bool AutoUnpinOnClear
    {
      get
      {
        if (this.mbOverrideAutoUnpinOnClear)
          return this.mbAutoUnpinOnClear;
        return this.mVisualParent != null ? this.mVisualParent.AutoUnpinOnClear : ObservableSingleton<ApplicationSettings>.Instance.AutoUnpinLocationsOnClear;
      }
      set
      {
        this.mbOverrideAutoUnpinOnClear = true;
        this.SetProperty<bool>(ref this.mbAutoUnpinOnClear, value, nameof (AutoUnpinOnClear));
      }
    }

    public ImageReference OpenChestImage
    {
      get
      {
        if (this.mOpenChestImage != null)
          return this.mOpenChestImage;
        return this.mVisualParent != null ? this.mVisualParent.OpenChestImage : (ImageReference) null;
      }
      set
      {
        if (!this.SetProperty<ImageReference>(ref this.mOpenChestImage, value, nameof (OpenChestImage)))
          return;
        if (this.mOpenChestImage != null)
          this.UnavailableOpenChestImage = ImageReference.FromImageReference(this.mOpenChestImage, "grayscale,dim");
        else
          this.UnavailableOpenChestImage = (ImageReference) null;
      }
    }

    public ImageReference ClosedChestImage
    {
      get
      {
        if (this.mClosedChestImage != null)
          return this.mClosedChestImage;
        return this.mVisualParent != null ? this.mVisualParent.ClosedChestImage : (ImageReference) null;
      }
      set
      {
        if (!this.SetProperty<ImageReference>(ref this.mClosedChestImage, value, nameof (ClosedChestImage)))
          return;
        if (this.mClosedChestImage != null)
          this.UnavailableClosedChestImage = ImageReference.FromImageReference(this.mClosedChestImage, "grayscale,dim");
        else
          this.UnavailableClosedChestImage = (ImageReference) null;
      }
    }

    public ImageReference UnavailableOpenChestImage
    {
      get
      {
        if (this.mUnavailableOpenChestImage != null)
          return this.mUnavailableOpenChestImage;
        return this.mVisualParent != null ? this.mVisualParent.UnavailableOpenChestImage : (ImageReference) null;
      }
      private set => this.SetProperty<ImageReference>(ref this.mUnavailableOpenChestImage, value, nameof (UnavailableOpenChestImage));
    }

    public ImageReference UnavailableClosedChestImage
    {
      get
      {
        if (this.mUnavailableClosedChestImage != null)
          return this.mUnavailableClosedChestImage;
        return this.mVisualParent != null ? this.mVisualParent.UnavailableClosedChestImage : (ImageReference) null;
      }
      private set => this.SetProperty<ImageReference>(ref this.mUnavailableClosedChestImage, value, nameof (UnavailableClosedChestImage));
    }
  }
}
