﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Media.ImageReference
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using System;

namespace EmoTracker.Data.Media
{
  public abstract class ImageReference : ObservableObject
  {
    public static ImageReference FromPackRelativePath(string path, string filter = null) => ImageReference.FromPackRelativePath(ObservableSingleton<Tracker>.Instance.ActiveGamePackage, path, filter);

    public static ImageReference FromPackRelativePath(
      IGamePackage package,
      string path,
      string filter = null)
    {
      if (string.IsNullOrWhiteSpace(path))
        return (ImageReference) null;
      path = path.Trim();
      path = path.TrimStart(',', '/', '\\');
      if (package == null || !package.Exists(path))
        return (ImageReference) null;
      if (!path.StartsWith("gamepackage://"))
        path = "gamepackage://" + path;
      return (ImageReference) new ConcreteImageReference()
      {
        URI = new Uri(path),
        Filter = filter
      };
    }

    public static ImageReference FromImageReference(
      ImageReference existingReference,
      string filter = null)
    {
      if (existingReference == null)
        return (ImageReference) null;
      if (string.IsNullOrWhiteSpace(filter))
        return existingReference;
      return (ImageReference) new FilterImageReference()
      {
        Reference = existingReference,
        Filter = filter
      };
    }

    public static ImageReference FromExternalURI(Uri uri, string filter = null) => (ImageReference) new ConcreteImageReference()
    {
      URI = uri,
      Filter = filter
    };

    public static ImageReference FromLayeredImageReferences(
      params ImageReference[] layers)
    {
      LayeredImageReference layeredImageReference = new LayeredImageReference();
      foreach (ImageReference layer in layers)
      {
        if (layer != null)
          layeredImageReference.Layers.Add(layer);
      }
      return layeredImageReference.Layers.Count > 0 ? (ImageReference) layeredImageReference : (ImageReference) null;
    }
  }
}
