﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Notes.NoteTakingSite
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using Newtonsoft.Json.Linq;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;

namespace EmoTracker.Data.Notes
{
  public class NoteTakingSite : ObservableObject, INoteTaking
  {
    private ObservableCollection<Note> mNotes = new ObservableCollection<Note>();

    public IEnumerable<Note> Notes => (IEnumerable<Note>) this.mNotes;

    public bool Any => this.mNotes.Count > 0;

    public bool Empty => this.mNotes.Count == 0;

    public bool AddNote(Note note)
    {
      if (this.mNotes.Contains(note))
        return false;
      note.PropertyChanged += new PropertyChangedEventHandler(this.Note_PropertyChanged);
      this.mNotes.Add(note);
      return true;
    }

    public bool RemoveNote(Note note)
    {
      if (!this.mNotes.Contains(note))
        return false;
      note.PropertyChanged -= new PropertyChangedEventHandler(this.Note_PropertyChanged);
      this.mNotes.Remove(note);
      return true;
    }

    public void Clear() => this.mNotes.Clear();

    public JArray AsJsonArray()
    {
      try
      {
        JArray jarray1 = new JArray();
        foreach (Note note in this.Notes)
        {
          if (note is MarkdownTextWithItemsNote textWithItemsNote)
          {
            JObject jobject = new JObject();
            if (!string.IsNullOrWhiteSpace(textWithItemsNote.MarkdownSource))
              jobject["markdown_source"] = (JToken) textWithItemsNote.MarkdownSource;
            JArray jarray2 = new JArray();
            foreach (ITrackableItem trackableItem in textWithItemsNote.Items)
            {
              try
              {
                string persistableItemReference = Singleton<ItemDatabase>.Instance.GetPersistableItemReference(trackableItem);
                if (!string.IsNullOrWhiteSpace(persistableItemReference))
                  jarray2.Add(JToken.FromObject((object) persistableItemReference));
              }
              catch
              {
              }
            }
            if (jarray2.Count > 0)
              jobject["items"] = (JToken) jarray2;
            jarray1.Add((JToken) jobject);
          }
        }
        if (jarray1.Count > 0)
          return jarray1;
      }
      catch
      {
      }
      return (JArray) null;
    }

    public bool PopulateWithJsonArray(JArray array)
    {
      try
      {
        this.Clear();
        if (array != null && array.Count > 0)
        {
          foreach (JObject token in array)
          {
            MarkdownTextWithItemsNote textWithItemsNote = new MarkdownTextWithItemsNote();
            textWithItemsNote.MarkdownSource = token.GetValue<string>("markdown_source", (string) null);
            JArray jarray = token.GetValue<JArray>("items");
            if (jarray != null)
            {
              foreach (JToken reference in jarray)
              {
                ITrackableItem trackableItem = Singleton<ItemDatabase>.Instance.ResolvePersistableItemReference((string) reference);
                if (trackableItem != null)
                  textWithItemsNote.AddItem(trackableItem);
              }
            }
            this.AddNote((Note) textWithItemsNote);
          }
        }
        return true;
      }
      catch
      {
      }
      return false;
    }

    public NoteTakingSite() => this.mNotes.CollectionChanged += new NotifyCollectionChangedEventHandler(this.Notes_CollectionChanged);

    private void Notes_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
    {
      this.NotifyPropertyChanged("Any");
      this.NotifyPropertyChanged("Empty");
    }

    private void Note_PropertyChanged(object sender, PropertyChangedEventArgs e)
    {
    }

    public override void Dispose() => this.DisposeCollection<Note>((IEnumerable<Note>) this.mNotes);
  }
}
