﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Packages.DirectoryPackageSource
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using System.Collections.Generic;
using System.IO;

namespace EmoTracker.Data.Packages
{
  public class DirectoryPackageSource : IGamePackageSource
  {
    private string mPath;

    public DirectoryPackageSource(string path) => this.mPath = path;

    public string PackPath => this.mPath;

    public Stream Open(string path)
    {
      if (string.IsNullOrWhiteSpace(path))
        return (Stream) null;
      string path1 = Path.Combine(this.mPath, path);
      return !File.Exists(path1) ? (Stream) null : (Stream) File.OpenRead(path1);
    }

    public void AcquireStorage()
    {
    }

    public void ReleaseStorage()
    {
    }

    private string NormalizePath(string path)
    {
      if (string.IsNullOrWhiteSpace(path))
        return (string) null;
      while (path.StartsWith("/"))
        path = path.Substring(1);
      return path;
    }

    private void BuildFileList(string root, List<string> files, string prefix = null)
    {
      if (prefix == null)
        prefix = root;
      try
      {
        foreach (string enumerateDirectory in Directory.EnumerateDirectories(root))
          this.BuildFileList(enumerateDirectory, files, prefix);
        foreach (string enumerateFile in Directory.EnumerateFiles(root))
          files.Add(this.NormalizePath(enumerateFile.Replace(prefix, "").Replace(Path.DirectorySeparatorChar, '/')));
      }
      catch
      {
      }
    }

    public IEnumerable<string> Files
    {
      get
      {
        List<string> files = new List<string>();
        this.BuildFileList(this.mPath, files);
        return (IEnumerable<string>) files;
      }
    }
  }
}
