﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Packages.ZipPackageSource
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using System;
using System.Collections.Generic;
using System.IO;
using System.IO.Compression;

namespace EmoTracker.Data.Packages
{
  public class ZipPackageSource : IGamePackageSource
  {
    private ZipArchive mArchive;
    private string mPath;

    public string ArchivePath => this.mPath;

    public IEnumerable<string> Files
    {
      get
      {
        List<string> files = new List<string>();
        if (this.mArchive != null)
        {
          foreach (ZipArchiveEntry entry in this.mArchive.Entries)
          {
            if (!string.IsNullOrWhiteSpace(entry.FullName) && !entry.FullName.EndsWith("/"))
              files.Add(entry.FullName);
          }
          files.Sort(new Comparison<string>(this.FileListSort));
        }
        return (IEnumerable<string>) files;
      }
    }

    public string PackPath => this.mPath;

    private int FileListSort(string x, string y)
    {
      if (Path.GetDirectoryName(x) == null && Path.GetDirectoryName(y) != null)
        return 1;
      return Path.GetDirectoryName(x) != null && Path.GetDirectoryName(y) == null ? -1 : x.CompareTo(y);
    }

    public ZipPackageSource(string path)
    {
      this.mPath = path;
      this.AcquireStorage();
    }

    public Stream Open(string path)
    {
      if (this.mArchive != null && !string.IsNullOrWhiteSpace(path))
      {
        ZipArchiveEntry entry = this.mArchive.GetEntry(path);
        if (entry != null)
        {
          using (Stream stream = entry.Open())
          {
            MemoryStream destination = new MemoryStream();
            stream.CopyTo((Stream) destination);
            destination.Seek(0L, SeekOrigin.Begin);
            return (Stream) destination;
          }
        }
      }
      return (Stream) null;
    }

    public void AcquireStorage()
    {
      this.ReleaseStorage();
      try
      {
        using (Stream stream = (Stream) File.OpenRead(this.mPath))
        {
          MemoryStream destination = new MemoryStream();
          stream.CopyTo((Stream) destination);
          destination.Seek(0L, SeekOrigin.Begin);
          this.mArchive = new ZipArchive((Stream) destination, ZipArchiveMode.Read, false);
          stream.Close();
        }
      }
      catch
      {
      }
    }

    public void ReleaseStorage()
    {
      if (this.mArchive == null)
        return;
      this.mArchive.Dispose();
      this.mArchive = (ZipArchive) null;
    }
  }
}
