﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Scripting.LuaItem
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.Items;
using Newtonsoft.Json.Linq;
using NLua;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace EmoTracker.Data.Scripting
{
  [JsonTypeTags(new string[] {"lua"})]
  [DisallowCreationFromTag]
  public class LuaItem : ItemBase
  {
    private LuaTable mItemState;
    private LuaFunction mOnLeftClick;
    private LuaFunction mOnRightClick;
    private LuaFunction mProvidesCode;
    private LuaFunction mCanProvideCode;
    private LuaFunction mAdvanceToCode;
    private LuaFunction mSave;
    private LuaFunction mLoad;
    private LuaFunction mPropertyChanged;

    public LuaTable ItemState
    {
      get => this.mItemState;
      set
      {
        LuaTable mItemState = this.mItemState;
        if (!this.SetProperty<LuaTable>(ref this.mItemState, value, nameof (ItemState)))
          return;
        this.DisposeObject((object) mItemState);
      }
    }

    public LuaFunction OnLeftClickFunc
    {
      get => this.mOnLeftClick;
      set
      {
        LuaFunction mOnLeftClick = this.mOnLeftClick;
        if (!this.SetProperty<LuaFunction>(ref this.mOnLeftClick, value, nameof (OnLeftClickFunc)))
          return;
        this.DisposeObject((object) mOnLeftClick);
      }
    }

    public LuaFunction OnRightClickFunc
    {
      get => this.mOnRightClick;
      set
      {
        LuaFunction mOnRightClick = this.mOnRightClick;
        if (!this.SetProperty<LuaFunction>(ref this.mOnRightClick, value, nameof (OnRightClickFunc)))
          return;
        this.DisposeObject((object) mOnRightClick);
      }
    }

    public LuaFunction ProvidesCodeFunc
    {
      get => this.mProvidesCode;
      set
      {
        LuaFunction mProvidesCode = this.mProvidesCode;
        if (!this.SetProperty<LuaFunction>(ref this.mProvidesCode, value, nameof (ProvidesCodeFunc)))
          return;
        this.DisposeObject((object) mProvidesCode);
      }
    }

    public LuaFunction CanProvideCodeFunc
    {
      get => this.mCanProvideCode;
      set
      {
        LuaFunction mCanProvideCode = this.mCanProvideCode;
        if (!this.SetProperty<LuaFunction>(ref this.mCanProvideCode, value, nameof (CanProvideCodeFunc)))
          return;
        this.DisposeObject((object) mCanProvideCode);
      }
    }

    public LuaFunction AdvanceToCodeFunc
    {
      get => this.mAdvanceToCode;
      set
      {
        LuaFunction mAdvanceToCode = this.mAdvanceToCode;
        if (!this.SetProperty<LuaFunction>(ref this.mAdvanceToCode, value, nameof (AdvanceToCodeFunc)))
          return;
        this.DisposeObject((object) mAdvanceToCode);
      }
    }

    public LuaFunction SaveFunc
    {
      get => this.mSave;
      set
      {
        LuaFunction mSave = this.mSave;
        if (!this.SetProperty<LuaFunction>(ref this.mSave, value, nameof (SaveFunc)))
          return;
        this.DisposeObject((object) mSave);
      }
    }

    public LuaFunction LoadFunc
    {
      get => this.mLoad;
      set
      {
        LuaFunction mLoad = this.mLoad;
        if (!this.SetProperty<LuaFunction>(ref this.mLoad, value, nameof (LoadFunc)))
          return;
        this.DisposeObject((object) mLoad);
      }
    }

    public LuaFunction PropertyChangedFunc
    {
      get => this.mPropertyChanged;
      set
      {
        LuaFunction mPropertyChanged = this.mPropertyChanged;
        if (!this.SetProperty<LuaFunction>(ref this.mPropertyChanged, value, nameof (PropertyChangedFunc)))
          return;
        this.DisposeObject((object) mPropertyChanged);
      }
    }

    public override void Dispose()
    {
      this.DisposeObjectAndDefault<LuaTable>(ref this.mItemState);
      this.DisposeObjectAndDefault<LuaFunction>(ref this.mOnLeftClick);
      this.DisposeObjectAndDefault<LuaFunction>(ref this.mOnRightClick);
      this.DisposeObjectAndDefault<LuaFunction>(ref this.mProvidesCode);
      this.DisposeObjectAndDefault<LuaFunction>(ref this.mCanProvideCode);
      this.DisposeObjectAndDefault<LuaFunction>(ref this.mAdvanceToCode);
      this.DisposeObjectAndDefault<LuaFunction>(ref this.mSave);
      this.DisposeObjectAndDefault<LuaFunction>(ref this.mLoad);
      this.DisposeObjectAndDefault<LuaFunction>(ref this.mPropertyChanged);
      base.Dispose();
    }

    public override void AdvanceToCode(string code = null)
    {
      try
      {
        if (this.AdvanceToCodeFunc == null)
          return;
        this.AdvanceToCodeFunc.Call((object) this, (object) code);
      }
      catch (Exception ex)
      {
        ObservableSingleton<ScriptManager>.Instance.OutputException(ex);
      }
    }

    public override bool CanProvideCode(string code)
    {
      try
      {
        if (this.CanProvideCodeFunc != null)
        {
          object[] source = this.CanProvideCodeFunc.Call((object) this, (object) code);
          if (source != null)
          {
            if (source.Length != 0)
              return Convert.ToBoolean(((IEnumerable<object>) source).First<object>());
          }
        }
      }
      catch (Exception ex)
      {
        ObservableSingleton<ScriptManager>.Instance.OutputException(ex);
      }
      return false;
    }

    public override void OnLeftClick()
    {
      try
      {
        if (this.OnLeftClickFunc == null)
          return;
        this.OnLeftClickFunc.Call((object) this);
      }
      catch (Exception ex)
      {
        ObservableSingleton<ScriptManager>.Instance.OutputException(ex);
      }
    }

    public override void OnRightClick()
    {
      try
      {
        if (this.OnRightClickFunc == null)
          return;
        this.OnRightClickFunc.Call((object) this);
      }
      catch (Exception ex)
      {
        ObservableSingleton<ScriptManager>.Instance.OutputException(ex);
      }
    }

    public override uint ProvidesCode(string code)
    {
      try
      {
        if (this.ProvidesCodeFunc != null)
        {
          object[] source = this.ProvidesCodeFunc.Call((object) this, (object) code);
          if (source != null)
          {
            if (source.Length != 0)
              return Convert.ToUInt32(((IEnumerable<object>) source).First<object>());
          }
        }
      }
      catch (Exception ex)
      {
        ObservableSingleton<ScriptManager>.Instance.OutputException(ex);
      }
      return 0;
    }

    protected override void ParseDataInternal(JObject data, IGamePackage package)
    {
    }

    protected override bool Save(JObject data)
    {
      try
      {
        if (this.SaveFunc == null)
          return true;
        object[] source = this.SaveFunc.Call((object) this);
        if (source != null)
        {
          if (source.Length != 0)
          {
            if (((IEnumerable<object>) source).First<object>() is LuaTable luaTable)
            {
              IDictionaryEnumerator enumerator = luaTable.GetEnumerator();
              if (enumerator != null)
              {
                while (enumerator.MoveNext())
                {
                  if (enumerator.Key != null)
                  {
                    string propertyName = enumerator.Key.ToString();
                    if (enumerator.Value != null)
                      data[propertyName] = JToken.FromObject(enumerator.Value);
                  }
                }
              }
              luaTable.Dispose();
              return true;
            }
          }
        }
      }
      catch (Exception ex)
      {
        ObservableSingleton<ScriptManager>.Instance.OutputException(ex);
      }
      return false;
    }

    protected override bool Load(JObject data)
    {
      try
      {
        if (this.LoadFunc != null)
        {
          Dictionary<string, object> dictionary = new Dictionary<string, object>();
          foreach (KeyValuePair<string, JToken> keyValuePair in data)
          {
            try
            {
              dictionary[keyValuePair.Key] = keyValuePair.Value.ToObject<object>();
            }
            catch (Exception ex)
            {
              ObservableSingleton<ScriptManager>.Instance.OutputException(ex);
            }
          }
          object[] source = this.LoadFunc.Call((object) this, (object) dictionary);
          return source == null || source.Length == 0 || Convert.ToBoolean(((IEnumerable<object>) source).First<object>());
        }
      }
      catch (Exception ex)
      {
        ObservableSingleton<ScriptManager>.Instance.OutputException(ex);
      }
      return false;
    }

    public bool Set(string key, object value) => this.SetTransactableProperty<object>(value, (Action<object>) (v =>
    {
      try
      {
        if (this.PropertyChangedFunc == null)
          return;
        this.PropertyChangedFunc.Call((object) this, (object) key, v);
      }
      catch (Exception ex)
      {
        ObservableSingleton<ScriptManager>.Instance.OutputException(ex);
      }
    }), key);

    public object Get(string key, bool forceReadFromOpenTransaction = false) => this.GetTransactableProperty<object>(key, forceReadFromOpenTransaction);
  }
}
