﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Data.Settings.ApplicationColors
// Assembly: EmoTracker.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D41289DD-41C0-4478-8624-1DDBDED644F2
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.Data.dll

using EmoTracker.Core;
using EmoTracker.Data.JSON;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System.IO;

namespace EmoTracker.Data.Settings
{
  public class ApplicationColors : ObservableSingleton<ApplicationColors>
  {
    private string mAccessibilityColor_None = "#ff3030";
    private string mAccessibilityColor_Partial = "DarkOrange";
    private string mAccessibilityColor_Unlockable = "MediumPurple";
    private string mAccessibilityColor_Inspect = "CornflowerBlue";
    private string mAccessibilityColor_Glitch = "#b399c1";
    private string mAccessibilityColor_SequenceBreak = "Yellow";
    private string mAccessibilityColor_Normal = "#00ff00";
    private string mAccessibilityColor_Cleared = "#333333";
    private string mStatus_Generic_Success = "#00ff00";
    private string mStatus_Generic_Error = "#ff0000";
    private string mStatus_Generic_Warning = "#ffff00";
    private string mStatus_Generic_Active = "#35e0b5";
    private string mMap_LocationNoteBadgeBackground = "#35e0b5";

    public string AccessibilityColor_None
    {
      get => this.mAccessibilityColor_None;
      set => this.SetProperty<string>(ref this.mAccessibilityColor_None, value, nameof (AccessibilityColor_None));
    }

    public string AccessibilityColor_Partial
    {
      get => this.mAccessibilityColor_Partial;
      set => this.SetProperty<string>(ref this.mAccessibilityColor_Partial, value, nameof (AccessibilityColor_Partial));
    }

    public string AccessibilityColor_Unlockable
    {
      get => this.mAccessibilityColor_Unlockable;
      set => this.SetProperty<string>(ref this.mAccessibilityColor_Unlockable, value, nameof (AccessibilityColor_Unlockable));
    }

    public string AccessibilityColor_Inspect
    {
      get => this.mAccessibilityColor_Inspect;
      set => this.SetProperty<string>(ref this.mAccessibilityColor_Inspect, value, nameof (AccessibilityColor_Inspect));
    }

    public string AccessibilityColor_SequenceBreak
    {
      get => this.mAccessibilityColor_SequenceBreak;
      set => this.SetProperty<string>(ref this.mAccessibilityColor_SequenceBreak, value, nameof (AccessibilityColor_SequenceBreak));
    }

    public string AccessibilityColor_Glitch
    {
      get => this.mAccessibilityColor_Glitch;
      set => this.SetProperty<string>(ref this.mAccessibilityColor_Glitch, value, nameof (AccessibilityColor_Glitch));
    }

    public string AccessibilityColor_Normal
    {
      get => this.mAccessibilityColor_Normal;
      set => this.SetProperty<string>(ref this.mAccessibilityColor_Normal, value, nameof (AccessibilityColor_Normal));
    }

    public string AccessibilityColor_Cleared
    {
      get => this.mAccessibilityColor_Cleared;
      set => this.SetProperty<string>(ref this.mAccessibilityColor_Cleared, value, nameof (AccessibilityColor_Cleared));
    }

    public string Status_Generic_Success
    {
      get => this.mStatus_Generic_Success;
      set => this.SetProperty<string>(ref this.mStatus_Generic_Success, value, nameof (Status_Generic_Success));
    }

    public string Status_Generic_Error
    {
      get => this.mStatus_Generic_Error;
      set => this.SetProperty<string>(ref this.mStatus_Generic_Error, value, nameof (Status_Generic_Error));
    }

    public string Status_Generic_Warning
    {
      get => this.mStatus_Generic_Warning;
      set => this.SetProperty<string>(ref this.mStatus_Generic_Warning, value, nameof (Status_Generic_Warning));
    }

    public string Status_Generic_Active
    {
      get => this.mStatus_Generic_Active;
      set => this.SetProperty<string>(ref this.mStatus_Generic_Active, value, nameof (Status_Generic_Active));
    }

    public string Map_LocationNoteBadgeBackground
    {
      get => this.mMap_LocationNoteBadgeBackground;
      set => this.SetProperty<string>(ref this.mMap_LocationNoteBadgeBackground, value, nameof (Map_LocationNoteBadgeBackground));
    }

    public ApplicationColors() => this.LoadColors();

    public void ResetColors()
    {
      this.AccessibilityColor_None = "#ff3030";
      this.AccessibilityColor_Partial = "DarkOrange";
      this.AccessibilityColor_Unlockable = "MediumPurple";
      this.AccessibilityColor_Inspect = "CornflowerBlue";
      this.AccessibilityColor_Glitch = "#b399c1";
      this.AccessibilityColor_SequenceBreak = "Yellow";
      this.AccessibilityColor_Normal = "#00ff00";
      this.AccessibilityColor_Cleared = "#333333";
      this.Status_Generic_Success = "#00ff00";
      this.Status_Generic_Warning = "#ffff00";
      this.Status_Generic_Error = "#ff0000";
      this.Status_Generic_Active = "#35e0b5";
      this.Map_LocationNoteBadgeBackground = "#35e0b5";
    }

    public void LoadColors()
    {
      this.ResetColors();
      if (!File.Exists(Path.Combine(UserDirectory.Path, "application_colors.json")))
        return;
      try
      {
        using (StreamReader reader = new StreamReader((Stream) File.OpenRead(Path.Combine(UserDirectory.Path, "application_colors.json"))))
        {
          JObject token = (JObject) JToken.ReadFrom((JsonReader) new JsonTextReader((TextReader) reader));
          this.AccessibilityColor_None = token.GetValue<string>("accessibility_none", this.AccessibilityColor_None);
          this.AccessibilityColor_Partial = token.GetValue<string>("accessibility_partial", this.AccessibilityColor_Partial);
          this.AccessibilityColor_Unlockable = token.GetValue<string>("accessibility_unlockable", this.AccessibilityColor_Unlockable);
          this.AccessibilityColor_Inspect = token.GetValue<string>("accessibility_inspect", this.AccessibilityColor_Inspect);
          this.AccessibilityColor_SequenceBreak = token.GetValue<string>("accessibility_sequencebreak", this.AccessibilityColor_SequenceBreak);
          this.AccessibilityColor_Normal = token.GetValue<string>("accessibility_normal", this.AccessibilityColor_Normal);
          this.AccessibilityColor_Cleared = token.GetValue<string>("accessibility_cleared", this.AccessibilityColor_Cleared);
          this.Status_Generic_Active = token.GetValue<string>("status_generic_active", this.Status_Generic_Active);
          this.Status_Generic_Success = token.GetValue<string>("status_generic_success", this.Status_Generic_Success);
          this.Status_Generic_Warning = token.GetValue<string>("status_generic_warning", this.Status_Generic_Warning);
          this.Status_Generic_Error = token.GetValue<string>("status_generic_error", this.Status_Generic_Error);
          this.Map_LocationNoteBadgeBackground = token.GetValue<string>("map_location_has_note_badge_background", this.Map_LocationNoteBadgeBackground);
        }
      }
      catch
      {
      }
    }
  }
}
