﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.UI.Media.ImageReferenceService
// Assembly: EmoTracker.UI, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D3E1A4EF-7464-460D-863E-F2F24592E22D
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.UI.dll

using EmoTracker.Core;
using EmoTracker.Data.Media;
using EmoTracker.UI.Media.Resolvers;
using System.Collections.Generic;
using System.Windows.Media;

namespace EmoTracker.UI.Media
{
  public class ImageReferenceService : ObservableSingleton<ImageReferenceService>
  {
    private Dictionary<ImageReference, ImageSource> mCache = new Dictionary<ImageReference, ImageSource>();

    public void ClearImageCache() => this.mCache.Clear();

    public ImageSource ResolveImageReference(ImageReference imageRef)
    {
      if (imageRef == null)
        return (ImageSource) null;
      ImageSource imageSource1;
      if (this.mCache.TryGetValue(imageRef, out imageSource1))
        return imageSource1;
      foreach (ImageReferenceResolver referenceResolver in TypedObjectRegistry<ImageReferenceResolver>.SupportRegistry)
      {
        if (referenceResolver.CanResolveReference(imageRef))
        {
          ImageSource imageSource2 = referenceResolver.ResolveReference(imageRef);
          try
          {
            if (imageSource2 != null)
            {
              if (imageSource2.CanFreeze)
                imageSource2.Freeze();
            }
          }
          catch
          {
          }
          this.mCache[imageRef] = imageSource2;
          return imageSource2;
        }
      }
      return (ImageSource) null;
    }
  }
}
