﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.UI.Media.Resolvers.ConcreteImageReferenceResolver
// Assembly: EmoTracker.UI, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D3E1A4EF-7464-460D-863E-F2F24592E22D
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.UI.dll

using EmoTracker.Core;
using EmoTracker.Data;
using EmoTracker.Data.Media;
using EmoTracker.UI.Media.Utility;
using System;
using System.IO;
using System.Windows.Media;

namespace EmoTracker.UI.Media.Resolvers
{
  public class ConcreteImageReferenceResolver : ImageReferenceResolver
  {
    public override bool CanResolveReference(ImageReference imageRef) => imageRef is ConcreteImageReference;

    public override ImageSource ResolveReference(ImageReference imageRef)
    {
      if (!(imageRef is ConcreteImageReference concreteImageReference))
        return (ImageSource) null;
      if (concreteImageReference.URI == (Uri) null)
        return (ImageSource) null;
      if (!concreteImageReference.URI.Scheme.Equals("gamepackage", StringComparison.OrdinalIgnoreCase))
        return IconUtility.GetImageRaw(concreteImageReference.URI);
      if (ObservableSingleton<Tracker>.Instance.ActiveGamePackage == null)
        return (ImageSource) null;
      using (Stream stream = ObservableSingleton<Tracker>.Instance.ActiveGamePackage.Open(string.Format("{0}{1}", (object) Uri.UnescapeDataString(concreteImageReference.URI.Host), (object) Uri.UnescapeDataString(concreteImageReference.URI.AbsolutePath))))
        return stream == null ? (ImageSource) null : IconUtility.ApplyFilterSpecToImage(ObservableSingleton<Tracker>.Instance.ActiveGamePackage, IconUtility.GetImage(stream), concreteImageReference.Filter);
    }
  }
}
