﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.UI.Media.Resolvers.LayeredImageReferenceResolver
// Assembly: EmoTracker.UI, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D3E1A4EF-7464-460D-863E-F2F24592E22D
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.UI.dll

using EmoTracker.Core;
using EmoTracker.Data.Media;
using EmoTracker.UI.Media.Utility;
using System.Collections.Generic;
using System.Windows.Media;

namespace EmoTracker.UI.Media.Resolvers
{
  internal class LayeredImageReferenceResolver : ImageReferenceResolver
  {
    public override bool CanResolveReference(ImageReference imageRef) => imageRef is LayeredImageReference;

    public override ImageSource ResolveReference(ImageReference imageRef)
    {
      if (!(imageRef is LayeredImageReference layeredImageReference))
        return (ImageSource) null;
      if (layeredImageReference.Layers.Count == 0)
        return (ImageSource) null;
      ImageSource image = (ImageSource) null;
      foreach (ImageReference layer in (IEnumerable<ImageReference>) layeredImageReference.Layers)
      {
        ImageSource overlay = ObservableSingleton<ImageReferenceService>.Instance.ResolveImageReference(layer);
        image = IconUtility.ApplyOverlayImage(image, overlay);
      }
      image?.Freeze();
      return image;
    }
  }
}
