﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.UI.Media.Utility.IconUtility
// Assembly: EmoTracker.UI, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: D3E1A4EF-7464-460D-863E-F2F24592E22D
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.UI.dll

using EmoTracker.Core;
using EmoTracker.Data;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Net.Cache;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace EmoTracker.UI.Media.Utility
{
  public class IconUtility : ObservableSingleton<IconUtility>
  {
    private bool mbEnableDpiConversion = true;
    private static RequestCachePolicy RawImageRequestPolicy = new RequestCachePolicy(RequestCacheLevel.BypassCache);

    public bool EnableDpiConversion
    {
      get => this.mbEnableDpiConversion;
      set => this.SetProperty<bool>(ref this.mbEnableDpiConversion, value, nameof (EnableDpiConversion));
    }

    public static ImageSource GetImageRaw(Uri uri)
    {
      try
      {
        return (ImageSource) new BitmapImage(uri)
        {
          UriCachePolicy = IconUtility.RawImageRequestPolicy
        };
      }
      catch
      {
        return (ImageSource) null;
      }
    }

    public static ImageSource GetImage(Uri uri)
    {
      try
      {
        FormatConvertedBitmap source = new FormatConvertedBitmap();
        source.BeginInit();
        source.DestinationFormat = PixelFormats.Bgra32;
        source.Source = (BitmapSource) new BitmapImage(uri);
        source.EndInit();
        WriteableBitmap image1 = new WriteableBitmap((BitmapSource) source);
        byte[] pixels = new byte[image1.PixelHeight * image1.PixelWidth * 4];
        image1.CopyPixels((Array) pixels, image1.PixelWidth * 4, 0);
        for (int index1 = 0; index1 < image1.PixelHeight; ++index1)
        {
          for (int index2 = 0; index2 < image1.PixelWidth; ++index2)
          {
            byte num1 = pixels[index1 * image1.BackBufferStride + index2 * 4];
            byte num2 = pixels[index1 * image1.BackBufferStride + index2 * 4 + 1];
            if (pixels[index1 * image1.BackBufferStride + index2 * 4 + 2] == byte.MaxValue && num2 == (byte) 0 && num1 == byte.MaxValue)
              pixels[index1 * image1.BackBufferStride + index2 * 4 + 3] = (byte) 0;
          }
        }
        if (ObservableSingleton<IconUtility>.Instance.EnableDpiConversion)
        {
          BitmapSource image2 = BitmapSource.Create(image1.PixelWidth, image1.PixelHeight, 96.0, 96.0, image1.Format, image1.Palette, (Array) pixels, image1.BackBufferStride);
          image2?.Freeze();
          return (ImageSource) image2;
        }
        image1.WritePixels(new Int32Rect(0, 0, image1.PixelWidth, image1.PixelHeight), (Array) pixels, image1.PixelWidth * 4, 0);
        image1.Freeze();
        return (ImageSource) image1;
      }
      catch
      {
        return (ImageSource) null;
      }
    }

    public static ImageSource GetImage(Stream stream)
    {
      if (stream == null)
        return (ImageSource) null;
      try
      {
        BitmapImage bitmapImage = new BitmapImage();
        bitmapImage.BeginInit();
        bitmapImage.StreamSource = stream;
        bitmapImage.CacheOption = BitmapCacheOption.OnLoad;
        bitmapImage.EndInit();
        bitmapImage.Freeze();
        FormatConvertedBitmap source = new FormatConvertedBitmap();
        source.BeginInit();
        source.DestinationFormat = PixelFormats.Bgra32;
        source.Source = (BitmapSource) bitmapImage;
        source.EndInit();
        WriteableBitmap image1 = new WriteableBitmap((BitmapSource) source);
        byte[] pixels = new byte[image1.PixelHeight * image1.PixelWidth * 4];
        image1.CopyPixels((Array) pixels, image1.PixelWidth * 4, 0);
        for (int index1 = 0; index1 < image1.PixelHeight; ++index1)
        {
          for (int index2 = 0; index2 < image1.PixelWidth; ++index2)
          {
            byte num1 = pixels[index1 * image1.BackBufferStride + index2 * 4];
            byte num2 = pixels[index1 * image1.BackBufferStride + index2 * 4 + 1];
            if (pixels[index1 * image1.BackBufferStride + index2 * 4 + 2] == byte.MaxValue && num2 == (byte) 0 && num1 == byte.MaxValue)
              pixels[index1 * image1.BackBufferStride + index2 * 4 + 3] = (byte) 0;
          }
        }
        if (ObservableSingleton<IconUtility>.Instance.EnableDpiConversion)
        {
          BitmapSource image2 = BitmapSource.Create(image1.PixelWidth, image1.PixelHeight, 96.0, 96.0, image1.Format, image1.Palette, (Array) pixels, image1.BackBufferStride);
          image2?.Freeze();
          return (ImageSource) image2;
        }
        image1.WritePixels(new Int32Rect(0, 0, image1.PixelWidth, image1.PixelHeight), (Array) pixels, image1.PixelWidth * 4, 0);
        image1.Freeze();
        return (ImageSource) image1;
      }
      catch
      {
        return (ImageSource) null;
      }
    }

    public static ImageSource ApplyOverlayImage(
      IGamePackage package,
      ImageSource image,
      params string[] args)
    {
      if (package == null || args.Length < 1)
        return image;
      ImageSource image1 = IconUtility.GetImage(package.Open(args[0]));
      return image1 != null ? IconUtility.ApplyOverlayImage(image, image1) : image;
    }

    public static ImageSource ApplyOverlayImage(ImageSource image, ImageSource overlay)
    {
      if (overlay == null)
        return image;
      if (image == null)
        return overlay;
      if (image == null && overlay == null)
        return (ImageSource) null;
      WriteableBitmap writeableBitmap1 = new WriteableBitmap((BitmapSource) image);
      WriteableBitmap writeableBitmap2 = new WriteableBitmap((BitmapSource) overlay);
      if (writeableBitmap2.PixelWidth != writeableBitmap1.PixelWidth || writeableBitmap2.PixelHeight != writeableBitmap1.PixelHeight)
      {
        ObservableSingleton<ScriptManager>.Instance.OutputError("Not applying overlay to base image because dimensions don't match.");
        return image;
      }
      byte[] pixels1 = new byte[writeableBitmap1.PixelHeight * writeableBitmap1.PixelWidth * 4];
      writeableBitmap1.CopyPixels((Array) pixels1, writeableBitmap1.PixelWidth * 4, 0);
      byte[] pixels2 = new byte[writeableBitmap2.PixelHeight * writeableBitmap2.PixelWidth * 4];
      writeableBitmap2.CopyPixels((Array) pixels2, writeableBitmap1.PixelWidth * 4, 0);
      for (int index1 = 0; index1 < writeableBitmap1.PixelHeight; ++index1)
      {
        for (int index2 = 0; index2 < writeableBitmap1.PixelWidth; ++index2)
        {
          byte num1 = pixels1[index1 * writeableBitmap1.BackBufferStride + index2 * 4];
          byte num2 = pixels1[index1 * writeableBitmap1.BackBufferStride + index2 * 4 + 1];
          byte num3 = pixels1[index1 * writeableBitmap1.BackBufferStride + index2 * 4 + 2];
          byte val1 = pixels1[index1 * writeableBitmap1.BackBufferStride + index2 * 4 + 3];
          int num4 = (int) pixels2[index1 * writeableBitmap2.BackBufferStride + index2 * 4];
          byte num5 = pixels2[index1 * writeableBitmap2.BackBufferStride + index2 * 4 + 1];
          byte num6 = pixels2[index1 * writeableBitmap2.BackBufferStride + index2 * 4 + 2];
          byte val2 = pixels2[index1 * writeableBitmap2.BackBufferStride + index2 * 4 + 3];
          float num7 = (float) val2 / (float) byte.MaxValue;
          float num8 = 1f - num7;
          byte num9 = (byte) Math.Min(Math.Max((uint) ((double) (uint) num4 * (double) num7 + (double) num1 * (double) num8), 0U), (uint) byte.MaxValue);
          byte num10 = (byte) Math.Min(Math.Max((uint) ((double) num5 * (double) num7 + (double) num2 * (double) num8), 0U), (uint) byte.MaxValue);
          byte num11 = (byte) Math.Min(Math.Max((uint) ((double) num6 * (double) num7 + (double) num3 * (double) num8), 0U), (uint) byte.MaxValue);
          pixels1[index1 * writeableBitmap1.BackBufferStride + index2 * 4] = num9;
          pixels1[index1 * writeableBitmap1.BackBufferStride + index2 * 4 + 1] = num10;
          pixels1[index1 * writeableBitmap1.BackBufferStride + index2 * 4 + 2] = num11;
          pixels1[index1 * writeableBitmap1.BackBufferStride + index2 * 4 + 3] = Math.Max(val1, val2);
        }
      }
      writeableBitmap1.WritePixels(new Int32Rect(0, 0, writeableBitmap1.PixelWidth, writeableBitmap1.PixelHeight), (Array) pixels1, writeableBitmap1.PixelWidth * 4, 0);
      writeableBitmap1.Freeze();
      return (ImageSource) writeableBitmap1;
    }

    private static byte Lerp(byte a, byte b, float factor)
    {
      if ((double) factor <= 0.0)
        return a;
      return (double) factor >= 1.0 ? b : (byte) ((double) a * (1.0 - (double) factor) + (double) b * (double) factor + 0.5);
    }

    public static ImageSource MakeImageGrayscale(
      ImageSource image,
      IconUtility.LuminanceMode mode = IconUtility.LuminanceMode.Average,
      float saturation = 0.0f)
    {
      if (image == null)
        return (ImageSource) null;
      WriteableBitmap writeableBitmap = new WriteableBitmap((BitmapSource) image);
      byte[] pixels = new byte[writeableBitmap.PixelHeight * writeableBitmap.PixelWidth * 4];
      writeableBitmap.CopyPixels((Array) pixels, writeableBitmap.PixelWidth * 4, 0);
      for (int index1 = 0; index1 < writeableBitmap.PixelHeight; ++index1)
      {
        for (int index2 = 0; index2 < writeableBitmap.PixelWidth; ++index2)
        {
          byte num1 = pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4];
          byte num2 = pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 1];
          byte num3 = pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 2];
          byte b1 = num1;
          byte b2 = num2;
          byte b3 = num3;
          switch (mode)
          {
            case IconUtility.LuminanceMode.Avg:
            case IconUtility.LuminanceMode.Average:
              int num4;
              num3 = (byte) (num4 = (int) (byte) ((double) ((int) num1 + (int) num2 + (int) num3) / 3.0));
              num2 = (byte) num4;
              num1 = (byte) num4;
              break;
            case IconUtility.LuminanceMode.Max:
              int num5;
              num3 = (byte) (num5 = (int) Math.Max(Math.Max(num1, num2), num3));
              num2 = (byte) num5;
              num1 = (byte) num5;
              break;
            case IconUtility.LuminanceMode.Blue:
              num2 = num3 = num1;
              break;
            case IconUtility.LuminanceMode.Green:
              num1 = num3 = num2;
              break;
            case IconUtility.LuminanceMode.Red:
              num1 = num2 = num3;
              break;
            case IconUtility.LuminanceMode.BT709:
              int num6;
              num3 = (byte) (num6 = (int) (byte) (((uint) num3 + (uint) num3 + (uint) num1 + (uint) num2 + (uint) num2 + (uint) num2) / 6U));
              num2 = (byte) num6;
              num1 = (byte) num6;
              break;
            case IconUtility.LuminanceMode.BT601:
              int num7;
              num3 = (byte) (num7 = (int) (byte) ((uint) num3 + (uint) num3 + (uint) num1 + (uint) num2 + (uint) num2 + (uint) num2 >> 3));
              num2 = (byte) num7;
              num1 = (byte) num7;
              break;
          }
          byte num8 = IconUtility.Lerp(num1, b1, saturation);
          byte num9 = IconUtility.Lerp(num2, b2, saturation);
          byte num10 = IconUtility.Lerp(num3, b3, saturation);
          pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4] = num8;
          pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 1] = num9;
          pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 2] = num10;
        }
      }
      writeableBitmap.WritePixels(new Int32Rect(0, 0, writeableBitmap.PixelWidth, writeableBitmap.PixelHeight), (Array) pixels, writeableBitmap.PixelWidth * 4, 0);
      writeableBitmap.Freeze();
      return (ImageSource) writeableBitmap;
    }

    public static ImageSource AdjustSaturation(
      IGamePackage package,
      ImageSource image,
      params string[] args)
    {
      if (image == null)
        return (ImageSource) null;
      float result1;
      if (args.Length < 1 || !float.TryParse(args[0], NumberStyles.Float, (IFormatProvider) CultureInfo.InvariantCulture, out result1))
        return image;
      IconUtility.LuminanceMode result2 = IconUtility.LuminanceMode.Average;
      if (args.Length >= 2)
        Enum.TryParse<IconUtility.LuminanceMode>(args[1], true, out result2);
      result1 = Math.Min(Math.Max(result1, 0.0f), 1f);
      return IconUtility.MakeImageGrayscale(image, result2, result1);
    }

    public static ImageSource AdjustBrightness(
      IGamePackage package,
      ImageSource image,
      params string[] args)
    {
      if (image == null)
        return (ImageSource) null;
      float result;
      if (args.Length < 1 || !float.TryParse(args[0], NumberStyles.Float, (IFormatProvider) CultureInfo.InvariantCulture, out result))
        return image;
      result = Math.Max(result, 0.0f);
      WriteableBitmap writeableBitmap = new WriteableBitmap((BitmapSource) image);
      byte[] pixels = new byte[writeableBitmap.PixelHeight * writeableBitmap.PixelWidth * 4];
      writeableBitmap.CopyPixels((Array) pixels, writeableBitmap.PixelWidth * 4, 0);
      for (int index1 = 0; index1 < writeableBitmap.PixelHeight; ++index1)
      {
        for (int index2 = 0; index2 < writeableBitmap.PixelWidth; ++index2)
        {
          byte num1 = (byte) Math.Min((float) byte.MaxValue, Math.Max(0.0f, (float) pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4] * result));
          byte num2 = (byte) Math.Min((float) byte.MaxValue, Math.Max(0.0f, (float) pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 1] * result));
          byte num3 = (byte) Math.Min((float) byte.MaxValue, Math.Max(0.0f, (float) pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 2] * result));
          pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4] = num1;
          pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 1] = num2;
          pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 2] = num3;
        }
      }
      writeableBitmap.WritePixels(new Int32Rect(0, 0, writeableBitmap.PixelWidth, writeableBitmap.PixelHeight), (Array) pixels, writeableBitmap.PixelWidth * 4, 0);
      writeableBitmap.Freeze();
      return (ImageSource) writeableBitmap;
    }

    public static ImageSource MakeImageDim(ImageSource image, int divisor = 2)
    {
      if (image == null)
        return (ImageSource) null;
      WriteableBitmap writeableBitmap = new WriteableBitmap((BitmapSource) image);
      byte[] pixels = new byte[writeableBitmap.PixelHeight * writeableBitmap.PixelWidth * 4];
      writeableBitmap.CopyPixels((Array) pixels, writeableBitmap.PixelWidth * 4, 0);
      for (int index1 = 0; index1 < writeableBitmap.PixelHeight; ++index1)
      {
        for (int index2 = 0; index2 < writeableBitmap.PixelWidth; ++index2)
        {
          byte num1 = (byte) ((uint) pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4] - (uint) pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4] / (uint) divisor);
          byte num2 = (byte) ((uint) pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 1] - (uint) pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 1] / (uint) divisor);
          byte num3 = (byte) ((uint) pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 2] - (uint) pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 2] / (uint) divisor);
          pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4] = num1;
          pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 1] = num2;
          pixels[index1 * writeableBitmap.BackBufferStride + index2 * 4 + 2] = num3;
        }
      }
      writeableBitmap.WritePixels(new Int32Rect(0, 0, writeableBitmap.PixelWidth, writeableBitmap.PixelHeight), (Array) pixels, writeableBitmap.PixelWidth * 4, 0);
      writeableBitmap.Freeze();
      return (ImageSource) writeableBitmap;
    }

    public static ImageSource ApplyFilterSpecToImage(
      IGamePackage package,
      ImageSource image,
      string filterSpec)
    {
      if (image == null)
        return (ImageSource) null;
      if (!string.IsNullOrWhiteSpace(filterSpec))
      {
        string str1 = filterSpec;
        char[] chArray = new char[1]{ ',' };
        foreach (string filterCommand in str1.Split(chArray))
        {
          string[] args = IconUtility.GetArgs(filterCommand);
          if (args.Length >= 1)
          {
            string str2 = args[0];
            string[] array = ((IEnumerable<string>) args).Skip<string>(1).ToArray<string>();
            if (str2.StartsWith("grayscale", StringComparison.OrdinalIgnoreCase))
              image = IconUtility.MakeImageGrayscale(image);
            else if (str2.StartsWith("dim", StringComparison.OrdinalIgnoreCase))
              image = IconUtility.MakeImageDim(image);
            else if (str2.StartsWith("halfdim", StringComparison.OrdinalIgnoreCase))
              image = IconUtility.MakeImageDim(image, 4);
            else if (str2.StartsWith("quarterdim", StringComparison.OrdinalIgnoreCase))
              image = IconUtility.MakeImageDim(image, 8);
            else if (str2.StartsWith("brightness", StringComparison.OrdinalIgnoreCase))
              image = IconUtility.AdjustBrightness(package, image, array);
            else if (str2.StartsWith("overlay", StringComparison.OrdinalIgnoreCase))
              image = IconUtility.ApplyOverlayImage(package, image, array);
            else if (str2.StartsWith("saturation", StringComparison.OrdinalIgnoreCase))
              image = IconUtility.AdjustSaturation(package, image, array);
            else if (str2.StartsWith("@disabled", StringComparison.OrdinalIgnoreCase))
              image = IconUtility.ApplyFilterSpecToImage(package, image, ObservableSingleton<Tracker>.Instance.DisabledImageFilterSpec);
          }
        }
      }
      image?.Freeze();
      return image;
    }

    public static string[] GetArgs(string filterCommand)
    {
      string[] args = filterCommand.Split(new char[1]{ '|' }, StringSplitOptions.RemoveEmptyEntries);
      for (int index = 0; index < args.Length; ++index)
        args[index] = args[index].Trim();
      return args;
    }

    public enum LuminanceMode
    {
      Avg,
      Average,
      Max,
      Blue,
      Green,
      Red,
      BT709,
      BT601,
    }
  }
}
