﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Extensions.AutoTracker.MemoryTimer
// Assembly: EmoTracker, Version=2.3.8.17, Culture=neutral, PublicKeyToken=null
// MVID: 0D1A2596-8086-4DA5-90AE-09EB4913AFBC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.exe

using ConnectorLib;
using EmoTracker.Data.Packages;
using NLua;
using System;

namespace EmoTracker.Extensions.AutoTracker
{
  public class MemoryTimer : IDisposable
  {
    private string mName;
    private Func<IAddressableConnector, PackageManager.Game, bool> mCallback;
    private DateTime mLastUpdate;
    private int mPeriod = 500;

    public string Name => this.mName;

    public int Period => this.mPeriod;

    public MemoryTimer(
      string name,
      Func<IAddressableConnector, PackageManager.Game, bool> callback,
      int period = 500)
    {
      this.mName = name;
      this.mCallback = callback;
      this.mPeriod = period;
    }

    [LuaHide]
    public bool UpdateWithConnector(IAddressableConnector connector, PackageManager.Game game)
    {
      try
      {
        DateTime now = DateTime.Now;
        if (this.mLastUpdate.ToBinary() != 0L && (now - this.mLastUpdate).CompareTo(TimeSpan.FromMilliseconds((double) this.Period)) < 0)
          return true;
        this.mLastUpdate = now;
        if (this.mCallback != null)
          return this.mCallback(connector, game);
      }
      catch
      {
      }
      return false;
    }

    public void Dispose()
    {
    }
  }
}
