﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Extensions.BontaMultiworld.MultiWorldExtension
// Assembly: EmoTracker, Version=2.3.8.17, Culture=neutral, PublicKeyToken=null
// MVID: 0D1A2596-8086-4DA5-90AE-09EB4913AFBC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.exe

using EmoTracker.Core;
using EmoTracker.Extensions.AutoTracker;
using Newtonsoft.Json.Linq;
using System;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Windows;

namespace EmoTracker.Extensions.BontaMultiworld
{
    public class MultiWorldExtension : MultiWorldClientSession, Extension
    {
        private MultiWorldExtensionView mStatusIndicator;
        private MultiWorldExtensionStatus mStatus;
        private DelegateCommand mConnectCmd;
        private DelegateCommand mDisconnectCmd;
        private DelegateCommand mJoinGameCmd;
        private DelegateCommand mClearMessageLogCmd;
        private DelegateCommand mForfeitCmd;
        private DelegateCommand mPopOutCmd;
        private MultiWorldLogWindow mLogWindow;

        public string Name => "BontaWorld";

        public string UID => "lttp_multiworld_bonta";

        public int Priority => -99;

        public FrameworkElement StatusBarControl
        {
            get
            {
                if (this.mStatusIndicator == null)
                {
                    MultiWorldExtensionView worldExtensionView = new MultiWorldExtensionView();
                    worldExtensionView.DataContext = (object)this;
                    this.mStatusIndicator = worldExtensionView;
                }
                return (FrameworkElement)this.mStatusIndicator;
            }
        }

        public MultiWorldExtensionStatus Status
        {
            get => this.mStatus;
            private set => this.SetProperty<MultiWorldExtensionStatus>(ref this.mStatus, value, nameof(Status));
        }

        public DelegateCommand ConnectCmd
        {
            get => this.mConnectCmd;
            private set => this.SetProperty<DelegateCommand>(ref this.mConnectCmd, value, nameof(ConnectCmd));
        }

        public DelegateCommand DisconnectCmd
        {
            get => this.mDisconnectCmd;
            private set => this.SetProperty<DelegateCommand>(ref this.mDisconnectCmd, value, nameof(DisconnectCmd));
        }

        public DelegateCommand JoinGameCmd
        {
            get => this.mJoinGameCmd;
            private set => this.SetProperty<DelegateCommand>(ref this.mJoinGameCmd, value, nameof(JoinGameCmd));
        }

        public DelegateCommand ClearMessageLogCmd
        {
            get => this.mClearMessageLogCmd;
            private set => this.SetProperty<DelegateCommand>(ref this.mClearMessageLogCmd, value, nameof(ClearMessageLogCmd));
        }

        public DelegateCommand ForfeitCmd
        {
            get => this.mForfeitCmd;
            private set => this.SetProperty<DelegateCommand>(ref this.mForfeitCmd, value, nameof(ForfeitCmd));
        }

        public DelegateCommand PopOutCmd
        {
            get => this.mPopOutCmd;
            private set => this.SetProperty<DelegateCommand>(ref this.mPopOutCmd, value, nameof(PopOutCmd));
        }

        public MultiWorldExtension()
        {
            this.ConnectCmd = new DelegateCommand(new Action<object>(this.ConnectHandler), new Predicate<object>(((MultiWorldClientSession)this).CanConnect));
            this.DisconnectCmd = new DelegateCommand(new Action<object>(((MultiWorldClientSession)this).Disconnect));
            this.ForfeitCmd = new DelegateCommand(new Action<object>(this.ForfeitHandler));
            this.JoinGameCmd = new DelegateCommand(new Action<object>(((MultiWorldClientSession)this).Authenticate), new Predicate<object>(((MultiWorldClientSession)this).CanAuthenticate));
            this.ClearMessageLogCmd = new DelegateCommand(new Action<object>(((MultiWorldClientSession)this).ClearMessageLog));
            this.PopOutCmd = new DelegateCommand(new Action<object>(this.PopOutLogWindow), new Predicate<object>(this.CanPopOutLogWindow));
        }

        protected void RefreshCommandAvailability() => Application.Current.Dispatcher.BeginInvoke(new Action(delegate ()
        {
            this.ConnectCmd?.RaiseCanExecuteChanged();
            this.DisconnectCmd?.RaiseCanExecuteChanged();
            this.JoinGameCmd?.RaiseCanExecuteChanged();
            this.ForfeitCmd?.RaiseCanExecuteChanged();
            this.PopOutCmd?.RaiseCanExecuteChanged();
        }));

        protected override void NotifyPropertyChanged([CallerMemberName] string propertyName = null)
        {
            this.RefreshCommandAvailability();
            base.NotifyPropertyChanged(propertyName);
        }

        private void Autotracker_PropertyChanged(object sender, PropertyChangedEventArgs e) => this.RefreshCommandAvailability();

        private void ConnectHandler(object obj) => this.Connect();

        private void ForfeitHandler(object obj) => this.Say("!forfeit");

        public MultiWorldLogWindow LogWindow
        {
            get => this.mLogWindow;
            set
            {
                if (!this.SetProperty<MultiWorldLogWindow>(ref this.mLogWindow, value, nameof(LogWindow)) || this.mLogWindow == null)
                    return;
                this.mLogWindow.Closed += new EventHandler(this.LogWindow_Closed);
            }
        }

        private void LogWindow_Closed(object sender, EventArgs e)
        {
            if (!(sender is MultiWorldLogWindow multiWorldLogWindow) || multiWorldLogWindow != this.LogWindow)
                return;
            this.LogWindow = (MultiWorldLogWindow)null;
        }

        private bool CanPopOutLogWindow(object obj) => this.LogWindow == null;

        private void PopOutLogWindow(object obj)
        {
            MultiWorldLogWindow multiWorldLogWindow = new MultiWorldLogWindow();
            multiWorldLogWindow.DataContext = (object)this;
            this.LogWindow = multiWorldLogWindow;
            this.LogWindow.Show();
        }

        public void Start()
        {
            AutoTrackerExtension extension = ObservableSingleton<ExtensionManager>.Instance.FindExtension<AutoTrackerExtension>();
            if (extension == null)
                return;
            extension.PropertyChanged += new PropertyChangedEventHandler(this.Autotracker_PropertyChanged);
        }

        public void Stop()
        {
        }

        public void OnPackageLoaded()
        {
        }

        public void OnPackageUnloaded() => this.Disconnect();

        public JToken SerializeToJson() => (JToken)null;

        public bool DeserializeFromJson(JToken token) => true;
    }
}
