﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Extensions.ExtensionManager
// Assembly: EmoTracker, Version=2.3.8.17, Culture=neutral, PublicKeyToken=null
// MVID: 0D1A2596-8086-4DA5-90AE-09EB4913AFBC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.exe

using EmoTracker.Core;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Reflection;

namespace EmoTracker.Extensions
{
  public class ExtensionManager : ObservableSingleton<ExtensionManager>
  {
    private ObservableCollection<Extension> mExtensions = new ObservableCollection<Extension>();

    public IEnumerable<Extension> Extensions => (IEnumerable<Extension>) this.mExtensions;

    public ExtensionManager()
    {
      this.LoadExtensionModules();
      Type type1 = typeof (Extension);
      List<Type> typeList = new List<Type>();
      foreach (Assembly assembly in AppDomain.CurrentDomain.GetAssemblies())
      {
        try
        {
          foreach (Type type2 in assembly.GetTypes())
          {
            try
            {
              if (!type2.IsAbstract)
              {
                if (type1.IsAssignableFrom(type2))
                {
                  if (!typeList.Contains(type2))
                    typeList.Add(type2);
                }
              }
            }
            catch
            {
            }
          }
        }
        catch
        {
        }
      }
      foreach (Type type3 in typeList)
      {
        try
        {
          if (Activator.CreateInstance(type3) is Extension instance)
            this.mExtensions.Add(instance);
        }
        catch
        {
        }
      }
      this.mExtensions.Sort<Extension, object>(new Func<Extension, object>(this.ExtensionSortKeyFunc));
    }

    public void Start()
    {
      foreach (Extension extension in this.Extensions)
        extension.Start();
    }

    private object ExtensionSortKeyFunc(Extension arg) => (object) arg.Priority;

    public T FindExtension<T>() where T : class, Extension
    {
      foreach (Extension extension in this.Extensions)
      {
        if (extension.GetType() == typeof (T))
          return extension as T;
      }
      return default (T);
    }

    public Extension FindExtensionByUID(string uid)
    {
      foreach (Extension extension in this.Extensions)
      {
        if (extension.UID.Equals(uid, StringComparison.OrdinalIgnoreCase))
          return extension;
      }
      return (Extension) null;
    }

    public static string GetExtensionPath(Extension instance) => Path.Combine(UserDirectory.Path, "extensions", instance.UID);

    private void LoadExtensionModules()
    {
    }

    public void OnApplicationClosing()
    {
      foreach (Extension extension in this.Extensions)
        extension.Stop();
    }

    public void OnPackageUnloaded()
    {
      foreach (Extension extension in this.Extensions)
        extension.OnPackageUnloaded();
    }

    public void OnPackageLoaded()
    {
      foreach (Extension extension in this.Extensions)
        extension.OnPackageLoaded();
    }
  }
}
