﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.MainWindow
// Assembly: EmoTracker, Version=2.3.8.17, Culture=neutral, PublicKeyToken=null
// MVID: 0D1A2596-8086-4DA5-90AE-09EB4913AFBC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.exe

using EmoTracker.Core;
using EmoTracker.Data;
using EmoTracker.Data.Core.Transactions;
using EmoTracker.Data.Core.Transactions.Processors;
using EmoTracker.UI;
using System;
using System.CodeDom.Compiler;
using System.ComponentModel;
using System.Diagnostics;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Markup;
using System.Windows.Media;
using WpfScreenHelper;

namespace EmoTracker
{
  public partial class MainWindow : Window, INotifyPropertyChanged, IComponentConnector
  {
    private bool bInManualSet;
    private BroadcastView mBroadcastView;
    private DeveloperConsole mDeveloperConsole;
    private bool mbHasIssuedSubWindowDispose;

    public event PropertyChangedEventHandler PropertyChanged;

    protected void NotifyPropertyChanged([CallerMemberName] string propertyName = null)
    {
      if (this.PropertyChanged == null)
        return;
      this.PropertyChanged((object) this, new PropertyChangedEventArgs(propertyName));
    }

    public MainWindow()
    {
      this.SourceInitialized += new EventHandler(this.win_SourceInitialized);
      this.InitializeComponent();
      if (!DesignerProperties.GetIsInDesignMode((DependencyObject) this))
      {
        ObservableSingleton<ApplicationModel>.Instance.Initialize();
        this.DataContext = (object) ObservableSingleton<ApplicationModel>.Instance;
        ObservableSingleton<ApplicationModel>.Instance.PropertyChanged += new PropertyChangedEventHandler(this.Instance_PropertyChanged);
      }
      if (!DesignerProperties.GetIsInDesignMode((DependencyObject) this))
      {
        if (ObservableSingleton<ApplicationSettings>.Instance.InitialWidth >= 0.0)
          this.Width = ObservableSingleton<ApplicationSettings>.Instance.InitialWidth;
        if (ObservableSingleton<ApplicationSettings>.Instance.InitialHeight >= 0.0)
          this.Height = ObservableSingleton<ApplicationSettings>.Instance.InitialHeight;
      }
      this.Loaded += new RoutedEventHandler(this.MainWindow_Loaded);
      this.PreviewKeyDown += new KeyEventHandler(this.MainWindow_PreviewKeyDown);
      this.MouseWheel += new MouseWheelEventHandler(this.MainWindow_MouseWheel);
      this.ContentRendered += new EventHandler(this.MainWindow_ContentRendered);
    }

    private void MainWindow_MouseWheel(object sender, MouseWheelEventArgs e)
    {
      if (!Keyboard.Modifiers.HasFlag((Enum) ModifierKeys.Control))
        return;
      ObservableSingleton<ApplicationModel>.Instance.IncrementMainLayoutScale(e.Delta / 30);
    }

    private void MainWindow_SizeChanged(object sender, SizeChangedEventArgs e)
    {
      if (this.bInManualSet)
        return;
      try
      {
        this.bInManualSet = true;
        this.Width = Math.Max(e.NewSize.Width, this.MinWidth);
        this.Height = Math.Max(e.NewSize.Height, this.MinHeight);
      }
      finally
      {
        this.bInManualSet = false;
      }
    }

    public event KeyEventHandler OnGlobalPreviewKeyDown;

    public event KeyEventHandler OnGlobalPreviewKeyUp;

    private void win_SourceInitialized(object sender, EventArgs e) => HwndSource.FromHwnd(new WindowInteropHelper((Window) this).Handle).AddHook(new HwndSourceHook(MainWindow.WindowProc));

    private static IntPtr WindowProc(
      IntPtr hwnd,
      int msg,
      IntPtr wParam,
      IntPtr lParam,
      ref bool handled)
    {
      if (msg == 36)
      {
        MainWindow.WmGetMinMaxInfo(hwnd, lParam);
        handled = true;
      }
      return (IntPtr) 0;
    }

    private static void WmGetMinMaxInfo(IntPtr hwnd, IntPtr lParam)
    {
      MINMAXINFO structure = (MINMAXINFO) Marshal.PtrToStructure(lParam, typeof (MINMAXINFO));
      Screen screen1 = Screen.PrimaryScreen;
      Screen screen2 = Screen.FromHandle(hwnd);
      if (screen2 != null)
        screen1 = screen2;
      Rect bounds = screen1.Bounds;
      Rect workingArea = screen1.WorkingArea;
      structure.ptMinTrackSize.x = (int) Application.Current.MainWindow.MinWidth;
      structure.ptMinTrackSize.y = (int) Application.Current.MainWindow.MinHeight;
      structure.ptMaxPosition.x = Math.Abs((int) workingArea.Left - (int) bounds.Left);
      structure.ptMaxPosition.y = Math.Abs((int) workingArea.Top - (int) bounds.Top);
      structure.ptMaxSize.x = Math.Abs((int) workingArea.Right - (int) workingArea.Left);
      structure.ptMaxSize.y = Math.Abs((int) workingArea.Bottom - (int) workingArea.Top);
      Marshal.StructureToPtr<MINMAXINFO>(structure, lParam, true);
    }

    private void CheckForUpdates(object obj = null)
    {
      AppUpdateWindow appUpdateWindow = new AppUpdateWindow(true);
      appUpdateWindow.Owner = (Window) this;
      appUpdateWindow.ShowDialog();
    }

    private void MainWindow_ContentRendered(object sender, EventArgs e) => Application.Current.Dispatcher.BeginInvoke(new Action(delegate()
    {
      this.CheckForUpdates();
      this.TrackerLayout.Focus();
    }));

    public BroadcastView BroadcastView => this.mBroadcastView;

    public DeveloperConsole DeveloperConsole => this.mDeveloperConsole;

    public double FixedContentWidth => this.ActiveLayout != null && this.ActiveLayout.Root != null && this.ActiveLayout.Root.OverrideWidth ? this.ActiveLayout.Root.Width * ObservableSingleton<ApplicationModel>.Instance.MainLayoutScaleFactor : 0.0;

    public bool UseFixedContentWidth => this.FixedContentWidth > 0.0 && !ObservableSingleton<Tracker>.Instance.AllowResize;

    private void MainWindow_Loaded(object sender, RoutedEventArgs e)
    {
      if (this.Template.FindName("SystemButton", (FrameworkElement) this) is Button name1)
        name1.Click += new RoutedEventHandler(this.SystemButton_Click);
      if (this.Template.FindName("SettingsButton", (FrameworkElement) this) is Button name2)
        name2.Click += new RoutedEventHandler(this.SettingsButton_Click);
      if (this.Template.FindName("MinimizeButton", (FrameworkElement) this) is Button name3)
        name3.Click += new RoutedEventHandler(this.MinimizeButton_Click);
      if (this.Template.FindName("MaximizeButton", (FrameworkElement) this) is Button name4)
        name4.Click += new RoutedEventHandler(this.MaximizeButton_Click);
      if (!(this.Template.FindName("CloseButton", (FrameworkElement) this) is Button name5))
        return;
      name5.Click += new RoutedEventHandler(this.CloseButton_Click);
    }

    private Point ConvertToScreenCoordinates(Point p) => PresentationSource.FromVisual((Visual) this).CompositionTarget.TransformFromDevice.Transform(this.PointToScreen(p));

    private void SystemButton_Click(object sender, RoutedEventArgs e) => SystemCommands.ShowSystemMenu((Window) this, this.ConvertToScreenCoordinates(new Point(0.0, 30.0)));

    private void SettingsButton_Click(object sender, RoutedEventArgs e)
    {
      Keyboard.Focus((IInputElement) Application.Current.MainWindow);
      if (!(sender is FrameworkElement frameworkElement))
        return;
      frameworkElement.ContextMenu.PlacementTarget = (UIElement) frameworkElement;
      frameworkElement.ContextMenu.IsOpen = true;
    }

    protected override void OnStateChanged(EventArgs e)
    {
      Application.Current.Dispatcher.BeginInvoke(new Action(delegate ()
      {
        if (this.WindowState == WindowState.Minimized)
          return;
        Keyboard.Focus((IInputElement) Application.Current.MainWindow);
      }));
      base.OnStateChanged(e);
    }

    private void MaximizeButton_Click(object sender, RoutedEventArgs e)
    {
      if (ObservableSingleton<Tracker>.Instance.AllowResize)
      {
        if (this.WindowState == WindowState.Maximized)
          this.WindowState = WindowState.Normal;
        else
          this.WindowState = WindowState.Maximized;
      }
      else
        this.WindowState = WindowState.Normal;
    }

    private void MinimizeButton_Click(object sender, RoutedEventArgs e) => this.WindowState = WindowState.Minimized;

    private void CloseButton_Click(object sender, RoutedEventArgs e) => this.Close();

    private void Instance_PropertyChanged(object sender, PropertyChangedEventArgs e)
    {
      this.NotifyPropertyChanged("ActiveLayout");
      this.NotifyPropertyChanged("FixedContentWidth");
      this.NotifyPropertyChanged("UseFixedContentWidth");
      this.InvalidateVisual();
    }

    protected override void OnRenderSizeChanged(SizeChangedInfo sizeInfo)
    {
      Size size = sizeInfo.PreviousSize;
      double height1 = size.Height;
      size = sizeInfo.PreviousSize;
      double width1 = size.Width;
      int num1 = height1 > width1 ? 1 : 0;
      size = sizeInfo.NewSize;
      double height2 = size.Height;
      size = sizeInfo.NewSize;
      double width2 = size.Width;
      int num2 = height2 > width2 ? 1 : 0;
      if (num1 != num2)
      {
        this.NotifyPropertyChanged("UseVerticalOrientation");
        this.NotifyPropertyChanged("ActiveLayout");
      }
      base.OnRenderSizeChanged(sizeInfo);
    }

    public bool UseVerticalOrientation => this.ActualHeight > this.ActualWidth;

    public EmoTracker.Data.Layout.Layout ActiveLayout => this.UseVerticalOrientation ? ObservableSingleton<ApplicationModel>.Instance.TrackerVerticalLayout : ObservableSingleton<ApplicationModel>.Instance.TrackerHorizontalLayout;

    private void MainWindow_PreviewKeyDown(object sender, KeyEventArgs e)
    {
      if (e.Key == Key.F1)
      {
        if (ObservableSingleton<ApplicationModel>.Instance.OpenPackageDocumentationCommand.CanExecute((object) null))
          ObservableSingleton<ApplicationModel>.Instance.OpenPackageDocumentationCommand.Execute((object) null);
        e.Handled = true;
      }
      else if (e.Key == Key.F5)
      {
        ObservableSingleton<ApplicationModel>.Instance.RefreshCommand.Execute((object) null);
        e.Handled = true;
      }
      else if (e.Key == Key.F2)
      {
        this.ShowBroadcastView();
        e.Handled = true;
      }
      else if (e.Key == Key.F11)
      {
        ObservableSingleton<ApplicationSettings>.Instance.DisplayAllLocations = !ObservableSingleton<ApplicationSettings>.Instance.DisplayAllLocations;
        e.Handled = true;
      }
      else
      {
        if (e.Key == Key.S)
        {
          if (Keyboard.Modifiers.HasFlag((Enum) (ModifierKeys.Control | ModifierKeys.Shift)))
          {
            ObservableSingleton<ApplicationModel>.Instance.SaveAsCommand.Execute((object) null);
            e.Handled = true;
            return;
          }
          if (Keyboard.Modifiers.HasFlag((Enum) ModifierKeys.Control))
          {
            ObservableSingleton<ApplicationModel>.Instance.SaveCommand.Execute((object) null);
            e.Handled = true;
            return;
          }
        }
        else if (e.Key == Key.O)
        {
          if (Keyboard.Modifiers.HasFlag((Enum) ModifierKeys.Control))
          {
            ObservableSingleton<ApplicationModel>.Instance.OpenCommand.Execute((object) null);
            e.Handled = true;
            return;
          }
        }
        else if (e.Key == Key.Z)
        {
          if (Keyboard.Modifiers.HasFlag((Enum) ModifierKeys.Control))
          {
            if (TransactionProcessor.Current is IUndoableTransactionProcessor current)
              current.Undo();
            e.Handled = true;
            return;
          }
        }
        else if (e.Key == Key.D0 && Keyboard.Modifiers.HasFlag((Enum) ModifierKeys.Control))
        {
          ObservableSingleton<ApplicationModel>.Instance.ResetLayoutScale();
          e.Handled = true;
          return;
        }
        if (e.Handled || this.OnGlobalPreviewKeyDown == null)
          return;
        this.OnGlobalPreviewKeyDown((object) this, e);
      }
    }

    protected override void OnPreviewKeyUp(KeyEventArgs e)
    {
      if (this.OnGlobalPreviewKeyUp != null)
        this.OnGlobalPreviewKeyUp((object) this, e);
      base.OnPreviewKeyUp(e);
    }

    public void ShowDeveloperConsole()
    {
      if (this.mDeveloperConsole == null)
      {
        this.mDeveloperConsole = new DeveloperConsole();
        this.mDeveloperConsole.Closing += new CancelEventHandler(this.DeveloperConsole_Closing);
        Application.Current.Dispatcher.BeginInvoke(new Action(delegate () { this.mDeveloperConsole.Show(); }));
      }
      else
        this.mDeveloperConsole.Activate();
    }

    public void ShowBroadcastView()
    {
      if (this.mBroadcastView == null)
      {
        this.mBroadcastView = new BroadcastView();
        this.mBroadcastView.Closing += new CancelEventHandler(this.BroadcastView_Closing);
        Application.Current.Dispatcher.BeginInvoke(new Action(delegate () { this.mBroadcastView.Show(); }));
      }
      else
        this.mBroadcastView.Activate();
    }

    protected override void OnClosing(CancelEventArgs e)
    {
      if (ObservableSingleton<ApplicationSettings>.Instance.PromptOnRefreshClose && MessageBox.Show((Window) this, "Closing the application will cause you to lose all unsaved progress. Are you sure you want to continue?", "Warning!", MessageBoxButton.YesNo, MessageBoxImage.Exclamation, MessageBoxResult.No) != MessageBoxResult.Yes)
      {
        e.Cancel = true;
      }
      else
      {
        if (!this.mbHasIssuedSubWindowDispose)
        {
          this.mbHasIssuedSubWindowDispose = true;
          Application.Current.Dispatcher.BeginInvoke(new Action(delegate ()
          {
            if (this.mBroadcastView != null)
            {
              this.mBroadcastView.Close();
              this.mBroadcastView = (BroadcastView) null;
            }
            if (this.mDeveloperConsole == null)
              return;
            this.mDeveloperConsole.Close();
            this.mDeveloperConsole = (DeveloperConsole) null;
          }));
        }
        base.OnClosing(e);
      }
    }

    private void BroadcastView_Closing(object sender, CancelEventArgs e) => this.mBroadcastView = (BroadcastView) null;

    private void DeveloperConsole_Closing(object sender, CancelEventArgs e) => this.mDeveloperConsole = (DeveloperConsole) null;
  }
}
