﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.Notifications.Notification
// Assembly: EmoTracker, Version=2.3.8.17, Culture=neutral, PublicKeyToken=null
// MVID: 0D1A2596-8086-4DA5-90AE-09EB4913AFBC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.exe

using EmoTracker.Core;
using EmoTracker.Data.Scripting;
using System;

namespace EmoTracker.Notifications
{
  public abstract class Notification : ObservableObject
  {
    private NotificationType mType;
    private DateTime mExpirationTime;
    private bool mbExpired;
    private DelegateCommand mForceExpireCommand;

    public NotificationType Type
    {
      get => this.mType;
      set => this.SetProperty<NotificationType>(ref this.mType, value, nameof (Type));
    }

    public DateTime ExpirationTime
    {
      get => this.mExpirationTime;
      set => this.SetProperty<DateTime>(ref this.mExpirationTime, value, nameof (ExpirationTime));
    }

    public bool Expired
    {
      get => this.mbExpired;
      set => this.SetProperty<bool>(ref this.mbExpired, value, nameof (Expired));
    }

    public DelegateCommand ForceExpireCommand => this.mForceExpireCommand;

    protected Notification(int timeout)
    {
      this.ExpirationTime = timeout >= 0 ? (timeout <= 0 ? DateTime.MaxValue : DateTime.Now.AddMilliseconds((double) timeout)) : DateTime.Now.AddSeconds(10.0);
      this.mForceExpireCommand = new DelegateCommand(new Action<object>(this.ForceExpireNotification));
    }

    private void ForceExpireNotification(object obj) => this.Expired = true;
  }
}
