﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.UI.BroadcastView
// Assembly: EmoTracker, Version=2.3.8.17, Culture=neutral, PublicKeyToken=null
// MVID: 0D1A2596-8086-4DA5-90AE-09EB4913AFBC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.exe

using EmoTracker.Core;
using EmoTracker.Extensions;
using EmoTracker.Extensions.NDI;
using NewTek.NDI.WPF;
using System;
using System.CodeDom.Compiler;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Media;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Media.Animation;

namespace EmoTracker.UI
{
  public partial class BroadcastView : Window, IComponentConnector
  {
    private bool mbClosed;

    public BroadcastView()
    {
      this.InitializeComponent();
      this.NDIHost.PropertyChanged += new PropertyChangedEventHandler(this.NDIHost_PropertyChanged);
      this.UpdateNDIExtensionStatus();
    }

    protected override void OnPreviewKeyDown(KeyEventArgs e)
    {
      if (e.Key == Key.F5)
      {
        ObservableSingleton<ApplicationModel>.Instance.RefreshCommand.Execute((object) null);
        e.Handled = true;
      }
      else
        base.OnPreviewKeyDown(e);
    }

    protected override void OnClosing(CancelEventArgs e)
    {
      this.mbClosed = true;
      this.NDIHost.Stop();
      this.NDIHost.Dispose();
      this.UpdateNDIExtensionStatus();
      base.OnClosing(e);
    }

    private void NDIHost_PropertyChanged(object sender, PropertyChangedEventArgs e) => this.UpdateNDIExtensionStatus();

    private void UpdateNDIExtensionStatus()
    {
      NDIExtension extension = ObservableSingleton<ExtensionManager>.Instance.FindExtension<NDIExtension>();
      if (extension == null)
        return;
      extension.Active = !this.mbClosed && !this.NDIHost.IsSendPaused;
    }

    public new void Flush()
    {
      TranslateTransform translateTransform = new TranslateTransform();
      this.HostedLayout.RenderTransform = (Transform) translateTransform;
      this.HostedLayout.RenderTransformOrigin = new Point(0.5, 0.5);
      PowerEase powerEase1 = new PowerEase();
      powerEase1.EasingMode = EasingMode.EaseInOut;
      powerEase1.Power = 2.0;
      PowerEase powerEase2 = powerEase1;
      DoubleAnimationUsingKeyFrames animation = new DoubleAnimationUsingKeyFrames();
      animation.KeyFrames.Add((DoubleKeyFrame) new EasingDoubleKeyFrame(0.0, KeyTime.FromPercent(0.0), (IEasingFunction) powerEase2));
      animation.KeyFrames.Add((DoubleKeyFrame) new EasingDoubleKeyFrame(-10.0, KeyTime.FromPercent(0.1), (IEasingFunction) powerEase2));
      animation.KeyFrames.Add((DoubleKeyFrame) new EasingDoubleKeyFrame(this.Height + 50.0, KeyTime.FromPercent(0.2), (IEasingFunction) powerEase2));
      animation.KeyFrames.Add((DoubleKeyFrame) new EasingDoubleKeyFrame(0.0, KeyTime.FromPercent(1.0), (IEasingFunction) powerEase2));
      animation.Duration = new Duration(new TimeSpan(0, 0, 3));
      translateTransform.BeginAnimation(TranslateTransform.YProperty, (AnimationTimeline) animation, HandoffBehavior.SnapshotAndReplace);
      try
      {
        using (SoundPlayer soundPlayer = new SoundPlayer(Application.GetResourceStream(new Uri("Resources/flush.wav", UriKind.Relative)).Stream))
          soundPlayer.Play();
      }
      catch
      {
      }
    }

    public void Rain(ImageSource image)
    {
      try
      {
        Random random = new Random();
        List<Image> imageList = new List<Image>();
        for (int index = 0; index < 100; ++index)
        {
          Image drop = new Image() { Source = image };
          drop.Width = drop.Height = 32.0;
          double height = drop.Height;
          Canvas.SetLeft((UIElement) drop, (double) random.Next() % this.OverlayCanvas.ActualWidth);
          TranslateTransform translateTransform = new TranslateTransform();
          drop.RenderTransform = (Transform) translateTransform;
          drop.RenderTransformOrigin = new Point(0.5, 0.5);
          PowerEase powerEase1 = new PowerEase();
          powerEase1.EasingMode = EasingMode.EaseInOut;
          powerEase1.Power = 2.0;
          PowerEase powerEase2 = powerEase1;
          int milliseconds1 = random.Next() % 5000;
          int milliseconds2 = milliseconds1 + 1800;
          DoubleAnimationUsingKeyFrames animation = new DoubleAnimationUsingKeyFrames();
          animation.KeyFrames.Add((DoubleKeyFrame) new EasingDoubleKeyFrame(-height, KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 0)), (IEasingFunction) powerEase2));
          animation.KeyFrames.Add((DoubleKeyFrame) new EasingDoubleKeyFrame(-height, KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, milliseconds1)), (IEasingFunction) powerEase2));
          animation.KeyFrames.Add((DoubleKeyFrame) new EasingDoubleKeyFrame(this.Height + height, KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, milliseconds2)), (IEasingFunction) powerEase2));
          animation.Duration = new Duration(new TimeSpan(0, 0, 0, 0, milliseconds2));
          this.OverlayCanvas.Children.Add((UIElement) drop);
          animation.Completed += (EventHandler) ((sender, e) =>
          {
            try
            {
              this.OverlayCanvas.Children.Remove((UIElement) drop);
            }
            catch
            {
            }
          });
          translateTransform.BeginAnimation(TranslateTransform.YProperty, (AnimationTimeline) animation, HandoffBehavior.SnapshotAndReplace);
        }
        using (SoundPlayer soundPlayer = new SoundPlayer(Application.GetResourceStream(new Uri("Resources/rain.wav", UriKind.Relative)).Stream))
          soundPlayer.Play();
      }
      catch
      {
      }
    }
  }
}
