﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.UI.CapturableItemControl
// Assembly: EmoTracker, Version=2.3.8.17, Culture=neutral, PublicKeyToken=null
// MVID: 0D1A2596-8086-4DA5-90AE-09EB4913AFBC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.exe

using EmoTracker.Core;
using EmoTracker.Data;
using EmoTracker.Data.Core.Transactions;
using System;
using System.CodeDom.Compiler;
using System.ComponentModel;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Input;
using System.Windows.Markup;

namespace EmoTracker.UI
{
    public partial class CapturableItemControl :
      UserControl,
      TrackableItemControl.IClickHandler,
      IComponentConnector
    {
        private CapturableItemControl.LeftClickCommand mProgressCmd;
        private CapturableItemControl.ClearItemSlotCommand mClearCmd;

        public CapturableItemControl()
        {
            this.mProgressCmd = new CapturableItemControl.LeftClickCommand(this);
            this.mClearCmd = new CapturableItemControl.ClearItemSlotCommand(this);
            this.InitializeComponent();
        }

        bool TrackableItemControl.IClickHandler.OnLeftClick(ITrackableItem item)
        {
            this.SelectItemCommand.Execute((object)item);
            return true;
        }

        bool TrackableItemControl.IClickHandler.OnRightClick(ITrackableItem item) => true;

        public ICommand SelectItemCommand => (ICommand)this.mProgressCmd;

        public ICommand ClearItemCommand => (ICommand)this.mClearCmd;

        class LeftClickCommand : ICommand
        {
            private CapturableItemControl mHost;

            public LeftClickCommand(CapturableItemControl host) => this.mHost = host;

            public event EventHandler CanExecuteChanged;

            public void NotifyCanExecutedChanged()
            {
                if (this.CanExecuteChanged == null)
                    return;
                this.CanExecuteChanged((object)this, EventArgs.Empty);
            }

            public bool CanExecute(object parameter) => true;

            public void Execute(object parameter)
            {
                EmoTracker.Data.Locations.Section dataContext1 = this.mHost.DataContext as EmoTracker.Data.Locations.Section;
                IItemCollection dataContext2 = this.mHost.DataContext as IItemCollection;
                if (dataContext1 != null)
                {
                    using (TransactionProcessor.Current.OpenTransaction())
                    {
                        ITrackableItem trackableItem = parameter as ITrackableItem;
                        dataContext1.CapturedItem = trackableItem;
                        if (trackableItem != null && ObservableSingleton<ApplicationSettings>.Instance.PinLocationsOnItemCapture)
                            dataContext1.Owner.Pinned = true;
                        this.mHost.PopupInstance.IsOpen = false;
                    }
                }
                else if (dataContext2 != null)
                {
                    using (TransactionProcessor.Current.OpenTransaction())
                    {
                        if (!(parameter is ITrackableItem trackableItem))
                            return;
                        dataContext2.AddItem(trackableItem);
                        this.mHost.PopupInstance.IsOpen = false;
                    }
                }
                else
                    this.mHost.PopupInstance.IsOpen = false;
            }
        }

        class ClearItemSlotCommand : ICommand
        {
            private CapturableItemControl mHost;

            public ClearItemSlotCommand(CapturableItemControl host) => this.mHost = host;

            public event EventHandler CanExecuteChanged;

            public void NotifyCanExecutedChanged()
            {
                if (this.CanExecuteChanged == null)
                    return;
                this.CanExecuteChanged((object)this, EventArgs.Empty);
            }

            public bool CanExecute(object parameter) => this.mHost.DataContext is System.Windows.Documents.Section;

            public void Execute(object parameter)
            {
                using (TransactionProcessor.Current.OpenTransaction())
                {
                    if (!(this.mHost.DataContext is EmoTracker.Data.Locations.Section dataContext))
                        return;
                    dataContext.CapturedItem = (ITrackableItem)null;
                }
            }
        }
    }
}
