﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.UI.ChestListControl
// Assembly: EmoTracker, Version=2.3.8.17, Culture=neutral, PublicKeyToken=null
// MVID: 0D1A2596-8086-4DA5-90AE-09EB4913AFBC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.exe

using System;
using System.CodeDom.Compiler;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Markup;
using System.Windows.Media;

namespace EmoTracker.UI
{
  public partial class ChestListControl : UserControl, IComponentConnector
  {
    public static readonly DependencyProperty ClosedChestProperty = DependencyProperty.Register(nameof (ClosedChest), typeof (ImageSource), typeof (ChestListControl), new PropertyMetadata((PropertyChangedCallback) null));
    public static readonly DependencyProperty OpenChestProperty = DependencyProperty.Register(nameof (OpenChest), typeof (ImageSource), typeof (ChestListControl), new PropertyMetadata((PropertyChangedCallback) null));
    public static readonly DependencyProperty UnavailableClosedChestProperty = DependencyProperty.Register(nameof (UnavailableClosedChest), typeof (ImageSource), typeof (ChestListControl), new PropertyMetadata((PropertyChangedCallback) null));
    public static readonly DependencyProperty UnavailableOpenChestProperty = DependencyProperty.Register(nameof (UnavailableOpenChest), typeof (ImageSource), typeof (ChestListControl), new PropertyMetadata((PropertyChangedCallback) null));
    private ObservableCollection<bool> mChestStates = new ObservableCollection<bool>();
    public static readonly DependencyProperty AccessibleProperty = DependencyProperty.Register(nameof (Accessible), typeof (bool), typeof (ChestListControl), new PropertyMetadata((object) true));
    public static readonly DependencyProperty CountProperty = DependencyProperty.Register(nameof (Count), typeof (uint), typeof (ChestListControl), new PropertyMetadata((object) 5U));
    public static readonly DependencyProperty AvailableProperty = DependencyProperty.Register(nameof (Available), typeof (uint), typeof (ChestListControl), (PropertyMetadata) new FrameworkPropertyMetadata((object) 3U, FrameworkPropertyMetadataOptions.BindsTwoWayByDefault));
    public static readonly DependencyProperty ClearAsGroupProperty = DependencyProperty.Register(nameof (ClearAsGroup), typeof (bool), typeof (ChestListControl), new PropertyMetadata((object) false));
    public static readonly DependencyProperty CompactProperty = DependencyProperty.Register(nameof (Compact), typeof (bool), typeof (ChestListControl), new PropertyMetadata((object) false));

    public ImageSource ClosedChest
    {
      get => (ImageSource) this.GetValue(ChestListControl.ClosedChestProperty);
      set => this.SetValue(ChestListControl.ClosedChestProperty, (object) value);
    }

    public ImageSource OpenChest
    {
      get => (ImageSource) this.GetValue(ChestListControl.OpenChestProperty);
      set => this.SetValue(ChestListControl.OpenChestProperty, (object) value);
    }

    public ImageSource UnavailableClosedChest
    {
      get => (ImageSource) this.GetValue(ChestListControl.UnavailableClosedChestProperty);
      set => this.SetValue(ChestListControl.UnavailableClosedChestProperty, (object) value);
    }

    public ImageSource UnavailableOpenChest
    {
      get => (ImageSource) this.GetValue(ChestListControl.UnavailableOpenChestProperty);
      set => this.SetValue(ChestListControl.UnavailableOpenChestProperty, (object) value);
    }

    protected static void LoadImages()
    {
    }

    public ChestListControl()
    {
      ChestListControl.LoadImages();
      this.InitializeComponent();
    }

    public IEnumerable<bool> Chests => (IEnumerable<bool>) this.mChestStates;

    public uint Count
    {
      get => (uint) this.GetValue(ChestListControl.CountProperty);
      set => this.SetValue(ChestListControl.CountProperty, (object) value);
    }

    public bool Accessible
    {
      get => (bool) this.GetValue(ChestListControl.AccessibleProperty);
      set => this.SetValue(ChestListControl.AccessibleProperty, (object) value);
    }

    public uint Available
    {
      get => (uint) this.GetValue(ChestListControl.AvailableProperty);
      set => this.SetValue(ChestListControl.AvailableProperty, (object) value);
    }

    public bool ClearAsGroup
    {
      get => (bool) this.GetValue(ChestListControl.ClearAsGroupProperty);
      set => this.SetValue(ChestListControl.ClearAsGroupProperty, (object) value);
    }

    public bool Compact
    {
      get => (bool) this.GetValue(ChestListControl.CompactProperty);
      set => this.SetValue(ChestListControl.CompactProperty, (object) value);
    }

    protected override void OnPropertyChanged(DependencyPropertyChangedEventArgs e)
    {
      this.UpdateChests();
      base.OnPropertyChanged(e);
    }

    private void UpdateChests()
    {
      while ((long) this.mChestStates.Count > (long) this.Count)
        this.mChestStates.RemoveAt(0);
      while ((long) this.mChestStates.Count < (long) this.Count)
        this.mChestStates.Add(true);
      for (int index = 0; (long) index < (long) this.Count; ++index)
        this.mChestStates[index] = (long) index < (long) this.Available;
    }

    protected override void OnMouseLeftButtonDown(MouseButtonEventArgs e)
    {
      if (!this.IsEnabled)
        return;
      if (this.ClearAsGroup)
        this.Available = 0U;
      else
        this.Available = (uint) Math.Max(0, (int) this.Available - 1);
    }

    protected override void OnMouseRightButtonDown(MouseButtonEventArgs e)
    {
      if (!this.IsEnabled)
        return;
      if (this.ClearAsGroup)
        this.Available = this.Count;
      else
        this.Available = (uint) Math.Min((long) this.Count, (long) ((int) this.Available + 1));
    }
  }
}
