﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.UI.LocationMapControl
// Assembly: EmoTracker, Version=2.3.8.17, Culture=neutral, PublicKeyToken=null
// MVID: 0D1A2596-8086-4DA5-90AE-09EB4913AFBC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.exe

using EmoTracker.Data;
using EmoTracker.Data.Core.Transactions;
using EmoTracker.Data.Locations;
using EmoTracker.Data.Media;
using EmoTracker.Data.Notes;
using EmoTracker.UI.Controls;
using System;
using System.CodeDom.Compiler;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Input;
using System.Windows.Markup;

namespace EmoTracker.UI
{
  public partial class LocationMapControl : ObservableUserControl, IComponentConnector
  {
    private FrameworkElement mDetailsTarget;
    private Location mDetailsLocation;
    private FrameworkElement mBadgesTarget;
    private Location mBadgesLocation;
    private ObservableCollection<ImageReference> mBadgeImages = new ObservableCollection<ImageReference>();

    public LocationMapControl()
    {
      this.InitializeComponent();
      this.Loaded += new RoutedEventHandler(this.LocationMapControl_Loaded);
      this.Unloaded += new RoutedEventHandler(this.LocationMapControl_Unloaded);
      this.LocationDetails.Opened += new EventHandler(this.LocationDetails_Opened);
      this.LocationDetails.Closed += new EventHandler(this.LocationDetails_Closed);
      this.BadgeDetails.Closed += new EventHandler(this.BadgeDetails_Closed);
    }

    private void LocationMapControl_Loaded(object sender, RoutedEventArgs e)
    {
      if (!(Application.Current.MainWindow is MainWindow mainWindow))
        return;
      mainWindow.OnGlobalPreviewKeyDown += new KeyEventHandler(this.MainWindow_OnGlobalPreviewKeyEvent);
      mainWindow.OnGlobalPreviewKeyUp += new KeyEventHandler(this.MainWindow_OnGlobalPreviewKeyEvent);
    }

    private void LocationMapControl_Unloaded(object sender, RoutedEventArgs e)
    {
      if (!(Application.Current.MainWindow is MainWindow mainWindow))
        return;
      mainWindow.OnGlobalPreviewKeyDown -= new KeyEventHandler(this.MainWindow_OnGlobalPreviewKeyEvent);
      mainWindow.OnGlobalPreviewKeyUp -= new KeyEventHandler(this.MainWindow_OnGlobalPreviewKeyEvent);
    }

    private void MainWindow_OnGlobalPreviewKeyEvent(object sender, KeyEventArgs e) => this.NotifyPropertyChanged("IsShiftPressed");

    protected override void OnRenderSizeChanged(SizeChangedInfo sizeInfo)
    {
      Size size = sizeInfo.PreviousSize;
      double height1 = size.Height;
      size = sizeInfo.PreviousSize;
      double width1 = size.Width;
      int num1 = height1 > width1 ? 1 : 0;
      size = sizeInfo.NewSize;
      double height2 = size.Height;
      size = sizeInfo.NewSize;
      double width2 = size.Width;
      int num2 = height2 > width2 ? 1 : 0;
      if (num1 != num2)
        this.NotifyPropertyChanged("UseVerticalOrientation");
      base.OnRenderSizeChanged(sizeInfo);
    }

    private void LocationDetails_Opened(object sender, EventArgs e) => this.BadgeDetails.IsOpen = false;

    private void LocationDetails_Closed(object sender, EventArgs e) => this.LocationDetails.IsOpen = false;

    private void BadgeDetails_Closed(object sender, EventArgs e) => this.BadgeDetails.IsOpen = false;

    public FrameworkElement DetailsTarget
    {
      get => this.mDetailsTarget;
      set
      {
        if (!this.SetProperty<FrameworkElement>(ref this.mDetailsTarget, value, nameof (DetailsTarget)) && this.LocationDetails.IsOpen || this.DetailsTarget == null)
          return;
        this.LocationDetails.IsOpen = false;
        this.LocationDetails.IsOpen = true;
      }
    }

    public Location DetailsLocation
    {
      get => this.mDetailsLocation;
      set => this.SetProperty<Location>(ref this.mDetailsLocation, value, nameof (DetailsLocation));
    }

    public FrameworkElement BadgesTarget
    {
      get => this.mBadgesTarget;
      set
      {
        if (!this.SetProperty<FrameworkElement>(ref this.mBadgesTarget, value, nameof (BadgesTarget)))
          return;
        if (this.BadgesTarget != null)
        {
          this.BadgeDetails.IsOpen = false;
          this.BadgeDetails.IsOpen = true;
        }
        else
          this.BadgeDetails.IsOpen = false;
      }
    }

    public Location BadgesLocation
    {
      get => this.mBadgesLocation;
      set => this.SetProperty<Location>(ref this.mBadgesLocation, value, nameof (BadgesLocation));
    }

    public IReadOnlyList<ImageReference> BadgeImages => (IReadOnlyList<ImageReference>) this.mBadgeImages;

    private void CollectBadgeImages(Location location)
    {
      this.mBadgeImages.Clear();
      if (location == null)
        return;
      foreach (ImageReference badge in location.Badges)
        this.mBadgeImages.Add(badge);
      HashSet<ITrackableItem> trackableItemSet = new HashSet<ITrackableItem>();
      foreach (Section section in location.Sections)
      {
        if (section.CapturedItem != null && !trackableItemSet.Contains(section.CapturedItem))
          trackableItemSet.Add(section.CapturedItem);
      }
      foreach (Note note in location.NoteTakingSite.Notes)
      {
        if (note is IItemCollection itemCollection)
        {
          foreach (ITrackableItem trackableItem in itemCollection.Items)
          {
            if (!trackableItemSet.Contains(trackableItem))
              trackableItemSet.Add(trackableItem);
          }
        }
      }
      foreach (ITrackableItem trackableItem in trackableItemSet)
      {
        if (trackableItem.PotentialIcon != null)
          this.mBadgeImages.Add(trackableItem.PotentialIcon);
      }
    }

    private FrameworkElement FindDataContextRoot(FrameworkElement element)
    {
      if (element != null)
      {
        object dataContext = element.DataContext;
        while (element.Parent is FrameworkElement && (element.Parent as FrameworkElement).DataContext == dataContext)
          element = element.Parent as FrameworkElement;
      }
      return element;
    }

    public bool UseVerticalOrientation => this.ActualHeight > this.ActualWidth;

    public bool IsShiftPressed => Keyboard.Modifiers.HasFlag((Enum) ModifierKeys.Shift) && !(Keyboard.FocusedElement is TextBox) && this.IsMouseOver;

    protected override void OnPreviewMouseMove(MouseEventArgs e)
    {
      if (e.MouseDevice.DirectlyOver is FrameworkElement directlyOver)
      {
        if (directlyOver.DataContext is MapLocation dataContext && !this.LocationDetails.IsOpen)
        {
          if (dataContext.Location != this.BadgesLocation || this.BadgesTarget == null)
          {
            this.CollectBadgeImages(dataContext.Location);
            if (this.mBadgeImages.Count > 0)
            {
              FrameworkElement dataContextRoot = this.FindDataContextRoot(directlyOver);
              this.BadgesLocation = dataContext.Location;
              this.BadgesTarget = dataContextRoot;
            }
          }
        }
        else
          this.BadgesTarget = (FrameworkElement) null;
      }
      base.OnPreviewMouseMove(e);
    }

    protected override void OnMouseMove(MouseEventArgs e)
    {
      this.NotifyPropertyChanged("IsShiftPressed");
      base.OnMouseMove(e);
    }

    protected override void OnPreviewMouseLeftButtonDown(MouseButtonEventArgs e)
    {
      if (e.MouseDevice.DirectlyOver is FrameworkElement directlyOver && directlyOver.DataContext is MapLocation dataContext)
      {
        this.DetailsLocation = dataContext.Location;
        this.DetailsTarget = directlyOver;
        e.Handled = true;
      }
      base.OnPreviewMouseLeftButtonDown(e);
    }

    protected override void OnPreviewMouseDoubleClick(MouseButtonEventArgs e)
    {
      if (e.ChangedButton == MouseButton.Left && e.MouseDevice.DirectlyOver is FrameworkElement directlyOver && directlyOver.DataContext is MapLocation dataContext && dataContext.Location != null)
      {
        dataContext.Location.Pinned = true;
        e.Handled = true;
      }
      else
        base.OnPreviewMouseDoubleClick(e);
    }

    protected override void OnPreviewMouseRightButtonDown(MouseButtonEventArgs e)
    {
      if (e.MouseDevice.DirectlyOver is FrameworkElement directlyOver && directlyOver.DataContext is MapLocation dataContext && !Keyboard.Modifiers.HasFlag((Enum) ModifierKeys.Shift))
      {
        using (TransactionProcessor.Current.OpenTransaction())
        {
          dataContext.Location.FullClearAllPossible();
          dataContext.Location.ModifiedByUser = true;
          e.Handled = true;
        }
      }
      base.OnPreviewMouseRightButtonDown(e);
    }
  }
}
