﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.UI.OverrideExportDialog
// Assembly: EmoTracker, Version=2.3.8.17, Culture=neutral, PublicKeyToken=null
// MVID: 0D1A2596-8086-4DA5-90AE-09EB4913AFBC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.exe

using EmoTracker.Core;
using EmoTracker.Data;
using EmoTracker.UI.Media.Utility;
using System;
using System.CodeDom.Compiler;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Media.Effects;

namespace EmoTracker.UI
{
  public partial class OverrideExportDialog : Window, IComponentConnector
  {
    private List<OverrideExportDialog.FileRecord> mFileRecords;
    private ListCollectionView mFileRecordsView;
    private string mFilterText;

    public CollectionView Records => (CollectionView) this.mFileRecordsView;

    public string FilterText
    {
      get => this.mFilterText;
      set
      {
        this.mFilterText = value;
        this.mFileRecordsView.Refresh();
      }
    }

    public OverrideExportDialog()
    {
      this.mFileRecords = new List<OverrideExportDialog.FileRecord>();
      if (ObservableSingleton<Tracker>.Instance.ActiveGamePackage != null)
      {
        DropShadowEffect dropShadowEffect = new DropShadowEffect()
        {
          ShadowDepth = 0.0,
          BlurRadius = 10.0
        };
        SolidColorBrush solidColorBrush = new SolidColorBrush(Colors.Gray);
        foreach (string file in ObservableSingleton<Tracker>.Instance.ActiveGamePackage.Source.Files)
        {
          FrameworkElement frameworkElement1 = (FrameworkElement) null;
          FrameworkElement frameworkElement2 = (FrameworkElement) null;
          ImageSource image = IconUtility.GetImage(ObservableSingleton<Tracker>.Instance.ActiveGamePackage.Open(file, true, true));
          bool flag = image != null;
          if (image == null)
            image = IconUtility.GetImage(new Uri(string.Format("pack://application:,,,/EmoTracker;component/Resources/filetype_{0}.png", (object) Path.GetExtension(file).TrimStart('.').ToLower())));
          if (image != null)
          {
            frameworkElement1 = (FrameworkElement) new Image()
            {
              Source = image
            };
            if (flag)
            {
              Grid grid = new Grid();
              grid.Children.Add((UIElement) new Image()
              {
                Source = image
              });
              ToolTip toolTip = new ToolTip();
              toolTip.Effect = (Effect) dropShadowEffect;
              toolTip.Background = (Brush) solidColorBrush;
              toolTip.BorderBrush = (Brush) null;
              toolTip.Content = (object) grid;
              frameworkElement2 = (FrameworkElement) toolTip;
            }
          }
          this.mFileRecords.Add(new OverrideExportDialog.FileRecord(file)
          {
            Preview = frameworkElement1,
            ToolTip = frameworkElement2
          });
        }
      }
      this.mFileRecordsView = new ListCollectionView((IList) this.mFileRecords);
      this.mFileRecordsView.Filter = new Predicate<object>(this.FilterFunc);
      this.InitializeComponent();
      this.DataContext = (object) this;
    }

    private bool FilterFunc(object obj) => string.IsNullOrWhiteSpace(this.FilterText) || !(obj is OverrideExportDialog.FileRecord fileRecord) || fileRecord.Path.ToLower().Contains(this.FilterText.ToLower());

    private void ExportOverridesButton_Click(object sender, RoutedEventArgs e)
    {
      foreach (OverrideExportDialog.FileRecord mFileRecord in this.mFileRecords)
      {
        if (mFileRecord.ExportOverride)
        {
          ObservableSingleton<Tracker>.Instance.ActiveGamePackage.ExportUserOverride(mFileRecord.Path);
          this.Close();
        }
      }
    }

    public class FileRecord : ObservableObject
    {
      private string mPath;
      private bool mbExportOverride;

      public bool ExportOverride
      {
        get => this.mbExportOverride;
        set => this.SetProperty<bool>(ref this.mbExportOverride, value, nameof (ExportOverride));
      }

      public string Path => this.mPath;

      public FileRecord(string path) => this.mPath = path;

      public FrameworkElement Preview { get; set; }

      public FrameworkElement ToolTip { get; set; }
    }
  }
}
