﻿// Decompiled with JetBrains decompiler
// Type: EmoTracker.UI.TrackableItemControl
// Assembly: EmoTracker, Version=2.3.8.17, Culture=neutral, PublicKeyToken=null
// MVID: 0D1A2596-8086-4DA5-90AE-09EB4913AFBC
// Assembly location: C:\Program Files (x86)\EmoTracker\EmoTracker.exe

using EmoTracker.Core;
using EmoTracker.Data;
using EmoTracker.Data.Core.Transactions;
using System;
using System.CodeDom.Compiler;
using System.ComponentModel;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Markup;

namespace EmoTracker.UI
{
  public partial class TrackableItemControl : UserControl, IComponentConnector
  {
    public static readonly DependencyProperty IconWidthProperty = DependencyProperty.Register(nameof (IconWidth), typeof (double), typeof (TrackableItemControl), new PropertyMetadata((object) 32.0));
    public static readonly DependencyProperty IconHeightProperty = DependencyProperty.Register(nameof (IconHeight), typeof (double), typeof (TrackableItemControl), new PropertyMetadata((object) 32.0));
    public static readonly DependencyProperty DisplayPotentialIconProperty = DependencyProperty.RegisterAttached("DisplayPotentialIcon", typeof (bool), typeof (TrackableItemControl), (PropertyMetadata) new FrameworkPropertyMetadata((object) false, FrameworkPropertyMetadataOptions.Inherits));
    public static readonly DependencyProperty DisplayCapturableOnlyProperty = DependencyProperty.RegisterAttached("DisplayCapturableOnly", typeof (bool), typeof (TrackableItemControl), (PropertyMetadata) new FrameworkPropertyMetadata((object) false, FrameworkPropertyMetadataOptions.Inherits));
    public static readonly DependencyProperty BadgeFontSizeProperty = DependencyProperty.RegisterAttached(nameof (BadgeFontSize), typeof (double), typeof (TrackableItemControl), (PropertyMetadata) new FrameworkPropertyMetadata((object) 12.0, FrameworkPropertyMetadataOptions.Inherits));
    public static readonly DependencyProperty ClickHandlerProperty = DependencyProperty.RegisterAttached("ClickHandler", typeof (TrackableItemControl.IClickHandler), typeof (TrackableItemControl), (PropertyMetadata) new FrameworkPropertyMetadata((object) null, FrameworkPropertyMetadataOptions.Inherits));
    private TrackableItemControl.LeftClickCommand mProgressCmd;
    private TrackableItemControl.RightClickCommand mRegressCmd;

    public TrackableItemControl()
    {
      this.mProgressCmd = new TrackableItemControl.LeftClickCommand((UIElement) this);
      this.mRegressCmd = new TrackableItemControl.RightClickCommand((UIElement) this);
      this.InitializeComponent();
    }

    public double IconWidth
    {
      get => (double) this.GetValue(TrackableItemControl.IconWidthProperty);
      set => this.SetValue(TrackableItemControl.IconWidthProperty, (object) value);
    }

    public double IconHeight
    {
      get => (double) this.GetValue(TrackableItemControl.IconHeightProperty);
      set => this.SetValue(TrackableItemControl.IconHeightProperty, (object) value);
    }

    public static bool GetDisplayPotentialIcon(DependencyObject obj) => (bool) obj.GetValue(TrackableItemControl.DisplayPotentialIconProperty);

    public static void SetDisplayPotentialIcon(DependencyObject obj, bool value) => obj.SetValue(TrackableItemControl.DisplayPotentialIconProperty, (object) value);

    public static bool GetDisplayCapturableOnly(DependencyObject obj) => (bool) obj.GetValue(TrackableItemControl.DisplayCapturableOnlyProperty);

    public static void SetDisplayCapturableOnly(DependencyObject obj, bool value) => obj.SetValue(TrackableItemControl.DisplayCapturableOnlyProperty, (object) value);

    public double BadgeFontSize
    {
      get => (double) this.GetValue(TrackableItemControl.BadgeFontSizeProperty);
      set => this.SetValue(TrackableItemControl.BadgeFontSizeProperty, (object) value);
    }

    public static TrackableItemControl.IClickHandler GetClickHandler(
      DependencyObject obj)
    {
      return (TrackableItemControl.IClickHandler) obj.GetValue(TrackableItemControl.ClickHandlerProperty);
    }

    public static void SetClickHandler(
      DependencyObject obj,
      TrackableItemControl.IClickHandler value)
    {
      obj.SetValue(TrackableItemControl.ClickHandlerProperty, (object) value);
    }

    public ICommand OnLeftClickCommand => (ICommand) this.mProgressCmd;

    public ICommand OnRightClickCommand => (ICommand) this.mRegressCmd;

    public interface IClickHandler
    {
      bool OnLeftClick(ITrackableItem item);

      bool OnRightClick(ITrackableItem item);
    }

    private class LeftClickCommand : ICommand
    {
      private UIElement mOwner;

      public LeftClickCommand(UIElement owner) => this.mOwner = owner;

      public event EventHandler CanExecuteChanged;

      public void NotifyCanExecutedChanged()
      {
        if (this.CanExecuteChanged == null)
          return;
        this.CanExecuteChanged((object) this, EventArgs.Empty);
      }

      public bool CanExecute(object parameter) => true;

      public void Execute(object parameter)
      {
        try
        {
          ObservableSingleton<LocationDatabase>.Instance.SuspendRefresh = true;
          if (!(parameter is ITrackableItem trackableItem))
            return;
          TrackableItemControl.IClickHandler clickHandler = TrackableItemControl.GetClickHandler((DependencyObject) this.mOwner);
          if (clickHandler != null && clickHandler.OnLeftClick(trackableItem) || trackableItem.IgnoreUserInput)
            return;
          using (TransactionProcessor.Current.OpenTransaction())
            trackableItem.OnLeftClick();
        }
        finally
        {
          ObservableSingleton<LocationDatabase>.Instance.SuspendRefresh = false;
        }
      }
    }

    private class RightClickCommand : ICommand
    {
      private UIElement mOwner;

      public RightClickCommand(UIElement owner) => this.mOwner = owner;

      public event EventHandler CanExecuteChanged;

      public void NotifyCanExecutedChanged()
      {
        if (this.CanExecuteChanged == null)
          return;
        this.CanExecuteChanged((object) this, EventArgs.Empty);
      }

      public bool CanExecute(object parameter) => true;

      public void Execute(object parameter)
      {
        try
        {
          ObservableSingleton<LocationDatabase>.Instance.SuspendRefresh = true;
          if (!(parameter is ITrackableItem trackableItem))
            return;
          TrackableItemControl.IClickHandler clickHandler = TrackableItemControl.GetClickHandler((DependencyObject) this.mOwner);
          if (clickHandler != null && clickHandler.OnRightClick(trackableItem) || trackableItem.IgnoreUserInput)
            return;
          using (TransactionProcessor.Current.OpenTransaction())
            trackableItem.OnRightClick();
        }
        finally
        {
          ObservableSingleton<LocationDatabase>.Instance.SuspendRefresh = false;
        }
      }
    }
  }
}
