﻿// Decompiled with JetBrains decompiler
// Type: NewTek.NDI.AudioFrame
// Assembly: NDILibDotNet2, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: A7218F26-32E7-4B46-B496-253D3CB5BE4C
// Assembly location: C:\Program Files (x86)\EmoTracker\NDILibDotNet2.dll

using System;
using System.Runtime.InteropServices;
using System.Xml.Linq;

namespace NewTek.NDI
{
  public class AudioFrame : IDisposable
  {
    internal NDIlib.audio_frame_v2_t _ndiAudioFrame;
    private bool _memoryOwned;

    public AudioFrame(int maxSamples, int sampleRate, int numChannels)
    {
      this._memoryOwned = true;
      IntPtr num = Marshal.AllocHGlobal(numChannels * maxSamples * 4);
      this._ndiAudioFrame = new NDIlib.audio_frame_v2_t()
      {
        sample_rate = sampleRate,
        no_channels = numChannels,
        no_samples = maxSamples,
        timecode = NDIlib.send_timecode_synthesize,
        p_data = num,
        channel_stride_in_bytes = 4 * maxSamples,
        p_metadata = IntPtr.Zero,
        timestamp = 0L
      };
    }

    public AudioFrame(
      IntPtr bufferPtr,
      int sampleRate,
      int numChannels,
      int channelStride,
      int numSamples)
    {
      this._ndiAudioFrame = new NDIlib.audio_frame_v2_t()
      {
        sample_rate = 48000,
        no_channels = 2,
        no_samples = 1602,
        timecode = NDIlib.send_timecode_synthesize,
        p_data = bufferPtr,
        channel_stride_in_bytes = channelStride,
        p_metadata = IntPtr.Zero,
        timestamp = 0L
      };
    }

    public IntPtr AudioBuffer => this._ndiAudioFrame.p_data;

    public int NumSamples
    {
      get => this._ndiAudioFrame.no_samples;
      set => this._ndiAudioFrame.no_samples = value;
    }

    public int NumChannels
    {
      get => this._ndiAudioFrame.no_channels;
      set => this._ndiAudioFrame.no_channels = value;
    }

    public int ChannelStride
    {
      get => this._ndiAudioFrame.channel_stride_in_bytes;
      set => this._ndiAudioFrame.channel_stride_in_bytes = value;
    }

    public int SampleRate
    {
      get => this._ndiAudioFrame.sample_rate;
      set => this._ndiAudioFrame.sample_rate = value;
    }

    public long TimeStamp
    {
      get => this._ndiAudioFrame.timestamp;
      set => this._ndiAudioFrame.timestamp = value;
    }

    public XElement MetaData
    {
      get
      {
        if (this._ndiAudioFrame.p_metadata == IntPtr.Zero)
          return (XElement) null;
        string text = UTF.Utf8ToString(this._ndiAudioFrame.p_metadata);
        return string.IsNullOrEmpty(text) ? (XElement) null : XElement.Parse(text);
      }
    }

    public void Dispose()
    {
      this.Dispose(true);
      GC.SuppressFinalize((object) this);
    }

    ~AudioFrame() => this.Dispose(false);

    protected virtual void Dispose(bool disposing)
    {
      if (!disposing)
        return;
      if (this._memoryOwned && this._ndiAudioFrame.p_data != IntPtr.Zero)
      {
        Marshal.FreeHGlobal(this._ndiAudioFrame.p_data);
        this._ndiAudioFrame.p_data = IntPtr.Zero;
      }
      NDIlib.destroy();
    }
  }
}
