﻿// Decompiled with JetBrains decompiler
// Type: NewTek.NDI.Finder
// Assembly: NDILibDotNet2, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: A7218F26-32E7-4B46-B496-253D3CB5BE4C
// Assembly location: C:\Program Files (x86)\EmoTracker\NDILibDotNet2.dll

using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Windows.Data;

namespace NewTek.NDI
{
  public class Finder : IDisposable
  {
    private bool _disposed;
    private IntPtr _findInstancePtr = IntPtr.Zero;
    private ObservableCollection<Source> _sourceList = new ObservableCollection<Source>();
    private object _sourceLock = new object();
    private Thread _findThread;
    private bool _exitThread;

    public ObservableCollection<Source> Sources => this._sourceList;

    public Finder(bool showLocalSources = false, string[] groups = null, string[] extraIps = null)
    {
      if (!NDIlib.initialize())
      {
        if (!NDIlib.is_supported_CPU())
          throw new InvalidOperationException("CPU incompatible with NDI.");
        throw new InvalidOperationException("Unable to initialize NDI.");
      }
      BindingOperations.EnableCollectionSynchronization((IEnumerable) this._sourceList, this._sourceLock);
      IntPtr hglobal1 = IntPtr.Zero;
      if (groups != null)
      {
        StringBuilder stringBuilder = new StringBuilder();
        foreach (string group in groups)
        {
          stringBuilder.Append(group);
          if (group != ((IEnumerable<string>) groups).Last<string>())
            stringBuilder.Append(',');
        }
        hglobal1 = UTF.StringToUtf8(stringBuilder.ToString());
      }
      IntPtr hglobal2 = IntPtr.Zero;
      if (extraIps != null)
      {
        StringBuilder stringBuilder = new StringBuilder();
        foreach (string extraIp in extraIps)
        {
          stringBuilder.Append(extraIp);
          if (extraIp != ((IEnumerable<string>) groups).Last<string>())
            stringBuilder.Append(',');
        }
        hglobal2 = UTF.StringToUtf8(stringBuilder.ToString());
      }
      NDIlib.find_create_t p_create_settings = new NDIlib.find_create_t()
      {
        p_groups = hglobal1,
        show_local_sources = showLocalSources,
        p_extra_ips = hglobal2
      };
      this._findInstancePtr = NDIlib.find_create_v2(ref p_create_settings);
      if (hglobal1 != IntPtr.Zero)
        Marshal.FreeHGlobal(hglobal1);
      if (hglobal2 != IntPtr.Zero)
        Marshal.FreeHGlobal(hglobal2);
      this._findThread = new Thread(new ThreadStart(this.FindThreadProc))
      {
        IsBackground = true,
        Name = "NdiFindThread"
      };
      this._findThread.Start();
    }

    public void Dispose()
    {
      this.Dispose(true);
      GC.SuppressFinalize((object) this);
    }

    ~Finder() => this.Dispose(false);

    protected virtual void Dispose(bool disposing)
    {
      if (this._disposed)
        return;
      if (disposing)
      {
        this._exitThread = true;
        if (this._findThread != null)
        {
          this._findThread.Join();
          this._findThread = (Thread) null;
        }
      }
      if (this._findInstancePtr != IntPtr.Zero)
      {
        NDIlib.find_destroy(this._findInstancePtr);
        this._findInstancePtr = IntPtr.Zero;
      }
      NDIlib.destroy();
      this._disposed = true;
    }

    private void FindThreadProc()
    {
      int num = Marshal.SizeOf(typeof (NDIlib.source_t));
      while (!this._exitThread)
      {
        if (NDIlib.find_wait_for_sources(this._findInstancePtr, 500U))
        {
          uint p_no_sources = 0;
          IntPtr getCurrentSources = NDIlib.find_get_current_sources(this._findInstancePtr, ref p_no_sources);
          for (int index = 0; (long) index < (long) p_no_sources; ++index)
          {
            NDIlib.source_t structure = (NDIlib.source_t) Marshal.PtrToStructure(IntPtr.Add(getCurrentSources, index * num), typeof (NDIlib.source_t));
            string name = UTF.Utf8ToString(structure.p_ndi_name);
            if (!this._sourceList.Any<Source>((Func<Source, bool>) (item => item.Name == name)))
              this._sourceList.Add(new Source(structure));
          }
        }
      }
    }
  }
}
