﻿// Decompiled with JetBrains decompiler
// Type: NewTek.NDI.ImageProcessing
// Assembly: NDILibDotNet2, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: A7218F26-32E7-4B46-B496-253D3CB5BE4C
// Assembly location: C:\Program Files (x86)\EmoTracker\NDILibDotNet2.dll

using System;

namespace NewTek.NDI
{
  public static class ImageProcessing
  {
    private static readonly int[] MulTable = new int[(int) byte.MaxValue]
    {
      512,
      512,
      456,
      512,
      328,
      456,
      335,
      512,
      405,
      328,
      271,
      456,
      388,
      335,
      292,
      512,
      454,
      405,
      364,
      328,
      298,
      271,
      496,
      456,
      420,
      388,
      360,
      335,
      312,
      292,
      273,
      512,
      482,
      454,
      428,
      405,
      383,
      364,
      345,
      328,
      312,
      298,
      284,
      271,
      259,
      496,
      475,
      456,
      437,
      420,
      404,
      388,
      374,
      360,
      347,
      335,
      323,
      312,
      302,
      292,
      282,
      273,
      265,
      512,
      497,
      482,
      468,
      454,
      441,
      428,
      417,
      405,
      394,
      383,
      373,
      364,
      354,
      345,
      337,
      328,
      320,
      312,
      305,
      298,
      291,
      284,
      278,
      271,
      265,
      259,
      507,
      496,
      485,
      475,
      465,
      456,
      446,
      437,
      428,
      420,
      412,
      404,
      396,
      388,
      381,
      374,
      367,
      360,
      354,
      347,
      341,
      335,
      329,
      323,
      318,
      312,
      307,
      302,
      297,
      292,
      287,
      282,
      278,
      273,
      269,
      265,
      261,
      512,
      505,
      497,
      489,
      482,
      475,
      468,
      461,
      454,
      447,
      441,
      435,
      428,
      422,
      417,
      411,
      405,
      399,
      394,
      389,
      383,
      378,
      373,
      368,
      364,
      359,
      354,
      350,
      345,
      341,
      337,
      332,
      328,
      324,
      320,
      316,
      312,
      309,
      305,
      301,
      298,
      294,
      291,
      287,
      284,
      281,
      278,
      274,
      271,
      268,
      265,
      262,
      259,
      257,
      507,
      501,
      496,
      491,
      485,
      480,
      475,
      470,
      465,
      460,
      456,
      451,
      446,
      442,
      437,
      433,
      428,
      424,
      420,
      416,
      412,
      408,
      404,
      400,
      396,
      392,
      388,
      385,
      381,
      377,
      374,
      370,
      367,
      363,
      360,
      357,
      354,
      350,
      347,
      344,
      341,
      338,
      335,
      332,
      329,
      326,
      323,
      320,
      318,
      315,
      312,
      310,
      307,
      304,
      302,
      299,
      297,
      294,
      292,
      289,
      287,
      285,
      282,
      280,
      278,
      275,
      273,
      271,
      269,
      267,
      265,
      263,
      261,
      259
    };
    private static readonly int[] ShgTable = new int[(int) byte.MaxValue]
    {
      9,
      11,
      12,
      13,
      13,
      14,
      14,
      15,
      15,
      15,
      15,
      16,
      16,
      16,
      16,
      17,
      17,
      17,
      17,
      17,
      17,
      17,
      18,
      18,
      18,
      18,
      18,
      18,
      18,
      18,
      18,
      19,
      19,
      19,
      19,
      19,
      19,
      19,
      19,
      19,
      19,
      19,
      19,
      19,
      19,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      20,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      21,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      22,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      23,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24,
      24
    };

    public static void Blur(byte[] pixels, int width, int height, int radius)
    {
      int num1 = radius + radius + 1;
      int num2 = width - 1;
      int num3 = height - 1;
      int num4 = radius + 1;
      int num5 = num4 * (num4 + 1) / 2;
      BlurStack blurStack1 = new BlurStack();
      BlurStack blurStack2 = blurStack1;
      BlurStack blurStack3 = blurStack1;
      for (int index = 1; index < num1; ++index)
      {
        blurStack1 = blurStack1.Next = new BlurStack();
        if (index == num4)
          blurStack3 = blurStack1;
      }
      blurStack1.Next = blurStack2;
      int num6 = 0;
      int index1 = 0;
      int num7 = ImageProcessing.MulTable[radius];
      int num8 = ImageProcessing.ShgTable[radius];
      for (int index2 = 0; index2 < height; ++index2)
      {
        int num9 = 0;
        int num10 = 0;
        int num11 = 0;
        int num12 = 0;
        int num13 = 0;
        int num14 = 0;
        int num15 = 0;
        int num16 = 0;
        byte pixel1 = pixels[index1];
        byte pixel2 = pixels[index1 + 1];
        byte pixel3 = pixels[index1 + 2];
        byte pixel4 = pixels[index1 + 3];
        int num17 = num4 * (int) pixel1;
        int num18 = num4 * (int) pixel2;
        int num19 = num4 * (int) pixel3;
        int num20 = num4 * (int) pixel4;
        int num21 = num13 + num5 * (int) pixel1;
        int num22 = num14 + num5 * (int) pixel2;
        int num23 = num15 + num5 * (int) pixel3;
        int num24 = num16 + num5 * (int) pixel4;
        BlurStack blurStack4 = blurStack2;
        for (int index3 = 0; index3 < num4; ++index3)
        {
          blurStack4.R = pixel1;
          blurStack4.G = pixel2;
          blurStack4.B = pixel3;
          blurStack4.A = pixel4;
          blurStack4 = blurStack4.Next;
        }
        for (int index4 = 1; index4 < num4; ++index4)
        {
          int index5 = index1 + ((num2 < index4 ? num2 : index4) << 2);
          int num25 = num4 - index4;
          int num26 = num21;
          BlurStack blurStack5 = blurStack4;
          int pixel5;
          byte num27 = (byte) (pixel5 = (int) pixels[index5]);
          byte num28 = (byte) pixel5;
          blurStack5.R = (byte) pixel5;
          int num29 = (int) num28 * num25;
          num21 = num26 + num29;
          int num30 = num22;
          BlurStack blurStack6 = blurStack4;
          int pixel6;
          byte num31 = (byte) (pixel6 = (int) pixels[index5 + 1]);
          byte num32 = (byte) pixel6;
          blurStack6.G = (byte) pixel6;
          int num33 = (int) num32 * num25;
          num22 = num30 + num33;
          int num34 = num23;
          BlurStack blurStack7 = blurStack4;
          int pixel7;
          byte num35 = (byte) (pixel7 = (int) pixels[index5 + 2]);
          byte num36 = (byte) pixel7;
          blurStack7.B = (byte) pixel7;
          int num37 = (int) num36 * num25;
          num23 = num34 + num37;
          int num38 = num24;
          BlurStack blurStack8 = blurStack4;
          int pixel8;
          byte num39 = (byte) (pixel8 = (int) pixels[index5 + 3]);
          byte num40 = (byte) pixel8;
          blurStack8.A = (byte) pixel8;
          int num41 = (int) num40 * num25;
          num24 = num38 + num41;
          num9 += (int) num27;
          num10 += (int) num31;
          num11 += (int) num35;
          num12 += (int) num39;
          blurStack4 = blurStack4.Next;
        }
        BlurStack blurStack9 = blurStack2;
        BlurStack blurStack10 = blurStack3;
        for (int index6 = 0; index6 < width; ++index6)
        {
          byte num42 = (byte) (num24 * num7 >> num8);
          pixels[index1 + 3] = num42;
          if (num42 != (byte) 0)
          {
            byte num43 = (byte) ((uint) byte.MaxValue / (uint) num42);
            pixels[index1] = (byte) ((uint) (num21 * num7 >> num8) * (uint) num43);
            pixels[index1 + 1] = (byte) ((uint) (num22 * num7 >> num8) * (uint) num43);
            pixels[index1 + 2] = (byte) ((uint) (num23 * num7 >> num8) * (uint) num43);
          }
          else
            pixels[index1] = pixels[index1 + 1] = pixels[index1 + 2] = (byte) 0;
          int num44 = num21 - num17;
          int num45 = num22 - num18;
          int num46 = num23 - num19;
          int num47 = num24 - num20;
          int num48 = num17 - (int) blurStack9.R;
          int num49 = num18 - (int) blurStack9.G;
          int num50 = num19 - (int) blurStack9.B;
          int num51 = num20 - (int) blurStack9.A;
          int num52 = index6 + radius + 1;
          int index7 = num6 + (num52 < num2 ? num52 : num2) << 2;
          int num53 = num9 + (int) (blurStack9.R = pixels[index7]);
          int num54 = num10 + (int) (blurStack9.G = pixels[index7 + 1]);
          int num55 = num11 + (int) (blurStack9.B = pixels[index7 + 2]);
          int num56 = num12 + (int) (blurStack9.A = pixels[index7 + 3]);
          num21 = num44 + num53;
          num22 = num45 + num54;
          num23 = num46 + num55;
          num24 = num47 + num56;
          blurStack9 = blurStack9.Next;
          byte r;
          num17 = num48 + (int) (r = blurStack10.R);
          byte g;
          num18 = num49 + (int) (g = blurStack10.G);
          byte b;
          num19 = num50 + (int) (b = blurStack10.B);
          byte a;
          num20 = num51 + (int) (a = blurStack10.A);
          num9 = num53 - (int) r;
          num10 = num54 - (int) g;
          num11 = num55 - (int) b;
          num12 = num56 - (int) a;
          blurStack10 = blurStack10.Next;
          index1 += 4;
        }
        num6 += width;
      }
      for (int index8 = 0; index8 < width; ++index8)
      {
        int num57 = 0;
        int num58 = 0;
        int num59 = 0;
        int num60 = 0;
        int num61 = 0;
        int num62 = 0;
        int num63 = 0;
        int num64 = 0;
        int index9 = index8 << 2;
        byte pixel9 = pixels[index9];
        byte pixel10 = pixels[index9 + 1];
        byte pixel11 = pixels[index9 + 2];
        byte pixel12 = pixels[index9 + 3];
        int num65 = num4 * (int) pixel9;
        int num66 = num4 * (int) pixel10;
        int num67 = num4 * (int) pixel11;
        int num68 = num4 * (int) pixel12;
        int num69 = num61 + num5 * (int) pixel9;
        int num70 = num62 + num5 * (int) pixel10;
        int num71 = num63 + num5 * (int) pixel11;
        int num72 = num64 + num5 * (int) pixel12;
        BlurStack blurStack11 = blurStack2;
        for (int index10 = 0; index10 < num4; ++index10)
        {
          blurStack11.R = pixel9;
          blurStack11.G = pixel10;
          blurStack11.B = pixel11;
          blurStack11.A = pixel12;
          blurStack11 = blurStack11.Next;
        }
        int num73 = width;
        for (int index11 = 1; index11 <= radius; ++index11)
        {
          int index12 = num73 + index8 << 2;
          int num74 = num4 - index11;
          int num75 = num69;
          BlurStack blurStack12 = blurStack11;
          int pixel13;
          byte num76 = (byte) (pixel13 = (int) pixels[index12]);
          byte num77 = (byte) pixel13;
          blurStack12.R = (byte) pixel13;
          int num78 = (int) num77 * num74;
          num69 = num75 + num78;
          int num79 = num70;
          BlurStack blurStack13 = blurStack11;
          int pixel14;
          byte num80 = (byte) (pixel14 = (int) pixels[index12 + 1]);
          byte num81 = (byte) pixel14;
          blurStack13.G = (byte) pixel14;
          int num82 = (int) num81 * num74;
          num70 = num79 + num82;
          int num83 = num71;
          BlurStack blurStack14 = blurStack11;
          int pixel15;
          byte num84 = (byte) (pixel15 = (int) pixels[index12 + 2]);
          byte num85 = (byte) pixel15;
          blurStack14.B = (byte) pixel15;
          int num86 = (int) num85 * num74;
          num71 = num83 + num86;
          int num87 = num72;
          BlurStack blurStack15 = blurStack11;
          int pixel16;
          byte num88 = (byte) (pixel16 = (int) pixels[index12 + 3]);
          byte num89 = (byte) pixel16;
          blurStack15.A = (byte) pixel16;
          int num90 = (int) num89 * num74;
          num72 = num87 + num90;
          num57 += (int) num76;
          num58 += (int) num80;
          num59 += (int) num84;
          num60 += (int) num88;
          blurStack11 = blurStack11.Next;
          if (index11 < num3)
            num73 += width;
        }
        int num91 = index8;
        BlurStack blurStack16 = blurStack2;
        BlurStack blurStack17 = blurStack3;
        for (int index13 = 0; index13 < height; ++index13)
        {
          int index14 = num91 << 2;
          byte num92 = (byte) (num72 * num7 >> num8);
          pixels[index14 + 3] = num92;
          if (num92 > (byte) 0)
          {
            byte num93 = (byte) ((uint) byte.MaxValue / (uint) num92);
            pixels[index14] = (byte) ((uint) (num69 * num7 >> num8) * (uint) num93);
            pixels[index14 + 1] = (byte) ((uint) (num70 * num7 >> num8) * (uint) num93);
            pixels[index14 + 2] = (byte) ((uint) (num71 * num7 >> num8) * (uint) num93);
          }
          else
            pixels[index14] = pixels[index14 + 1] = pixels[index14 + 2] = (byte) 0;
          int num94 = num69 - num65;
          int num95 = num70 - num66;
          int num96 = num71 - num67;
          int num97 = num72 - num68;
          int num98 = num65 - (int) blurStack16.R;
          int num99 = num66 - (int) blurStack16.G;
          int num100 = num67 - (int) blurStack16.B;
          int num101 = num68 - (int) blurStack16.A;
          int num102;
          int index15 = index8 + ((num102 = index13 + num4) < num3 ? num102 : num3) * width << 2;
          int num103;
          num69 = num94 + (num103 = num57 + (int) (blurStack16.R = pixels[index15]));
          int num104;
          num70 = num95 + (num104 = num58 + (int) (blurStack16.G = pixels[index15 + 1]));
          int num105;
          num71 = num96 + (num105 = num59 + (int) (blurStack16.B = pixels[index15 + 2]));
          int num106;
          num72 = num97 + (num106 = num60 + (int) (blurStack16.A = pixels[index15 + 3]));
          blurStack16 = blurStack16.Next;
          byte r;
          num65 = num98 + (int) (r = blurStack17.R);
          byte g;
          num66 = num99 + (int) (g = blurStack17.G);
          byte b;
          num67 = num100 + (int) (b = blurStack17.B);
          byte a;
          num68 = num101 + (int) (a = blurStack17.A);
          num57 = num103 - (int) r;
          num58 = num104 - (int) g;
          num59 = num105 - (int) b;
          num60 = num106 - (int) a;
          blurStack17 = blurStack17.Next;
          num91 += width;
        }
      }
    }

    public static void ApplyOverlayImage(
      byte[] pixels,
      int width,
      int height,
      int stride,
      byte[] overlayBuffer)
    {
      if (pixels == null || overlayBuffer == null || overlayBuffer.Length != pixels.Length)
        return;
      for (int index1 = 0; index1 < height; ++index1)
      {
        for (int index2 = 0; index2 < width; ++index2)
        {
          int index3 = index1 * stride + index2 * 4;
          byte pixel1 = pixels[index3];
          byte pixel2 = pixels[index3 + 1];
          byte pixel3 = pixels[index3 + 2];
          byte pixel4 = pixels[index3 + 3];
          int num1 = (int) overlayBuffer[index3];
          byte num2 = overlayBuffer[index3 + 1];
          byte num3 = overlayBuffer[index3 + 2];
          byte val2 = overlayBuffer[index3 + 3];
          float num4 = (float) val2 / (float) byte.MaxValue;
          float num5 = 1f - num4;
          byte num6 = (byte) Math.Min(Math.Max((uint) ((double) (uint) num1 * (double) num4 + (double) pixel1 * (double) num5), 0U), (uint) byte.MaxValue);
          byte num7 = (byte) Math.Min(Math.Max((uint) ((double) num2 * (double) num4 + (double) pixel2 * (double) num5), 0U), (uint) byte.MaxValue);
          byte num8 = (byte) Math.Min(Math.Max((uint) ((double) num3 * (double) num4 + (double) pixel3 * (double) num5), 0U), (uint) byte.MaxValue);
          pixels[index3] = num6;
          pixels[index3 + 1] = num7;
          pixels[index3 + 2] = num8;
          pixels[index3 + 3] = Math.Max(pixel4, val2);
        }
      }
    }

    public static byte[] FastDropShadow(byte[] buffer, int width, int height, int stride)
    {
      if (buffer == null)
        return (byte[]) null;
      byte[] overlayBuffer = new byte[buffer.Length];
      buffer.CopyTo((Array) overlayBuffer, 0);
      for (int index1 = 0; index1 < height; ++index1)
      {
        for (int index2 = 0; index2 < width; ++index2)
        {
          int index3 = index1 * stride + index2 * 4;
          buffer[index3] = (byte) 0;
          buffer[index3 + 1] = (byte) 0;
          buffer[index3 + 2] = (byte) 0;
          buffer[index3 + 3] = buffer[index3 + 3] <= (byte) 10 ? (byte) 0 : byte.MaxValue;
        }
      }
      ImageProcessing.Blur(buffer, width, height, 10);
      ImageProcessing.ApplyOverlayImage(buffer, width, height, stride, overlayBuffer);
      return buffer;
    }

    public static byte[] ScaleBuffer(
      byte[] buffer,
      int width,
      int height,
      int stride,
      int scalar)
    {
      if (scalar < 1)
        return buffer;
      int num1 = width * scalar;
      int num2 = height * scalar;
      int num3 = stride * scalar;
      byte[] numArray = new byte[num1 * num2 * 4];
      for (int index1 = 0; index1 < num2; ++index1)
      {
        for (int index2 = 0; index2 < num1; ++index2)
        {
          int index3 = index1 * num3 + index2 * 4;
          int index4 = index1 / scalar * stride + index2 / scalar * 4;
          numArray[index3] = buffer[index4];
          numArray[index3 + 1] = buffer[index4 + 1];
          numArray[index3 + 2] = buffer[index4 + 2];
          numArray[index3 + 3] = buffer[index4 + 3];
        }
      }
      return numArray;
    }
  }
}
