﻿// Decompiled with JetBrains decompiler
// Type: NewTek.NDI.Sender
// Assembly: NDILibDotNet2, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: A7218F26-32E7-4B46-B496-253D3CB5BE4C
// Assembly location: C:\Program Files (x86)\EmoTracker\NDILibDotNet2.dll

using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;

namespace NewTek.NDI
{
  public class Sender : IDisposable
  {
    private IntPtr _sendInstancePtr = IntPtr.Zero;
    private NDIlib.tally_t _ndiTally;

    public Sender(string sourceName, bool clockVideo = true, bool clockAudio = false, string[] groups = null)
    {
      if (string.IsNullOrEmpty(sourceName))
        throw new ArgumentException("sourceName can not be null or empty.", sourceName);
      if (!NDIlib.initialize())
      {
        if (!NDIlib.is_supported_CPU())
          throw new InvalidOperationException("CPU incompatible with NDI.");
        throw new InvalidOperationException("Unable to initialize NDI.");
      }
      IntPtr utf8 = UTF.StringToUtf8(sourceName);
      IntPtr hglobal = IntPtr.Zero;
      if (groups != null)
      {
        StringBuilder stringBuilder = new StringBuilder();
        foreach (string group in groups)
        {
          stringBuilder.Append(group);
          if (group != ((IEnumerable<string>) groups).Last<string>())
            stringBuilder.Append(',');
        }
        hglobal = UTF.StringToUtf8(stringBuilder.ToString());
      }
      NDIlib.send_create_t p_create_settings = new NDIlib.send_create_t()
      {
        p_ndi_name = utf8,
        p_groups = hglobal,
        clock_video = clockVideo,
        clock_audio = clockAudio
      };
      this._sendInstancePtr = NDIlib.send_create(ref p_create_settings);
      Marshal.FreeHGlobal(utf8);
      Marshal.FreeHGlobal(hglobal);
      if (this._sendInstancePtr == IntPtr.Zero)
        throw new InvalidOperationException("Failed to create send instance.");
    }

    public NDIlib.tally_t Tally
    {
      get
      {
        if (this._sendInstancePtr == IntPtr.Zero)
          return this._ndiTally;
        NDIlib.send_get_tally(this._sendInstancePtr, ref this._ndiTally, 0U);
        return this._ndiTally;
      }
    }

    public bool GetTally(ref NDIlib.tally_t tally, int timeout) => !(this._sendInstancePtr == IntPtr.Zero) && NDIlib.send_get_tally(this._sendInstancePtr, ref tally, (uint) timeout);

    public int Connections => this._sendInstancePtr == IntPtr.Zero ? 0 : NDIlib.send_get_no_connections(this._sendInstancePtr, 0U);

    public int GetConnections(int waitMs) => this._sendInstancePtr == IntPtr.Zero ? 0 : NDIlib.send_get_no_connections(this._sendInstancePtr, (uint) waitMs);

    public void Send(VideoFrame videoFrame) => this.Send(ref videoFrame._ndiVideoFrame);

    public void Send(ref NDIlib.video_frame_v2_t videoFrame)
    {
      if (this._sendInstancePtr == IntPtr.Zero)
        return;
      NDIlib.send_send_video_v2(this._sendInstancePtr, ref videoFrame);
    }

    public void Send(AudioFrame audioFrame) => this.Send(ref audioFrame._ndiAudioFrame);

    public void Send(ref NDIlib.audio_frame_v2_t audioFrame)
    {
      if (this._sendInstancePtr == IntPtr.Zero)
        return;
      NDIlib.send_send_audio_v2(this._sendInstancePtr, ref audioFrame);
    }

    public void Dispose()
    {
      this.Dispose(true);
      GC.SuppressFinalize((object) this);
    }

    ~Sender() => this.Dispose(false);

    protected virtual void Dispose(bool disposing)
    {
      if (!disposing)
        return;
      if (this._sendInstancePtr != IntPtr.Zero)
      {
        NDIlib.send_destroy(this._sendInstancePtr);
        this._sendInstancePtr = IntPtr.Zero;
      }
      NDIlib.destroy();
    }
  }
}
