﻿// Decompiled with JetBrains decompiler
// Type: SuperfastBlur.GaussianBlur
// Assembly: NDILibDotNet2, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: A7218F26-32E7-4B46-B496-253D3CB5BE4C
// Assembly location: C:\Program Files (x86)\EmoTracker\NDILibDotNet2.dll

using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media.Imaging;

namespace SuperfastBlur
{
  public class GaussianBlur
  {
    private readonly int[] _alpha;
    private readonly int[] _red;
    private readonly int[] _green;
    private readonly int[] _blue;
    private readonly int _width;
    private readonly int _height;
    private readonly ParallelOptions _pOptions = new ParallelOptions()
    {
      MaxDegreeOfParallelism = 16
    };
    private Int32Rect mRect;
    private WriteableBitmap mSrc;

    public unsafe GaussianBlur(WriteableBitmap image)
    {
      GaussianBlur gaussianBlur = this;
      this._width = image.PixelWidth;
      this._height = image.PixelHeight;
      this.mRect = new Int32Rect(0, 0, this._width, this._height);
      this.mSrc = image;
      int[] source = new int[image.PixelWidth * image.PixelHeight];
      fixed (int* numPtr = source)
      {
        IntPtr buffer = new IntPtr((void*) numPtr);
        image.CopyPixels(this.mRect, buffer, this._width * this._height * 4, image.BackBufferStride);
      }
      this._alpha = new int[this._width * this._height];
      this._red = new int[this._width * this._height];
      this._green = new int[this._width * this._height];
      this._blue = new int[this._width * this._height];
      Parallel.For(0, source.Length, this._pOptions, (Action<int>) (i =>
      {
        gaussianBlur._alpha[i] = (int) (((long) source[i] & 4278190080L) >> 24);
        gaussianBlur._red[i] = (source[i] & 16711680) >> 16;
        gaussianBlur._green[i] = (source[i] & 65280) >> 8;
        gaussianBlur._blue[i] = source[i] & (int) byte.MaxValue;
      }));
    }

    public unsafe void Process(int radial)
    {
      int[] newAlpha = new int[this._width * this._height];
      int[] newRed = new int[this._width * this._height];
      int[] newGreen = new int[this._width * this._height];
      int[] newBlue = new int[this._width * this._height];
      int[] dest = new int[this._width * this._height];
      Parallel.Invoke((Action) (() => this.gaussBlur_4(this._alpha, newAlpha, radial)), (Action) (() => this.gaussBlur_4(this._red, newRed, radial)), (Action) (() => this.gaussBlur_4(this._green, newGreen, radial)), (Action) (() => this.gaussBlur_4(this._blue, newBlue, radial)));
      Parallel.For(0, dest.Length, this._pOptions, (Action<int>) (i =>
      {
        if (newAlpha[i] > (int) byte.MaxValue)
          newAlpha[i] = (int) byte.MaxValue;
        if (newRed[i] > (int) byte.MaxValue)
          newRed[i] = (int) byte.MaxValue;
        if (newGreen[i] > (int) byte.MaxValue)
          newGreen[i] = (int) byte.MaxValue;
        if (newBlue[i] > (int) byte.MaxValue)
          newBlue[i] = (int) byte.MaxValue;
        if (newAlpha[i] < 0)
          newAlpha[i] = 0;
        if (newRed[i] < 0)
          newRed[i] = 0;
        if (newGreen[i] < 0)
          newGreen[i] = 0;
        if (newBlue[i] < 0)
          newBlue[i] = 0;
        dest[i] = newAlpha[i] << 24 | newRed[i] << 16 | newGreen[i] << 8 | newBlue[i];
      }));
      fixed (int* numPtr = dest)
        this.mSrc.WritePixels(this.mRect, new IntPtr((void*) numPtr), this._width * this._height * 4, this.mSrc.BackBufferStride);
    }

    private void gaussBlur_4(int[] source, int[] dest, int r)
    {
      int[] numArray = this.boxesForGauss(r, 3);
      this.boxBlur_4(source, dest, this._width, this._height, (numArray[0] - 1) / 2);
      this.boxBlur_4(dest, source, this._width, this._height, (numArray[1] - 1) / 2);
      this.boxBlur_4(source, dest, this._width, this._height, (numArray[2] - 1) / 2);
    }

    private int[] boxesForGauss(int sigma, int n)
    {
      int num1 = (int) Math.Floor(Math.Sqrt((double) (12 * sigma * sigma / n + 1)));
      if (num1 % 2 == 0)
        --num1;
      int num2 = num1 + 2;
      double num3 = Math.Round((double) (12 * sigma * sigma - n * num1 * num1 - 4 * n * num1 - 3 * n) / (double) (-4 * num1 - 4));
      List<int> intList = new List<int>();
      for (int index = 0; index < n; ++index)
        intList.Add((double) index < num3 ? num1 : num2);
      return intList.ToArray();
    }

    private void boxBlur_4(int[] source, int[] dest, int w, int h, int r)
    {
      for (int index = 0; index < source.Length; ++index)
        dest[index] = source[index];
      this.boxBlurH_4(dest, source, w, h, r);
      this.boxBlurT_4(source, dest, w, h, r);
    }

    private void boxBlurH_4(int[] source, int[] dest, int w, int h, int r)
    {
      double iar = 1.0 / (double) (r + r + 1);
      Parallel.For(0, h, this._pOptions, (Action<int>) (i =>
      {
        int index1 = i * w;
        int num1 = index1;
        int num2 = index1 + r;
        int num3 = source[index1];
        int num4 = source[index1 + w - 1];
        int num5 = (r + 1) * num3;
        for (int index2 = 0; index2 < r; ++index2)
          num5 += source[index1 + index2];
        for (int index3 = 0; index3 <= r; ++index3)
        {
          num5 += source[num2++] - num3;
          dest[index1++] = (int) Math.Round((double) num5 * iar);
        }
        for (int index4 = r + 1; index4 < w - r; ++index4)
        {
          num5 += source[num2++] - dest[num1++];
          dest[index1++] = (int) Math.Round((double) num5 * iar);
        }
        for (int index5 = w - r; index5 < w; ++index5)
        {
          num5 += num4 - source[num1++];
          dest[index1++] = (int) Math.Round((double) num5 * iar);
        }
      }));
    }

    private void boxBlurT_4(int[] source, int[] dest, int w, int h, int r)
    {
      double iar = 1.0 / (double) (r + r + 1);
      Parallel.For(0, w, this._pOptions, (Action<int>) (i =>
      {
        int index1 = i;
        int index2 = index1;
        int index3 = index1 + r * w;
        int num1 = source[index1];
        int num2 = source[index1 + w * (h - 1)];
        int num3 = (r + 1) * num1;
        for (int index4 = 0; index4 < r; ++index4)
          num3 += source[index1 + index4 * w];
        for (int index5 = 0; index5 <= r; ++index5)
        {
          num3 += source[index3] - num1;
          dest[index1] = (int) Math.Round((double) num3 * iar);
          index3 += w;
          index1 += w;
        }
        for (int index6 = r + 1; index6 < h - r; ++index6)
        {
          num3 += source[index3] - source[index2];
          dest[index1] = (int) Math.Round((double) num3 * iar);
          index2 += w;
          index3 += w;
          index1 += w;
        }
        for (int index7 = h - r; index7 < h; ++index7)
        {
          num3 += num2 - source[index2];
          dest[index1] = (int) Math.Round((double) num3 * iar);
          index2 += w;
          index1 += w;
        }
      }));
    }
  }
}
