﻿// Decompiled with JetBrains decompiler
// Type: NewTek.NDI.VideoFrame
// Assembly: NDILibDotNet2, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: A7218F26-32E7-4B46-B496-253D3CB5BE4C
// Assembly location: C:\Program Files (x86)\EmoTracker\NDILibDotNet2.dll

using System;
using System.Runtime.InteropServices;
using System.Xml.Linq;

namespace NewTek.NDI
{
  public class VideoFrame : IDisposable
  {
    internal NDIlib.video_frame_v2_t _ndiVideoFrame;
    private bool _memoryOwned;

    public VideoFrame(
      int width,
      int height,
      float aspectRatio,
      int frameRateNumerator,
      int frameRateDenominator,
      NDIlib.frame_format_type_e format = NDIlib.frame_format_type_e.frame_format_type_progressive)
    {
      this._memoryOwned = true;
      int num1 = (width * 32 + 7) / 8;
      IntPtr num2 = Marshal.AllocHGlobal(height * num1);
      this._ndiVideoFrame = new NDIlib.video_frame_v2_t()
      {
        xres = width,
        yres = height,
        FourCC = NDIlib.FourCC_type_e.FourCC_type_BGRA,
        frame_rate_N = frameRateNumerator,
        frame_rate_D = frameRateDenominator,
        picture_aspect_ratio = aspectRatio,
        frame_format_type = format,
        timecode = NDIlib.send_timecode_synthesize,
        p_data = num2,
        line_stride_in_bytes = num1,
        p_metadata = IntPtr.Zero,
        timestamp = 0L
      };
    }

    public VideoFrame(
      IntPtr bufferPtr,
      int width,
      int height,
      int stride,
      NDIlib.FourCC_type_e fourCC,
      float aspectRatio,
      int frameRateNumerator,
      int frameRateDenominator,
      NDIlib.frame_format_type_e format)
    {
      this._ndiVideoFrame = new NDIlib.video_frame_v2_t()
      {
        xres = width,
        yres = height,
        FourCC = fourCC,
        frame_rate_N = frameRateNumerator,
        frame_rate_D = frameRateDenominator,
        picture_aspect_ratio = aspectRatio,
        frame_format_type = format,
        timecode = NDIlib.send_timecode_synthesize,
        p_data = bufferPtr,
        line_stride_in_bytes = stride,
        p_metadata = IntPtr.Zero,
        timestamp = 0L
      };
    }

    public int Width => this._ndiVideoFrame.xres;

    public int Height => this._ndiVideoFrame.yres;

    public int Stride => this._ndiVideoFrame.line_stride_in_bytes;

    public IntPtr BufferPtr => this._ndiVideoFrame.p_data;

    public long TimeStamp
    {
      get => this._ndiVideoFrame.timestamp;
      set => this._ndiVideoFrame.timestamp = value;
    }

    public XElement MetaData
    {
      get
      {
        if (this._ndiVideoFrame.p_metadata == IntPtr.Zero)
          return (XElement) null;
        string text = UTF.Utf8ToString(this._ndiVideoFrame.p_metadata);
        return string.IsNullOrEmpty(text) ? (XElement) null : XElement.Parse(text);
      }
    }

    public void Dispose()
    {
      this.Dispose(true);
      GC.SuppressFinalize((object) this);
    }

    ~VideoFrame() => this.Dispose(false);

    protected virtual void Dispose(bool disposing)
    {
      if (!disposing)
        return;
      if (this._memoryOwned)
      {
        Marshal.FreeHGlobal(this._ndiVideoFrame.p_data);
        this._ndiVideoFrame.p_data = IntPtr.Zero;
      }
      NDIlib.destroy();
    }
  }
}
