﻿// Decompiled with JetBrains decompiler
// Type: NewTek.NDI.WPF.ReceiveView
// Assembly: NDILibDotNet2, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: A7218F26-32E7-4B46-B496-253D3CB5BE4C
// Assembly location: C:\Program Files (x86)\EmoTracker\NDILibDotNet2.dll

using NAudio.CoreAudioApi;
using NAudio.Wave;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace NewTek.NDI.WPF
{
  public class ReceiveView : Viewbox, IDisposable, INotifyPropertyChanged
  {
    public static readonly DependencyProperty ReceiverNameProperty = DependencyProperty.Register(nameof (ReceiverName), typeof (string), typeof (ReceiveView), new PropertyMetadata((object) ""));
    public static readonly DependencyProperty ConnectedSourceProperty = DependencyProperty.Register(nameof (ConnectedSource), typeof (Source), typeof (ReceiveView), new PropertyMetadata((object) new Source(), new PropertyChangedCallback(ReceiveView.OnConnectedSourceChanged)));
    private bool _disposed;
    private IntPtr _recvInstancePtr = IntPtr.Zero;
    private Thread _receiveThread;
    private bool _exitThread;
    private Image VideoSurface = new Image();
    private WriteableBitmap VideoBitmap;
    private bool _audioEnabled = true;
    private bool _videoEnabled = true;
    private WasapiOut _wasapiOut;
    private MultiplexingWaveProvider _multiplexProvider;
    private BufferedWaveProvider _bufferedProvider;
    private WaveFormat _waveFormat;
    private float _volume = 1f;
    private bool _isPtz;
    private bool _canRecord;
    private string _webControlUrl = string.Empty;
    private string _receiverName = string.Empty;

    [Category("NewTek NDI")]
    [Description("The name of this receiver channel. Required or else an invalid argument exception will be thrown.")]
    public string ReceiverName
    {
      get => (string) this.GetValue(ReceiveView.ReceiverNameProperty);
      set => this.SetValue(ReceiveView.ReceiverNameProperty, (object) value);
    }

    [Category("NewTek NDI")]
    [Description("The NDI source to connect to. An empty new Source() or a Source with no Name will disconnect.")]
    public Source ConnectedSource
    {
      get => (Source) this.GetValue(ReceiveView.ConnectedSourceProperty);
      set => this.SetValue(ReceiveView.ConnectedSourceProperty, (object) value);
    }

    [Category("NewTek NDI")]
    [Description("If true (default) received audio will be sent to the default Windows audio playback device.")]
    public bool IsAudioEnabled
    {
      get => this._audioEnabled;
      set
      {
        if (value == this._audioEnabled)
          return;
        this.NotifyPropertyChanged(nameof (IsAudioEnabled));
      }
    }

    [Category("NewTek NDI")]
    [Description("If true (default) received video will be sent to the screen.")]
    public bool IsVideoEnabled
    {
      get => this._videoEnabled;
      set
      {
        if (value == this._videoEnabled)
          return;
        this.NotifyPropertyChanged(nameof (IsVideoEnabled));
      }
    }

    [Category("NewTek NDI")]
    [Description("Set or get the current audio volume. Range is 0.0 to 1.0")]
    public float Volume
    {
      get => this._volume;
      set
      {
        if ((double) value == (double) this._volume)
          return;
        this._volume = Math.Max(0.0f, Math.Min(1f, value));
        if (this._wasapiOut != null)
          this._wasapiOut.Volume = this._volume;
        this.NotifyPropertyChanged(nameof (Volume));
      }
    }

    [Category("NewTek NDI")]
    [Description("Does the current source support PTZ functionality?")]
    public bool IsPtz
    {
      get => this._isPtz;
      set
      {
        if (value == this._isPtz)
          return;
        this.NotifyPropertyChanged(nameof (IsPtz));
      }
    }

    [Category("NewTek NDI")]
    [Description("Does the current source support record functionality?")]
    public bool IsRecordingSupported
    {
      get => this._canRecord;
      set
      {
        if (value == this._canRecord)
          return;
        this.NotifyPropertyChanged(nameof (IsRecordingSupported));
      }
    }

    [Category("NewTek NDI")]
    [Description("The web control URL for the current device, as a String, or an Empty String if not supported.")]
    public string WebControlUrl
    {
      get => this._webControlUrl;
      set
      {
        if (!(value != this._webControlUrl))
          return;
        this.NotifyPropertyChanged(nameof (WebControlUrl));
      }
    }

    public ReceiveView() => DesignerProperties.GetIsInDesignMode((DependencyObject) this);

    public event PropertyChangedEventHandler PropertyChanged;

    public bool SetPtzZoom(double value) => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_zoom(this._recvInstancePtr, (float) value);

    public bool SetPtzZoomSpeed(double value) => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_zoom_speed(this._recvInstancePtr, (float) value);

    public bool SetPtzPanTilt(double pan, double tilt) => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_pan_tilt(this._recvInstancePtr, (float) pan, (float) tilt);

    public bool SetPtzPanTiltSpeed(double panSpeed, double tiltSpeed) => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_pan_tilt_speed(this._recvInstancePtr, (float) panSpeed, (float) tiltSpeed);

    public bool PtzStorePreset(int index) => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && index >= 0 && index <= 99 && NDIlib.recv_ptz_store_preset(this._recvInstancePtr, index);

    public bool PtzRecallPreset(int index, double speed) => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && index >= 0 && index <= 99 && NDIlib.recv_ptz_recall_preset(this._recvInstancePtr, index, (float) speed);

    public bool PtzAutoFocus() => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_auto_focus(this._recvInstancePtr);

    public bool SetPtzFocusSpeed(double speed) => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_focus_speed(this._recvInstancePtr, (float) speed);

    public bool PtzWhiteBalanceAuto() => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_white_balance_auto(this._recvInstancePtr);

    public bool PtzWhiteBalanceIndoor() => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_white_balance_indoor(this._recvInstancePtr);

    public bool PtzWhiteBalanceOutdoor() => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_white_balance_outdoor(this._recvInstancePtr);

    public bool PtzWhiteBalanceOneShot() => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_white_balance_oneshot(this._recvInstancePtr);

    public bool PtzWhiteBalanceManual(double red, double blue) => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_white_balance_manual(this._recvInstancePtr, (float) red, (float) blue);

    public bool PtzExposureAuto() => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_exposure_auto(this._recvInstancePtr);

    public bool PtzExposureManual(double level) => this._isPtz && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_ptz_exposure_manual(this._recvInstancePtr, (float) level);

    public bool RecordingStart(string filenameHint = "")
    {
      if (!this._canRecord || this._recvInstancePtr == IntPtr.Zero)
        return false;
      bool flag;
      if (string.IsNullOrEmpty(filenameHint))
      {
        flag = NDIlib.recv_recording_start(this._recvInstancePtr, IntPtr.Zero);
      }
      else
      {
        IntPtr utf8 = UTF.StringToUtf8(filenameHint);
        flag = NDIlib.recv_recording_start(this._recvInstancePtr, IntPtr.Zero);
        Marshal.FreeHGlobal(utf8);
      }
      return flag;
    }

    public bool RecordingStop() => this._canRecord && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_recording_stop(this._recvInstancePtr);

    public bool RecordingSetAudioLevel(double level) => this._canRecord && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_recording_set_audio_level(this._recvInstancePtr, (float) level);

    public bool IsRecording() => this._canRecord && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_recording_is_recording(this._recvInstancePtr);

    public string GetRecordingFilename()
    {
      if (!this._canRecord || this._recvInstancePtr == IntPtr.Zero)
        return string.Empty;
      IntPtr filename = NDIlib.recv_recording_get_filename(this._recvInstancePtr);
      if (filename == IntPtr.Zero)
        return string.Empty;
      string recordingFilename = UTF.Utf8ToString(filename);
      NDIlib.recv_free_string(this._recvInstancePtr, filename);
      return recordingFilename;
    }

    public string GetRecordingError()
    {
      if (!this._canRecord || this._recvInstancePtr == IntPtr.Zero)
        return string.Empty;
      IntPtr error = NDIlib.recv_recording_get_error(this._recvInstancePtr);
      if (error == IntPtr.Zero)
        return string.Empty;
      string recordingError = UTF.Utf8ToString(error);
      NDIlib.recv_free_string(this._recvInstancePtr, error);
      return recordingError;
    }

    public bool GetRecordingTimes(ref NDIlib.recv_recording_time_t recordingTimes) => this._canRecord && !(this._recvInstancePtr == IntPtr.Zero) && NDIlib.recv_recording_get_times(this._recvInstancePtr, ref recordingTimes);

    private void NotifyPropertyChanged(string info)
    {
      if (this.PropertyChanged == null)
        return;
      this.PropertyChanged((object) this, new PropertyChangedEventArgs(info));
    }

    public void Dispose()
    {
      this.Dispose(true);
      GC.SuppressFinalize((object) this);
    }

    ~ReceiveView() => this.Dispose(false);

    protected virtual void Dispose(bool disposing)
    {
      if (this._disposed)
        return;
      if (disposing)
      {
        this._exitThread = true;
        if (this._receiveThread != null)
        {
          this._receiveThread.Join();
          this._receiveThread = (Thread) null;
        }
        if (this._wasapiOut != null)
        {
          this._wasapiOut.Stop();
          this._wasapiOut.Dispose();
          this._wasapiOut = (WasapiOut) null;
        }
      }
      if (this._recvInstancePtr != IntPtr.Zero)
      {
        NDIlib.recv_destroy(this._recvInstancePtr);
        this._recvInstancePtr = IntPtr.Zero;
      }
      NDIlib.destroy();
      this._disposed = true;
    }

    private static void OnConnectedSourceChanged(
      object sender,
      DependencyPropertyChangedEventArgs e)
    {
      if (!(sender is ReceiveView receiveView))
        return;
      receiveView.Connect(receiveView.ConnectedSource);
    }

    private void Connect(Source source)
    {
      if (DesignerProperties.GetIsInDesignMode((DependencyObject) this))
        return;
      if (string.IsNullOrEmpty(this.ReceiverName))
        throw new ArgumentException("sourceName can not be null or empty.", this.ReceiverName);
      this.Disconnect();
      if (this.Child == null)
        this.Child = (UIElement) this.VideoSurface;
      if (source == null || string.IsNullOrEmpty(source.Name))
        return;
      NDIlib.source_t sourceT = new NDIlib.source_t()
      {
        p_ndi_name = UTF.StringToUtf8(source.Name)
      };
      NDIlib.recv_create_v3_t p_create_settings = new NDIlib.recv_create_v3_t()
      {
        source_to_connect_to = sourceT,
        color_format = NDIlib.recv_color_format_e.recv_color_format_BGRX_BGRA,
        bandwidth = NDIlib.recv_bandwidth_e.recv_bandwidth_highest,
        allow_video_fields = false,
        p_ndi_name = UTF.StringToUtf8(this.ReceiverName)
      };
      this._recvInstancePtr = NDIlib.recv_create_v3(ref p_create_settings);
      Marshal.FreeHGlobal(sourceT.p_ndi_name);
      Marshal.FreeHGlobal(p_create_settings.p_ndi_name);
      if (!(this._recvInstancePtr != IntPtr.Zero))
        return;
      this.SetTallyIndicators(true, false);
      this._receiveThread = new Thread(new ThreadStart(this.ReceiveThreadProc))
      {
        IsBackground = true,
        Name = "NdiExampleReceiveThread"
      };
      this._receiveThread.Start();
    }

    public void Disconnect()
    {
      this.SetTallyIndicators(false, false);
      if (this._receiveThread != null)
      {
        this._exitThread = true;
        this._receiveThread.Join();
      }
      this._receiveThread = (Thread) null;
      this._exitThread = false;
      NDIlib.recv_destroy(this._recvInstancePtr);
      this._recvInstancePtr = IntPtr.Zero;
      this.IsPtz = false;
      this.IsRecordingSupported = false;
      this.WebControlUrl = string.Empty;
    }

    private void SetTallyIndicators(bool onProgram, bool onPreview)
    {
      if (!(this._recvInstancePtr != IntPtr.Zero))
        return;
      NDIlib.tally_t p_tally = new NDIlib.tally_t()
      {
        on_program = onProgram,
        on_preview = onPreview
      };
      NDIlib.recv_set_tally(this._recvInstancePtr, ref p_tally);
    }

    private void ReceiveThreadProc()
    {
      while (!this._exitThread && this._recvInstancePtr != IntPtr.Zero)
      {
        NDIlib.video_frame_v2_t videoFrame = new NDIlib.video_frame_v2_t();
        NDIlib.audio_frame_v2_t audioFrameV2T = new NDIlib.audio_frame_v2_t();
        NDIlib.metadata_frame_t p_metadata = new NDIlib.metadata_frame_t();
        switch (NDIlib.recv_capture_v2(this._recvInstancePtr, ref videoFrame, ref audioFrameV2T, ref p_metadata, 1000U))
        {
          case NDIlib.frame_type_e.frame_type_video:
            if (!this._videoEnabled || videoFrame.p_data == IntPtr.Zero)
            {
              NDIlib.recv_free_video_v2(this._recvInstancePtr, ref videoFrame);
              continue;
            }
            int yres = videoFrame.yres;
            int xres = videoFrame.xres;
            double dpiX = 96.0 * ((double) videoFrame.picture_aspect_ratio / ((double) xres / (double) yres));
            int stride = videoFrame.line_stride_in_bytes;
            int bufferSize = yres * stride;
            base.Dispatcher.BeginInvoke(new Action(delegate ()
            {
                if (this.VideoBitmap == null || this.VideoBitmap.PixelWidth != xres || this.VideoBitmap.PixelHeight != yres || this.VideoBitmap.DpiX != dpiX)
                {
                    this.VideoBitmap = new WriteableBitmap(xres, yres, dpiX, 96.0, PixelFormats.Pbgra32, null);
                    this.VideoSurface.Source = this.VideoBitmap;
                }
                this.VideoBitmap.WritePixels(new Int32Rect(0, 0, xres, yres), videoFrame.p_data, bufferSize, stride);
                NDIlib.recv_free_video_v2(this._recvInstancePtr, ref videoFrame);
            }), new object[0]);
            continue;
          case NDIlib.frame_type_e.frame_type_audio:
            if (!this._audioEnabled || audioFrameV2T.p_data == IntPtr.Zero || audioFrameV2T.no_samples == 0)
            {
              NDIlib.recv_free_audio_v2(this._recvInstancePtr, ref audioFrameV2T);
              continue;
            }
            bool flag = false;
            if (this._waveFormat == null || this._waveFormat.Channels != audioFrameV2T.no_channels || this._waveFormat.SampleRate != audioFrameV2T.sample_rate)
            {
              this._waveFormat = WaveFormat.CreateIeeeFloatWaveFormat(audioFrameV2T.sample_rate, audioFrameV2T.no_channels);
              flag = true;
            }
            if (this._bufferedProvider == null | flag)
            {
              this._bufferedProvider = new BufferedWaveProvider(this._waveFormat);
              this._bufferedProvider.DiscardOnBufferOverflow = true;
            }
            if (this._multiplexProvider == null | flag)
              this._multiplexProvider = new MultiplexingWaveProvider((IEnumerable<IWaveProvider>) new List<IWaveProvider>()
              {
                (IWaveProvider) this._bufferedProvider
              }, 2);
            if (this._wasapiOut == null | flag)
            {
              this._wasapiOut = new WasapiOut(AudioClientShareMode.Shared, 50);
              this._wasapiOut.Init((IWaveProvider) this._multiplexProvider);
              this._wasapiOut.Volume = this._volume;
              this._wasapiOut.Play();
            }
            int count = audioFrameV2T.no_samples * audioFrameV2T.no_channels * 4;
            NDIlib.audio_frame_interleaved_32f_t p_dst = new NDIlib.audio_frame_interleaved_32f_t()
            {
              sample_rate = audioFrameV2T.sample_rate,
              no_channels = audioFrameV2T.no_channels,
              no_samples = audioFrameV2T.no_samples,
              timecode = audioFrameV2T.timecode
            };
            byte[] buffer = new byte[count];
            GCHandle gcHandle = GCHandle.Alloc((object) buffer, GCHandleType.Pinned);
            p_dst.p_data = gcHandle.AddrOfPinnedObject();
            NDIlib.util_audio_to_interleaved_32f_v2(ref audioFrameV2T, ref p_dst);
            gcHandle.Free();
            this._bufferedProvider.AddSamples(buffer, 0, count);
            NDIlib.recv_free_audio_v2(this._recvInstancePtr, ref audioFrameV2T);
            continue;
          case NDIlib.frame_type_e.frame_type_metadata:
            NDIlib.recv_free_metadata(this._recvInstancePtr, ref p_metadata);
            continue;
          case NDIlib.frame_type_e.frame_type_status_change:
            this.IsPtz = NDIlib.recv_ptz_is_supported(this._recvInstancePtr);
            this.IsRecordingSupported = NDIlib.recv_recording_is_supported(this._recvInstancePtr);
            IntPtr webControl = NDIlib.recv_get_web_control(this._recvInstancePtr);
            if (webControl == IntPtr.Zero)
            {
              this.WebControlUrl = string.Empty;
              continue;
            }
            this.WebControlUrl = UTF.Utf8ToString(webControl);
            NDIlib.recv_free_string(this._recvInstancePtr, webControl);
            continue;
          default:
            continue;
        }
      }
    }
  }
}
