﻿// Decompiled with JetBrains decompiler
// Type: NewTek.NDI.WPF.NdiSendContainer
// Assembly: NDILibDotNet2, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: A7218F26-32E7-4B46-B496-253D3CB5BE4C
// Assembly location: C:\Program Files (x86)\EmoTracker\NDILibDotNet2.dll

using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Threading;

namespace NewTek.NDI.WPF
{
    public class NdiSendContainer : ContentPresenter, INotifyPropertyChanged, IDisposable
    {
        public static readonly DependencyProperty NdiDropShadowProperty = DependencyProperty.Register(nameof(NdiDropShadow), typeof(bool), typeof(NdiSendContainer), new PropertyMetadata((object)false));
        public static readonly DependencyProperty NdiWidthProperty = DependencyProperty.Register(nameof(NdiWidth), typeof(int), typeof(NdiSendContainer), new PropertyMetadata((object)1280));
        public static readonly DependencyProperty NdiHeightProperty = DependencyProperty.Register(nameof(NdiHeight), typeof(int), typeof(NdiSendContainer), new PropertyMetadata((object)720));
        public static readonly DependencyProperty NdiFrameRateNumeratorProperty = DependencyProperty.Register(nameof(NdiFrameRateNumerator), typeof(int), typeof(NdiSendContainer), new PropertyMetadata((object)30000));
        public static readonly DependencyProperty NdiFrameRateDenominatorProperty = DependencyProperty.Register(nameof(NdiFrameRateDenominator), typeof(int), typeof(NdiSendContainer), new PropertyMetadata((object)1000));
        public static readonly DependencyProperty NdiIntegerScaleProperty = DependencyProperty.Register(nameof(NdiIntegerScale), typeof(int), typeof(NdiSendContainer), new PropertyMetadata((object)1));
        public static readonly DependencyProperty NdiNameProperty = DependencyProperty.Register(nameof(NdiName), typeof(string), typeof(NdiSendContainer), new PropertyMetadata((object)"Unnamed - Fix Me.", new PropertyChangedCallback(NdiSendContainer.OnNdiSenderPropertyChanged)));
        public static readonly DependencyProperty NdiGroupsProperty = DependencyProperty.Register(nameof(NdiGroups), typeof(List<string>), typeof(NdiSendContainer), new PropertyMetadata((object)new List<string>(), new PropertyChangedCallback(NdiSendContainer.OnNdiSenderPropertyChanged)));
        public static readonly DependencyProperty NdiClockToVideoProperty = DependencyProperty.Register(nameof(NdiClockToVideo), typeof(bool), typeof(NdiSendContainer), new PropertyMetadata((object)true, new PropertyChangedCallback(NdiSendContainer.OnNdiSenderPropertyChanged)));
        public static readonly DependencyProperty IsOnProgramProperty = DependencyProperty.Register(nameof(IsOnProgram), typeof(bool), typeof(NdiSendContainer), new PropertyMetadata((object)false));
        public static readonly DependencyProperty IsOnPreviewProperty = DependencyProperty.Register(nameof(IsOnPreview), typeof(bool), typeof(NdiSendContainer), new PropertyMetadata((object)false));
        private static readonly TimeSpan LockTimeout = new TimeSpan(0, 0, 0, 0, 250);
        private DispatcherTimer mConnectionCheckTimer;
        private bool _disposed;
        private static double xScalar = 1.0;
        private static double yScalar = 1.0;
        private TimeSpan mLastRenderTime;
        private object sendInstanceLock = new object();
        private IntPtr sendInstancePtr = IntPtr.Zero;
        private RenderTargetBitmap targetBitmap;
        private int stride;
        private int bufferSize;
        private float aspectRatio;
        private Thread sendThread;
        private bool exitThread;
        private BlockingCollection<NdiSendContainer.FrameImage> pendingFrames = new BlockingCollection<NdiSendContainer.FrameImage>();
        private bool isPausedValue = true;
        private bool unPremultiply;

        [Category("NewTek NDI")]
        [Description("Whether or not to apply a global dropshadow to the render result.")]
        public bool NdiDropShadow
        {
            get => (bool)this.GetValue(NdiSendContainer.NdiDropShadowProperty);
            set => this.SetValue(NdiSendContainer.NdiDropShadowProperty, (object)value);
        }

        [Category("NewTek NDI")]
        [Description("NDI output width in pixels. Required.")]
        public int NdiWidth
        {
            get => (int)this.GetValue(NdiSendContainer.NdiWidthProperty);
            set => this.SetValue(NdiSendContainer.NdiWidthProperty, (object)value);
        }

        [Category("NewTek NDI")]
        [Description("NDI output height in pixels. Required.")]
        public int NdiHeight
        {
            get => (int)this.GetValue(NdiSendContainer.NdiHeightProperty);
            set => this.SetValue(NdiSendContainer.NdiHeightProperty, (object)value);
        }

        [Category("NewTek NDI")]
        [Description("NDI output frame rate numerator. Required.")]
        public int NdiFrameRateNumerator
        {
            get => (int)this.GetValue(NdiSendContainer.NdiFrameRateNumeratorProperty);
            set => this.SetValue(NdiSendContainer.NdiFrameRateNumeratorProperty, (object)value);
        }

        [Category("NewTek NDI")]
        [Description("NDI output frame rate denominator. Required.")]
        public int NdiFrameRateDenominator
        {
            get => (int)this.GetValue(NdiSendContainer.NdiFrameRateDenominatorProperty);
            set => this.SetValue(NdiSendContainer.NdiFrameRateDenominatorProperty, (object)value);
        }

        [Category("NewTek NDI")]
        [Description("Integer scale applied to frame output prior to broadcast.")]
        public int NdiIntegerScale
        {
            get => (int)this.GetValue(NdiSendContainer.NdiIntegerScaleProperty);
            set => this.SetValue(NdiSendContainer.NdiIntegerScaleProperty, (object)value);
        }

        [Category("NewTek NDI")]
        [Description("NDI output name as displayed to receivers. Required.")]
        public string NdiName
        {
            get => (string)this.GetValue(NdiSendContainer.NdiNameProperty);
            set => this.SetValue(NdiSendContainer.NdiNameProperty, (object)value);
        }

        [Category("NewTek NDI")]
        [Description("NDI groups this sender will belong to. Optional.")]
        public List<string> NdiGroups
        {
            get => (List<string>)this.GetValue(NdiSendContainer.NdiGroupsProperty);
            set => this.SetValue(NdiSendContainer.NdiGroupsProperty, (object)value);
        }

        [Category("NewTek NDI")]
        [Description("If clocked to video, NDI will rate limit drawing to the specified frame rate. Defaults to true.")]
        public bool NdiClockToVideo
        {
            get => (bool)this.GetValue(NdiSendContainer.NdiClockToVideoProperty);
            set => this.SetValue(NdiSendContainer.NdiClockToVideoProperty, (object)value);
        }

        [Category("NewTek NDI")]
        [Description("True if some receiver has this source on program out.")]
        public bool IsOnProgram
        {
            get => (bool)this.GetValue(NdiSendContainer.IsOnProgramProperty);
            set => this.SetValue(NdiSendContainer.IsOnProgramProperty, (object)value);
        }

        [Category("NewTek NDI")]
        [Description("True if some receiver has this source on preview out.")]
        public bool IsOnPreview
        {
            get => (bool)this.GetValue(NdiSendContainer.IsOnPreviewProperty);
            set => this.SetValue(NdiSendContainer.IsOnPreviewProperty, (object)value);
        }

        [Category("NewTek NDI")]
        [Description("If True, the send thread does not send, taking no CPU time.")]
        public bool IsSendPaused
        {
            get => this.isPausedValue;
            set
            {
                if (value == this.isPausedValue)
                    return;
                this.isPausedValue = value;
                this.NotifyPropertyChanged(nameof(IsSendPaused));
            }
        }

        [Category("NewTek NDI")]
        [Description("If you need partial transparency, set this to true. If not, set to false and save some CPU cycles.")]
        public bool UnPremultiply
        {
            get => this.unPremultiply;
            set
            {
                if (value == this.unPremultiply)
                    return;
                this.unPremultiply = value;
                this.NotifyPropertyChanged(nameof(UnPremultiply));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(string info)
        {
            if (this.PropertyChanged == null)
                return;
            this.PropertyChanged((object)this, new PropertyChangedEventArgs(info));
        }

        public NdiSendContainer()
        {
            if (DesignerProperties.GetIsInDesignMode((DependencyObject)this))
                return;
            this.mConnectionCheckTimer = new DispatcherTimer(new TimeSpan(0, 0, 2), DispatcherPriority.Normal, new EventHandler(this.OnConnectionCheck), Application.Current.Dispatcher);
            this.Start();
        }

        public void Dispose()
        {
            this.Dispose(true);
            GC.SuppressFinalize((object)this);
        }

        ~NdiSendContainer() => this.Dispose(false);

        protected virtual void Dispose(bool disposing)
        {
            try
            {
                if (this._disposed)
                    return;
                if (disposing)
                {
                    this.exitThread = true;
                    if (this.sendThread != null)
                    {
                        this.sendThread.Join(250);
                        this.sendThread = (Thread)null;
                    }
                    this.pendingFrames.CompleteAdding();
                    while (this.pendingFrames.Count > 0)
                        this.pendingFrames.Take();
                    this.pendingFrames.Dispose();
                }
                if (this.sendInstancePtr != IntPtr.Zero)
                {
                    NDIlib.send_destroy(this.sendInstancePtr);
                    this.sendInstancePtr = IntPtr.Zero;
                }
                NDIlib.destroy();
            }
            catch
            {
            }
            finally
            {
                this._disposed = true;
            }
        }

        public void Start()
        {
            try
            {
                if (!NDIlib.initialize())
                {
                    int num = (int)MessageBox.Show("Cannot run NDI");
                }
                else
                {
                    this.sendThread = new Thread(new ThreadStart(this.SendThreadProc))
                    {
                        IsBackground = true,
                        Name = "WpfNdiSendThread"
                    };
                    this.sendThread.Start();
                    CompositionTarget.Rendering += new EventHandler(this.OnCompositionTargetRendering);
                }
            }
            catch
            {
            }
        }

        public void Stop() => this.IsSendPaused = true;

        private void OnConnectionCheck(object sender, EventArgs e)
        {
            if (this.IsOnProgram || this.IsOnPreview)
                this.IsSendPaused = false;
            else
                this.IsSendPaused = true;
        }

        private void GenerateFrame()
        {
            int pixelWidth = (int)((double)this.NdiWidth * NdiSendContainer.xScalar);
            int pixelHeight = (int)((double)this.NdiHeight * NdiSendContainer.yScalar);
            int dpiX = (int)(96.0 * NdiSendContainer.xScalar);
            int dpiY = (int)(96.0 * NdiSendContainer.yScalar);
            if (this.sendInstancePtr == IntPtr.Zero || pixelWidth < 8 || pixelHeight < 8)
                return;
            if (this.targetBitmap == null || this.targetBitmap.PixelWidth != pixelWidth || this.targetBitmap.PixelHeight != pixelHeight)
                this.targetBitmap = new RenderTargetBitmap(pixelWidth, pixelHeight, (double)dpiX, (double)dpiY, PixelFormats.Pbgra32);
            this.targetBitmap.Clear();
            this.targetBitmap.Render(this.Content as Visual);
            this.pendingFrames.Add(new NdiSendContainer.FrameImage((BitmapSource)this.targetBitmap, this.NdiFrameRateNumerator, this.NdiFrameRateDenominator, this.NdiIntegerScale, this.NdiDropShadow));
        }

        private void OnCompositionTargetRendering(object sender, EventArgs e)
        {
            if (!(e is RenderingEventArgs renderingEventArgs))
                return;
            TimeSpan mLastRenderTime = this.mLastRenderTime;
            if (this.mLastRenderTime.Ticks >= renderingEventArgs.RenderingTime.Ticks)
                return;
            TimeSpan timeSpan = renderingEventArgs.RenderingTime - this.mLastRenderTime;
            if (this.IsSendPaused || timeSpan.TotalMilliseconds < (double)(1000 / (this.NdiFrameRateNumerator / this.NdiFrameRateDenominator)))
                return;
            this.GenerateFrame();
            this.mLastRenderTime = renderingEventArgs.RenderingTime;
        }

        private static void OnNdiSenderPropertyChanged(
          object sender,
          DependencyPropertyChangedEventArgs e)
        {
            if (!(sender is NdiSendContainer ndiSendContainer))
                return;
            ndiSendContainer.InitializeNdi();
        }

        private void InitializeNdi()
        {
            if (DesignerProperties.GetIsInDesignMode((DependencyObject)this))
                return;
            Monitor.Enter(this.sendInstanceLock);
            try
            {
                if (string.IsNullOrEmpty(this.NdiName))
                    return;
                if (this.sendInstancePtr != IntPtr.Zero)
                {
                    NDIlib.send_destroy(this.sendInstancePtr);
                    this.sendInstancePtr = IntPtr.Zero;
                }
                IntPtr utf8 = UTF.StringToUtf8(this.NdiName);
                IntPtr hglobal = IntPtr.Zero;
                if (this.NdiGroups.Count > 0)
                {
                    StringBuilder stringBuilder = new StringBuilder();
                    for (int index = 0; index < this.NdiGroups.Count<string>(); ++index)
                    {
                        stringBuilder.Append(this.NdiGroups[index]);
                        if (index < this.NdiGroups.Count - 1)
                            stringBuilder.Append(',');
                    }
                    hglobal = UTF.StringToUtf8(stringBuilder.ToString());
                }
                NDIlib.send_create_t p_create_settings = new NDIlib.send_create_t()
                {
                    p_ndi_name = utf8,
                    p_groups = hglobal,
                    clock_video = this.NdiClockToVideo,
                    clock_audio = false
                };
                this.sendInstancePtr = NDIlib.send_create(ref p_create_settings);
                Marshal.FreeHGlobal(utf8);
                Marshal.FreeHGlobal(hglobal);
            }
            catch
            {
            }
            finally
            {
                Monitor.Exit(this.sendInstanceLock);
            }
        }

        private void SendThreadProc()
        {
            bool lastProg = false;
            bool lastPrev = false;
            NDIlib.tally_t p_tally = new NDIlib.tally_t();
            p_tally.on_program = lastProg;
            p_tally.on_preview = lastPrev;
            while (!this.exitThread)
            {
                if (Monitor.TryEnter(this.sendInstanceLock, 250))
                {
                    IntPtr sendInstancePtr = this.sendInstancePtr;
                    try
                    {
                        NdiSendContainer.FrameImage frameImage;
                        if (this.pendingFrames.TryTake(out frameImage, 250))
                        {
                            while (this.pendingFrames.Count > 1)
                                this.pendingFrames.Take();
                            if (!frameImage.dropshadow)
                            {
                                byte[] buffer = frameImage.buffer;
                            }
                            else
                                ImageProcessing.FastDropShadow(frameImage.buffer, frameImage.width, frameImage.height, frameImage.stride);
                            byte[] source = ImageProcessing.ScaleBuffer(frameImage.buffer, frameImage.width, frameImage.height, frameImage.stride, frameImage.scalar);
                            this.stride = (frameImage.width * frameImage.scalar * 32 + 7) / 8;
                            this.bufferSize = frameImage.height * frameImage.scalar * this.stride;
                            this.aspectRatio = (float)frameImage.width / (float)frameImage.height;
                            IntPtr hglobal = Marshal.AllocHGlobal(this.bufferSize);
                            NDIlib.video_frame_v2_t p_video_data = new NDIlib.video_frame_v2_t()
                            {
                                xres = frameImage.width * frameImage.scalar,
                                yres = frameImage.height * frameImage.scalar,
                                FourCC = NDIlib.FourCC_type_e.FourCC_type_BGRA,
                                frame_rate_N = frameImage.frNum,
                                frame_rate_D = frameImage.frDen,
                                picture_aspect_ratio = this.aspectRatio,
                                frame_format_type = NDIlib.frame_format_type_e.frame_format_type_progressive,
                                timecode = NDIlib.send_timecode_synthesize,
                                p_data = hglobal,
                                line_stride_in_bytes = this.stride,
                                p_metadata = IntPtr.Zero,
                                timestamp = 0
                            };
                            IntPtr destination = hglobal;
                            int bufferSize = this.bufferSize;
                            Marshal.Copy(source, 0, destination, bufferSize);
                            if (!this.IsSendPaused)
                                NDIlib.send_send_video_v2(this.sendInstancePtr, ref p_video_data);
                            Marshal.FreeHGlobal(hglobal);
                        }
                    }
                    catch (OperationCanceledException ex)
                    {
                        this.pendingFrames.CompleteAdding();
                    }
                    catch
                    {
                    }
                    Monitor.Exit(this.sendInstanceLock);
                }
                else
                    Thread.Sleep(20);
                NDIlib.send_get_tally(this.sendInstancePtr, ref p_tally, 0U);
                if (lastProg != p_tally.on_program || lastPrev != p_tally.on_preview)
                {
                    lastProg = p_tally.on_program;
                    lastPrev = p_tally.on_preview;
                    Application.Current.Dispatcher.BeginInvoke(new Action(delegate ()
                    {
                        this.IsOnProgram = lastProg;
                        this.IsOnPreview = lastPrev;
                    }), new object[0]);
                }
            }
        }

        private class FrameImage
        {
            public int width;
            public int height;
            public int stride;
            public int offset;
            public int frNum;
            public int frDen;
            public int scalar;
            public bool dropshadow;
            public byte[] buffer;

            public FrameImage(
              BitmapSource image,
              int srcfrNum,
              int srcfrDen,
              int scalar,
              bool dropshadow)
            {
                this.frNum = srcfrNum;
                this.frDen = srcfrDen;
                this.width = image.PixelWidth;
                this.height = image.PixelHeight;
                this.stride = this.width * 4;
                this.offset = 0;
                this.scalar = scalar;
                this.dropshadow = dropshadow;
                this.buffer = new byte[image.PixelHeight * image.PixelWidth * 4];
                image.CopyPixels((Array)this.buffer, this.stride, this.offset);
            }

            public WriteableBitmap AsWriteableBitmap()
            {
                WriteableBitmap writeableBitmap = new WriteableBitmap(this.width, this.height, 96.0, 96.0, PixelFormats.Pbgra32, (BitmapPalette)null);
                writeableBitmap.WritePixels(new Int32Rect(0, 0, this.width, this.height), (Array)this.buffer, this.stride, this.offset);
                return writeableBitmap;
            }
        }
    }
}
